; c a l l b a c k t e s t . s c h
;
; lth@cs.uoregon.edu / August 14, 1995
; $Id$
;
; The procedure 'callback-test' tests the lambda-as-callback facility,
; and provides an example of its use.

(require "callback.sch")

(define (callback-test)

  (define (choose x)
    (format #t "Chose \"~a\"~%" x))

  ; Editorial: this use of 'selection' is dumb; it should not be 
  ;   necessary to have to use 'catch'. However, even if there were 
  ;   a way to discover whether there is a selection (is there one?)
  ;   there would be a race condition between testing for the
  ;   selection and getting it. Why can't 'selection' just return
  ;   "" if there's none?

  (define (get-selection)
    (let ((x #f))
      (if (catch (set! x (selection 'get)))
	  ""
	  x)))

  ; Essentially the program from Ousterhout's book, p170.

  (button '.b
	  :text "Choose"
	  :command (tk-callback (lambda () (choose (get-selection)))))
  (pack .b)
  (listbox '.files
	   :relief 'raised
	   :borderwidth 2 
	   :yscrollcommand (tk-callback (lambda (a b c d)
					  (.scroll 'set a b c d))))
  (pack .files :side 'left)
  (scrollbar '.scroll
	     :command (tk-callback (lambda (ypos)
				     (.files 'yview ypos))))
  (pack .scroll :side 'right :fill 'y)
  (for-each (lambda (fn)
	      (.files 'insert 'end fn))
	    (glob "*"))
  #t)

; eof
