; e r r o r . s c h
;
;   Copyright (C) 1995 The University of Oregon
;   Copyright (C) 1995 Lars Thomas Hansen <lth@cs.uoregon.edu>
;
;   Permission to use, copy, and/or distribute this software and its
;   documentation for any purpose and with or without fee is hereby granted,
;   provided that both the above copyright notice and this permission notice
;   appear in all copies and derived works.  
;
;   This software is provided ``as is'' without express or implied warranty.
;
; lth@cs.uoregon.edu / June 27, 1995
; $Id: error.sch,v 1.3 1995/07/26 18:29:59 lth Exp lth $
;
; Improvements to the error procedure which allow graceful shutdown of
; various services in the face of multiple threads, and so on.
;
; BUGS
;   This code is not all that well tested, as it's depressing to test
;   an error procedure.

; Requires: nothing.

; Sys$error always has the original error procedure.

(define sys$error
  (if (symbol-bound? 'sys$error)
      sys$error
      error))

(define error-procs '())

(define (init-error)
  (set! error-procs '()))

(define (install-error-proc p)
  (set! error-procs (cons p error-procs)))

(define (remove-error-proc p)
  (define (remove p l)
    (cond ((null? l)
	   l)
	  ((equal? p (car l))
	   (remove p (cdr l)))
	  (else
	   (cons (car l) (remove p (cdr l))))))
  (set! error-procs (remove p error-procs)))

(define (error fmt . rest)
  (let ((msg (apply format #f fmt rest)))
    (for-each (lambda (x) (x msg)) (append error-procs '())))
  ; If control reaches this point, just do the usual thing.
  (sys$error (apply format #f fmt rest)))

(define (primitive-error . rest)
  (apply sys$error rest))

; Experimental!

(define (**report-error head msg obj)
  (set! %eval-stack (%get-eval-stack))
  (format #t "ERROR: ~a: ~s~%~%" msg obj)
  ; should run thunks here, I think.
  #t)

(provide "error.sch")

; eof
