; p v e c t . s c h
;
;   Copyright (C) 1995 The University of Oregon
;   Copyright (C) 1995 Lars Thomas Hansen <lth@cs.uoregon.edu>
;
;   Permission to use, copy, and/or distribute this software and its
;   documentation for any purpose and with or without fee is hereby granted,
;   provided that both the above copyright notice and this permission notice
;   appear in all copies and derived works.  
;
;   This software is provided ``as is'' without express or implied warranty.
;
; lth@cs.uoregon.edu / July 25, 1995
; $Id: pvect.sch,v 1.1 1995/07/26 18:29:59 lth Exp lth $
;
; Protected vector: a vector controlled by a mutex.
;
; BUGS
; - Should really use vector-ref, vector-set! (generically).

(define (make-pvector size . rest)
  (let ((init (if (null? rest) #f (car rest))))
    (wrap-vector-as-pvector (make-vector size init))))

(define (wrap-vector-as-pvector v)
  (vector 'pvect (make-mutex) v))

(define (pvector . args)
  (list->pvector args))

(define (list->pvector l)
  (wrap-vector-as-pvector (list->vector l)))

(define (pvector? obj) 
  (and (vector? obj)
       (> (vector-length obj) 0)
       (eq? (vector-ref obj 0) 'pvect)))

(define (pvector-length v)
  (vector-length (vector-ref v 2)))

(define (pvector-ref v i)
  (call-with-mutex (vector-ref v 1)
    (lambda ()
      (vector-ref (vector-ref v 2) i))))

(define (pvector-set! v i o) 
  (call-with-mutex (vector-ref v 1)
    (lambda ()
      (vector-set! (vector-ref v 2) i o))))

; eof





