
#include <stdio.h>
#include <stdlib.h>
#include "sage++user.h"

#define MAXTAGS 1000
static char *tag[MAXTAGS];
void initVariantNames(){
   for(int i = 0; i < MAXTAGS; i++) tag[i] = NULL;
#include "../h/tag.h"
}
void printVariantName(int i){
     if((i >= 0 && i < MAXTAGS) && tag[i]) printf("%s", tag[i]);
     else printf("not a known node variant");
}

void
ProjectUnparse(SgProject *project)
{
  for (int i = 0; i < project->numberOfFiles(); i++) {
    SgFile *f;
    
    f = &(project->file(i));
    printf("************** file %d in project ************\n",i);
    f->unparsestdout();
    printf("\n");
  }
}

// This routine creates a main program and inserts it in
// a blank file.
void create_a_main(SgFile *f){
  SgStatement *s = f->firstStatement();
  if(s == NULL) printf("no first statement\n");
  SgFuncHedrStmt *mane = new SgFuncHedrStmt("main");
  s->insertStmtAfter(*mane);
};

// This routine creates an array declaration and initializer 
// of the form
//   int x[][2]={1,2,3,4};
void declare_array(SgFile *f){
   SgStatement *s = f->firstStatement();
   SgStatement *mymain = f->mainProgram();
   SgArrayType *ar_type = new SgArrayType(*SgTypeInt());
   ar_type->addDimension(NULL);
   SgValueExp * texp = new SgValueExp(2);
   ar_type->addDimension(texp);
   SgSymbol * xsymb =new SgVariableSymb("x", *ar_type , *mymain);
   SgExpression *xref = new SgArrayRefExp(*xsymb);
   xref->setLhs(*(ar_type->getDimList()));
   SgExpression * one = new SgValueExp(1);
   SgExpression * two = new SgValueExp(2);
   SgExpression * three = new SgValueExp(3);
   SgExpression * four2 = new SgValueExp(4);
   SgExprListExp * ls = new SgExprListExp(*one);
   ls->append(*two);
   ls->append(*three);
   ls->append(*four2);
  SgExpression * in_ls = new SgInitListExp(*ls);
  SgExpression & aexp = SgAssignOp(*xref, *in_ls);
  SgExpression * as_ex = & aexp;
//  SgExpression * as_ex = &SgAssignOp(*xref, *in_ls);
  SgExpression * as_ex_ls = new SgExprListExp(*as_ex);
  SgStatement * ar_in = new SgVarDeclStmt(*as_ex_ls,*SgTypeInt()); 

  ar_in->setControlParent(*mymain);
  s->insertStmtAfter(*ar_in);

}	
	


int main(int argc, char **argv){

  SgProject project("x.proj");
  SgFile file(CSrc, "y.c");
  int c;

  initVariantNames();

  switch (file.languageType()) {
  case CSrc:
        create_a_main(&file);
        declare_array(&file);
        ProjectUnparse(&project);
        file.saveDepFile("y.dep");
	break;
  case ForSrc:
	printf("only works for C++ programs.\n");
	break;
  }
  return 0;
}
