///////////////////////////////////////////////////////////////////////////////////////
///////////////////////// Simple Exercice for Sage: Let's do a ////////////////////////
///////////////////////// simple parallelizer for KSR          ////////////////////////
///////////////////////// At least we are trying!!!!!!         ////////////////////////
///////////////////////////////////////////////////////////////////////////////////////


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "sage++user.h"
#include "depInterfaceExt.h"

FILE *finput;
FILE *outfile;
extern int Warning_count;
int NbLoopParallel = 0;
int NbLoopExamine = 0;


///////////////////////////////
// Reading Program Argument //
//////////////////////////////

// read the parameters value or check if here and return the value

 int
 isArgumentThere(char * s, int argc, char *argv[])
 {
   int i;
   for (i = 1 ; i<argc; i++)
     {
       if (strcmp(argv[i],s) == 0)
         { // we found the parameter 
           return(1);
         }
     }
   return(0);
 }

 int 
 getValueForArgument(char * s, int argc, char *argv[])
 {
   int i;

   for (i = 1 ; i<argc; i++)
     {
       if (strcmp(argv[i],s) == 0)
         { // we found the parameter 

           if (i+1<argc)
             return(atoi(argv[i+1]));
           else
             fprintf(stderr,"Argument value missing for %s\n",s);
           return(-1);
         }
     }
   return(-1);
 }

 char *
 getStringForArgument(char * s, int argc, char *argv[])
 {
   int i;

   for (i = 1 ; i<argc; i++)
     {
       if (strcmp(argv[i],s) == 0)
         { // we found the parameter 

           if (i+1<argc)
             return argv[i+1];
           else
             fprintf(stderr,"Argument value missing for %s\n",s);
           return(NULL);
         }
     }
   return(NULL);
 }

 ////////////////////////////////////////////////////////////////////////////////////
 // end for utilitary, we start here the program
 ////////////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////
// Attemp to parallize loops for the KSR1 machine (return one if success)
// loop is the outer loop
// if fails indicate in comments why.
//////////////////////////////////////////////////////////////////////////////////

int
parallelizeLoopForKSR(SgStatement *loop, depGraph *depg,int entryLevel)
{
  SgStatement *last, *temp, *nlast, *templast;
  int i;
  int parallel,Thereisprivate,Thereisreduction;
  depNode *datadep;
  char Cbuffer[1024];
  SgForStmt *doloop;
  int flagprivate = 0;
  if (!loop || ! depg)
    return 0;

  if (!(doloop = isSgForStmt(loop)))
    return 0;

  NbLoopExamine++;

  // first check there is no call to function inside the loop body //;
  if (isStmtCallToFuncNotIntrinsic(loop))
      {
        loop->addComment("C* Analysis Report: Not Parallel because of CALL TO NON INTRINSIC FUNCTION \n");
        return 0;
      }
  last = loop->lastNodeOfStmt();
  for (temp = loop; temp ; temp = temp->lexNext())
    {
      if (isSgCallStmt(temp))
        {
          loop->addComment("C* Analysis Report: Not Parallel because of CALL TO SUBROUTINE \n");
          return 0;
        }
      if (isSgGotoStmt(temp))
        {
          loop->addComment("C* Analysis Report: Not Parallel because of GOTO statement \n");
          return 0;
        }
      if ((temp != loop) && temp->hasLabel())
        {
          loop->addComment("C* Analysis Report: Not Parallel because of LABEL (will be less strict later)\n");
          return 0;
        }
      if (isSgStopOrPauseStmt(temp))
        {
          loop->addComment("C* Analysis Report: Not Parallel because of STOP statement\n");
          return 0;
        }
      if (isSgInputOutputStmt(temp) || isSgIOControlStmt(temp))
        {
          loop->addComment("C* Analysis Report: Not Parallel because of I/O STATEMENT \n");
          return 0;
        }
      if (temp == last)
        break;
    }
  // Now if something wrong in data dep //;
  for (datadep = depg->firstNode(); datadep; datadep = datadep->nextNode())
    {
      if (datadep->typedep == WRONGDEP)
        {
          loop->addComment("C* Analysis Report: something wrong in data dependence (INTERNAL error)\n");
          return 0;
        }
    }

  /////// NOW REALLY CHECK FOR PARRALELISM;
  if (entryLevel > 0)
    depg->redoScalarRefAnalysis(loop); 
  // Now check for scalar Datadep //;
  Thereisprivate = 0;  
  Thereisreduction = 0;
  for (datadep = depg->firstNode(); datadep; datadep = datadep->nextNode())
    {
      if (datadep->typedep == SCALARDEP)
        {
          // check that the write to the scalar does not belong by chance to the loop;
          // we are looking at;
          if (isWriteToSymbolInStatement(datadep->varin->symbol(), loop,depg))
            {
              sprintf(Cbuffer,"C* Analysis Report: Not Parallel because data dependence on SCALAR (%s)\n",
                      datadep->varin->symbol()->identifier());
              loop->addComment(Cbuffer);
              return 0;
            }
        }
      if (datadep->typedep == PRIVATEDEP)
        {
          if (isWriteToSymbolInStatement(datadep->varin->symbol(), loop,depg))
            Thereisprivate++;
        }
      if (datadep->typedep == REDUCTIONDEP)
        {
          if (isWriteToSymbolInStatement(datadep->varin->symbol(), loop,depg))
            Thereisreduction++;
        }
    }
  parallel = numberOfOuterParallelLoops(loop,depg,entryLevel);
  if (parallel < 1)
    {
      loop->addComment("C* Analysis Report: Not Parallel because data dependence on ARRAY\n");
      return 0;
    }
  if (parallel > doloop->isPerfectLoopNest())
    parallel = doloop->isPerfectLoopNest();

  /////// NOW ISSUE THE DIRECTIVES;
  temp = loop;
  sprintf(Cbuffer,"C*KSR* TILE (");
  for (i=0; i< parallel; i++)
    {
      if (doloop = isSgForStmt(temp))
        {
          strcat(Cbuffer,doloop->symbol()->identifier());
          if (i+1 <parallel)
            strcat(Cbuffer,",");
          templast = temp;
          temp = doloop->getNextLoop();
        }
    }
  // add the remaining index in the private list;
  if (templast)
    nlast = templast->lastNodeOfStmt();
  else 
    nlast = NULL;
  if (templast)
    templast = templast->lexNext();
  for (temp = templast; temp ; temp = temp->lexNext())
    {
      if (doloop = isSgForStmt(temp))
        {
          if (flagprivate)
            strcat(Cbuffer,",");
          if (!flagprivate)
            {
              strcat(Cbuffer,",\nC*KSR*& PRIVATE =(");
              flagprivate = 1;
            }
          strcat(Cbuffer,doloop->symbol()->identifier());
        }
      if (temp == nlast)
        break;
    }  

  if (Thereisprivate)
    {
      if (!flagprivate)
        {
          strcat(Cbuffer,",\nC*KSR*& PRIVATE =(");
          flagprivate = 1;
        } else
          strcat(Cbuffer,",");
      // add the private variable;
      for (datadep = depg->firstNode(); datadep; datadep = datadep->nextNode())
        {
          if (datadep->typedep == PRIVATEDEP)
            {
               if (isWriteToSymbolInStatement(datadep->varin->symbol(), loop,depg))
                 {
                   strcat(Cbuffer,datadep->varin->symbol()->identifier());
                   if (Thereisprivate > 1)
                     strcat(Cbuffer,",");
                   Thereisprivate--;
                 }
            }
        }
    }
  if (flagprivate)
    strcat(Cbuffer,")");

  if (Thereisreduction)
    {
      // add the private variable;
      strcat(Cbuffer,",\nC*KSR*& REDUCTION =(");
      for (datadep = depg->firstNode(); datadep; datadep = datadep->nextNode())
        {          
          if (datadep->typedep == REDUCTIONDEP)
            {
              if (isWriteToSymbolInStatement(datadep->varin->symbol(), loop,depg))
                {
                  strcat(Cbuffer,datadep->varin->symbol()->identifier());
                  if (Thereisreduction > 1)
                    strcat(Cbuffer,",");
                  Thereisreduction--;
                }
            }
        }
      strcat(Cbuffer,")");
    } 
  strcat(Cbuffer,")\n");
  loop->addComment(Cbuffer);
  // add the Tile end;
  if (last)
    last = last->lexNext();
  else
    Message("internal error in parallelizeLoopForKSR",0);
  if (last)
    last->addComment("C*KSR* ENDTILE\n");
  else
    Message("internal error in parallelizeLoopForKSR",0);
  NbLoopParallel++;
  return 1;
}

// attempt to find a  parallel loop nest..;
int 
  parallelizeLoopNestForKSR(SgStatement *loop, depGraph *depg, int  level)
{
  int i;
  int parallel;
  SgStatement *child;

  if (!loop)
    return FALSE;

  if (parallelizeLoopForKSR(loop,depg,level))
    return TRUE;
  
  parallel = FALSE;
  i = 1;
  child = loop->childList1(0);
  while (child)
    {
      if (isSgForStmt(child))
        {
          if (parallelizeLoopNestForKSR(child,depg,level+1))
            parallel= TRUE;
        }
      else
        {
          if (parallelizeLoopNestForKSR(child,depg,level))
            parallel= TRUE;
        }
      child = loop->childList1(i);
      i++;
    }
  i = 1;
  child = loop->childList2(0);
  while (child)
    {
      if (isSgForStmt(child))
        {
          if (parallelizeLoopNestForKSR(child,depg,level+1))
            parallel= TRUE;
        }
      else
        {
          if (parallelizeLoopNestForKSR(child,depg,level))
            parallel= TRUE;
        }
      child = loop->childList2(i);
      i++;
    }
  return parallel;
}


//////////////////////////////////////////////////////////////////////////////////
// main program
//////////////////////////////////////////////////////////////////////////////////
main(int argc,char **argv)
{
  SgProject *project;
  SgFile    *file;
  char *ifi, *ifo, *namefunc;
  SgForStmt *doloop;
  int i,j, nbfunc;
  SgStatement *func,  *temp, *last;
  depGraph *depg;

//
// read the parameter for the program
//
// input parameter
  ifi = getStringForArgument("-i",argc,argv);
  if (!ifi)
    {
      Message("Project Not Found (-i file.proj)",0);
      exit(1);
    }
  if (ifi)
    project =  new SgProject(ifi);
  file = &(project->file(0));
  if (!file)  
    {
      Message("file not found",0);
      exit(1);
    }
  // check this is Fortran file;
  if (file->languageType() != ForSrc)
    {
      Message("This is not a Fortran file; exiting",0);
      exit(1);
    }
  // make the data dep analysis;
  doDependenceAnalysisOnTheFullFile(file,0,0,0);
  nbfunc = file->numberOfFunctions();
  for (i=0; i<nbfunc; i++)
    {
      func = file->functions(i);
      if (func)
        {
          printf(" - %s\n",func->symbol()->identifier());

          if (!isThereEquivalenceStatement(func))
            {
              last = func->lastNodeOfStmt();
              for (temp = func ; temp && (temp!= last); temp = temp->lexNext())
                {
                  if (doloop = isSgForStmt(temp))
                    {
                      depg = (depGraph *) doloop->attributeValue(0,DEPGRAPH_ATTRIBUTE);
                      if (depg)
                        {
                          // do it for the outer loops, if fails we do it for the innermost loops;
                          parallelizeLoopNestForKSR(temp,depg,0);
                        }
                      else
                        Message("no data dependence graph found",temp->lineNumber());
                      // skip the loop;
                      temp = doloop->lastNodeOfStmt();
                    }
                }
            } else
              {
                func->addComment("C* Analysis Report: Equivalence Statement Prevents Parallelization\n");
              }
        }
    }

  // output the file;
  ifo = getStringForArgument("-o",argc,argv);
  if (ifo)
    {
      outfile = fopen(ifo,"w");
      if (outfile)
        {
          file->unparse(outfile);
        }
      else
        {
          Message("Cannot open output file; unparsing stdout",0);
          file->unparsestdout();
        }
    } else
      {
        file->unparsestdout();
      }

  printf("FOUND %d PARALLEL LOOPS OVER %d LOOPS FOUND\n",NbLoopParallel,NbLoopExamine);
  // print the warning count
    if (Warning_count > 1)
      fprintf(stderr,"There was %d warnings\n",Warning_count);
    else
      if (Warning_count)
        fprintf(stderr,"There was %d warning\n",Warning_count);
  exit(0);
}
