
///////////////////////////////////////////////////////////////////////////////////////
///////////////////////// Example Of Statements Manipulation   ///////////////////////
/////////////////////////             For  Sage                ////////////////////////
///////////////////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <stdlib.h>
#include "sage++user.h"

///////////////////////////////////////////////////////////////////////////////////////
////////////////////////// Some more declaration /////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////

FILE *finput;
FILE *outfile,*debugoutfile;

extern int Warning_count;
// old unparser used for printing structure of the program (obsolete)
extern "C" char *funparse_bfnd(...);

// which include files???
extern "C" void exit(int i);
extern "C" int atoi(char *);

///////////////////////////////
// Reading Program Argument //
//////////////////////////////

// read the parameters value or check if here and return the value

 int
 isArgumentThere(char * s, int argc, char *argv[])
 {
   int i;
   for (i = 1 ; i<argc; i++)
     {
       if (strcmp(argv[i],s) == 0)
         { // we found the parameter 
           return(1);
         }
     }
   return(0);
 }

 int 
 getValueForArgument(char * s, int argc, char *argv[])
 {
   int i;

   for (i = 1 ; i<argc; i++)
     {
       if (strcmp(argv[i],s) == 0)
         { // we found the parameter 

           if (i+1<argc)
             return(atoi(argv[i+1]));
           else
             fprintf(stderr,"Argument value missing for %s\n",s);
           return(-1);
         }
     }
   return(-1);
 }

 char *
 getStringForArgument(char * s, int argc, char *argv[])
 {
   int i;

   for (i = 1 ; i<argc; i++)
     {
       if (strcmp(argv[i],s) == 0)
         { // we found the parameter 

           if (i+1<argc)
             return argv[i+1];
           else
             fprintf(stderr,"Argument value missing for %s\n",s);
           return(NULL);
         }
     }
   return(NULL);
 }


 void 
 writeUsage()
 {
  fprintf(stderr,"usage:\n");
  fprintf(stderr,"stmtExample -i file.proj -o file.f\n");
 }

 void 
 printHelp()
 {
  fprintf(stderr,"help:\n");
  fprintf(stderr,"not yet available \n");
 }

 ////////////////////////////////////////////////////////////////////////////////////
 // end for utilitary, we start here the program
 ////////////////////////////////////////////////////////////////////////////////////


#define MAXTAGS 1000
static char *tag[MAXTAGS];
void initVariantNames(){
   for(int i = 0; i < MAXTAGS; i++) tag[i] = NULL;
#include "tag.h"
}

// print the structure of the stmt in the database;
void
printStructure(SgStatement *stmt, int level)
{
  SgStatement *child1, *child2,*tmp;
  int i,j;
  char *s;
  if (!stmt)
    return ;
  for (j = 0; j<level; j++) printf("   ");
  // we use the old unparser here (line to line unparse) but it is obsolete;
  s = funparse_bfnd(stmt->thebif);
  if (s)
    {
      for (i=0; i < strlen(s); i++)
        { // remove carriage return;
          if (s[i] == '\n')
            s[i] = ' ';
        }
      printf("%s(id=%d) %s\n",tag[stmt->variant()],stmt->id(),s);
    } else
      printf("%s(id=%d)\n",tag[stmt->variant()],stmt->id());
  if (stmt->numberOfChildrenList1())
    {
      for (i=0; i < stmt->numberOfChildrenList1(); i++)
        {
          tmp =  stmt->childList1(i);
          printStructure(tmp,level+1);
        }
    }
  if (stmt->numberOfChildrenList2())
    {
      for (i=0; i < stmt->numberOfChildrenList2(); i++)
        {
          tmp =  stmt->childList2(i);
          printStructure(tmp,level+1);
        }
    }
}

void
printSeqStructure(SgStatement *stmt)
{
  SgStatement *temp;
  temp = stmt;
  while(temp)
    {
      printf("%s(id=%d)\n",tag[temp->variant()],temp->id()); 
      if (temp->lexNext())
        {
          printf("    \\/lexNext()\n");
        }
      temp = temp->lexNext();
    }
}

//////////////////////////////////////////////////////////////////////////////////
  // Example: how to fusion the body of two loops
//////////////////////////////////////////////////////////////////////////////////

int
loopFusion(SgStatement *loop1,SgStatement *loop2)
{
  SgForStmt *doloop1;
  SgForStmt *doloop2;
  SgStatement *body,*last;
  
  printf("Entering in the loopFusion Function\n");
  // check that the parameters are right and cast the statement to be the;
  // the one of loops;
  if (!(doloop1 = isSgForStmt(loop1)))
     return 0;
  if (!(doloop2 = isSgForStmt(loop2)))
    return 0;  
  if (!doloop1->symbol())
    return 0;
  printf("\n\n\nreplacing the reference to symbol %s in the second loop by the one of the first loop (%s)\n",
         doloop2->symbol()->identifier(),doloop1->symbol()->identifier());
  printf("We are calling function  doloop2->replaceSymbByExp(*doloop1->symbol(),\n");
  printf("*(new SgVarRefExp(*doloop1->symbol())))\n");
  printf("Where the expression new SgVarRefExp(*doloop1->symbol()) create an reference to the symbol %s\n",
         doloop1->symbol()->identifier());
  doloop2->replaceSymbByExp(*doloop2->symbol(), *(new SgVarRefExp(*doloop1->symbol())));
  printf("here is the result of this operation\n");
  doloop2->unparsestdout();
  printf("\n\n\nNow we remove the body of the second loop by using\n");
  printf("body = doloop2->extractStmtBody()\n");
  printf("Here is the original structure of the loop\n");
  printStructure(doloop2,0);
  body = doloop2->extractStmtBody();
  printf("Here is the new structure of the loop\n");
  printStructure(doloop2,0);
  if (!body)
    return 0;
  printf("\n\n\nWe no get the last node of loop 1 doloop1->lastNodeOfStmt()");
  last = doloop1->lastNodeOfStmt();
  printf("Which gives: "); 
  printStructure(last,0);
  if (!last)
    return 0;
  printf("\n\n\nNow we take the node just before in lex order\n");
  last = last->nodeBefore();
  printf("Which gives: "); 
  printStructure(last,0);
  if (!last)
    return 0;
  printf("We no have the insertion point. Applying last->insertStmtAfter(*body,*doloop1)\n");
  printf(" LAST is where we  want to insert\n");
  printf(" BODY is the list of statement (EXTRACTED) we want to insert\n");
  printf(" DOLOOP1 is the controlParent we want for BODY\n");
  last->insertStmtAfter(*body,*doloop1);
  printf("Here is the new structure of the first\n");
  printStructure(doloop1,0);
  printf("\n\n\nWe still have to remove loop 2: doloop2->extractStmt()\n");
  doloop2->extractStmt();
  printf("\n\nTHE LOOP FUSION IS DONE\n\n");
  return 1;
}

//////////////////////////////////////////////////////////////////////////////////
// main program
//////////////////////////////////////////////////////////////////////////////////
main(int argc,char **argv)
{
  SgProject *project;
  SgFile    *file;
  char *ifi, *ifo;
  int i,j, nbfunc;
  SgStatement *func,*stmt,*last,*lastloopstmt,*followloop;
  SgForStmt *doloop;

//
// read the parameter for the program
//

  if (isArgumentThere("-help",argc,argv) ||
      isArgumentThere("-?",argc,argv) ||
      isArgumentThere("-H",argc,argv) ||
      isArgumentThere("-h",argc,argv))
    {
      printHelp();
    }
  printf("Starting reading file\n");
  ifi = getStringForArgument("-i",argc,argv);
  if (!ifi)
    {
      Message("no input files specified, trying test.proj",0);
      project =  new SgProject("test.proj");
      if (!project)
        {
          writeUsage();
          exit(1);
        }
    } else
      project =  new SgProject(ifi);
  file = &(project->file(0));
  if (!file)  
    {
      Message("file not found",0);
      exit(1);
    }
  // to print the tags names; initialize a table;
  initVariantNames();
  printf("End reading file\n");
  
  ////////////////////////////////////////////////////////////////////
  // Here the examples
  ////////////////////////////////////////////////////////////////////;
  
  //print the structure of the dep file;
  printf("Here is the program source by using unparsestdout():\n");
  file->unparsestdout();
  printf("\n");
  printf("Here is the structure of the program (tree structure):\n");
  printStructure(file->firstStatement(),0);
  printf("\n");
  printf("Here is the structure going through lexNext() (list structure):\n");
  printSeqStructure(file->firstStatement());
  printf("\n");
  // get the number of functions in the current file;
  nbfunc = file->numberOfFunctions();
  for (i=0; i<nbfunc; i++)
    {
      // get the SgStatement * corresponding to the function;
      func = file->functions(i);
      // print the name of the function;
      // to get the name first get the symbol corresponding to the function;
      // by using func->symbol(), then take the identifier of the symbol;
      // by func->symbol()->identifier();
      printf("Entering in function %s \n",func->symbol()->identifier());
      // get the last node of the function;
      last = func->lastNodeOfStmt();
      // going thru the statement of the function;
      for (stmt = func ; stmt && (stmt!= last); stmt = stmt->lexNext())
        {
          // loop if the statement is a doloop;
          if (doloop = isSgForStmt(stmt))
            {
              // get the last stmt in the loop;
              lastloopstmt = doloop->lastNodeOfStmt();
              // is it followed in the text by another loop;
              followloop = lastloopstmt->lexNext();
              // if yes call the fusion algorithm;
              if (isSgForStmt(followloop))
                {
                  printf("Calling the loop fusion function\n");
                  printf("The first loop is:\n");
                  doloop->unparsestdout();
                  printf("The second loop is:\n");
                  followloop->unparsestdout();
                  loopFusion(doloop,followloop);                  
                  printf("Here is the result of the fusion\n");
                  doloop->unparsestdout();
                  printf("Here is the structure of the new program:\n");
                  printStructure(file->firstStatement(),0);
                }
            }
        }
    }
  
  ////////////////////////////////////////////////////////////////////
  // output the file;
  ////////////////////////////////////////////////////////////////////
  ifo = getStringForArgument("-o",argc,argv);
  if (ifo)
    {
      outfile = fopen(ifo,"w");
      if (outfile)
        {
          file->unparse(outfile);
        }
      else
        {
          Message("Cannot open output file; unparsing stdout",0);
          file->unparsestdout();
        }
    } else
      printf("To get the result in a file do: stmtExample -o file.out\n");

  // print the warning count
    if (Warning_count > 1)
      fprintf(stderr,"There was %d warnings\n",Warning_count);
    else
      if (Warning_count)
        fprintf(stderr,"There was %d warning\n",Warning_count);
  exit(0);
}
