//////////////////////////////////////////////////////////////////////////
// To deals with the intrisics function call
//////////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "sage++user.h"
#include "definesValues.h"
#include "intrinsic.h"


// table for intrinsic;

char *intrinsicTable[INTRINSIC_LAST] = 
{  
  STRING_INTRINSIC_DUM,
  STRING_INTRINSIC_MAX,
  STRING_INTRINSIC_MIN,
  STRING_INTRINSIC_ABS,
  STRING_INTRINSIC_COS,  
  STRING_INTRINSIC_SIN,
  STRING_INTRINSIC_DFLOAT,
  STRING_INTRINSIC_FLOAT,
  STRING_INTRINSIC_NUMNODES,
  STRING_INTRINSIC_MYNODE,
  STRING_INTRINSIC_MOD,
  STRING_INTRINSIC_DEXP,
  STRING_INTRINSIC_DCOS,
  STRING_INTRINSIC_DSIN,
  STRING_INTRINSIC_ASIN,
  STRING_INTRINSIC_EXP,
  STRING_INTRINSIC_DBLE,
  STRING_INTRINSIC_LOG10,
  STRING_INTRINSIC_AINT,
  STRING_INTRINSIC_RANDLC,
  STRING_INTRINSIC_INT,
  STRING_INTRINSIC_SQRT,
  STRING_INTRINSIC_ATAN,
  STRING_INTRINSIC_LOG,
  STRING_INTRINSIC_ACOS,
  STRING_INTRINSIC_SIGN,
  STRING_INTRINSIC_REAL,
  STRING_INTRINSIC_DIM,
  STRING_INTRINSIC_CMPLX,
  STRING_INTRINSIC_AIMAG,
  STRING_INTRINSIC_DABS,
  STRING_INTRINSIC_KCCSHARED,
  STRING_INTRINSIC_GSYNC1,
  STRING_INTRINSIC_KCCPROCSEQNUM
  };

// return the ID; in the table;
int
isSymbolIntrinsic(SgSymbol *symb)
{
  int i;
  SgFunctionSymb *fs;
  char *ident;
  if (fs = isSgFunctionSymb(symb))
    {
      ident = fs->identifier();
      if (!ident)
         return FALSE;
      for (i=1 ; i < INTRINSIC_LAST; i++)
        {
          if (strcmp(ident, intrinsicTable[i]) == 0)
            return i;
        }
    }
  return FALSE;
}

int
isExprCallToFuncNotIntrinsic(SgExpression *exp)
{
  SgFunctionCallExp *fc;

  if (!exp)
    return FALSE;

  if (fc = isSgFunctionCallExp(exp))
    {
      if (!isSymbolIntrinsic(fc->funName()))
        return TRUE;
    }

  if (isExprCallToFuncNotIntrinsic(exp->lhs()))
    return TRUE;
  if (isExprCallToFuncNotIntrinsic(exp->rhs()))
     return TRUE;

  return FALSE;
}


int
isStmtCallToFuncNotIntrinsic(SgStatement *stmt)
{
  int i;
  SgStatement *child;

  if (!stmt)
    return FALSE;

  if (isExprCallToFuncNotIntrinsic(stmt->expr(0)))
    return TRUE;
  if (isExprCallToFuncNotIntrinsic(stmt->expr(1)))
    return TRUE;
  if (isExprCallToFuncNotIntrinsic(stmt->expr(2)))
    return TRUE;
  
  i = 1;
  child = stmt->childList1(0);
  while (child)
    {
      if (isStmtCallToFuncNotIntrinsic(child))
        return TRUE;
      child = stmt->childList1(i);
      i++;
    }
  i = 1;
  child = stmt->childList2(0);
  while (child)
    {
      if (isStmtCallToFuncNotIntrinsic(child))
        return TRUE;
      child = stmt->childList2(i);
      i++;
    }
  return FALSE;
}
