#include  "std.h"
#include  <stdio.h>
#include  "xstdio.h"
#include  "structs.h"
#include  "scan.h"
#include  "parse.h"
#include  "parse.tab.h"
#include  "scan.h"
#include  "strs.h"
#include  "ave_interf.h"
#include  "math.h"
#include  <sys/types.h>
#include  <sys/socket.h>
#include "abstract.h"
#include  <X11/Xlib.h>

#include  "Xm/Xm.h"
#include  "Xm/BulletinB.h"
#include  "Xm/CascadeB.h"
#include  "Xm/Form.h"
#include  "Xm/Frame.h"
#include  "Xm/Label.h"
#include  "Xm/List.h"
#include  "Xm/MainW.h"
#include  "Xm/MessageB.h"
#include  "Xm/PushB.h"
#include  "Xm/PushBG.h"
#include  "Xm/RowColumn.h"
#include  "Xm/ScrollBar.h"
#include  "Xm/ScrolledW.h"
#include  "Xm/SelectioB.h"
#include  "Xm/Separator.h"
#include  "Xm/DrawingA.h"
#include  "Xm/Text.h"
#include  "win.h"
#include "DrawingCanvas.h"



/*
 *******************************************************************
 * FUNCTION:     draw_line()                                       *
 * DESCRIPTION:  Given coordinates of two points, draws a line     *
 *               connecting the two.                               *
 * DESIGN:                                                         *
 * CALLER:       ave_draw_line_plot(), ave_draw_match_tree()       *
 *******************************************************************
*/



/*
 *******************************************************************
 * FUNCTION:     draw_line_plot()                                  *
 * DESCRIPTION:  called if user clicks on the Line Plot button     *
 * DESIGN:       + Clear the drawing canvas                        *
 *               + Walk through the RectData structure, and plot   *
 *******************************************************************
*/

int ave_draw_line_plot (Widget w, GC gc, RECT_DATA *rd, 
			int where_to_start_x, int x_shift)
{
  int x_position = where_to_start_x;

  if (rd == NULL)
    return;



  /* Rectangles are drawn with colors associated with the value */
  while (rd) {
    XSetForeground (XtDisplay(w), gc, ave_color[rd->color].pixel);
    XFillRectangle (XtDisplay(w), XtWindow(w), gc, x_position,
		    rd->height, 1, 1);

    /* Lines are drawn with the 0-th color */
    if (rd->next) {
      XSetForeground (XtDisplay(w), gc, ave_color[0].pixel);
      XDrawLine (XtDisplay(w), XtWindow(w), gc,
		 x_position, rd->height, 
		 x_position+x_shift, rd->next->height);
    }

    x_position += x_shift;
  }
  return x_position;  
}
    

/*
 *****************************************************************
 * FUNCTION:       ave_draw_scatter_plot()                       *
 * DESCRIPTION:    Draws individual scatter plots.               *
 * DESIGN:                                                       *
 * CALLER:                                                       *
 *****************************************************************
*/

int ave_draw_scatter_plot (Widget w, GC gc, RECT_DATA *rd, 
			    int x_shift, int y_shift)
{
  RECT_DATA *trd = rd;
  int count = 0;
  int colors_seen[MAX_ALLOWED_COLOR];

  if (rd == NULL)  /* sanity check */
    return;

  for (i=0; i<g_max_color; i++)
    colors_seen[i] = 0;

  /* count total number of points in the scatter plot */
  while (trd) {
    ++count;
    trd = trd->next;
  }
  
  max_col = get_max_column(count);
  max_row = ceil(((float) count)/((float) max_col));

  x_sep = g_scatter_plot_x_sep;
  y_sep = g_scatter_plot_y_sep;

  if (max_col < SCATTER_COLUMN_THRESHOLD) {
    width = height = SCATTER_DEFAULT_WIDTH;
  }
  else {
    width  = g_scatter_plot_max_y_dim/(2*max_col);
    height = g_scatter_plot_max_x_dim/(2*max_row);

    if (height < width)  /* make it square for aesthetic reasons */
      width = height;  
    else
      height = width;
  }

  while (rd) {
    XSetForeground (XtDisplay(w), gc, ave_color[rd->color].pixel);

    /* if we are seeing this color for the first time, we need to put it
       in the legend at the top of the scatter plot */
    if (colors_seen[rd->color] == 0) { 
      char tmp[10];
      colors_seen[rd->color] = 1;
      sprintf(tmp, "%d", rd->value);
      XFillRectangle 
	(XtDisplay(w), XtWindow(w), gc, x_shift + LEGEND_X_DEFAULT,
	 y_shift - LEGEND_Y_DEFAULT - rd->color*LEGEND_COLOR_DEFAULT,
	 tmp, strlen(tmp));
    }


    /* Now draw the actual rectangles making up the scatter plot */
    XFillRectangle 
      (XtDisplay(w), XtWindow(w), gc, x_shift + (x_sep+width)*rd->col_id,
       y_shift - (y_sep+height)*rd->row_id, width, height);
    rd = rd->next;
  }
  return (x_shift+ ((max_col+2)*(width+g_scatter_plot_x_sep)));
}


int ave_draw_category_statistics (Widget w, GC gc, RECT_DATA *rd, 
				   int x_shift, int y_shift)
{
  if (rd == NULL)   /* sanity check */
    return;

  while (rd) {
    char tmp[64];
    int x = x_shift + (g_ctg_stat_x_sep + g_ctg_stat_width)*rd->col_id;
    int y = y_shift - g_ctg_stat_y_sep - g_ctg_stat_height*rd->height;

    sprintf(tmp, "%d", rd->value);

    XSetForeground (XtDisplay(w), gc, ave_color[rd->color].pixel);
    XFillRectangle (XtDisplay(w), XtWindow(w), gc, x, y,
		    g_ctg_stat_width, g_ctg_stat_height*rd->height);
    XDrawString (XtDisplay(w), XtWindow(w), gc, x, y-20, stat, strlen(stat));
    rd = rd->next;
    ++cnt;
  }
  x_shift += (cnt+1)*g_ctg_stat_width;
  return x_shift;
}
