#include <stdio.h>
#include <strings.h>
#include "std.h"

/*
 *********************************************************************
 * FILE:          strs.c                                             *
 * PROGRAMMER:    Joydip Kundu (kundu@cs.umass.edu)                  *
 * ORGANIZATION:  University of Massachusetts, Amherst               *
 *                University of Oregon, Eugene                       *
 * FUNCTIONS:     + StrLen()                                         *
 *                + StrCat()                                         *
 *                + StrCmp()                                         *
 *                + StrCat()                                         *
 *                + StrAlloc( int len )                              *
 * NOTES:         SUN compiler does not like "str" functions passed  *
 *                a NULL argument. So we use these wrappers.         *
 *                DYNIX worked fine without the wrappers.            *
 *********************************************************************
*/

char *StrAlloc (int len)
{
  char *str = NULL;
  if (len == 0)
    return NULL;

  str = (char *) malloc (len);
  memset (str, '\0', len);
  return str;
}

  

int StrLen (const char *s)
{
  if (s == NULL)
    return 0;
  else
    return (strlen(s));
}

char *StrCat (char* dest, const char* src)
{
  if (src == NULL)
    return dest;
  else
    return (strcat(dest,src));
}

int StrCmp (const char* s, const char *t)
{
  if (s == NULL)
    return 1;

  if (t== NULL)
    return 1;

  return strcmp(s,t);
}

char *StrCpy (char *t, const char *s)
{
  int len_s = StrLen(s);

  if (len_s == 0) {
    t[0] = '\0';
    return;
  }
  return strcpy (t,s);
}
    
