#include  "std.h"
#include  <stdio.h>
#include  "xstdio.h"
#include  "structs.h"
#include  "scan.h"
#include  "parse.h"
#include  "parse.tab.h"
#include  "scan.h"
#include  "strs.h"
#include  "ave_interf.h"
#include  "math.h"
#include  <sys/types.h>
#include  <sys/socket.h>
#include "abstract.h"
#include "default.h"
#include "global.h"
#include  <X11/Xlib.h>

#include  "Xm/Xm.h"
#include  "Xm/BulletinB.h"
#include  "Xm/CascadeB.h"
#include  "Xm/Form.h"
#include  "Xm/Frame.h"
#include  "Xm/Label.h"
#include  "Xm/List.h"
#include  "Xm/MainW.h"
#include  "Xm/MessageB.h"
#include  "Xm/PushB.h"
#include  "Xm/PushBG.h"
#include  "Xm/RowColumn.h"
#include  "Xm/Scale.h"
#include  "Xm/ScrollBar.h"
#include  "Xm/ScrolledW.h"
#include  "Xm/SelectioB.h"
#include  "Xm/Separator.h"
#include  "Xm/DrawingA.h"
#include  "Xm/Text.h"
#include  "win.h"
#include "DrawingCanvas.h"
#include "plot1.h"

extern ABSTRACT_EVENT *get_root_of_tree (ABSTRACT_EVENT *ae);
extern void Collapsed_cb_select (Widget w, caddr_t call_data, caddr_t client_data);
extern void build_widget_list (ABSTRACT_EVENT *ae, int thru_part);
extern ABSTRACT_EVENT *GSelectAbstractEvent;
extern COLLAPSE_NODE  *GSelectCollapseNode;
extern XColor ave_color[MAX_COLOR];
extern WIDGET_INFO *allocate_winfo();
extern Widget query_canvas;
void handle_collapse_slider (Widget w, caddr_t call_data, caddr_t client_data)
{
}

ABSTRACT_EVENT *get_parent_abstract_event (COLLAPSE_NODE *cn)
{
  if (cn == NULL) {
    printf("get_parent_abstract_event(): passed NULL pointer!\n");
    return NULL;
  }
  if (cn->pae)
    return cn->pae;
  return get_parent_abstract_event (cn->parent);
}
    
/*
 ********************************************************************
 * FUNCTION:     get_named_partition()
 * DESCRIPTION:  Given a collapse_node pointer, and a name, returns 
 *               the collapse_node corresponding to the named part-'
 *               ition, if it exists. NULL otherwise.
 *
 * CALLER:       + view_abstract_event_thru_named_part()
 *               + view_collapse_node_thru_named_part()
 ********************************************************************
*/

COLLAPSE_NODE *get_named_partition (COLLAPSE_NODE *cn, char *name)
{
  COLLAPSE_NODE *result;
  if (cn == NULL)  /* sanity check */
    return NULL;

  if (!StrCmp(cn->pattern, name))
    return cn;

  result = get_named_partition (cn->next, name);
  if (result)
    return result;

  result = get_named_partition (cn->down, name);
  return result;
}

extern void ave_unmark_nodes (ABSTRACT_EVENT *ae);
/*
 ***********************************************************************
 * FUNCTION:       ave_unmark_slide_clps()                             *
 * DESCRITION:     Unmarks slider nodes reachable through default tree.*
 * DESIGN:                                                             *
 * CALLER:         ave_unmark_node()                                   *
 * NOTES:                                                              *
 ***********************************************************************
*/

void ave_unmark_slide_clps (SLIDE_COLLAPSE_NODE *scn) 
{
  if (scn->ave->draw_flag && scn->winfo)
    XtUnmanageChild (scn->winfo->w);
  scn->ave->draw_flag = 0;
  ave_unmark_nodes(scn->next);
}

/*
 ***********************************************************************
 * FUNCTION:       ave_unmark_clps()                                   *
 * DESCRITION:     Unmarks all collapse nodes reachable from the given *
 *                 collapse node (children and sibling)                *
 * DESIGN:                                                             *
 * CALLER:         ave_unmark_node()                                   *
 * NOTES:          Recursive                                           *
 ***********************************************************************
*/

void ave_unmark_clps (COLLAPSE_NODE *cn)
{
  if (cn == NULL)
    return;
  if (cn->ave->draw_flag && cn->winfo)
    XtUnmanageChild (cn->winfo->w);
  cn->ave->draw_flag = 0;
  ave_unmark_clps (cn->down);
  ave_unmark_clps (cn->next);
  return;
}

/*
 **************************************************************************
 * FUNCTION:      ave_unmark_nodes()                                      *
 * DESCRIPTION:   The default marking of nodes, follow the matching order *
 *                However, when they are displayed through the structural *
 *                filter of equivalence classes (or partitions wrt an     *
 *                attribute), the matching order is no longer preserved.  *
 *                So we unmark all the nodes below the "select"ed node,   *
 *                and mark them anew -- this time through the partitions. *
 *                If this looks confusing, you can always send mail to    *
 *                Usenet Oracle (I did). Or you can read   the  Ariadne   *
 *                manual (if and when it is ready) where this will be     *
 *                discussed in detail.                                    *
 **************************************************************************
*/

void ave_unmark_nodes (ABSTRACT_EVENT *ae) 
{
  if (ae == NULL)       /* sanity check */
    return;

  if (ae->ave) {
    if (ae->ave->draw_flag && ae->winfo)
      XtUnmanageChild (ae->winfo->w);
    ae->ave->draw_flag = 0;
  }
  else {
    printf("PANIC: Abstract Event at %x has ae->ave = NULL\n", ae);
    return;
  }
  
  if (ae->slide_clps)
    ave_unmark_slide_clps (ae->slide_clps);
  else
    ave_unmark_nodes (ae->next);
  
  if (ae->clps)
    ave_unmark_clps (ae->clps);
  else
    ave_unmark_nodes (ae->down);
  return;
}


/*
 ***********************************************************************
 * FUNCTION:      swap_clps_under_ae()                                 *
 * DESCRITION:    An abstract event may have different partitions. So  *
 *                need to bring the named partition at the front of the*
 *                partition list.                                      *
 * DESIGN:                                                             *
 * CALLER:        view_abstract_event_thru_part()                      *
 * NOTES:                                                              *
 ***********************************************************************
*/

void swap_clps_under_ae (ABSTRACT_EVENT *ae, COLLAPSE_NODE *cn)
{
  COLLAPSE_NODE *tmp = ae->clps;

  if (cn == ae->clps)
    return;

  /* "tmp" points to a collapse node prior to "cn" */
  while (tmp->next != cn)
    tmp = tmp->next;

  tmp->next = cn->next;
  cn->next = ae->clps;
  ae->clps = cn;
  return;
}


/*
 ***********************************************************************
 * FUNCTION:      swap_clps_under_clps()                               *
 * DESCRITION:    An collapse node  may have different partitions. So  *
 *                need to bring the named partition at the front of the*
 *                partition list.                                      *
 * DESIGN:                                                             *
 * CALLER:        view_collapse_node_thru_part()                       *
 * NOTES:                                                              *
 ***********************************************************************
*/
void swap_clps_under_clps (COLLAPSE_NODE *pcn, COLLAPSE_NODE *ccn)
{
  COLLAPSE_NODE *tmp = pcn->down;
  if (ccn == pcn->down)
    return;
  
  while (tmp->next != ccn)
    tmp = tmp->next;

  tmp->next = ccn->next;
  ccn->next = pcn->down;
  pcn->down = ccn;
  return;
}

void ave_mark_nodes_view_part (ABSTRACT_EVENT *ae, int propagate)
{
  if (ae == NULL)
    return;
  
  printf("ave_mark_nodes: %s\n", ae->name);
  if (ae->ave)
    ae->ave->draw_flag = 1;
  
  if (propagate)
    ave_mark_nodes_view_part (ae->next, 1);

  ave_mark_nodes_view_part (ae->down, 1);
}

int is_default_clps_my_sibling (COLLAPSE_NODE *cn)
{
  if (cn == NULL)
    return 0;
  while (cn) {
    if (!StrCmp(cn->pattern, "default"))
      return 1;
    cn = cn->next;
  }
  return 0;
}


/*
 ***********************************************************************
 * FUNCTION:
 * DESCRITION:
 * DESIGN:
 * CALLER:
 * NOTES:
 ***********************************************************************
*/

void ave_mark_clps_view_part (COLLAPSE_NODE *cn, int def)
{
  if (cn == NULL)        /* sanity check */
    return;
  
  cn->ave->draw_flag = 1;
  
  ave_mark_clps_view_part (cn->down, def);

  if (cn->ael) {
    if (!def) {
      if (cn->scn) {     /* Do we have a slider? */
	ave_mark_nodes_view_part (cn->scn->prev, 0);
	build_slide_clps (cn->scn, (XtEventHandler) handle_collapse_slider);
	ave_mark_nodes_view_part (cn->scn->next, 0);
      }
      else {      /* Mark each node in the list */
	int size = get_size_of_list ((LINKED_LIST *) cn->ael);
	int i;
	for (i=0; i<size; i++) {
	  ABSTRACT_EVENT *ae =
	    (ABSTRACT_EVENT *) get_element_from_list ((LINKED_LIST *) cn->ael, i);
	  printf("ae selected %x, i = %d\n", ae, i);
	  ave_mark_nodes_view_part (ae, 0);
	}
      }
    }
    ave_mark_clps_view_part (cn->next, def);
  }
  return;
}


void build_clps_widget_view_part (COLLAPSE_NODE *cn)
{
  int n;
  Arg args[10];

  if (cn == NULL)
    return;

  /* Allocate a widget info structure */
  if (cn->winfo == NULL && (cn->ave->draw_flag == 1) ) {
    cn->winfo = allocate_winfo();

    n = 0;
    XtSetArg (args[n], XmNx, XSCALE_BUTTON*cn->ave->x - 10); n++;
    XtSetArg (args[n], XmNy, YSCALE_BUTTON*cn->ave->y); n++;
    XtSetArg (args[n], XmNforeground, ave_color[g_color_collapsed].pixel); n++;
    cn->winfo->w = 
      XmCreatePushButton (query_canvas, cn->pattern, args, n);
    XtAddCallback (cn->winfo->w, XmNactivateCallback, 
		   (XtCallbackProc) Collapsed_cb_select, NULL);
    XtVaSetValues (cn->winfo->w, XmNuserData, (void *) cn, NULL);
  }

  if (cn->ael) {
    if (cn->scn) {
      build_widget_list (cn->scn->prev, 0);
      build_widget_list (cn->scn->next, 0);
    }
    else {
      int size = get_size_of_list ((LINKED_LIST *) cn->ael);
      int i;
      for (i=0; i<size; i++) {
	ABSTRACT_EVENT *ae = 
	  (ABSTRACT_EVENT *) get_element_from_list ((LINKED_LIST *) cn->ael, i);
	build_widget_list (ae, 0);
      }
    }
    build_clps_widget_view_part (cn->next);
  }
  build_clps_widget_view_part (cn->down);
}
    

  
extern void init_coordinate();
extern void change_widget_coord (ABSTRACT_EVENT *ae);
extern void ave_calc_line (ABSTRACT_EVENT *ae);
extern void ave_free_line ();
extern GC GCanvasGC[2];
extern LINE_DATA *GLines2Draw;

void ave_calc_line_clps (COLLAPSE_NODE *cn)
{
  if (cn == NULL)
    return;
  if (cn->ave->draw_flag) {
    if (cn->pae)
      add_to_line_list (cn->ave, cn->pae->ave);
    else 
      add_to_line_list (cn->ave, cn->parent->ave);
  }
  if (cn->ael)
    ave_calc_line_clps(cn->next);

  ave_calc_line_clps (cn->down);
  
}

void ave_calc_line_view (ABSTRACT_EVENT *ae)
{
  if (ae == NULL)
    return;
  if (ae->ave->draw_flag) {
    if (ae->parent)
      add_to_line_list 	(ae->ave, ae->parent->ave);
    if (ae->clps)
      ave_calc_line_clps(ae->clps);
    else
      ave_calc_line_view (ae->down);
  }
  if (ae->slide_clps)
    ave_calc_line_slide (ae->slide_clps);
  else
    ave_calc_line_view(ae->next);
}
  

void view_abstract_event_thru_named_part (ABSTRACT_EVENT *ae, char *name)
{
  COLLAPSE_NODE *cn = get_named_partition (ae->clps, name);
  ABSTRACT_EVENT *root = get_root_of_tree (ae);
  int def = 0;
  ave_unmark_clps (ae->clps);
  ave_unmark_nodes(ae->down);
  swap_clps_under_ae (ae, cn);
  printf("view_abstract_event: about to mark clps_view_part\n");
  def = is_default_clps_my_sibling(cn);
  ave_mark_clps_view_part (cn, def);
  build_clps_widget_view_part (cn);
  init_coordinate();
  ave_calc_coord(root, 1);
  change_widget_coord (root);
  ave_free_line();
  ave_calc_line_view(root);
  ave_draw_line (query_canvas, GCanvasGC[0], GLines2Draw);
  printf("view_abstract_event: about to draw tree\n");
  ave_draw_tree (root, 1);
}


void view_collapse_node_thru_named_part (COLLAPSE_NODE *pcn, char *name)
{
  COLLAPSE_NODE *cn  = get_named_partition (pcn, name);
  ABSTRACT_EVENT *ae = get_parent_abstract_event (pcn);
  ABSTRACT_EVENT *root = get_root_of_tree (ae);
  printf("view_collapsed: came here\n");

  ave_unmark_clps (pcn);
  ave_mark_clps_view_part (pcn, 0);
  ave_calc_coord (root, 1);
  build_clps_widget_view_part (pcn);
  ave_draw_tree (root, 1);
}

/*
 **************************************************************************
 * FUNCTION:      view_node_through_named_partition()                     *
 * DESCRIPTION:   "VIEW select THRU partition"                            *
 *                where partition is the name of the partition.           *
 **************************************************************************
*/

void view_node_through_named_partition (IDENT *id, char *name)
{
  COLLAPSE_NODE *cn;
  if (!StrCmp(id->id_chars,"select")) {
    ABSTRACT_EVENT *ae = get_select_abstract_event();
    COLLAPSE_NODE  *cn = get_select_collapse_node();
    if (ae)
      view_abstract_event_thru_named_part (ae, name);
    else
      view_collapse_node_thru_named_part (cn, name);
    return;
  }

  /* there should be an else clause here */
}
    
  
  
  
