#include <stdio.h>
#include "strs.h"
#include "defs.h"
#include "common.h"
#include <stdlib.h>


#define MAX_TAGS   2000
FILE *fp_trace, *fp_map, *fp_out;
typedef struct tag_map {
  int  msg_type;      /* paragon's msg_type */
  char event_tag[MSG_TYPE_SIZE];
} TAG_MAP;


TAG_MAP user_tags[MAX_TAGS];
static int current_node = -1;


initialize_tag_database()
{
  int cnt = 0;
  int i;
  int msg_type;
  char tag[MSG_TYPE_SIZE];

  /* init of tags */
  for (i=0; i<MAX_TAGS; i++) {
    user_tags[i].msg_type = -1;
    user_tags[i].event_tag[0] = '\0';
  }


  while (fscanf(fp_map, "%d %s\n", &msg_type, &tag) != -1) {
    user_tags[cnt].msg_type = msg_type;
    sprintf(user_tags[cnt].event_tag,"%s", tag);
    cnt++;
  }
}

char *get_user_tag (int msg_type)
{
  int i;
  for (i=0; i<MAX_TAGS; i++) {
    if (user_tags[i].event_tag == NULL)
      return NULL;
    if (user_tags[i].msg_type == msg_type)
      return user_tags[i].event_tag;
  }
  return NULL;
}
  

int get_msg_type (char *event_tag)
{
  int i;
  for (i=0; i<MAX_TAGS; i++) {
    if (user_tags[i].event_tag == NULL)
      return AA_UNDEFINED;
    if ( !StrCmp(user_tags[i].event_tag, event_tag))
      return user_tags[i].msg_type;
  }
  return AA_UNDEFINED;
}


void convert_paragon_ave(char *file_prefix, int file_count)
{
  int myid, otherid, msg_type, size, bpoint, extra;
  int msg_rw;
  char *event_tag;
  int i;

  for (i=0; i<file_count; i++) {
    char fname[64];
    sprintf(fname,"%s%d", file_prefix, i);
    fp_trace = fopen(fname, "r");

    while (fscanf(fp_trace,"%d %d %d %d %d %d %d\n", &myid, &otherid, &msg_rw,
		  &msg_type, &size, &bpoint, &extra) != -1) {
      
      event_tag = get_user_tag (msg_type);

      if (msg_rw == AA_SEND)
	fprintf (fp_out, "%d %d W %s %d %d %d", myid, otherid, 
		 event_tag, size, bpoint, extra);
      else if (msg_rw == AA_RECEIVE)
	fprintf (fp_out, "%d %d R %s %d %d %d", myid, otherid, 
		 event_tag, size, bpoint, extra);
      else if (msg_rw == AA_MCAST)
	fprintf (fp_out, "%d %d M %s %d %d %d", myid, otherid, 
		 event_tag, size, bpoint, extra);

      while (extra) {
	int tmp;
	fscanf(fp_trace, "%d", &tmp);
	fprintf(fp_out, "%d ", tmp);
	--extra;
      }
      fprintf(fp_out, "\n");
    }
    fclose(fp_trace);
  }
}


main(int argc, char **argv)
{
  int i;
  int msg_type;
  char tag[80];
  int cnt = 0;

  if (argc < 5) {
    printf("usage: pgon2ave <tag_map_file> <trace_file_prefix> <trace_file_count>  <outfile> \n");
    exit(0);
  }

  fp_map = fopen(argv[1], "r");
  fp_out = fopen(argv[4], "w");
  fprintf(fp_out, "%d %d\n", FORMAT_VERSION, atoi(argv[3])+1);
  initialize_tag_database();
  convert_paragon_ave (argv[2], atoi(argv[3]));
  fclose(fp_map);
  fclose(fp_out);
  
}
