//
// Darryl Brown 
// March, 94
// Sage utilities
//
// sageUtils.h

SgType *extractBaseType(SgType *ty);

SgExpression *addFunctionToClass(SgClassStmt *cs, 
				 SgType *funcType, 
				 char *funcName, 
				 int status);

SgExpression *addParamToFuncExp(SgExpression *fs, SgSymbol *vs);

SgFuncHedrStmt  *buildFuncDefStmt(char *funcName, SgType *funcType);

SgExpression *addParamToFuncStmt(char *paramName, SgType *varType, 
				 SgStatement *fhs);

SgExpression *addParamToFuncCall(char *paramName, SgType *varType, 
				 SgStatement *fhs);

SgSymbol *declareVarInFunc(SgStatement *fhs, SgType *vt, char *vname);

SgExpression *extractFuncExpFromHedr(SgStatement *fhs);

SgType *buildArrayType(int numDims, int *dimSizes, 
		       SgType *baseType);

SgType *buildDerivedCollectionType(SgType *elementType, char *collName,
				   SgType *collType);

SgExpression *buildAssignExp(SgExpression *lhs, SgExpression *rhs);

SgStatement *buildAssignStmt(SgExpression *lhs, 
      SgExpression *rhs);

SgExpression *buildCastExp(SgSymbol *s, SgType *ty);

SgStatement *composeCastAssignStatement(SgSymbol *lhs, SgSymbol *rhs);

SgSymbol *findCollectionSymbol(char *cname, SgFile *f);

SgExpression *buildDerefExp(SgSymbol *sy);

SgExpression *buildCollGetElemExp(SgExpression *collExp, SgExpression *elemNum);

SgStatement *buildFuncCallStmt(char *funcName, SgFile *f);

SgExpression *buildFuncCallExp(char *funcName, SgFile *f);

SgSymbol *findFunctionSymb(char *fname, SgFile *f);

SgSymbol *isFuncDeclStmt(SgStatement *st);

SgExpression *addParamExpToFuncExp(SgExpression *fs, SgExpression *vexp);

SgSymbol *findVarDeclSymbFromStmt(char *fname, SgStatement *stmp);

SgStatement *findVarDeclStmt(char *fname, SgStatement *stmp);

SgSymbol *findVarDeclSymb(char *fname, SgFile *f);


//   find variable declaration of a given name beginning from given
//   statement;
SgStatement *findDefStmt(char *fname, 
			     SgStatement *stmp);


//   find variable declaration symbol of a given name beginning from given
//   statement;
SgSymbol *findDefSymbFromStmt(char *fname, 
			      SgStatement *stmp);


// find a the first variable declaration of a given name in;
// a file;
SgSymbol *findDefSymb (char *fname, SgFile *f);



SgStatement *findCompDeclStmt(char *cname, SgFile *f);

SgSymbol *searchForParamInFuncStmt(SgStatement *fs, char *pname);

SgSymbol *extractParamIFromFuncStmt(SgStatement *fs, int paramNum);

SgStatement *buildFuncDefFromSymb(SgSymbol *symb);

SgStatement *lastExecutableOfBlock(SgStatement *st);

SgExpression *buildMembFuncCallExpOfExp(SgSymbol *cvar, 
					SgExpression *fce);

SgExpression *buildMembFuncCallExp(char *className, char *membName, 
				   SgFile *f, SgSymbol *cvar);

// build a function call statement;
SgStatement *buildMembFuncCallStmt(char *className, char *membName, 
				   SgFile *f, SgSymbol *cvar);

SgExpression *buildThisMembCallExp(char *className, char *membName, 
				   SgFile *f);

SgStatement *buildThisMembCallStmt(char *className, char *membName, 
				   SgFile *f);

SgType *buildDerivedType(char *sName, SgFile *f);

SgStatement *lastGlobalStatement(SgFile *f);

SgStatement *lastStatement(SgFile *f);

void addFuncDeclToSymb(SgStatement *fhdr, SgSymbol *fsymb);

SgStatement *findFuncHedrStmt(char *fname, SgFile *f) ;

SgStatement *buildForStmt(int start, int end, SgSymbol *loopvar,
			  SgStatement *body);

char *unparseExp(SgExpression *e);

int evalStr(char *expStr);

int evalExp(SgExpression *e);

SgType *dupType(SgType *ty);

/* // finds a member of a given class */
SgSymbol *findMemb(char *className, char *membName, 
		   SgFile *f);

int sameType(char *tname, SgType *ty);
SgType *findUserType(char *tName, SgFile *f);

/* returns the last lexical statement with given control parent cp */
SgStatement *lastStatementWithControlParent(SgStatement *cp);


int funcDefinedInClass(SgStatement *clhdr, char *fname);
