# -----------------------------------------
#
#  Darryl Brown
#  April 1994
#
#  parser(s) for breakpoint types
#  
#
# -----------------------------------------


set Collections "";
set Classes "";
set Structs "";

#  --------------------------------------------------------------


proc readInFieldsFromFile {fd} {

  set fieldFormat { #type# %[^#] #field# %[^ \n]}
  set fieldlist "";

  while {![eof $fd]} {
    gets $fd line;
    if {[scan $line $fieldFormat typestr fieldstr]} {
      lappend fieldlist [list $fieldstr $typestr];
    } else {
      break;
    }
  }


  return $fieldlist;
}
    
#  --------------------------------------------------------------


proc parseTypesFromFile {fd} {
  global Collections;
  global Classes;
  global Structs;
  
  set collectFormat1 { Collection %[^>] < %[^>] > ( %[^)] )};
  set collectFormat2 { Collection %[^<] < > ( %[^)] )};
  set classFormat { class %[^(] ( %[^)] )};
  set structFormat { struct %[^( \n] };
  gets $fd line;
  while {![eof $fd]} {
    if {([set num [scan $line $collectFormat1 coll elemtype parents]] > 1) ||
	  ([set num [scan $line $collectFormat2 coll parents]] >= 1)} {
	    if {$num == 2} {
	      set fields [readInFieldsFromFile $fd];
	      lappend Collections [concat $coll [list $parents] \
				   [list $fields]];
	    }
	    if {$num == 3} {
	      set fields [readInFieldsFromFile $fd];
	      lappend Collections [concat $coll \
				   " < " $elemtype " > " \
				   [list $parents] \
				   [list $fields]];
	    }
	    set parents "";
	  } 
    
    if {([set num [scan $line $classFormat class parents]] > 0)} {
      if {$num > 0} {
	set fields [readInFieldsFromFile $fd];
	lappend Classes [concat $class [list $parents] \
			 [list $fields]];
      }
      set parents "";
    } 

    if {([set num [scan $line $structFormat struct]] == 1)} {
      if {$num == 1} {
	set fields [readInFieldsFromFile $fd];
	lappend Structs [concat $struct [list $fields]];
      }
    }
    
    gets $fd line;
  }
}

#  --------------------------------------------------------------

set strPointer 0;
set strLength 0;

proc readInFieldsFromStr {str} {
  set fieldFormat [format " ( %%\[^ \] %%\[^)\] ) "];
  set fieldlist "";

  while {[scan $str $fieldFormat fieldstr typestr] == 2} {
    # grab next field;
    set ind1 [string first ")" $str];
    set str [string range $str [expr $ind1+1] end];
    puts "looking at field $fieldstr and type $typestr"
    lappend fieldlist [list $fieldstr $typestr];
  }

  puts "all fields: $fieldlist"
  return $fieldlist;
}
    
#  --------------------------------------------------------------

set Elements "";
proc parseTypesFromStr {str} {
  global Collections;
  global Classes;
  global Structs;
  global strPointer;
  global strLength;

  set parents "";	  
  # construct the regular expression for all chars except a newline;
  set rexp [format "\[^\n\]*\n"];
  #set up formats for scan-ning
  set collectFormat1 { Collection %[^>] < %[^>] > ( %[^)] )};
  set collectFormat2 { Collection %[^<] < > ( %[^)] )};
  set classFormat { class %[^(] ( %[^)] )};
  set structFormat { struct %[^( \n] };
  #set up global vals for string pointer/length
  set strPointer $str;
  set strLength [string length $str];
	
  puts stdout "parsing type $str"
  while {[regexp -indices $rexp $strPointer ind] } {

    set line [string range $strPointer [lindex $ind 0] [lindex $ind 1]];

    flush stdout
    set strPointer [string range $strPointer [expr [lindex $ind 1]+1] end] ;
    puts "looking at $line"
    puts "Whats left:t $strPointer"

    # check to see if it is a collection...      
    if {([set num [scan $line $collectFormat1 coll elemtype parents]] > 1) ||
	  ([set num [scan $line $collectFormat2 coll parents]] >= 1)} {
	    
	    if {$num == 2} {
	      set fields [readInFieldsFromStr $line];
	      lappend Collections [concat $coll [list $parents] \
				   [list $fields]];
	    }
	    if {$num == 3} {
	      set fields [readInFieldsFromStr $line];
	      lappend Collections [concat $coll \
				   " < " $elemtype " > " \
				   [list $parents] \
				   [list $fields]];
	    }
	    set parents "";
	  } 
    
    # check to see if it is a class...
    puts "checking for a class $line"
    if {([set num [scan $line $classFormat class parents]] > 0)} {
	puts "class $class parents $parents"
      if {$num > 0} {
	# now name is in class and all parent names are in parents  

	# retreive the part of the line that lists the fields
	set ind1 [string first "{" $line];
	set ind2 [string last "}" $line];
	set line [string range $line [expr $ind1+1] [expr $ind2-1]]

	puts "matched fields: $line"

	set fields [readInFieldsFromStr $line];
	lappend Classes [concat $class [list $parents] \
			 [list $fields]];
	lappend Elements [concat $class [list $parents] \
			 [list $fields]];
      } else {
	  puts "no class"
      }

      set parents "";
    } 

    # check to see if it is a struct...
    if {([set num [scan $line $structFormat struct]] == 1)} {
      if {$num == 1} {
	set fields [readInFieldsFromStr $str];
	lappend Structs [concat $struct [list $fields]];
      }
    }

  }
}

