#define UNKNOWN_TAG -1

#define PU_HEAD_START 0
#define PU_HEAD_END   1
#define PU_BODY_START 2
#define PU_BODY_END   3
#define PU_MAX        4

typedef struct child_list     /* list of children functions */
   { struct func_list *func;  /* pointer to child func record */
     int line;                /* position of function call */
     int start;
     int end;
     struct child_list *next; /* link */
   } Child_List;

typedef struct func_list        /* list of functions */
   { char *name;                /* function name */
     int tag;                   /* unique id */
     int *lines;                /* linenumbers or 0 */
     int *pos;                  /* positions - stmtfunc only */
     char *file;                /* filename */
     Child_List *calls;         /* children information */
     int numcalled;             /* number of calls of this function */
     struct func_list *scope;   /* pointer to parent or 0 */
     struct func_list *next;    /* link */
   } Func_List;

extern void write_pdb_file(char *filename, char *arg1);
extern Func_List *get_function(char *funcname,int tag,Func_List *scope);
