
# line 2 "readcomfile.y"

# include <stdio.h>
# include "regexp.h"
# include "instr.h"

/* We may use builtin alloca */
#include "compatible.h"
#ifdef _NEEDALLOCAH_
#  include <alloca.h>
#endif

static char *comfile;             /* name of command file        */
static char *errstring;           /* token that caused the error */
static int lineno  = 0;           /* input linenumber            */
static FILE *infile;              /* input filepointer           */
static int noError = TRUE;        /* input error indicator       */

extern void addCommand (int command, REXP *file, REXP *class, REXP *func);


# line 23 "readcomfile.y"
typedef union 
{
  struct
  {
    char *string;
    int   num;
  }
  term;

  struct
  {
    REXP *file;
    REXP *class;
    REXP *func;
  }
  nonterm;

  REXP *rexp;

  LIMIT lmt;
} YYSTYPE;
#ifdef __cplusplus
#  include <stdio.h>
   extern "C" {
     extern void yyerror(char *);
     extern int yylex();
   }
#endif	/* __cplusplus */ 
# define T_AND 257
# define T_CHILDREN 258
# define T_CLASS 259
# define T_COUNT 260
# define T_EXCLUDE 261
# define T_FILE 262
# define T_FUNCTION 263
# define T_INCLUDE 264
# define T_INLINE 265
# define T_LEVEL 266
# define T_ONLY 267
# define T_OR 268
# define T_SMALLER 269
# define T_STATEMENTS 270
# define T_THAN 271
# define T_TO 272
# define T_UP 273
# define Identifier 274
# define Number 275
# define RegExpression 276
# define T_EOC 277
# define T_COLON 278
# define T_DBL_COLON 279
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif

/* __YYSCLASS defines the scoping/storage class for global objects
 * that are NOT renamed by the -p option.  By default these names
 * are going to be 'static' so that multi-definition errors
 * will not occur with multiple parsers.
 * If you want (unsupported) access to internal names you need
 * to define this to be null so it implies 'extern' scope.
 * This should not be used in conjunction with -p.
 */
#ifndef __YYSCLASS
# define __YYSCLASS static
#endif
YYSTYPE yylval;
__YYSCLASS YYSTYPE yyval;
typedef int yytabelem;
# define YYERRCODE 256

# line 309 "readcomfile.y"


int yyerror (char *msg)
{
  if ( strcmp (msg, "syntax error") != 0 )
  {
    fprintf (stderr, "%s[%2d]: yacc %s\n", comfile, lineno+1, msg);
    exit (1);
  }
  errstring = yylval.term.string;
}

void regerror (char *msg)
{
  fprintf (stderr, "%s[%2d]: regular expression error: %s\n",
           comfile, lineno+1, msg);
  noError = FALSE;
}

# if defined(sequent) || defined(butterfly)
char *bsearch (key, base, nel, size, compar)
char *key;
char *base;
int nel;
int size;
int (*compar) ();
{
  int i;

  for (i=0; i<nel; i++)
  {
    if ( (* compar) (key, base) == 0 ) return (base);
    base += size;
  }
  return (NULL);
}
# else
extern char *bsearch();
# endif


# define MAXSYMBOL 20

static struct symbol
{
  int   Token;      /* key word token number */
  char *Name;       /* key word              */
}
Symbols[MAXSYMBOL] =
{
  T_AND,        "and",
  T_CHILDREN,   "child",
  T_CHILDREN,   "children",
  T_CLASS,      "class",
  T_COUNT,      "count",
  T_EXCLUDE,    "exclude",
  T_FILE,       "file",
  T_FUNCTION,   "function",
  T_FUNCTION,   "functions",
  T_INCLUDE,    "include",
  T_INLINE,     "inline",
  T_LEVEL,      "level",
  T_ONLY,       "only",
  T_OR,         "or",
  T_SMALLER,    "smaller",
  T_STATEMENTS, "statement",
  T_STATEMENTS, "statements",
  T_THAN,       "than",
  T_TO,         "to",
  T_UP,         "up"
};

static int symbolCompare (struct symbol *s1, struct symbol *s2)
{
  return ( strcmp (s1->Name, s2->Name) );
}

static char *strSave (char *string)
{
  char *res;

  res = xalloc (strlen(string)+1, char);
  strcpy (res, string);
  return (res);
}

static int isSymbol (char *string, char **name)
{
  struct symbol *ptr;    /* -- pointer to element found --------------------- */
  struct symbol  symb;   /* -- element to search ---------------------------- */

  symb.Name = string;
  /* -- binary search in key word table (Symbols) --------------------------- */
  ptr = (struct symbol *) bsearch ((char *) (&symb),
                                   (char *) Symbols,
                                   MAXSYMBOL,
                                   sizeof(struct symbol),
                                   symbolCompare
                                  );
  if (ptr == NULL)
  {
    /* -- not found ------------------------------------ */
    *name = strSave (string);
    return (Identifier);
  }
  else
  {
    /* -- found: return key word token number ---------- */
    *name = ptr->Name;
    return (ptr->Token);
  }
}
static int ch;                      /* scanner character buffer      */
static int getnext = TRUE;          /* scanner lookahead indicator   */
static char  inbuf[256];            /* scanner input buffer          */

# define S 3
# define D 2
# define X 1
# define n 0

static char validch[] = {           /* valid identifier characters   */
/*      !  "  #  $  %  &  '  (  )  *  +  ,  -  .  /   */
        X, X, n, X, X, X, X, X, X, X, X, X, X, X, X,
/*   0  1  2  3  4  5  6  7  8  9  :  ;  <  =  >  ?   */
     D, D, D, D, D, D, D, D, D, D, n, X, n, X, n, X,
/*   @  A  B  C  D  E  F  G  H  I  J  K  L  M  N  O   */
     X, S, S, S, S, S, S, S, S, S, S, S, S, S, S, S,
/*   P  Q  R  S  T  U  V  W  X  Y  Z  [  \  ]  ^  _   */
     S, S, S, S, S, S, S, S, S, S, S, X, X, X, X, X,
/*   `  a  b  c  d  e  f  g  h  i  j  k  l  m  n  o   */
     X, S, S, S, S, S, S, S, S, S, S, S, S, S, S, S,
/*   p  q  r  s  t  u  v  w  x  y  z  {  |  }  ~      */
     S, S, S, S, S, S, S, S, S, S, S, X, X, X, X
};

# define ISVALID(ch,op,val) ((ch > ' ') && (ch <= '~') && (validch[ch - '!'] op val))

# undef X
# undef n

int yylex ()
{
  int i, n;

  do
  {
    if ( getnext ) ch = getc (infile);

    if ( ISVALID(ch,==,S) )
    {
      i = 0;
      do
      {
        inbuf[i++] = ch;
        ch = getc (infile);
      }
      while ( ISVALID(ch,>,0) );
      inbuf[i++] = '\0';
      getnext = FALSE;
      return ( yylval.term.num = isSymbol (inbuf, &yylval.term.string) );
    }
    else if ( ISVALID(ch,==,D) )
    {
      i = n = 0;
      do
      {
        inbuf[i++] = ch;
        n = n*10 + ch - '0';
        ch = getc (infile);
      }
      while ( ISVALID(ch,==,D) );
      inbuf[i++] = '\0';
      getnext = FALSE;
      yylval.term.num = n;
      yylval.term.string = strSave (inbuf);
      return ( Number );
    }
    else if (ch == '<')
    {
      getnext = TRUE;
      i = 0;
      while ( (ch = getc(infile)) != EOF )
      {
        if ( ch == '>' ) break;
        if ( ch == '\n' )
        {
          fprintf (stderr, "%s[%2d]: unterminated regular expression\n",
                   comfile, lineno+1);
          noError = FALSE;
          getnext = FALSE;
          break;
        }
        inbuf[i++] = ch;
      }
      inbuf[i++] = '\0';
      yylval.term.string = strSave (inbuf);
      return ( yylval.term.num = RegExpression );
    }
    else if (ch == ':')
    {
      if ( (ch = getc(infile)) != ':' )
      {
        getnext = FALSE;
        yylval.term.string = ":";
        return ( yylval.term.num = T_COLON );
      }
      else
      {
        getnext = TRUE;
        yylval.term.string = "::";
        return ( yylval.term.num = T_DBL_COLON );
      }
    }
    else
    {
      getnext = TRUE;
      switch ( ch )
      {
        case EOF : return ( 0 );
        case '#' : while ( getc(infile) != '\n' );   /* comment */
        case '\n': lineno++;
                   return ( T_EOC );
        default  : /* skip */
                   break;
      }
    }
  }
  while ( ch != EOF );

  return (0);
}

int readComFile (char *filename)
{
  comfile = filename;
  if ( (infile = fopen (comfile, "r")) == NULL )
  {
    perror (comfile);
    exit (1);
  }
  yyparse ();
  fclose (infile);
  return (noError);
}
__YYSCLASS yytabelem yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
	};
# define YYNPROD 37
# define YYLAST 90
__YYSCLASS yytabelem yyact[]={

     8,    37,    38,    46,    10,    11,    31,    19,     9,    25,
    18,    20,    23,    17,    24,    39,    15,    14,    12,    13,
    56,     7,    23,    49,    24,    55,    47,    45,    26,    41,
    58,    52,    30,    28,    44,    48,    33,    57,    22,    51,
    29,    32,    53,    27,     5,     4,     3,     2,     1,    21,
    16,     6,     0,     0,     0,     0,     0,    34,    35,    36,
     0,     0,     0,     0,     0,     0,     0,     0,    40,     0,
     0,     0,     0,     0,     0,     0,    42,    43,     0,     0,
     0,     0,     0,     0,     0,    50,     0,     0,     0,    54 };
__YYSCLASS yytabelem yypact[]={

 -3000,  -256, -3000,  -258,  -260,  -261,  -252, -3000,  -268,  -245,
  -234,  -237, -3000, -3000, -3000, -3000,  -271,  -227,  -262,  -262,
  -262, -3000,  -277, -3000, -3000, -3000,  -257,  -237, -3000, -3000,
  -242, -3000, -3000, -3000, -3000, -3000, -3000,  -262,  -262,  -232,
 -3000,  -248,  -276, -3000,  -249,  -235,  -262, -3000,  -226,  -226,
 -3000,  -250, -3000, -3000,  -255,  -221,  -240, -3000, -3000 };
__YYSCLASS yytabelem yypgo[]={

     0,    51,    39,    50,    49,    38,    40,    48,    47,    46,
    45,    44,    43,    41 };
__YYSCLASS yytabelem yyr1[]={

     0,     7,     7,     8,     8,     8,     8,     8,     8,     1,
     1,     1,     3,     3,     3,     3,     5,     5,     4,     4,
     4,     4,     4,     4,     4,    11,    11,     6,     6,    12,
    12,     2,     2,    10,    13,    13,     9 };
__YYSCLASS yytabelem yyr2[]={

     0,     4,     0,     4,     4,     4,     7,     3,     5,     3,
     3,     3,     5,     5,     5,     3,     3,     3,    11,     7,
     9,     7,     5,     5,     3,     7,     5,    15,    15,     3,
     1,     3,     3,     7,     3,     1,    11 };
__YYSCLASS yytabelem yychk[]={

 -3000,    -7,    -8,    -9,   -10,   -11,    -1,   277,   256,   264,
   260,   261,   274,   277,   277,   277,    -3,   265,   262,   259,
   263,    -4,    -5,   274,   276,   277,   273,   -12,   267,    -6,
   269,   277,   -13,   263,    -5,    -5,    -5,   278,   279,   272,
    -6,   271,    -5,    -5,   266,   275,   279,   275,   270,   258,
    -5,    -2,   257,   268,    -2,   275,   275,   258,   270 };
__YYSCLASS yytabelem yydef[]={

     2,    -2,     1,     0,     0,     0,     0,     7,     0,    10,
    30,     9,    11,     3,     4,     5,     0,    35,     0,     0,
     0,    15,    24,    16,    17,     8,     0,     0,    29,    26,
     0,     6,    33,    34,    12,    13,    14,    22,    23,     0,
    25,     0,    21,    19,     0,     0,    20,    36,     0,     0,
    18,     0,    31,    32,     0,     0,     0,    27,    28 };
typedef struct { char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

__YYSCLASS yytoktype yytoks[] =
{
	"T_AND",	257,
	"T_CHILDREN",	258,
	"T_CLASS",	259,
	"T_COUNT",	260,
	"T_EXCLUDE",	261,
	"T_FILE",	262,
	"T_FUNCTION",	263,
	"T_INCLUDE",	264,
	"T_INLINE",	265,
	"T_LEVEL",	266,
	"T_ONLY",	267,
	"T_OR",	268,
	"T_SMALLER",	269,
	"T_STATEMENTS",	270,
	"T_THAN",	271,
	"T_TO",	272,
	"T_UP",	273,
	"Identifier",	274,
	"Number",	275,
	"RegExpression",	276,
	"T_EOC",	277,
	"T_COLON",	278,
	"T_DBL_COLON",	279,
	"-unknown-",	-1	/* ends search */
};

__YYSCLASS char * yyreds[] =
{
	"-no such reduction-",
	"Commands : Commands Commandline",
	"Commands : /* empty */",
	"Commandline : LevelCommand T_EOC",
	"Commandline : InlineCommand T_EOC",
	"Commandline : LimitCommand T_EOC",
	"Commandline : ExclInclCommand Parameter T_EOC",
	"Commandline : T_EOC",
	"Commandline : error T_EOC",
	"ExclInclCommand : T_EXCLUDE",
	"ExclInclCommand : T_INCLUDE",
	"ExclInclCommand : Identifier",
	"Parameter : T_FILE Name",
	"Parameter : T_CLASS Name",
	"Parameter : T_FUNCTION Name",
	"Parameter : QualifiedName",
	"Name : Identifier",
	"Name : RegExpression",
	"QualifiedName : Name T_COLON Name T_DBL_COLON Name",
	"QualifiedName : Name T_DBL_COLON Name",
	"QualifiedName : Name T_COLON Name T_DBL_COLON",
	"QualifiedName : Name T_COLON Name",
	"QualifiedName : Name T_COLON",
	"QualifiedName : Name T_DBL_COLON",
	"QualifiedName : Name",
	"LimitCommand : T_COUNT OptOnly Limit",
	"LimitCommand : T_EXCLUDE Limit",
	"Limit : T_SMALLER T_THAN Number T_STATEMENTS LogOp Number T_CHILDREN",
	"Limit : T_SMALLER T_THAN Number T_CHILDREN LogOp Number T_STATEMENTS",
	"OptOnly : T_ONLY",
	"OptOnly : /* empty */",
	"LogOp : T_AND",
	"LogOp : T_OR",
	"InlineCommand : ExclInclCommand T_INLINE OptFunction",
	"OptFunction : T_FUNCTION",
	"OptFunction : /* empty */",
	"LevelCommand : T_INCLUDE T_UP T_TO T_LEVEL Number",
};
#endif /* YYDEBUG */
#define YYFLAG  (-3000)
/* @(#) $Revision: 1.2 $ */    

/*
** Skeleton parser driver for yacc output
*/

#if defined(NLS) && !defined(NL_SETN)
#include <msgbuf.h>
#endif

#ifndef nl_msg
#define nl_msg(i,s) (s)
#endif

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab

#ifndef __RUNTIME_YYMAXDEPTH
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#else
#define YYACCEPT	{free_stacks(); return(0);}
#define YYABORT		{free_stacks(); return(1);}
#endif

#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( (nl_msg(30001,"syntax error - cannot backup")) );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
/* define for YYFLAG now generated by yacc program. */
/*#define YYFLAG		(FLAGVAL)*/

/*
** global variables used by the parser
*/
# ifndef __RUNTIME_YYMAXDEPTH
__YYSCLASS YYSTYPE yyv[ YYMAXDEPTH ];	/* value stack */
__YYSCLASS int yys[ YYMAXDEPTH ];		/* state stack */
# else
__YYSCLASS YYSTYPE *yyv;			/* pointer to malloc'ed value stack */
__YYSCLASS int *yys;			/* pointer to malloc'ed stack stack */

#if defined(__STDC__) || defined (__cplusplus)
#include <stdlib.h>
#else
	extern char *malloc();
	extern char *realloc();
	extern void free();
#endif /* __STDC__ or __cplusplus */


static int allocate_stacks(); 
static void free_stacks();
# ifndef YYINCREMENT
# define YYINCREMENT (YYMAXDEPTH/2) + 10
# endif
# endif	/* __RUNTIME_YYMAXDEPTH */
long  yymaxdepth = YYMAXDEPTH;

__YYSCLASS YYSTYPE *yypv;			/* top of value stack */
__YYSCLASS int *yyps;			/* top of state stack */

__YYSCLASS int yystate;			/* current state */
__YYSCLASS int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */
__YYSCLASS int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */



/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
int
yyparse()
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */

	/*
	** Initialize externals - yyparse may be called more than once
	*/
# ifdef __RUNTIME_YYMAXDEPTH
	if (allocate_stacks()) YYABORT;
# endif
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

	goto yystack;
	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
# ifndef __RUNTIME_YYMAXDEPTH
			yyerror( (nl_msg(30002,"yacc stack overflow")) );
			YYABORT;
# else
			/* save old stack bases to recalculate pointers */
			YYSTYPE * yyv_old = yyv;
			int * yys_old = yys;
			yymaxdepth += YYINCREMENT;
			yys = (int *) realloc(yys, yymaxdepth * sizeof(int));
			yyv = (YYSTYPE *) realloc(yyv, yymaxdepth * sizeof(YYSTYPE));
			if (yys==0 || yyv==0) {
			    yyerror( (nl_msg(30002,"yacc stack overflow")) );
			    YYABORT;
			    }
			/* Reset pointers into stack */
			yy_ps = (yy_ps - yys_old) + yys;
			yyps = (yyps - yys_old) + yys;
			yy_pv = (yy_pv - yyv_old) + yyv;
			yypv = (yypv - yyv_old) + yyv;
# endif

		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( (nl_msg(30003,"syntax error")) );
				yynerrs++;
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
				yynerrs++;
			skip_init:
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 6:
# line 96 "readcomfile.y"
{
      if ( noError )
      {
        addCommand (yypvt[-2].term.num, yypvt[-1].nonterm.file, yypvt[-1].nonterm.class, yypvt[-1].nonterm.func);
      }
    } break;
case 7:
# line 104 "readcomfile.y"
{} break;
case 8:
# line 107 "readcomfile.y"
{
      fprintf (stderr, "%s[%2d]: invalid commandline [near %s]\n",
               comfile, lineno, errstring);
      noError = FALSE;
      yyerrok;
    } break;
case 9:
# line 117 "readcomfile.y"
{
      yyval.term.string = yypvt[-0].term.string;
      yyval.term.num    = COM_EXCLUDE;
    } break;
case 10:
# line 123 "readcomfile.y"
{
      yyval.term.string = yypvt[-0].term.string;
      yyval.term.num    = COM_INCLUDE;
    } break;
case 11:
# line 129 "readcomfile.y"
{
      yyval.term.string = yypvt[-0].term.string;
      yyval.term.num    = COM_NULL;

      fprintf (stderr, "%s[%2d]: invalid command `%s'\n",
               comfile, lineno+1, yypvt[-0].term.string);
      noError = FALSE;
      yyerrok;
    } break;
case 12:
# line 142 "readcomfile.y"
{
      yyval.nonterm.file  = yypvt[-0].rexp;
      yyval.nonterm.class = RNULL;
      yyval.nonterm.func  = RNULL;
    } break;
case 13:
# line 149 "readcomfile.y"
{
      yyval.nonterm.file  = RNULL;
      yyval.nonterm.class = yypvt[-0].rexp;
      yyval.nonterm.func  = RNULL;
    } break;
case 14:
# line 156 "readcomfile.y"
{
      yyval.nonterm.file  = RNULL;
      yyval.nonterm.class = RNULL;
      yyval.nonterm.func  = yypvt[-0].rexp;
    } break;
case 15:
# line 163 "readcomfile.y"
{
      yyval.nonterm = yypvt[-0].nonterm;
    } break;
case 16:
# line 170 "readcomfile.y"
{
      yyval.rexp = xalloc (1, REXP);
      yyval.rexp->regexpr = (regexp *) 0;
      yyval.rexp->regstr  = yypvt[-0].term.string;
    } break;
case 17:
# line 177 "readcomfile.y"
{
      yyval.rexp = xalloc (1, REXP);
      yyval.rexp->regexpr = regcomp (yypvt[-0].term.string);
      yyval.rexp->regstr  = yypvt[-0].term.string;
    } break;
case 18:
# line 186 "readcomfile.y"
{
      yyval.nonterm.file  = yypvt[-4].rexp;
      yyval.nonterm.class = yypvt[-2].rexp;
      yyval.nonterm.func  = yypvt[-0].rexp;
    } break;
case 19:
# line 193 "readcomfile.y"
{
      yyval.nonterm.file  = RNULL;
      yyval.nonterm.class = yypvt[-2].rexp;
      yyval.nonterm.func  = yypvt[-0].rexp;
    } break;
case 20:
# line 200 "readcomfile.y"
{
      yyval.nonterm.file  = yypvt[-3].rexp;
      yyval.nonterm.class = yypvt[-1].rexp;
      yyval.nonterm.func  = RNULL;
    } break;
case 21:
# line 207 "readcomfile.y"
{
      yyval.nonterm.file  = yypvt[-2].rexp;
      yyval.nonterm.class = RNULL;
      yyval.nonterm.func  = yypvt[-0].rexp;
    } break;
case 22:
# line 214 "readcomfile.y"
{
      yyval.nonterm.file  = yypvt[-1].rexp;
      yyval.nonterm.class = RNULL;
      yyval.nonterm.func  = RNULL;
    } break;
case 23:
# line 221 "readcomfile.y"
{
      yyval.nonterm.file  = RNULL;
      yyval.nonterm.class = yypvt[-1].rexp;
      yyval.nonterm.func  = RNULL;
    } break;
case 24:
# line 228 "readcomfile.y"
{
      yyval.nonterm.file  = RNULL;
      yyval.nonterm.class = RNULL;
      yyval.nonterm.func  = yypvt[-0].rexp;
    } break;
case 25:
# line 237 "readcomfile.y"
{
      count_limit.stmts = yypvt[-0].lmt.stmts;
      count_limit.child = yypvt[-0].lmt.child;
      count_limit.op    = yypvt[-0].lmt.op;
    } break;
case 26:
# line 244 "readcomfile.y"
{
      excl_limit.stmts = yypvt[-0].lmt.stmts;
      excl_limit.child = yypvt[-0].lmt.child;
      excl_limit.op    = yypvt[-0].lmt.op;
    } break;
case 27:
# line 253 "readcomfile.y"
{
      yyval.lmt.stmts = yypvt[-4].term.num;
      yyval.lmt.child = yypvt[-1].term.num;
      yyval.lmt.op    = yypvt[-2].term.num;
    } break;
case 28:
# line 260 "readcomfile.y"
{
      yyval.lmt.stmts = yypvt[-1].term.num;
      yyval.lmt.child = yypvt[-4].term.num;
      yyval.lmt.op    = yypvt[-2].term.num;
    } break;
case 29:
# line 269 "readcomfile.y"
{} break;
case 30:
# line 272 "readcomfile.y"
{} break;
case 31:
# line 277 "readcomfile.y"
{
      yyval.term.num = OP_AND;
    } break;
case 32:
# line 282 "readcomfile.y"
{
      yyval.term.num = OP_OR;
    } break;
case 33:
# line 289 "readcomfile.y"
{
      ignoreInlines = ( yypvt[-2].term.num == COM_EXCLUDE );
    } break;
case 34:
# line 296 "readcomfile.y"
{} break;
case 35:
# line 299 "readcomfile.y"
{} break;
case 36:
# line 304 "readcomfile.y"
{
      level_limit = yypvt[-0].term.num;
    } break;
	}
	goto yystack;		/* reset registers in driver code */
}

# ifdef __RUNTIME_YYMAXDEPTH

static int allocate_stacks() {
	/* allocate the yys and yyv stacks */
	yys = (int *) malloc(yymaxdepth * sizeof(int));
	yyv = (YYSTYPE *) malloc(yymaxdepth * sizeof(YYSTYPE));

	if (yys==0 || yyv==0) {
	   yyerror( (nl_msg(30004,"unable to allocate space for yacc stacks")) );
	   return(1);
	   }
	else return(0);

}


static void free_stacks() {
	if (yys!=0) free((char *) yys);
	if (yyv!=0) free((char *) yyv);
}

# endif  /* defined(__RUNTIME_YYMAXDEPTH) */

