; c t - i n f o . s c h
; $Id: ct-info.sch,v 1.1 1996/05/01 20:07:53 lth Exp $
; 
; Context-TargetThread info
; kurtw@cs.uoregon.edu / Feb 29, 1996

(require "ct-tbl.sch")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; Globals

(define ct-state (make-ct-table))     ; val is 'running or 'ready
(define ct-handlers (make-ct-table))  ; val is list of handlers installed

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; Selected threads

(define (make-tthread-set) 
  (vector 'tthread-set '() (make-mutex)))

(define (tthread-set? obj)
  (and (vector? obj)
       (= (vector-length obj) 3)
       (eq? (vector-ref obj 0) 'tthread-set)))

(define (tthread-get tts)
  (call-with-mutex (vector-ref tts 2)
    (lambda () (vector-ref tts 1))))

(define (tthread-set! tts l)
  (call-with-mutex (vector-ref tts 2)
    (lambda () (vector-set! tts 1 l))))

(define (tthread-selected? tts cid tid)
  (call-with-mutex (vector-ref tts 2)
    (lambda ()
      (if (member (cons cid tid) (vector-ref tts 1)) #t #f))))

;FIX it would be nice if the threads were sorted by cid/tid
(define (select-tthread! tts cid tid)
  (call-with-mutex (vector-ref tts 2)
    (lambda ()
      (if (member (cons cid tid) (vector-ref tts 1)) 
	  #f
	  (vector-set! tts 1 (append (vector-ref tts 1) 
				     (list (cons cid tid))))))))

(define (remove-tthread! tts cid tid)
  (call-with-mutex (vector-ref tts 2)
    (lambda ()
      (let ((l (vector-ref tts 1)))
	(cond ((null? l) #f)
	      ((and (= (caar l) cid) (= (cdar l) tid))
	       (vector-set! tts 1 (cdr l)))
	      (else
	       (let ((ptr
		      (do ((p l (cdr p))
			   (q (cdr l) (cdr q)))
			  ((or (null? q) 
			       (and (= (caar q) cid) (= (cdar q) tid))) p))))
		 (if (null? (cdr ptr))
		     #f
		     (set-cdr! ptr (cddr ptr))))))))))
		 
  

(define (select-all-tthreads! tts)
  (for-each-thread (lambda (cid tid)
		     (select-tthread! tts cid tid))))

(define (remove-all-tthreads! tts)
  (call-with-mutex (vector-ref tts 2)
    (lambda ()
      (vector-set! tts 1 '()))))

(define (for-each-selected-tthread proc tts)
  (call-with-mutex (vector-ref tts 2)
    (lambda ()
      (for-each (lambda (ct-pair)
		  (proc (car ct-pair) (cdr ct-pair)))
		(vector-ref tts 1)))))

(define (format-selected-tthreads tts)
  (let ((l (vector-ref tts 1)))
    (do ((str "" str)
	 (p l (cdr p)))
	((null? p) str)
      (set! str (string-append str 
			       (format #f "~a:~a " (caar p) (cdar p)))))))


(provide "ct-info.sch")

; eof
