; c t - t b l . s c h
; 
; Associate datum with a pair of context ID and thread ID.
;
; lth@cs.uoregon.edu / July 27, 1995
; $Id: ct-tbl.sch,v 1.1 1996/05/01 20:07:54 lth Exp $

(require "synch.sch")

(define (make-ct-table)
  (vector 'ct-table '() (make-mutex)))

(define (ct-table? obj)
  (and (vector? obj)
       (> (vector-length obj) 0)
       (eq? (vector-ref obj 0) 'ct-table)))

(define (ct-table-ref tbl cid tid . rest)
  (call-with-mutex (vector-ref tbl 2)
    (lambda ()
      (let ((probe (assoc (cons cid tid) (vector-ref tbl 1))))
	(cond (probe
	       (cdr probe))
	      ((null? rest)
	       (error "ct-table-ref: not found: (~a,~a)" cid tid))
	      (else
	       (car rest)))))))

(define (ct-table-set! tbl cid tid val)
  (call-with-mutex (vector-ref tbl 2)
    (lambda ()
      (let ((probe (assoc (cons cid tid) (vector-ref tbl 1))))
	(if probe
	    (set-cdr! probe val)
	    (let ((x (cons (cons cid tid) val)))
	      (vector-set! tbl 1 (cons x (vector-ref tbl 1)))))))))

(provide "ct-tbl.sch")
