(define (parse-command cmd-str)
  (cmdmsg "~%")
  (let* ((cmd-list (string-split cmd-str))
	 (cmd-name (cadr cmd-list))
	 (arg-list (cddr cmd-list)))
    (cond ((string-start? "target" cmd-name) (cmd:target arg-list))
	  ((string-start? "exit" cmd-name) (cmd:exit arg-list))
	  ((string-start? "quit" cmd-name) (cmd:exit arg-list))
	  ((string-start? "handle" cmd-name) (cmd:handle arg-list))
	  (else (cmdmsg "Invalid Command: ~a~%" cmd-name)))
))


(define-method cmd.msg (w . rest)
  (call-with-mutex (get-mutex w)
    (lambda ()
      (let* ((str (apply format #f rest))
	     (len (string-length str))
	     (has-newline?  (char=? #\newline  
				    (string-ref str (- len 1)))))
	(text-insert (get-text w) 'end (substring str 0 (- len 1)))
	(let ((line (car (string-split (text-index (get-text w) 'end) #\.)))
	      (tkwidget (slot-ref (slot-ref w 'text) 'id)))
	  (format #t "Line: ~a -- ~a~%" line rest)
	  (tkwidget 'yview `-pickplace line)
	  (if has-newline? (begin (display "*")(text-insert (get-text w) 'end
					(format #f "~%")))))))))
