// Sneezy support code for pC++ runtime system.
// lth@cs.uoregon.edu / March 16, 1996

#define SERVER_SIDE
#include "/home/users/lth/net/sneezy/c-api/server-api.h"

#define SNZU_GETCTX 600
#define SNZU_GETLOCLADDR 601
#define SNZU_CREATE_COLLECTION 602

void _SNZ_get_context( unsigned long p, int idx1, int idx2, int dummy )
{
  Kernel *kp = (Kernel*)p;
  int proc_id;

  /* This code from kernel-SMRTS,DMRTS.c */
  switch (kp->CollectionInfo.number_dimension) {
    case 1: proc_id = kp->AllocatedProc(idx1); break;
    case 2: proc_id = kp->AllocatedProc(idx1,idx2); break;
  }
  snz_push_value( 0, &proc_id, sizeof( proc_id ) );
}

void _SNZ_get_local_addr( unsigned long p, int idx1, int idx2, int dummy )
{
  tulip_GlobalPointer_t gp;
  Kernel *kp;

  kp = (Kernel*)p;
  switch (kp->CollectionInfo.number_dimension) {
    case 1: gp = kp->ElementReference( kp->ElemIndex(idx1) ); break;
    case 2: gp = kp->ElementReference( kp->ElemIndex(idx1,idx2) ); break;
  }
  snz_push_value( 0, &gp.LocalAddress, sizeof( gp.LocalAddress ) );
}

void _SNZ_standard_initialization()
{
  snz_user_event( SNZU_GETCTX, (void*)&_SNZ_get_context, 0 );
  snz_user_event( SNZU_GETLOCLADDR, (void*)&_SNZ_get_local_addr, 0 );
}

// eof
