/* c l i e n t - t y p e s . h
 * $Id: client-types.h,v 1.1 1996/05/01 20:09:45 lth Exp $
 *
 * Copyright (C) 1995 The University of Oregon
 *
 *   Author: Lars Thomas Hansen [lth@cs.uoregon.edu]
 *  Created: October 30, 1995
 * Modified:
 *
 * Concrete manifestations of (some) abstract types from client-api.h.
 */

#if defined(SERVER_SIDE) || !defined(CLIENT_SIDE)
#error "client-types.h valid only on the client side."
#endif

#ifndef INCLUDED_CLIENT_TYPES
#define INCLUDED_CLIENT_TYPES

#ifdef __cplusplus
extern "C" {
#endif

#include "client-repr.h"
#include "proginfo.h"

#ifndef DEFINED_CONN_T
#define DEFINED_CONN_T
typedef struct snz_conn_t snz_conn_t;
#endif

typedef struct snz_param_t snz_param_t;
typedef struct snz_int_t snz_int_t;
typedef struct snz_long_t snz_long_t;
typedef struct snz_str_t snz_str_t;
typedef struct snz_addr_t snz_addr_t;
typedef struct snz_gptr_t snz_gptr_t;
typedef struct snz_time_t snz_time_t;

struct snz_gptr_t {
  int        context;   /* context number */
  snz_addr_t addr;      /* global pointer */
};

snz_int_t  snz_mkint( snz_conn_t *c, int i );
snz_long_t snz_mklong( snz_conn_t *c, long i );
snz_str_t  snz_mkstr( snz_conn_t *c, char *s );
snz_addr_t snz_mkaddr( snz_conn_t *c, unsigned long s );

void snz_int2str( snz_int_t i, char *buf );
void snz_long2str( snz_long_t i, char *buf );
void snz_addr2str( snz_addr_t i, char *buf );
void snz_time2str( snz_time_t t, char *buf );

snz_int_t  snz_str2int( snz_conn_t *c, char *buf );
snz_long_t snz_str2long( snz_conn_t *c, char *buf );
snz_addr_t snz_str2addr( snz_conn_t *c, char *buf );

int        val( snz_long_t n );
int        ival( snz_int_t n );
long       lval( snz_long_t n );
snz_addr_t addr( snz_conn_t *c, snz_long_t n );

snz_str_t *snzstr_dup( snz_str_t *s );
void      snz_str_free( snz_str_t *s );

#ifdef __cplusplus
}
#endif

#endif /* INCLUDED_CLIENT_TYPES */

/* eof */
