(define limit 16)
(define len 4)

(define (gen)
  (display "switch (k) {") (newline)
  (do ((i 0 (+ i 1)))
      ((= i limit))
    (display "case ") (display i) (display ":") (newline)
    (display "(")
    (display (buildcast i)) 
    (display "fptr)(")
    (display (arglist i))
    (display "); break;")
    (newline))
  (display "}") (newline)
  #t)

(define (buildcast n)
  (string-append "(void (*)("
		 (alist n cast)
		 "))"))

(define (arglist n)
  (set! iidx (- 3 (popcount n)))
  (set! lidx (- (popcount n) 1))
  (alist n arg))
  
(define (popcount n)
  (if (zero? n)
      0
      (+ (remainder n 2)
	 (popcount (quotient n 2)))))

(define (alist n f)
  (let ((s   ""))
    (do ((i 0 (+ i 1))
	 (n n (quotient n 2)))
	((= i len) s)
      (set! s (string-append (f i (remainder n 2))
			     (if (not (string=? s "")) "," "")
			     s)))))

(define (cast i bit)
  (if (zero? bit)
      "unsigned"
      "unsigned long"))

(define (arg i bit)
  (if (zero? bit)
      (let ((s (string-append "iarg[" (number->string iidx) "]")))
	(set! iidx (- iidx 1))
	s)
      (let ((s (string-append "larg[" (number->string lidx) "]")))
	(set! lidx (- lidx 1))
	s)))
