/* p r o x y - s o c k - m u l t i . c
 * $Id: proxy-sock-multi.c,v 1.1 1996/05/01 20:09:52 lth Exp $
 *
 * Copyright (C) 1995 The University of Oregon.
 *
 *   Author: Lars Thomas Hansen [lth@cs.uoregon.edu]
 *  Created: November 8, 1995
 * Modified:
 *
 * Multiple client support -- complicated, expensive 
 */

#define SERVER_SIDE
#include <stdio.h>
#include <unistd.h>
#include "sneezy.h"
#include "proxy-sock.h"

int 
_proxy_accept_new_client_multi_client( int client_fd, snz_proginfo_t *info )
{
#ifdef NOT_DEFINED
  /* allocate space for client in client table */
  c = _snz_new_client( fd );
  
  /* set client's state to NEW */
  /* negotiate protocol */
  /* send startup message to client with SLAVE attribute and client ID. */
  /* send client connect message to other clients */
#endif
  snz_panic( "Multi-client support not done." );
  return 0;
}


/* Route message to client when there is potentially more than one client. */
int _proxy_route_to_program_multi_client( int *program_fds, snz_clnt_t *src )
{
#ifdef NOT_DEFINED
  snz_cmd_t cmd;

  /* read message off wire using negotiated protocol into 'cmd' */
  proxy_read_client( client_fd, &cmd );

  /* if (cid,tid)=(-1,-1) then process locally:
     (transfer-control -1 -1 target-client)
   */
  /* if handler setup/takedown, process locally:
     -install handler for given client,cid,tid
     -remove handler for given client,cid,tid
     then forward somehow.  May have to queue for forwarding if
     state of client does not allow manipulation at this time. [Ouch!]
   */

  if (write( &cmd, sizeof( cmd ), 1, program_fds[ cmd->cid ] ) != 1) {
    /* oops */
  }
#endif
  snz_panic( "Multi-client support not done." );
  return 0;
}

int _proxy_route_to_client_multi_client( int context_fd )
{
#ifdef NOT_DEFINED
  snz_event_t e;
  int i;

  if (read( context_fd, (void*)&e, sizeof( e ) ) == -1) {
    /* oops */
  }

  for ( i = 0 ; i < clients ; i++ ) {
    if (client[i].eventmask[e->etype] != -1) {
      /* client wants this event at least some times; now filter for cid/tid */
      /* this is getting to be really annoying, but we can assume memory is
         cheap and just use a big 2D table.
       */
      e->eid = client[i].event[e->cid][e->tid];
      if (e->eid >= 0) {
	/* write msg to client using negotiated protocol */
      }
    }
  }
#endif
  snz_panic( "Multi-client support not done." );
  return 0;
}

/* eof */
