/* s n e e z y . c
 * $Id: sneezy.c,v 1.1 1996/05/01 20:10:05 lth Exp $
 *
 * Copyright (C) 1995 The University of Oregon.
 *
 *   Author: Lars Thomas Hansen [lth@cs.uoregon.edu]
 *  Created: November 9, 1995
 * Modified:
 *
 * Common sneezy functionality
 */

#include <stdio.h>
#include <stdarg.h>
#include <errno.h>

#include "sneezy.h"

/* Print message and return */
void snz_message( char *fmt, ... )
{
  va_list args;

  va_start( args, fmt );
  vfprintf( stderr, fmt, args );
  va_end( args );
  fputc( '\n', stderr );
  fflush( stderr );
}

/* printf() the string and args, then die. */
void snz_panic( char *fmt, ... )
{
  va_list args;

  putc( '\n', stderr );
  fprintf( stderr, "SNEEZY PANIC: " );
  va_start( args, fmt );
  vfprintf( stderr, fmt, args );
  va_end( args );
  fputc( '\n', stderr );
  abort();
}


/* printf() the string and args, then print the errno string, then die. */
void snz_perror_panic( char *fmt, ... )
{
  va_list args;
  int e;

  e = errno;
  putc( '\n', stderr );
  fprintf( stderr, "SNEEZY PANIC: " );
  va_start( args, fmt );
  vfprintf( stderr, fmt, args );
  va_end( args );
  fprintf( stderr, ": %s\n", strerror( e ) );
  abort();
}

snz_gptr_t snz_mkgptr( int context, snz_addr_t addr )
{
  snz_gptr_t g;

  g.context = context;
  g.addr = addr;
  return g;
}


/* eof */
