; test client modelled on the C test client (hence some ugliness)

(require "sneezy-client-api.sch")
(require "synch.sch")

; These load some sneaky stuff, for testing.

(require "inspect.sch")
(require "collection.sch")

(define num-contexts #f)
(define all-contexts #f)
(define threads-in-context #f)
(define live-cnta #f)
(define u #f)
(define l #f)

(define (main . rest)
  (if (not (tasking-enabled?))
      (begin (display "TASKING ENABLED.")
	     (begin-tasking)))
  (spawn (lambda ()
	   (main2 rest))))

(define (main2 rest)
  (let ((port (if (null? rest)
		  (sneezy.debugger-port)
		  (car rest)))
	(sem-in (make-semaphore 0))
	(sem-done (make-semaphore 0))
	(term-sem (make-semaphore 0)))
    (msg "connecting")
    (client.control 'monitor)
    (client.initialize "fire.cs.uoregon.edu" 
		       port 
		       (make-ready-handler sem-in sem-done))
    (msg "getting program info")
    (set! num-contexts (client.data 'server-context-count))
    (set! all-contexts (client.data 'all-contexts))
    (set! threads-in-context
	  (list->vector (map (lambda (n)
			       (client.data 'threads-in-context n))
			     (iota num-contexts))))
    (msg "num-contexts ~a" num-contexts)
    (msg "all-contexts ~a" all-contexts)
    (msg "threads-in-contexts ~a" threads-in-context)
    (set! live-cnta (vector-copy threads-in-context))
    (set! u (make-vector num-contexts #f))
    (set! l (make-vector num-contexts #f))
    (msg "releasing")
    (semaphore-up sem-in)
    (semaphore-down sem-done)
    (msg "have all READY")

    ; install some handlers
    (msg "Installing handlers")

    ; This is a common idiom: setup some handlers with a semaphore so that
    ; we can block on the semaphore until all the interesting threads have
    ; called the handler. Essentially a barrier, but we can't use a barrier
    ; because event handling is single-threaded: the handler has to return
    ; before the next event is handled.

    (let* ((cnt 0)
	   (h (lambda (etype cid tid data)
		(set! cnt (+ cnt 1))
		(if (= cnt num-contexts)
		    (semaphore-up term-sem)))))
      (do ((i 0 (+ i 1)))
	  ((= i num-contexts))
	(client.handle 'terminate i 0 h)))

    ; cheating
    (map (lambda (e)
	   (do ((i 0 (+ i 1)))
	       ((= i num-contexts))
	     (client.handle e i 0 generic)))
	 (sneezy.all-events))

    (msg "Have installed handlers; hit ENTER to continue all.")
    (read-char)
    (do ((i 0 (+ i 1)))
	((= i num-contexts))
      (client.continue i 0))
    (msg "Now waiting for all to terminate.")
    (semaphore-down term-sem)
    (msg "All terminated; exiting.")
    (client.cleanup)
    #t))

; User events in the 600 class are magic.

(define (generic etype cid tid data)
  (msg "~a ~a ~a ~a ~a" etype (sneezy.event-name etype) cid tid data)
  (cond ((and (= etype sneezy.etype:user-event)
	      (<= 600 (car data) 699))
	 (user-event-6xx cid tid data (lambda () (client.continue cid tid))))
	((stop-for-event? etype cid tid data)
	 (thread-has-stopped cid tid)
	 (display "STOPPING: ")
	 (display (list cid tid))
	 (newline))
	(else
	 (client.continue cid tid))))

(define (stop-for-event? etype cid tid data)
  (and (= etype sneezy.etype:user-event)
       (= (car data) 17)))

(define (continue cid tid)
  (thread-is-continuing cid tid)
  (client.continue cid tid))

; This is some old test code that can be used if we're not testing some
; of the sneaky stuff.

(define (user-event-666 cid tid data)
  (spawn (lambda ()
	   (let ((ctx (cadr data))
		 (ptr (caddr data))
		 (len (cadddr data)))
	     (display "Calling user function!") (newline)
	     (let ((r (client.call-user-function 
		       cid tid ptr `((,sneezy.argtype:int 0)
				     (,sneezy.argtype:int 1)
				     (,sneezy.argtype:int 2)
				     (,sneezy.argtype:int 3)))))
	       (display "User function called! Returned: ")
	       (write r)
	       (newline)
	       (display "Now continuing.") (newline)
	       (client.continue cid tid))))))

; FIXME: The mess with the semaphores is probably always necessary; 
; is there a way to fix this in the API?  The problem is to avoid a race
; condition in running READY and reading num-contexts.

(define (make-ready-handler sem-in sem-done)
  (let ((cnt 0))
    (lambda (etype cid tid data)
      (semaphore-down sem-in)
      (msg "READY ~a ~a ~a ~a" etype cid tid data)
      (set! cnt (+ cnt 1))
      (if (= cnt num-contexts)
	  (semaphore-up sem-done))
      (semaphore-up sem-in))))

(define (msg . args)
  (apply format #t args)
  (newline))

; eof


