# TODO
#  - Allow multiple possible extensions for each language source code file.



set languages {pc++ ansic}

set pc++(cgm_cmd)         "cgm"
set pc++(cgm_ext)         "dep"
set pc++(prog_ext)        "pc"
set pc++(template)        "source.pc"
set pc++(compileopts)     {CXX_SWITCHES PCXX_SWITCHES}
set pc++(compileopts_desc) {"extra C++ switches:" "extra pC++ switches:"}

set ansic(cgm_cmd)        "ccgm"
set ansic(cgm_ext)        "dep"
set ansic(prog_ext)       "c"
set ansic(template)       "source.c"
set ansic(compileopts)     {CC_SWITCHES}
set ansic(compileopts_desc) {"extra C switches:"}



proc Lang_GetCGM {lang} {
    global languages; foreach l $languages {global $l}
    return [eval set ${lang}(cgm_cmd)]
}

proc Lang_GetExt {lang} {
    global languages; foreach l $languages {global $l}
    return [eval set ${lang}(cgm_ext)]
}

proc Lang_GetProgExt {lang} {
    global languages; foreach l $languages {global $l}
    return [eval set ${lang}(prog_ext)]
}

proc Lang_GetTemplateName {lang} {
    global languages; foreach l $languages {global $l}
    return [eval set ${lang}(template)]
}

proc Lang_GetCompileOpts {lang} {
    global languages; foreach l $languages {global $l}
    return [eval set ${lang}(compileopts)]
}

proc Lang_GetCompileOptsDesc {lang} {
    global languages; foreach l $languages {global $l}
    return [eval set ${lang}(compileopts_desc)]
}

proc Lang_GuessLang {filen} {
    global languages; foreach l $languages {global $l}

    set file_ext [string range [file extension $filen] 1 end]
    foreach lang $languages {
	if {$file_ext == [Lang_GetProgExt $lang]} {
	    return $lang
	}
    }
}
    


