#*********************************************************************#
#*                TAU/pC++/Sage++  Copyright (C) 1994                *#
#*                        Jerry Manic Saftware                       *#
#*  Indiana University  University of Oregon  University of Rennes   *#
#*********************************************************************#

# FIX - FIX - FIX
# This is obsolete and should be removed, including the menu item in tau.

set selectfunc(show) puts;        # function to use for "show"
set selectfunc(select) puts;      # function to use for "select"
set selectfunc(funcs) "";         # list of functions to display
set selectfunc(display) nonlib;   # type of functions to display:
                                  # "all" or "nonlib"
set selectfunc(usedonly) 1;       # display only used (called) functions?

#
# selectFunction: display list of all functions in a listbox
#                 user can pick up funtions to invoke the global features
#                 selectFunc or showFunc on them
#

proc selectFunction {} {
  global selectfunc

  # -- generate sorted list of all functions
  foreach t $depfile(allftags) {
    set name  $funcs($t,name)
    set class $funcs($t,class)
    set add 1

    # -- prepend class name if necessary
    if { [lindex $class 0] != "-" } {
      set name "[lindex $class 0]::$name"
    }

    # -- check for library (no body) functions
    # -- (indicated by the fact they have no associated filename/linenumber)
    if { ! [lindex $funcs($t,file) 0] } {
      set add [expr {"$selectfunc(display)" == "all"}]
      set name "<$name>"
    }

    # -- add function to list according to user settings
    if { $add } {
      if { ! $selectfunc(usedonly) || "[lindex $funcs($t,type) 2]" == "used" } {
        lappend allfunc "$name $t"
      }
    }
  }
  set selectfunc(funcs) [lsort $allfunc]

  if [winfo exists .select] {
    # -- select window already displayed; reset listbox (delete old names)
    .select.l1 delete 0 end
  } else {
    # -- create new select window
    toplevel .select
    wm title .select "Select"
    wm minsize .select 50 50

    frame .select.mbar -relief raised -borderwidth 2
    menubutton .select.mbar.b1 -text Display -menu .select.mbar.b1.m1 \
                               -underline 0
    menu .select.mbar.b1.m1
    .select.mbar.b1.m1 add radiobutton -label "all functions" \
                       -underline 0 -variable selectfunc(display) \
                       -value all -command selectFunction
    .select.mbar.b1.m1 add radiobutton -label "non-library functions only" \
                       -underline 0 -variable selectfunc(display) \
                       -value nonlib -command selectFunction
    .select.mbar.b1.m1 add separator
    .select.mbar.b1.m1 add checkbutton -label "used functions only" \
                       -underline 0 -variable selectfunc(usedonly) \
                       -onvalue 1 -offvalue 0 -command selectFunction

    menubutton .select.mbar.b2 -text Help -menu .select.mbar.b2.m1 \
                               -underline 0
    menu .select.mbar.b2.m1
    .select.mbar.b2.m1 add command -label "on select" -underline 3 \
                       -command "showHelp tau 1.1.1-select 1"
    pack .select.mbar.b1 -side left -padx 5
    pack .select.mbar.b2 -side right -padx 5
    pack .select.mbar -side top -fill x

    listbox .select.l1 -relief sunken -exportselection false -selectmode single

    scrollbar .select.s1 -orient vert -relief sunken \
                    -command ".select.l1 yview"
    .select.l1 configure -yscrollcommand ".select.s1 set"
    scrollbar .select.s2 -orient horiz -relief sunken \
                    -command ".select.l1 xview"
    .select.l1 configure -xscrollcommand ".select.s2 set"

    frame .select.bottom

    frame .select.f1 -relief sunken -bd 1
    button .select.b1 -text "show" -command {
          set s [.select.l1 curselection]
          if { $s != "" } {
            set tag [lindex [lindex $selectfunc(funcs) $s] 1]
            $selectfunc(show) $tag
          }
        }
    pack .select.b1 -in .select.f1 -side left -padx 5 -pady 5

    bind .select.l1 <Double-1> ".select.b1 invoke"
    pack .select.f1 -in .select.bottom -side left -padx 10 -pady 10

    button .select.b2 -text "select" -command {
          set s [.select.l1 curselection]
          if { $s != "" } {
            set tag [lindex [lindex $selectfunc(funcs) $s] 1]
            $selectfunc(select) $tag
          }
        }
    pack .select.b2 -in .select.bottom -side left -padx 15 -pady 15

    button .select.b3 -text "cancel" -command "destroy .select"
    pack .select.b3 -in .select.bottom -side right -padx 15 -pady 15

    pack .select.bottom -side bottom -fill x
    pack .select.s1 -side right  -fill y
    pack .select.s2 -side bottom -fill x
    pack .select.l1 -side left   -expand yes -fill both
  }

  # -- add function names to listbox
  foreach f $selectfunc(funcs) {
    .select.l1 insert end [lindex $f 0]
  }
}
