/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993,1995             */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/


#define MAXNU 8

extern "C" void dgemm(char ta, char tb , int m, int n,
                      int k, double a,
                      double A[][MAXNU], int ldA,
                      double B[MAXNU][MAXNU], int ldB, double b,
                      double C[][MAXNU], int ldC);

extern "C" void dtrsm(char side, char uplo, char transa, char diag,
                      int m, int n, double alpha, double T[][MAXNU], int ldt,
                      double B[][MAXNU], int ldb);


/* solves T*X = B for unit lower triangular T n by n */
/*   and n by n X overwriting n by n B */
void triag_solve(double T[][MAXNU], double B[][MAXNU], int n){
    int i, j, k;
    for( i = 1; i < n; i++)
       for(j = 0; j < i; j++)
	   for(k = 0; k < n; k++) 
            B[i][k] -= T[i][j]*B[j][k];
}

void triag_solve2(double T[][MAXNU], double B[][MAXNU], int n){
    dtrsm('L', 'L', 'N', 'U', n, n, 1.0, T, MAXNU, B, MAXNU);
}

/* compute C -= A*B with C n by nu, A n by nu, B nu by nu */

void rank_nu(double A[][MAXNU], double B[][MAXNU], double C[][MAXNU], 
             int n, int nu){
     int i, j, k;
      for(i = 0; i < n; i++)
           for(j = 0; j < nu; j++)
               for(k = 0; k < nu; k++)
		   C[i][j] -= A[i][k]*B[k][j];
     
}
void rank_nu2(double A[][MAXNU], double B[][MAXNU], double C[][MAXNU], 
             int n, int nu){
     double a, b;
     int maxnu;
     maxnu = MAXNU;
     a = -1.0; b = 1.0;
     dgemm('N', 'N',  n, nu, nu, a, A, maxnu, B, maxnu, b, C, maxnu);
}
