/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993,1995             */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/


#include <stdio.h>
#define MAXNU 8
#define NUM_TIMES 100

extern "C" double fabs(double);
extern "C" double dclock(void);

extern  rank_nu(double A[][MAXNU], double B[][MAXNU], double C[][MAXNU], 
             int n, int nu);

extern  rank_nu2(double A[][MAXNU], double B[][MAXNU], double C[][MAXNU], 
             int n, int nu);

main(){
    double A[128][8], B[8][8], C[128][8], D[128][8];
    double e, ops, start_time, end_time;
    int i, j, k;
    for(i = 0; i < 128; i++)
	for(j = 0; j < 8; j++){
		A[i][j] = 10.0*i + j;
		C[i][j] = D[i][j] = 1.0;
		}
    for(i = 0; i < 8; i++)
	for(j = 0; j < 8; j++) B[i][j] = (1.0*i)/(j+1.0);

    start_time = dclock();
    for(k=0;k<NUM_TIMES;++k){
     rank_nu(A, B, C, 128, 8);
     }
    end_time = dclock();
    ops = (2*NUM_TIMES*128.*8.*8. + 128.*8)/1000000.0;
    printf(" speed = %f old way\n", ops/(end_time-start_time));
    start_time = dclock();
    for(k=0;k<NUM_TIMES;++k){
    	rank_nu2(A, B, D, 128, 8);
	}
    end_time = dclock();
    ops = (2*NUM_TIMES*128.*8.*8. + 128.*8)/1000000.0;
    printf(" speed = %f kmath way\n", ops/(end_time-start_time));
    /*
    e = 0.0;
    for(i = 0; i < 128; i++)
	for(j = 0; j < 8; j++)
		if(fabs(C[i][j] - D[i][j]) > e) e = fabs(C[i][j] - D[i][j]);
    printf("error is %f\n", e);
    */
}
		
     
