#include <stdio.h>
#include <stdlib.h>
#include "Trace.h"

#define MAX_HIST 40

void PrintTrace(FILE *file)
{
  Crt_Event_t event;
  double prev_time, ct_time, diff_time;
  int i;
  unsigned long int Hist[MAX_HIST];

  event.par = new long int[MAX_PAR];

  for(i=0;i<MAX_HIST;i++)
    Hist[i]=0;

  ReadCrtEvent(file, &event);
  prev_time = event.ti;
  while (!ReadCrtEvent(file, &event)) {
    ct_time = event.ti;
    diff_time = ct_time - prev_time;
    if (diff_time < 10) Hist[1]++;
    else if (diff_time < 100) Hist[2]++;
    else if (diff_time < 200) Hist[3]++;
    else if (diff_time < 400) Hist[4]++;
    else if (diff_time < 500) Hist[5]++;
    else if (diff_time < 1000) Hist[6]++;
    else if (diff_time < 2000) Hist[7]++;
    else if (diff_time < 4000) Hist[8]++;
    else if (diff_time < 5000) Hist[9]++;
    else if (diff_time < 10000) Hist[10]++;
    else Hist[11]++;
  }

  printf("<10       : %d\n", Hist[1]);
  printf("10-100    : %d\n", Hist[2]);
  printf("100-200   : %d\n", Hist[3]);
  printf("200-400   : %d\n", Hist[4]);
  printf("400-500   : %d\n", Hist[5]);
  printf("500-1000  : %d\n", Hist[6]);
  printf("1000-2000 : %d\n", Hist[7]);
  printf("2000-4000 : %d\n", Hist[8]);
  printf("4000-5000 : %d\n", Hist[9]);
  printf("5000-10000: %d\n", Hist[10]);
  printf(">10000    : %d\n", Hist[11]);
 
}

main(int argc,char **argv)
{
  char *trace_base;
  FILE *trace_file;

  trace_base=GetBaseName(argc,argv);
  trace_file=OpenTraceFile(trace_base, TRACE_TYPE_CRT, 
                           TRACE_NO_SUBSCRIPT, TRACE_READ);
  PrintTrace(trace_file);
}
