#define MAIN_C
#include <stdio.h>
#include <stdlib.h>
#include "TaskLibIncludes.h"
#include "Trace.h"
#include "Main.h"
#include "Generator.h"

int NumThreads = 4, NumBarriers = 128, NumRequests = 32;
int ElemSize = 1024;
char *OutFileName = DEF_OUTTRACEFILE;
Barrier GlobalBarr(0);
int RequestInterval = 1024;

void PrintUsage(char *pgm)
{
  fprintf(stderr, "Usage: %s -o <outfile> -n <numthreads>\n", pgm);
  fprintf(stderr, "          -b <numbarriers> -r <numrequests>\n");
  fprintf(stderr, "          -s <elemsize> -c<requestinterval>\n");
}

main(int argc,char **argv)
{
  int ch;
  int NumThreadsFlag, NumBarriersFlag, NumRequestsFlag;
  int OutFlag, ElemSizeFlag, IntervalFlag;
  Generator_c **Generator;

  GetOpt getopt(argc, argv, "o:n:b:r:s:c:");

  NumThreadsFlag = NumBarriersFlag = NumRequestsFlag = 0;
  OutFlag = IntervalFlag = ElemSizeFlag = 0;

  while ((ch = getopt()) != -1 ) {
    switch(ch) {
     case 'o':if (OutFlag == 1) {
               fprintf(stderr, "-o flag encountered twice\n");
               PrintUsage(argv[0]);
               exit(1);
              }
              OutFileName = getopt.optarg;
              OutFlag = 1;
              break;
     case 'n':if (NumThreadsFlag == 1) {
               fprintf(stderr, "-n flag encountered twice\n");
               PrintUsage(argv[0]);
               exit(1);
              }
              NumThreadsFlag = 1;
              NumThreads = atoi(getopt.optarg);
              break;
     case 'b':if (NumBarriersFlag == 1) {
               fprintf(stderr, "-b flag encountered twice\n");
               PrintUsage(argv[0]);
               exit(1);
              }
              NumBarriersFlag = 1;
              NumBarriers = atoi(getopt.optarg);
              break;
     case 'r':if (NumRequestsFlag == 1) {
               fprintf(stderr, "-r flag encountered twice\n");
               PrintUsage(argv[0]);
               exit(1);
              }
              NumRequestsFlag = 1;
              NumRequests = atoi(getopt.optarg);
              break;
     case 's':if (ElemSizeFlag == 1) {
               fprintf(stderr, "-s flag encountered twice\n");
               PrintUsage(argv[0]);
               exit(1);
              }
              ElemSizeFlag = 1;
              ElemSize = atoi(getopt.optarg);
              break;
     case 'c':if (IntervalFlag == 1) {
               fprintf(stderr, "-c flag encountered twice\n");
               PrintUsage(argv[0]);
               exit(1);
              }
              IntervalFlag = 1;
              RequestInterval = atoi(getopt.optarg);
              break;
     default: fprintf(stderr, "Unknown flag : -%c\n", ch);
              PrintUsage(argv[0]);
              exit(1);
    }
  }

  GlobalBarr.height(NumThreads);

  Generator = new Generator_c*[NumThreads];

  for(int i=0;i<NumThreads;i++) 
    Generator[i] = new Generator_c(i);

  for(i=0;i<NumThreads;i++)
    Generator[i]->result();

  thistask->resultis(0);
}

#undef MAIN_C
