#define READER_C
#include <stdio.h>
#include <stdlib.h>
#include "TaskLibIncludes.h"
#include "Trace.h"
#include "Collection.h"
#include "Main.h"
#include "Reader.h"
#include "Translator.h"
    
Reader_c::Reader_c() 
{
  Trc_Event_t event;
  unsigned long int prev_time_in, prev_time_out, tmp_time;
  unsigned long int ct_phase_start, ct_phase_end;
  int threads_in_ct_phase;

  fp = OpenTraceFile(InFileName,TRACE_TYPE_TRC, TRACE_NO_SUBSCRIPT, TRACE_READ);

  Reader_Translators_Barr.wait();

  ReadTrcEvent(fp, &event);
  prev_time_in = event.ti;
  prev_time_out = event.ti;
  do {

    if (event.ev == PCXX_EV_FLUSH_EXIT) {
      prev_time_in = event.ti; continue;
    }

    tmp_time = event.ti;
    event.ti = event.ti - prev_time_in + prev_time_out - Overhead;
    if (event.ti <= prev_time_out) event.ti = prev_time_out + 1;
    prev_time_out= event.ti;
    prev_time_in = tmp_time;

    if (event.ev == PCXX_EV_FLUSH_ENTER) continue;

    Translator[event.nid]->DeliverEvent(&event);
    
    if (event.ev == PCXX_FORK_ENTER) break;

  } while(!ReadTrcEvent(fp, &event));

  ct_phase_start = prev_time_out + 1;
  ct_phase_end = ct_phase_start;
  threads_in_ct_phase = 0;

  while(!ReadTrcEvent(fp, &event)) {

    prev_time_in = event.ti;
    prev_time_out = ct_phase_start;
    if (event.ev == PCXX_FORK_EXIT) break;

    do {

      if (event.ev == PCXX_EV_FLUSH_EXIT) {
        prev_time_in = event.ti; continue;
      }

      tmp_time = event.ti;
      event.ti = event.ti - prev_time_in + prev_time_out - Overhead;
      if (event.ti <= prev_time_out) event.ti = prev_time_out + 1;
      prev_time_out = event.ti;
      prev_time_in = tmp_time;

      if (event.ev == PCXX_EV_FLUSH_ENTER) continue;

      Translator[event.nid]->DeliverEvent(&event);

      if (event.ev == PCXX_BARRIER_ENTER || event.ev == PCXX_MAIN_EXIT) 
        break;

    } while(!ReadTrcEvent(fp, &event));

    if (event.ti > ct_phase_end) 
      ct_phase_end = event.ti; 
    threads_in_ct_phase++;

    if (threads_in_ct_phase == NumThreads) {
      ct_phase_start = ct_phase_end + 1;
      threads_in_ct_phase = 0;
    }
  }

  do {

    if (event.ev == PCXX_EV_FLUSH_EXIT) {
      prev_time_in = event.ti; continue;
    }

    tmp_time = event.ti;
    event.ti = event.ti - prev_time_in + prev_time_out - Overhead;
    if (event.ti <= prev_time_out) event.ti = prev_time_out + 1;
    prev_time_out= event.ti;
    prev_time_in = tmp_time;

    if (event.ev == PCXX_EV_FLUSH_ENTER) continue;

    Translator[event.nid]->DeliverEvent(&event);

  } while(!ReadTrcEvent(fp, &event));

  for(int i=0;i<NumThreads;i++)
    Translator[i]->DeliverEvent(NULL);

  Reader_Translators_Barr.wait();

  thistask->resultis(0);

}

#undef READER_C
