#include <stdio.h>
#include <stdlib.h>
#include "Trace.h"

#define MAX_HIST 40

void PrintTrace(FILE *file)
{
  Trc_Event_t event;
  unsigned long int prev_time, ct_time, diff_time;
  int i;
  unsigned long int Hist[MAX_HIST];
  unsigned long int Time[MAX_HIST];

  for(i=0;i<MAX_HIST;i++) {
    Hist[i]=0;
    Time[i]=0;
  }

  ReadTrcEvent(file, &event);
  prev_time = event.ti;
  while (!ReadTrcEvent(file, &event)) {
    ct_time = event.ti;
    diff_time = ct_time - prev_time;
    if (diff_time < 10) { Hist[1]++; Time[1] += diff_time; }
    else if (diff_time < 100) { Hist[2]++; Time[2] += diff_time; }
    else if (diff_time < 200)  {Hist[3]++; Time[3] += diff_time; }
    else if (diff_time < 400)  {Hist[4]++; Time[4] += diff_time; }
    else if (diff_time < 500)  {Hist[5]++; Time[5] += diff_time; }
    else if (diff_time < 1000)  {Hist[6]++; Time[6] += diff_time; }
    else if (diff_time < 2000)  {Hist[7]++; Time[7] += diff_time; }
    else if (diff_time < 4000)  {Hist[8]++; Time[8] += diff_time; }
    else if (diff_time < 5000)  {Hist[9]++; Time[9] += diff_time; }
    else if (diff_time < 10000)  {Hist[10]++; Time[10] += diff_time; }
    else if (diff_time < 100000)  {Hist[11]++; Time[11] += diff_time; }
    else if (diff_time < 500000)  {Hist[12]++; Time[12] += diff_time; }
    else if (diff_time < 1000000)  {Hist[13]++; Time[13] += diff_time; }
    else { Hist[14]++; Time[14] += diff_time; }
    prev_time = ct_time;
  }

  printf("<10       : %d  %lu\n", Hist[1], Time[1]);
  printf("10-100    : %d  %lu\n", Hist[2], Time[2]);
  printf("100-200   : %d  %lu\n", Hist[3], Time[3]);
  printf("200-400   : %d  %lu\n", Hist[4], Time[4]);
  printf("400-500   : %d  %lu\n", Hist[5], Time[5]);
  printf("500-1000  : %d  %lu\n", Hist[6], Time[6]);
  printf("1000-2000 : %d  %lu\n", Hist[7], Time[7]);
  printf("2000-4000 : %d  %lu\n", Hist[8], Time[8]);
  printf("4000-5000 : %d  %lu\n", Hist[9], Time[9]);
  printf("5000-10000: %d  %lu\n", Hist[10], Time[10]);
  printf("10000-100000: %d  %lu\n", Hist[11], Time[11]);
  printf("100000-500000: %d  %lu\n", Hist[12], Time[12]);
  printf("500000-1000000: %d  %lu\n", Hist[13], Time[13]);
  printf(">1000000    : %d  %lu\n", Hist[14], Time[14]);
 
}

main(int argc,char **argv)
{
  char *trace_base;
  FILE *trace_file;

  trace_base=GetBaseName(argc,argv);
  trace_file=OpenTraceFile(trace_base, TRACE_TYPE_TRC, 
                           TRACE_NO_SUBSCRIPT, TRACE_READ);
  PrintTrace(trace_file);
}
