#define DEFAULTSIMULATION_C
#include "Trace.h"
#include "TaskLibIncludes.h"
#include "SimulatorIncludes.h"

void DefaultSimulation(Node_c *Node)
{
  FILE *Fpout;
  Crt_Event_t Event,*CurrentEvent, *PrevEvent;
  double ComputationTime;
  int i;

  Fpout = Node->GetFpout(); 
  CurrentEvent = Node->GetCurrentEvent();
  PrevEvent = Node->GetPrevEvent();
  Event.par = new long int[MAX_PAR];

  ComputationTime = CurrentEvent->ti - PrevEvent->ti;
  Computation(Node, ComputationTime);

  if (!NoOutTrace) {
    Event.ti = GetCurrentTime();
    Event.nid = CurrentEvent->nid;
    Event.ev = CurrentEvent->ev;
    Event.num_par = CurrentEvent->num_par;
    for(i=0;i<Event.num_par;i++)
       Event.par[i] = CurrentEvent->par[i];
    WriteCrtEvent(Fpout, &Event);
  }

  delete Event.par;
}

#undef DEFAULTSIMULATION_C
