#ifndef GLOBALPAR_H
#define GLOBALPAR_H

extern int _RequestMsgSize;

extern double _BarrierExitTime;
extern double _BarrierEntryTime;
extern double _BarrierCheckTime;
extern double _BarrierModelTime;
extern double _BarrierExitCheckTime;
extern int    _BarrierByMsgs;
extern int    _BarrierMsgSize;

extern double _PackStartupTime;
extern double _BytePackTime;
extern double _ToNWStartupTime;
extern double _ByteToNWTransferTime;
extern double _CommStartupTime;
extern double _ByteTransferTime;
extern double _AddMsgTryTime;
extern double _AddMsgStartupTime;
extern double _AddMsgTime;
extern double _GetMsgTryTime;
extern double _GetMsgStartupTime;
extern double _GetMsgTime;
extern double _MsgProcessingTime;

extern double _MipsRatio;
extern double _Delta;
extern int    _ProcessMsgType;

extern int _Topology;

#ifdef SYSTEM_C

int _RequestMsgSize;

double _BarrierExitTime;
double _BarrierEntryTime;
double _BarrierCheckTime;
double _BarrierModelTime;
double _BarrierExitCheckTime;
int    _BarrierByMsgs;
int    _BarrierMsgSize;

double _PackStartupTime;
double _BytePackTime;
double _ToNWStartupTime;
double _ByteToNWTransferTime;
double _CommStartupTime;
double _ByteTransferTime;
double _AddMsgTryTime;
double _AddMsgStartupTime;
double _AddMsgTime;
double _GetMsgTryTime;
double _GetMsgStartupTime;
double _GetMsgTime;
double _MsgProcessingTime;

double _MipsRatio;
double _Delta;
int    _ProcessMsgType;  

int _Topology;

#endif

#endif

/*

_ProcessMsgType - When to process messages

    0 - default, during barrier waits and message reply waits
    1 - default + at the end of each event
    2 - default + polled every _Delta during computation
    3 - default + at the end of every event + polled every _Delta during comp.

_BarrierByMsgs - use real or imag messages for barrier synchronization

    0 - default, use IMAG type control messages which don't have transmission
        delays
    1 - use real messages which incur transmission delays.
*/
