#define MAIN_C
#include <stdio.h>
#include <stdlib.h>
#include "Trace.h"
#include "TaskLibIncludes.h"
#include "SimulatorIncludes.h"

void PrintUsage(char *pgmname)
{
  fprintf(stderr, "Usage: %s [-i infile] [-o outfile | -n] [-p parfile] [-s statfile] \n", pgmname);
}

main(int argc, char **argv)
{
  extern char* optarg;
  int ch, ParFlag, InTraceFlag, StatFlag, OutTraceFlag, NoOutTraceFlag;
  FILE *File0;
  int NumThreads;
  System_c *Sys;

  GetOpt getopt(argc, argv, "p:i:o:s:n");

  ParFlag = InTraceFlag = StatFlag = OutTraceFlag = NoOutTraceFlag = 0;
  while ((ch = getopt()) != -1) {  
    switch(ch) {
     case 'p':if (ParFlag == 1) {
               fprintf(stderr, "-p flag encountered twice\n");
               PrintUsage(argv[0]);
               exit(1);
              }
              ParFileName = getopt.optarg;
              ParFlag = 1;
              break;
     case 'i':if (InTraceFlag == 1) {
                fprintf(stderr, "-i flag encountered twice\n");
                PrintUsage(argv[0]); 
                exit(1);
              }
              InFileName = getopt.optarg;
              InTraceFlag = 1;
              break;
     case 's':if (StatFlag == 1) {
                fprintf(stderr, "-s flag encountered twice\n");
                PrintUsage(argv[0]);
                exit(1);
              }
              StatFileName = getopt.optarg;
              StatFlag = 1;
              break;
     case 'o':if (OutTraceFlag == 1 ) {
                 fprintf(stderr, "-o flag encountered twice\n");
                 PrintUsage(argv[0]);
                 exit(1);
              }
              if (NoOutTraceFlag == 1) {
                 fprintf(stderr, "conflicting flags -o and -n\n");
                 PrintUsage(argv[0]);
                 exit(1);
              }
              OutFileName = getopt.optarg;
              OutTraceFlag = 1;
              break;
     case 'n':if (NoOutTraceFlag == 1) { 
                 fprintf(stderr, "-n flag encountered twice\n");
                 PrintUsage(argv[0]);
                 exit(1);
               }
              if (OutTraceFlag == 1) {
                 fprintf(stderr, "conflicting flags -o and -n\n");
                 PrintUsage(argv[0]);
                 exit(1);
              }
              NoOutTrace = 1;
              NoOutTraceFlag = 1;
              break;
     default:fprintf(stderr, "Unknown flag : -%c\n", ch);
             PrintUsage(argv[0]);
             exit(1);
   }
  }

  File0 = OpenTraceFile(InFileName,TRACE_TYPE_CRT,0,TRACE_READ);
  NumThreads = GetNumThreads(File0, TRACE_TYPE_CRT);
  Sys = new System_c(NumThreads);
  Sys->Run();
  delete Sys;

  thistask->resultis(0);

  /* Programs using Cc Task library should NOT return.
     They should use resultis instead. */
  /* return 0; */
}

#undef MAIN_C
