#ifndef NODE_H
#define NODE_H

class System_c;
class Msg_c;
class MsgQueue_c;

class Node_c:public task{
 private:
  int NodeId;
  System_c *Sys;
  MsgQueue_c *MsgQueue;
  FILE *Fpin, *Fpout;
  Crt_Event_t *CurrentEvent, *PrevEvent;
  int State;
  long Remain;
  task *IntrTask;
 public:
  Node_c(System_c *sys,int node_id);
  void SetState(int s)         { State = s; };
  int GetState()               { return State; };
  void SetRemain(long d)       { Remain = d; };
  long GetRemain()             { return Remain; };
  task *GetIntrTask()          { return IntrTask; };
  void SetIntrTask(task *t)    { IntrTask = t; };
  int GetNodeId()              { return NodeId;} ;
  System_c *GetSys()           { return Sys;} ;
  int DeliverMsg(Msg_c *Msg)   { return MsgQueue->AddMsg(Msg); };
  Msg_c *GetMsgNoBlock()       { return MsgQueue->GetMsgNoBlock(); };
  Msg_c *GetMsg()              { return MsgQueue->GetMsg(); };
  FILE *GetFpin()              { return Fpin;} ;
  FILE *GetFpout()             { if (NoOutTrace) return NULL;
                                 else return Fpout;} ;
  Crt_Event_t *GetPrevEvent()      { return PrevEvent; };
  Crt_Event_t *GetCurrentEvent()   { return CurrentEvent; };
  int iSuspend(double time);
};

#ifndef NODE_C
#endif

#endif
