#define PROCESSMSG_C
#include "Trace.h"
#include "TaskLibIncludes.h"
#include "SimulatorIncludes.h"

double MsgProcessingTime()
{
  return _MsgProcessingTime;
}

void ProcessMsg(Node_c *Node, Msg_c *Msg)
{
  Msg_c *ReplyMsg;
  Network_c *Network;

  Network = Node->GetSys()->GetNetwork();

  if (Msg->GetMsgCat() == REAL)
    Suspend(MsgProcessingTime());
  switch(Msg->GetMsgType()) {
  case BARRIERENTRYMSG:
    NumNodesInBarrier++;
    delete Msg;
    break;
  case REQUESTMSG:
    ReplyMsg = new Msg_c(REAL, REPLYMSG, Msg->GetMsgPar(), Node->GetNodeId(),
			 Msg->GetFromNodeId(), 0);
    Network->SendMsg(ReplyMsg);
    delete Msg;
    break;
  default:
    delete Msg;
    break;
  }
}

#undef PROCESSMSG_C
