#ifndef SYSTEM_H
#define SYSTEM_H

class Node_c;
class Network_c;
class Statistics_c;

class System_c {
 private:
  Node_c **Nodes;
  Network_c *Network;
  Statistics_c *Statistics;
  int NumNodes;
 public:
  System_c(int numnodes);
  ~System_c();
  Node_c *GetNode(int i)  { return Nodes[i];} ;
  Network_c *GetNetwork() { return Network;} ;
  int GetNumNodes()       { return NumNodes;} ;
  Statistics_c *GetStatistics() { return Statistics;} ;
  void Run();
};

#ifndef SYSTEM_C
extern double GetCurrentTime();
extern void Suspend(double time);
extern int GetNumNodes();
#endif

#endif

