      program blocpq

C  -----------------------------------
C  |  p = 1   |    p = 4  |   p = 8  |
C  -----------------------------------
C  | 627 sec  |  187sec   |  108 sec |
C  -----------------------------------
C  | Sp = 1   |  sp = 3.36| sp = 5.8 |
C  -----------------------------------

C$ann[Define("SVM", 1)]
      implicit double precision (a-h,o-z)
      double precision a(8,8),eq(8),e(8),err(100),eexact(100),
     +          c(8),d(8),byn(512,8),bynp1(512,8),
     +          y(100),dy(100),v(100),aux(100),
     +          rjac(100,100),rjlu(100,100),
     +          bxn(512,8),bxnp1(512,8),ylast(100),coefl(8)
      integer itnewt(8), ipvt(100)
      integer t1, t2
C$ann[Shared(byn,"BLOCK")]
C$ann[Shared(bynp1,"BLOCK")]
C$ann[Shared(bxn,"BLOCK")]
C$ann[Shared(bxnp1,"BLOCK")]

      common/param/iprob
      common/dparam/eps,pi
      common/grid/nx
      common/count/itnewt
      common/osc/alfa
      nr=100
      pi=3.141592653589793238D0
C      read (5,*) meth
C      read (5,*) iprob
C      read (5,*) nsu
      meth = 8
      iprob = 9
      nsu = 16
      write(6,1)meth,iprob,nsu
    1 format(///,'  method nr.:',i5,/,
     +           '  we solved problem',i3,'  with step h=1/',i4,/) 
      if(iprob.eq.3 .or. iprob.eq.4 .or. iprob.eq.6)then
         read(5,*)eps
         write(6,3)eps
    3    format('  and eps=',e10.2)
      endif
      if(iprob.eq.9)then
C         read(5,*)nx
         nx = 64
         write(6,8)nx
    8    format('  and dx=1/',i4)
      endif
      call method(meth,a,d,c,e,eq,k)
      call lagr(k,1.0d0*(k+1),c,coefl)
      call problem(tb,tend,neqn)
      if(iprob.eq.10)then
         read(5,*)alfa
         write(6,9)alfa
    9    format('  alfa=',f10.5)
      endif
C      t1 = mclock()
      h=1.D0/nsu
      nsteps=nint((tend-tb)/h)
C---Compute the initial block
C$ann[DoShared("BLOCK")]
      do 6 j=1,k
         call init(neqn,tb+(c(j)-1.D0)*h,y)
         do  i=1,neqn
           byn(i,j)=y(i)
        enddo
    6 continue
C---Set the Newton counter to zero
      do  i=1,k
         itnewt(i)=0
      enddo
C---Main loop
      t=tb
      do 200 ns=1,nsteps
         do 7 i=1,neqn
            y(i)=byn(i,1)
    7    continue
         call evalj(neqn,t,y,rjac,nr)
C-----Compute X=Y-Yk.e and save Yk=ylast
         do  i=1,neqn
            ylast(i)=byn(i,k)
         enddo
C$ann[DoShared("BLOCK")]
         do 22 j=1,k
            do  i=1,neqn
               bxn(i,j)=byn(i,j)-ylast(i)
            enddo
   22    continue
C-----Construct an initial guess for the Newton process
C-----and solve the nonlinear relations
C$ann[DoShared("BLOCK")]
         do 100 j=1,k
            if (j.lt.k) then
               do 25 i=1,neqn
   25             y(i)=bxn(i,j+1)
            else
               do 27 i=1,neqn
                  y(i)=0.0d0
                  do  l=1,k
                     y(i)=y(i)+coefl(l)*bxn(i,l)
                  enddo
   27          continue
            endif
            do  i=1,neqn
               v(i)=0.D0
            enddo
            do 50 i=1,neqn
               do 40 l=1,k
                  v(i)=v(i)+a(j,l)*bxn(i,l)
   40          continue
   50       continue
            call newton(neqn,t+c(j)*h,y,v,h,d(j),
     +                 rjac,nr,rjlu,aux,ipvt,j,ylast,dy)
            do  i=1,neqn
               bxnp1(i,j)=y(i)
            enddo
  100    continue
C-----Compute Y(n+1)=X(n+1)+Yk
C$ann[DoShared("BLOCK")]
         do 105 j=1,k
            do  i=1,neqn
               bynp1(i,j)=ylast(i)+bxnp1(i,j)
            enddo
  105    continue
         t=t+h
C$ann[DoShared("BLOCK")]
         do 120 j=1,k
            do  i=1,neqn
               byn(i,j)=bynp1(i,j)
            enddo
  120    continue
  200 continue
C      call gsync()
C      t2 = mclock()
c
      call sol(neqn,t,y)
      errmax=0.D0
      do 210 i=1,neqn
         solnum=byn(i,1)
         error=abs(y(i)-solnum)/abs(y(i))
         errmax=max(errmax,error)
         write(6,4)i,solnum,-log10(error)
    4    format(' component',i3,' = ',e22.14,f10.2)
  210 continue
      write(6,2) t,-log10(errmax)
    2 format('  at t=',f12.8,'  we have sd=',f7.2)
      do 220 l=1,k
      write(6,13)l,itnewt(l),itnewt(l)/(1.D0*nsteps)
  220 continue
   13 format('  for comp.',i4,'  we need',i5,' newton it.',f6.2,
     +       '  per step') 

C$ann[BeginSeq()]
        print *,'3 : Timing results : ',t2-t1
C$ann[EndSeq()]

      end
C
C$ann[NoSideEffect()]
      subroutine lagr(k,x,c,coefl)
      implicit double precision (a-h,o-z)
      double precision  c(k),coefl(k)
      do 20 i=1,k
      coefl(i)=1.0d0
      do 10 j=1,k
      if(j.ne.i)coefl(i)=coefl(i)*(x-c(j))/(c(i)-c(j))
   10 continue
   20 continue
      return
      end
c
C$ann[NoSideEffect()]
      subroutine newton(neqn,t,y,v,h,d,rjac,nr,rjlu,aux,ipvt,l,
     +                  yl,arg)
      implicit double precision (a-h,o-z)
      double precision y(neqn),v(neqn),aux(neqn),yl(neqn),arg(neqn),
     +          rjac(nr,*),rjlu(nr,*)
      integer ipvt(neqn)
      common/count/itnewt(8)
      do  j=1,neqn
         do  i=1,neqn
            rjlu(i,j)=-d*h*rjac(i,j)
         enddo
         rjlu(j,j)=1.D0+rjlu(j,j)
      enddo
      call sgefa(rjlu,nr,neqn,ipvt,info)
       if(info.ne.0)then
          write(6,21)info
   21     format(' error in lu-factorization',i3)
       endif
      iter=0
      job=0
   30 do i=1,neqn
         arg(i)=y(i)+yl(i)
      enddo
      call f(neqn,t,arg,aux)
      do  i=1,neqn
         aux(i)=y(i)-h*d*aux(i)-v(i)
      enddo
      ifail=0
      call sgesl(rjlu,nr,neqn,ipvt,aux,job)
      if(ifail.ne.0)then
         write(6,1)ifail
    1    format('  error in solving linear system',i5)
      endif
      corr=0.D0
      do 50 i=1,neqn
      corr=max(corr,abs(aux(i)))
      y(i)=y(i)-aux(i)
   50 continue
      iter=iter+1
      itnewt(l)=itnewt(l)+1
      if(iter.eq.20)then
         write(6,2)t,corr
    2    format('  bad convergence in the newton-process at t=',
     +          f8.4,'  residu=',e10.3) 
         iter=0
      endif
      if(corr.gt.1.D-14) goto 30
      return
      end
C
C$ann[NoSideEffect()]
      subroutine method(meth,a,d,c,e,eq,k)
      implicit double precision (a-h,o-z)
      double precision a(8,8),c(8),d(8),e(8),eq(8)
c
      goto(10,20,30,40,50,60,70,80),meth
c
c--------------------------
c   order 1, Backward Euler
c--------------------------
   10 k=1
      a(1,1)=1.0d0
      d(1)=1.0d0
      c(1)=1.0d0
      return
c
c---------------------------
c   order 2, k=2
c---------------------------
   20 k=2
      a(1,1)=0.5d0
      a(1,2)=0.5d0
      a(2,1)=-0.25d0
      a(2,2)=1.25d0
      d(1)=0.5d0
      d(2)=0.75d0
      c(1)=1.0d0
      c(2)=2.0d0
C
      E(1) = -1
      E(2) = 2
C
      EQ(1) = -1
      EQ(2) = 1
C
      return
c
c-----------------------
c   order 3, k=3
c-----------------------
   30 k=3
C
C     r=3.1848506441250080137 leads to superconvergence
C
      r=3.1848506441250080137D0
C
      A(2,3) = (-9+2*r)/r/2
      A(1,1) = 1/r
      A(1,2) = 1
      A(2,1) = -3.D0/2.D0/r
      A(2,2) = 6/r
      A(3,2) = -(-16+3*r)/r
      A(1,3) = -1/r
      A(3,1) = (r-6)/r
      A(3,3) = (-10+3*r)/r
C
      D(1) = 2/r
      D(2) = 3/r
      D(3) = 4/r
C
      do  i=1,k
         c(i)=i
      enddo
C
      E(3) = 3-11.D0/4.D0*r+r**2/2
      E(1) = 6-15.D0/4.D0*r+r**2/2
      E(2) = -8+13.D0/2.D0*r-r**2
C
      EQ(3) = -3+r
      EQ(1) = -4+r
      EQ(2) = 7-2*r
C
      return
C
C-------------------------------------
C     Stage-order 3, order 3 or 4, k=3
C-------------------------------------
   40 k=4
C
C     r=5 is the method of the report and leads to superconvergence and order 5
C
      r=5.D0
C
      A(3,2) = -6.D0/r
      A(2,3) = (-3.D0+2.D0*r)/r/2.D0
      A(2,1) = -1.D0/r/2.D0
      A(1,2) = (1.D0+r)/r
      A(2,2) = 3.D0/r
      A(4,3) = -(-95.D0+12.D0*r)/r/2.D0
      A(4,1) = -(6.D0*r-55.D0)/r/6.D0
      A(3,1) = 4.D0/3.D0/r
      A(4,4) = (-65.D0+12.D0*r)/r/3.D0
      A(1,1) = 2.D0/3.D0/r
      A(3,4) = (-22.D0+3.D0*r)/r/3.D0
      A(3,3) = 12.D0/r
      A(1,4) = 1.D0/r/3.D0
      A(1,3) = -2.D0/r
      A(4,2) = (-35.D0+4.D0*r)/r
      A(2,4) = -1.D0/r
C
      D(2) = 3.D0/r
      D(4) = 5.D0/r
      D(1) = 2.D0/r
      D(3) = 4.D0/r
      do 41 i=1,k
      c(i)=1.0d0*i
   41 continue
C
      E(3) = 15-109.D0/6.D0*r+23.D0/4.D0*r**2-r**3/2
      E(4) = -4+185.D0/36.D0*r-7.D0/4.D0*r**2+r**3/6
      E(1) = 10-80.D0/9.D0*r+9.D0/4.D0*r**2-r**3/6
      E(2) = -20+263.D0/12.D0*r-25.D0/4.D0*r**2+r**3/2
C
      EQ(3) = -21+49.D0/4.D0*r-3.D0/2.D0*r**2
      EQ(4) = 6-15.D0/4.D0*r+r**2/2
      EQ(1) = -10+19.D0/4.D0*r-r**2/2
      EQ(2) = 25-53.D0/4.D0*r+3.D0/2.D0*r**2
C
      return
C
C------------------------------------
C    Stage-order 4, order 4 or 5, k=5
C------------------------------------
C
   50 k=5
C
C     r=4.3651991068647378479 leads to superconvergence.
C     r=6 is the method of the report.
C
      r=4.3651991068647378479D0
C
      A(3,2) = -2/r
      A(5,3) = (-117+10*r)/r
      A(2,3) = 1
      A(2,1) = -1/r/4
      A(1,2) = (5+3*r)/r/3
      A(4,5) = (-125+12*r)/r/12
      A(2,2) = 2/r
      A(5,5) = (-77+10*r)/r/2
      A(4,3) = -15/r
      A(4,1) = -5.D0/4.D0/r
      A(5,4) = -(-107+10*r)/r
      A(1,5) = -1/r/6
      A(3,1) = 1/r/3
      A(4,4) = 20/r
      A(1,1) = 1/r/2
      A(3,4) = (-10+3*r)/r/3
      A(3,3) = 6/r
      A(1,4) = 1/r
      A(5,2) = -(-61+5*r)/r
      A(1,3) = -3/r
      A(2,5) = 1/r/4
      A(3,5) = -1/r
      A(4,2) = 20.D0/3.D0/r
      A(2,4) = -2/r
      A(5,1) = (2*r-25)/r/2
C
      D(2) = 3/r
      D(5) = 6/r
      D(4) = 5/r
      D(1) = 2/r
      D(3) = 4/r
      do 51 i=1,k
      c(i)=1.0d0*i
   51 continue
C
      E(3) = 45-3205.D0/48.D0*r+1405.D0/48.D0*r**2+r**4/4-19.D0/4.D0*r**
     #3
      E(4) = -24+901.D0/24.D0*r-1255.D0/72.D0*r**2-r**4/6+3*r**3
      E(5) = 5-2333.D0/288.D0*r+1129.D0/288.D0*r**2-17.D0/24.D0*r**3+r**
     #4/24
      E(1) = 15-1631.D0/96.D0*r+1777.D0/288.D0*r**2-7.D0/8.D0*r**3+r**4/
     #24
      E(2) = -40+3911.D0/72.D0*r-1579.D0/72.D0*r**2-r**4/6+10.D0/3.D0*r*
     #*3
C
      EQ(3) = -81+787.D0/12.D0*r-15*r**2+r**3
      EQ(4) = 46-1415.D0/36.D0*r+19.D0/2.D0*r**2-2.D0/3.D0*r**3
      EQ(5) = -10+80.D0/9.D0*r-9.D0/4.D0*r**2+r**3/6
      EQ(1) = -20+491.D0/36.D0*r-11.D0/4.D0*r**2+r**3/6
      EQ(2) = 65-1757.D0/36.D0*r+21.D0/2.D0*r**2-2.D0/3.D0*r**3
C
      return
C
C-------------------------------------
C     Stage-order 5, order 5 or 6, k=6
C-------------------------------------
C
   60 k=6
C
C     r=3.9232210822126856421 or  r=6.1076901845814432165 leads
C     to superconvergence. I recommend the second value.
C     r=6 is the method of the report.
C
      r=6.1076901845814432165D0
C
      A(3,2) = -1/r
      A(5,3) = 20/r
      A(2,3) = (1+r)/r
      A(6,2) = 3.D0/2.D0*(-63+4*r)/r
      A(2,1) = -3.D0/20.D0/r
      A(2,6) = -1/r/10
      A(1,2) = (13+6*r)/r/6
      A(3,6) = 1/r/5
      A(4,5) = (-65+12*r)/r/12
      A(5,6) = (-137+10*r)/r/10
      A(6,5) = -3.D0/4.D0*(-273+20*r)/r
      A(2,2) = 3.D0/2.D0/r
      A(5,5) = 30/r
      A(4,3) = -5/r
      A(4,1) = -1/r/4
      A(5,4) = -30/r
      A(1,5) = -2.D0/3.D0/r
      A(6,3) = -3*(-77+5*r)/r
      A(3,1) = 2.D0/15.D0/r
      A(4,4) = 10/r
      A(4,6) = -1/r
      A(6,1) = -(60*r-959)/r/60
      A(1,1) = 2.D0/5.D0/r
      A(3,4) = (-4+3*r)/r/3
      A(3,3) = 4/r
      A(6,6) = 3.D0/10.D0*(-203+20*r)/r
      A(1,4) = 2/r
      A(5,2) = -15.D0/2.D0/r
      A(1,3) = -4/r
      A(2,5) = 3.D0/4.D0/r
      A(3,5) = -2/r
      A(1,6) = 1/r/10
      A(6,4) = (-889+60*r)/r/3
      A(4,2) = 5.D0/3.D0/r
      A(2,4) = -3/r
      A(5,1) = 6.D0/5.D0/r
C
      D(2) = 3/r
      D(5) = 6/r
      D(4) = 5/r
      D(1) = 2/r
      D(3) = 4/r
      D(6) = 7/r
C
      do 61 i=1,k
      c(i)=1.0d0*i
   61 continue
C
      E(3) = -131527.D0/720.D0*r+3625.D0/36.D0*r**2-3349.D0/144.D0*r**3-
     #r**5/12+7.D0/3.D0*r**4+105
      E(4) = 55241.D0/360.D0*r-4265.D0/48.D0*r**2+3097.D0/144.D0*r**3-84
     #-9.D0/4.D0*r**4+r**5/12
      E(5) = -95117.D0/1440.D0*r+5707.D0/144.D0*r**2-2869.D0/288.D0*r**3
     #+35+13.D0/12.D0*r**4-r**5/24
      E(6) = 20863.D0/1800.D0*r-2057.D0/288.D0*r**2+533.D0/288.D0*r**3-6
     #-5.D0/24.D0*r**4+r**5/120
      E(1) = -205777.D0/7200.D0*r+213.D0/16.D0*r**2-785.D0/288.D0*r**3+r
     #**4/4-r**5/120+21
      E(2) = 20209.D0/180.D0*r-16601.D0/288.D0*r**2+3625.D0/288.D0*r**3-
     #70+r**5/24-29.D0/24.D0*r**4
C
      EQ(3) = -231+11303.D0/48.D0*r-11045.D0/144.D0*r**2-5.D0/12.D0*r**4
     #+39.D0/4.D0*r**3
      EQ(4) = 196-30125.D0/144.D0*r+10253.D0/144.D0*r**2+5.D0/12.D0*r**4
     #-113.D0/12.D0*r**3
      EQ(5) = -85+27025.D0/288.D0*r-9533.D0/288.D0*r**2-5.D0/24.D0*r**4+
     #109.D0/24.D0*r**3
      EQ(6) = 15-1631.D0/96.D0*r+1777.D0/288.D0*r**2+r**4/24-7.D0/8.D0*r
     #**3
      EQ(1) = -35+8821.D0/288.D0*r-2569.D0/288.D0*r**2-r**4/24+25.D0/24.
     #D0*r**3
      EQ(2) = 140-38521.D0/288.D0*r+11909.D0/288.D0*r**2+5.D0/24.D0*r**4
     #-121.D0/24.D0*r**3
C
      return
C
C-------------------------------------
C     Stage-order 6, order 6 or 7, k=7
C-------------------------------------
C
   70 k=7
C
C     r=5.5438664370799515398 leads to superconvergence.
C     r=7 is the method of the report.
C
      r=5.5438664370799515398D0
C
      A(3,2) = -3.D0/5.D0/r
      A(5,3) = 5/r
      A(2,3) = (7+4*r)/r/4
      A(6,2) = 42.D0/5.D0/r
      A(2,1) = -1/r/10
      A(2,6) = -2.D0/5.D0/r
      A(1,2) = (77+30*r)/r/30
      A(3,6) = 3.D0/5.D0/r
      A(4,5) = (-35+12*r)/r/12
      A(5,6) = (-77+10*r)/r/10
      A(6,5) = -105.D0/2.D0/r
      A(7,2) = -(-2038+105*r)/r/15
      A(2,2) = 6.D0/5.D0/r
      A(5,5) = 15/r
      A(4,3) = -5.D0/2.D0/r
      A(7,7) = (-446+35*r)/r/5
      A(6,7) = (-343+20*r)/r/20
      A(7,5) = (-1898+105*r)/r/3
      A(3,7) = -1/r/15
      A(4,1) = -1/r/12
      A(5,4) = -10/r
      A(5,7) = -1/r
      A(1,5) = -5.D0/3.D0/r
      A(4,7) = 1/r/6
      A(6,3) = -105.D0/4.D0/r
      A(3,1) = 1/r/15
      A(4,4) = 20.D0/3.D0/r
      A(4,6) = -2/r
      A(6,1) = -7.D0/6.D0/r
      A(1,1) = 1/r/3
      A(3,4) = 1
      A(7,6) = -3.D0/5.D0*(-586+35*r)/r
      A(3,3) = 3/r
      A(6,6) = 42/r
      A(1,4) = 10.D0/3.D0/r
      A(5,2) = -3.D0/2.D0/r
      A(1,3) = -5/r
      A(2,5) = 3.D0/2.D0/r
      A(7,4) = -(-656+35*r)/r
      A(3,5) = -3/r
      A(1,7) = -1/r/15
      A(7,1) = (5*r-98)/r/5
      A(1,6) = 1/r/2
      A(6,4) = 140.D0/3.D0/r
      A(4,2) = 2.D0/3.D0/r
      A(2,7) = 1/r/20
      A(2,4) = -4/r
      A(5,1) = 1/r/5
      A(7,3) = 3*(-134+7*r)/r
C
      D(2) = 3/r
      D(5) = 6/r
      D(7) = 8/r
      D(4) = 5/r
      D(1) = 2/r
      D(3) = 4/r
      D(6) = 7/r
C
      do 71 i=1,k
      c(i)=1.0d0*i
   71 continue
C
      E(3) = -1198967.D0/2880.D0*r+4727647.D0/17280.D0*r**2-92957.D0/115
     #2.D0*r**3+r**6/48-77.D0/96.D0*r**5+6719.D0/576.D0*r**4+210
      E(4) = 200861.D0/432.D0*r-4139197.D0/12960.D0*r**2+28249.D0/288.D0
     #*r**3-r**6/36-224+25.D0/24.D0*r**5-6347.D0/432.D0*r**4
      E(5) = -863093.D0/2880.D0*r+3672487.D0/17280.D0*r**2-77641.D0/1152
     #.D0*r**3+r**6/48-73.D0/96.D0*r**5+140+5999.D0/576.D0*r**4
      E(6) = 756311.D0/7200.D0*r-3296197.D0/43200.D0*r**2+14299.D0/576.D
     #0*r**3-r**6/120+71.D0/240.D0*r**5-1135.D0/288.D0*r**4-48
      E(7) = -672859.D0/43200.D0*r+7+2987647.D0/259200.D0*r**2-4411.D0/1
     #152.D0*r**3+r**6/720-23.D0/480.D0*r**5+1075.D0/1728.D0*r**4
      E(1) = -1907521.D0/43200.D0*r+6438247.D0/259200.D0*r**2-839.D0/128
     #.D0*r**3+r**6/720-9.D0/160.D0*r**5+1507.D0/1728.D0*r**4+28
      E(2) = 1481219.D0/7200.D0*r-5477797.D0/43200.D0*r**2+20483.D0/576.
     #D0*r**3-r**6/120+79.D0/240.D0*r**5-1423.D0/288.D0*r**4-112
C
      EQ(3) = -546+106269.D0/160.D0*r-4975.D0/18.D0*r**2+r**5/8-25.D0/6.
     #D0*r**4+4861.D0/96.D0*r**3
      EQ(4) = 616-187393.D0/240.D0*r+48593.D0/144.D0*r**2-r**5/6+65.D0/1
     #2.D0*r**4-4603.D0/72.D0*r**3
      EQ(5) = -400+94057.D0/180.D0*r-67043.D0/288.D0*r**2+r**5/8-95.D0/2
     #4.D0*r**4+4361.D0/96.D0*r**3
      EQ(6) = 141-452329.D0/2400.D0*r+24781.D0/288.D0*r**2-r**5/20+37.D0
     #/24.D0*r**4-827.D0/48.D0*r**3
      EQ(7) = -21+205777.D0/7200.D0*r-213.D0/16.D0*r**2+r**5/120-r**4/4+
     #785.D0/288.D0*r**3
      EQ(1) = -56+213151.D0/3600.D0*r-6403.D0/288.D0*r**2+r**5/120-7.D0/
     #24.D0*r**4+1085.D0/288.D0*r**3
      EQ(2) = 266-2197687.D0/7200.D0*r+34913.D0/288.D0*r**2-r**5/20+41.D
     #0/24.D0*r**4-1027.D0/48.D0*r**3
C
      return
c
c--------------------
c   order 8, k=8
c--------------------
   80 k=8
C
C     Superconvergence for r=5.1115793863390873132 and r=7.2474044915485680465
C
      r=7.2474044915485680465D0
C
      A(4,7) = 1/r/2
      A(7,8) = (-726+35*r)/r/35
      A(3,7) = -4.D0/15.D0/r
      A(6,3) = -21.D0/4.D0/r
      A(1,2) = (29+10*r)/r/10
      A(8,5) = -(-6219+280*r)/r/4
      A(2,5) = 5.D0/2.D0/r
      A(5,7) = -2/r
      A(6,1) = -1/r/6
      A(4,2) = 1/r/3
      A(1,5) = -10.D0/3.D0/r
      A(3,2) = -2.D0/5.D0/r
      A(2,8) = -1/r/35
      A(5,2) = -1/r/2
      A(7,3) = 168.D0/5.D0/r
      A(4,5) = (-5+4*r)/r/4
      A(3,5) = -4/r
      A(6,6) = 21/r
      A(8,3) = -(-6429+280*r)/r/10
      A(2,3) = (47+20*r)/r/20
      A(1,8) = 1/r/21
      A(7,1) = 8.D0/7.D0/r
      A(1,1) = 2.D0/7.D0/r
      A(7,6) = -84/r
      A(4,8) = -1/r/21
      A(8,1) = -(140*r-3267)/r/140
      A(1,3) = -6/r
      A(3,8) = 1/r/35
      A(6,4) = 35.D0/3.D0/r
      A(8,6) = (-6009+280*r)/r/5
      A(2,6) = -1/r
      A(7,7) = 56/r
      A(4,3) = -3.D0/2.D0/r
      A(8,8) = (-4329+280*r)/r/35
      A(1,6) = 3.D0/2.D0/r
      A(5,3) = 2/r
      A(6,7) = (-203+20*r)/r/20
      A(3,1) = 4.D0/105.D0/r
      A(7,4) = -70/r
      A(4,6) = -3/r
      A(3,6) = 6.D0/5.D0/r
      A(5,1) = 2.D0/35.D0/r
      A(8,4) = (-1269+56*r)/r
      A(2,4) = -5/r
      A(2,1) = -1/r/14
      A(6,2) = 7.D0/5.D0/r
      A(5,6) = (-47+10*r)/r/10
      A(4,4) = 5/r
      A(3,3) = 12.D0/5.D0/r
      A(5,8) = 1/r/7
      A(1,4) = 5/r
      A(5,5) = 10/r
      A(4,1) = -1/r/28
      A(6,5) = -35.D0/2.D0/r
      A(8,7) = -(-5589+280*r)/r/10
      A(2,2) = 1/r
      A(2,7) = 1/r/4
      A(3,4) = (1+r)/r
      A(7,2) = -28.D0/3.D0/r
      A(1,7) = -2.D0/5.D0/r
      A(5,4) = -5/r
      A(6,8) = -1/r
      A(8,2) = (-927+40*r)/r/5
      A(7,5) = 280.D0/3.D0/r

C
      D(3) = 4/r
      D(1) = 2/r
      D(6) = 7/r
      D(4) = 5/r
      D(5) = 6/r
      D(7) = 8/r
      D(2) = 3/r
      D(8) = 9/r
C
      do i=1,k
         c(i)=i
      enddo
C
      E(3) = -10545343.D0/12600.D0*r+378+27393533.D0/43200.D0*r**2-19463
     #527.D0/86400.D0*r**3+101.D0/480.D0*r**6-r**7/240-12047.D0/2880.D0*
     #r**5+48305.D0/1152.D0*r**4
      E(4) = 70519439.D0/60480.D0*r-15901873.D0/17280.D0*r**2-504+439414
     #3.D0/12960.D0*r**3-11.D0/32.D0*r**6+r**7/144+11537.D0/1728.D0*r**5
     #-75037.D0/1152.D0*r**4
      E(5) = -15130963.D0/15120.D0*r+10541573.D0/12960.D0*r**2-15985597.
     #D0/51840.D0*r**3+97.D0/288.D0*r**6-r**7/144+420-11051.D0/1728.D0*r
     #**5+210329.D0/3456.D0*r**4
      E(6) = 52987253.D0/100800.D0*r-1509649.D0/3456.D0*r**2+7318301.D0/
     #43200.D0*r**3-19.D0/96.D0*r**6+r**7/240-216+10589.D0/2880.D0*r**5-
     #39407.D0/1152.D0*r**4
      E(7) = -2944307.D0/18900.D0*r+210719.D0/1600.D0*r**2-13484227.D0/2
     #59200.D0*r**3+31.D0/480.D0*r**6-r**7/720-10151.D0/8640.D0*r**5+137
     #1.D0/128.D0*r**4+63
      E(8) = 42398899.D0/2116800.D0*r-4449833.D0/259200.D0*r**2+223067.D
     #0/32400.D0*r**3-13.D0/1440.D0*r**6+1391.D0/8640.D0*r**5-4981.D0/34
     #56.D0*r**4-8+r**7/5040
      E(1) = -33966857.D0/529200.D0*r+45367.D0/1080.D0*r**2-3483511.D0/2
     #59200.D0*r**3+r**6/96-r**7/5040-1877.D0/8640.D0*r**5+2665.D0/1152.
     #D0*r**4+36
      E(2) = 104610097.D0/302400.D0*r-64015613.D0/259200.D0*r**2+1085455
     #1.D0/129600.D0*r**3-103.D0/1440.D0*r**6+r**7/720+12581.D0/8640.D0*
     #r**5-51943.D0/3456.D0*r**4-168
C
      EQ(3) = -1134+22916857.D0/14400.D0*r-68947729.D0/86400.D0*r**2+209
     #.D0/160.D0*r**5-7.D0/240.D0*r**6-12949.D0/576.D0*r**4+72301.D0/384
     #.D0*r**3
      EQ(4) = 1596-4019759.D0/1728.D0*r+62561209.D0/51840.D0*r**2-205.D0
     #/96.D0*r**5+7.D0/144.D0*r**6+62105.D0/1728.D0*r**4-337933.D0/1152.
     #D0*r**3
      EQ(5) = -1380+17867383.D0/8640.D0*r-57135469.D0/51840.D0*r**2+67.D
     #0/32.D0*r**5-7.D0/144.D0*r**6-59585.D0/1728.D0*r**4+105539.D0/384.
     #D0*r**3
      EQ(6) = 729-16066621.D0/14400.D0*r+52502029.D0/86400.D0*r**2-197.D
     #0/160.D0*r**5+7.D0/240.D0*r**6+11437.D0/576.D0*r**4-59473.D0/384.D
     #0*r**3
      EQ(7) = -217+14587309.D0/43200.D0*r-48518329.D0/259200.D0*r**2+193
     #.D0/480.D0*r**5-7.D0/720.D0*r**6-10981.D0/1728.D0*r**4+55997.D0/11
     #52.D0*r**3
      EQ(8) = 28-1907521.D0/43200.D0*r+6438247.D0/259200.D0*r**2-9.D0/16
     #0.D0*r**5+r**6/720+1507.D0/1728.D0*r**4-839.D0/128.D0*r**3
      EQ(1) = -84+4465333.D0/43200.D0*r-12200947.D0/259200.D0*r**2+31.D0
     #/480.D0*r**5-r**6/720-2011.D0/1728.D0*r**4+11891.D0/1152.D0*r**3
      EQ(2) = 462-26538769.D0/43200.D0*r+76489429.D0/259200.D0*r**2-71.D
     #0/160.D0*r**5+7.D0/720.D0*r**6+13501.D0/1728.D0*r**4-25835.D0/384.
     #D0*r**3
C
      return
      end
C
C$ann[NoSideEffect()]
      subroutine problem(tb,tend,neqn)
      implicit double precision (a-h,o-z)
      common/param/iprob
      common/dparam/eps,pi
      common/grid/nx
      goto(10,20,30,40,50,60,70,80,90,100),iprob
c-------------------------------------
c   testproblem d4 from enright et al.
c-------------------------------------
   10 tb=0.D0
      tend=50.D0
      neqn=3
      return
c-------------------------------------
c   testproblem b2 from enright et al.
c-------------------------------------
   20 tb=0.D0
      tend=20.D0
      neqn=6
      return
c----------------------------------------------------------------
c   problem proposed by kaps (1981) see dekker and verwer, p. 215
c----------------------------------------------------------------
   30 tb=0.D0
      tend=4.D0
      neqn=2
      return
c------------------------------------------------------------------
c   nonlinear prothero & Robinson
c------------------------------------------------------------------
   40 tb=0.D0
      tend=10.D0
      neqn=1
      return
c---------------
c   test problem
c---------------
   50 tb=0.0
      tend=1.D0
      neqn=1
      return
c-------------------------------------
c   problem from prothero and robinson
c-------------------------------------
   60 tb=0.D0
      tend=10.D0
      neqn=1
      return
c-------------------------------------------
c   pde with homogeneous boundary conditions
c-------------------------------------------
   70 tb=0.D0
      tend=5.D0
      neqn=100
      return
c----------------------------------------------
c   pde with time-dependent boundary conditions
c----------------------------------------------
   80 tb=0.D0
      tend=5.D0
      neqn=50
      return
c-----------------
c   hyperbolic pde
c-----------------
   90 tb=0.D0
      tend=10.D0
      neqn=nx
      return
c-------------------------------------------------
c   imaginary spectrum and slowly varying solution
c-------------------------------------------------
  100 tb=0.D0
      tend=100.D0
      neqn=2
      return
      end
C
C$ann[NoSideEffect()]
      subroutine init(neqn,t,y)
      implicit double precision (a-h,o-z)
      double precision y(neqn)
      common/param/iprob
      common/dparam/eps,pi
      common/osc/alfa
      goto(10,20,30,40,50,60,70,80,90,100),iprob
   10 y(1)=1.D0
      y(2)=1.D0
      y(3)=0.D0
      return
   20 alfa=3.D0
      y(1)=dexp(-10.D0*t)*(dcos(alfa*t)+dsin(alfa*t))
      y(2)=dexp(-10.D0*t)*(dcos(alfa*t)-dsin(alfa*t))
      y(3)=dexp(-4.D0*t)
      y(4)=dexp(-t)
      y(5)=dexp(-0.5D0*t)
      y(6)=dexp(-0.1D0*t)
      return
   30 y(1)=dexp(-2.D0*t)
      y(2)=dexp(-t)
      return
   40 y(1)=sin(t)
      return
   50 y(1)=exp(-t)
      return
   60 y(1)=sin(t)
      return
   70 et=dexp(-t)
      dx=1.D0/neqn
      do  i=1,neqn-1
         y(i)=dsin(i*dx*pi)*et
      enddo
      y(neqn)=t
      return
   80 et=dexp(-t)
      dx=1.D0/neqn
      do  i=1,neqn-1
         y(i)=dexp(-i*dx)*et
      enddo
      y(neqn)=t
      return
   90 dx=1.D0/neqn
      do  i=1,neqn
         y(i)=i*dx/(1.D0+t)
      enddo
      return
  100 y(1)=sin(t)
      y(2)=cos(t)
      return
      end
C
C$ann[NoSideEffect()]
      subroutine evalj(neqn,t,y,rjac,nr)
      implicit double precision (a-h,o-z)
      double precision  y(neqn),rjac(nr,*)
      common/param/iprob
      common/dparam/eps,pi
      common/osc/alfa
      do  j=1,neqn
         do  i=1,neqn
            rjac(i,j)=0.D0
         enddo
      enddo
      goto(10,20,30,40,50,60,70,80,90,100),iprob
   10 rjac(1,1)=-0.013D0-1000.D0*y(3)
      rjac(1,3)=-1000.D0*y(1)
      rjac(2,2)=-2500.D0*y(3)
      rjac(2,3)=-2500.D0*y(2)
      rjac(3,1)=-0.013D0-1000.D0*y(3)
      rjac(3,2)=-2500.D0*y(3)
      rjac(3,3)=-1000.D0*y(1)-2500.D0*y(2)
      return
   20 alfa=3.D0
      rjac(1,1)=-10.D0
      rjac(1,2)=alfa
      rjac(2,1)=-alfa
      rjac(2,2)=-10.D0
      rjac(3,3)=-4.D0
      rjac(4,4)=-1.D0
      rjac(5,5)=-0.5D0
      rjac(6,6)=-0.1D0
      return
   30 rjac(1,1)=-(1.D0/eps+2.D0)
      rjac(1,2)=2.D0*y(2)/eps
      rjac(2,1)=1.D0
      rjac(2,2)=-1.D0-2.D0*y(2)
      return
   40 rjac(1,1)=-3.0d0/eps*y(1)**2
      return
   50 rjac(1,1)=-1.D0
      return
   60 rjac(1,1)=-1.D0/eps
      return
   70 dx=1.D0/neqn
      dx2=dx*dx
      do 71 i=1,neqn-2
      rjac(i,i)=-2.D0/dx2
      rjac(i,i+1)=1.D0/dx2
      rjac(i+1,i)=1.D0/dx2
   71 continue
      rjac(neqn-1,neqn-1)=-2.D0/dx2
      f=dexp(-y(neqn))*(1.D0-pi*pi)
      do  i=1,neqn-1
         rjac(i,neqn)=dsin(i*dx*pi)*dble(f)
      enddo
      return
   80 dx=1.D0/neqn
      dx2=dx*dx
      do 81 i=1,neqn-2
      rjac(i,i)=-2.D0/dx2
      rjac(i,i+1)=1.D0/dx2
      rjac(i+1,i)=1.D0/dx2
   81 continue
      rjac(neqn-1,neqn-1)=-2.D0/dx2
      do  i=1,neqn-1
         rjac(i,neqn)=2.D0*dexp(-y(neqn)-i*dx)
      enddo
      rjac(1,neqn)=rjac(1,neqn)-dexp(-y(neqn))/dx2
      rjac(neqn-1,neqn)=rjac(neqn-1,neqn)-dexp(-y(neqn)-1.D0)/dx2
      return
   90 dx=1.D0/neqn
      rjac(1,2)=-y(2)/(2.D0*dx)
      do 91 i=2,neqn-1
      rjac(i,i+1)=-y(i+1)/(2.D0*dx)
      rjac(i,i-1)= y(i-1)/(2.D0*dx)
   91 continue
      rjac(neqn,neqn-2)=-y(neqn-1)/(2.D0*dx)
      rjac(neqn,neqn-1)=4.D0*y(neqn-1)/(2.D0*dx)
      rjac(neqn,neqn)=-3.D0*y(neqn)/(2.D0*dx)
      return
  100 rjac(1,2)=-alfa
      rjac(2,1)=alfa
      return
      end
C
C$ann[NoSideEffect()]
      subroutine f(neqn,t,y,dy)
      implicit double precision (a-h,o-z)
      double precision  y(neqn),dy(neqn)
      common/param/iprob
      common/dparam/eps,pi
      common/osc/alfa
      goto(10,20,30,40,50,60,70,80,90,100),iprob
   10 dy(1)=-0.013D0*y(1)-1000.D0*y(1)*y(3)
      dy(2)=-2500.D0*y(2)*y(3)
      dy(3)=-0.013D0*y(1)-1000.D0*y(1)*y(3)-2500.D0*y(2)*y(3)
      return
   20 alfa=3.D0
      dy(1)=-10.D0*y(1)+alfa*y(2)
      dy(2)=-10.D0*y(2)-alfa*y(1)
      dy(3)=-4.D0*y(3)
      dy(4)=-1.D0*y(4)
      dy(5)=-0.5D0*y(5)
      dy(6)=-0.1D0*y(6)
      return
   30 dy(1)=-(1.D0/eps+2.D0)*y(1)+1.D0/eps*y(2)**2
      dy(2)=y(1)-y(2)*(1.D0+y(2))
      return
   40 dy(1)=-1.0d0/eps*(y(1)**3-sin(t)**3)+cos(t)
      return
   50 dy(1)=-y(1)
      return
   60 dy(1)=-1.D0/eps*(y(1)-sin(t))+cos(t)
      return
   70 dx=1.D0/neqn
      dx2=dx*dx
      g=dexp(-y(neqn))*(1.D0-pi*pi)
      dy(1)=(-2.D0*y(1)+y(2))/dx2-g*dsin(dx*pi)
      do i=2,neqn-2
         dy(i)=(y(i-1)-2.D0*y(i)+y(i+1))/dx2-g*dsin(i*dx*pi)
      enddo
      dy(neqn-1)=(y(neqn-2)-2.D0*y(neqn-1))/dx2
     +           -g*dsin((neqn-1.D0)*dx*pi)
      dy(neqn)=1.D0
      return
   80 dx=1.D0/neqn
      dx2=dx*dx
      et=dexp(-y(neqn))
      dy(1)=(et-2.D0*y(1)+y(2))/dx2-2.D0*et*dexp(-dx)
      do  i=2,neqn-2
         dy(i)=(y(i-1)-2.D0*y(i)+y(i+1))/dx2-2.D0*et*dexp(-i*dx)
      enddo
      dy(neqn-1)=(y(neqn-2)-2.D0*y(neqn-1)+et*dexp(-1.D0))/dx2-
     +           2.D0*et*dexp(-(neqn-1.D0)*dx)
      dy(neqn)=1.D0
      return
   90 dx=1.D0/neqn
      dy(1)=-y(2)**2/(4.D0*dx)
      do i=2,neqn-1
         dy(i)=-(y(i+1)**2-y(i-1)**2)/(4.D0*dx)
      enddo
      dy(neqn)=-(3.D0*y(neqn)**2-4.D0*y(neqn-1)**2+y(neqn-2)**2)
     +          /(4.D0*dx)
      return
  100 dy(1)=-alfa*y(2)+(alfa+1.D0)*cos(t)
      dy(2)= alfa*y(1)-(alfa+1.D0)*sin(t)
      return
      end
C
C$ann[NoSideEffect()]
      subroutine sol(neqn,t,y)
      implicit double precision (a-h,o-z)
      double precision  y(neqn)
      common/param/iprob
      common/dparam/eps,pi
      common/osc/alfa
      goto(10,20,30,40,50,60,70,80,90,100),iprob
   10 y(3)=-0.18933865404D-5
      y(1)=0.59765469806D0
      y(2)=1.40234340855D0
      return
   20 alfa=3.D0
      y(1)=dexp(-10.D0*t)*(dcos(alfa*t)+dsin(alfa*t))
      y(2)=dexp(-10.D0*t)*(dcos(alfa*t)-dsin(alfa*t))
      y(3)=dexp(-4.D0*t)
      y(4)=dexp(-1.D0*t)
      y(5)=dexp(-0.5D0*t)
      y(6)=dexp(-0.1D0*t)
      return
   30 y(2)=dexp(-t)
      y(1)=dexp(-2.D0*t)
      return
   40 y(1)=sin(t)
      return
   50 y(1)=exp(-t)
      return
   60 y(1)=sin(t)
      return
   70 et=dexp(-t)
      dx=1.D0/neqn
      do  i=1,neqn-1
         y(i)=et*sin(i*dx*pi)
      enddo
      y(neqn)=t
      return
   80 dx=1.D0/neqn
      do  i=1,neqn-1
         y(i)=dexp(-t-i*dx)
      enddo
      y(neqn)=t
      return
   90 dx=1.D0/neqn
      do  i=1,neqn
         y(i)=i*dx/(1.D0+t)
      enddo
      return
  100 y(1)=sin(t)
      y(2)=cos(t)
      return
      end
C
C$ann[NoSideEffect()]
      subroutine sgefa(a,lda,n,ipvt,info)
      integer lda,n,ipvt(*),info
      double precision a(lda,*)
c
c     sgefa factors a real matrix by gaussian elimination.
c
c     sgefa is usually called by sgeco, but it can be called
c     directly with a saving in time if  rcond  is not needed.
c     (time for sgeco) = (1 + 9/n)*(time for sgefa) .
c
c     on entry
c
c        a       real(lda, n)
c                the matrix to be factored.
c
c        lda     integer
c                the leading dimension of the array  a .
c
c        n       integer
c                the order of the matrix  a .
c
c     on return
c
c        a       an upper triangular matrix and the multipliers
c                which were used to obtain it.
c                the factorization can be written  a = l*u  where
c                l  is a product of permutation and unit lower
c                triangular matrices and  u  is upper triangular.
c
c        ipvt    integer(n)
c                an integer vector of pivot indices.
c
c        info    integer
c                = 0  normal value.
c                = k  if  u(k,k) .eq. 0.0 .  this is not an error
c                     condition for this subroutine, but it does
c                     indicate that sgesl or sgedi will divide by zero
c                     if called.  use  rcond  in sgeco for a reliable
c                     indication of singularity.
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas saxpy,sscal,isamax
c
c     internal variables
c
      double precision t
      integer isamax,j,k,kp1,l,nm1
c
c
c     gaussian elimination with partial pivoting
c
      info = 0
      nm1 = n - 1
      if (nm1 .lt. 1) go to 70
      do 60 k = 1, nm1
         kp1 = k + 1
c
c        find l = pivot index
c
         l = isamax(n-k+1,a(k,k),1) + k - 1
         ipvt(k) = l
c
c        zero pivot implies this column already triangularized
c
         if (a(l,k) .eq. 0.0d0) go to 40
c
c           interchange if necessary
c
            if (l .eq. k) go to 10
               t = a(l,k)
               a(l,k) = a(k,k)
               a(k,k) = t
   10       continue
c
c           compute multipliers
c
            t = -1.0d0/a(k,k)
            call sscal(n-k,t,a(k+1,k),1)
c
c           row elimination with column indexing
c
            do 30 j = kp1, n
               t = a(l,j)
               if (l .eq. k) go to 20
                  a(l,j) = a(k,j)
                  a(k,j) = t
   20          continue
               call saxpy(n-k,t,a(k+1,k),1,a(k+1,j),1)
   30       continue
         go to 50
 40      info = k
   50    continue
   60 continue

   70   ipvt(n) = n
      if (a(n,n) .eq. 0.0d0) then
         info = n
      endif
      return
      end
C$ann[NoSideEffect()]
      subroutine sgesl(a,lda,n,ipvt,b,job)
      integer lda,n,ipvt(*),job
      double precision a(lda,*),b(*)
c
c     sgesl solves the real system
c     a * x = b  or  trans(a) * x = b
c     using the factors computed by sgeco or sgefa.
c
c     on entry
c
c        a       real(lda, n)
c                the output from sgeco or sgefa.
c
c        lda     integer
c                the leading dimension of the array  a .
c
c        n       integer
c                the order of the matrix  a .
c
c        ipvt    integer(n)
c                the pivot vector from sgeco or sgefa.
c
c        b       real(n)
c                the right hand side vector.
c
c        job     integer
c                = 0         to solve  a*x = b ,
c                = nonzero   to solve  trans(a)*x = b  where
c                            trans(a)  is the transpose.
c
c     on return
c
c        b       the solution vector  x .
c
c     error condition
c
c        a division by zero will occur if the input factor contains a
c        zero on the diagonal.  technically this indicates singularity
c        but it is often caused by improper arguments or improper
c        setting of lda .  it will not occur if the subroutines are
c        called correctly and if sgeco has set rcond .gt. 0.0
c        or sgefa has set info .eq. 0 .
c
c     to compute  inverse(a) * c  where  c  is a matrix
c     with  p  columns
c           call sgeco(a,lda,n,ipvt,rcond,z)
c           if (rcond is too small) go to ...
c           do 10 j = 1, p
c              call sgesl(a,lda,n,ipvt,c(1,j),0)
c        10 continue
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas saxpy,sdot
c
c     internal variables
c
      double precision sdot,t
      integer k,kb,l,nm1
c
      nm1 = n - 1
      if (job .ne. 0) go to 50
c
c        job = 0 , solve  a * x = b
c        first solve  l*y = b
c
         if (nm1 .lt. 1) go to 30
         do 20 k = 1, nm1
            l = ipvt(k)
            t = b(l)
            if (l .eq. k) go to 10
               b(l) = b(k)
               b(k) = t
   10       continue
            call saxpy(n-k,t,a(k+1,k),1,b(k+1),1)
   20    continue
   30    continue
c
c        now solve  u*x = y
c
         do 40 kb = 1, n
            k = n + 1 - kb
            b(k) = b(k)/a(k,k)
            t = -b(k)
            call saxpy(k-1,t,a(1,k),1,b(1),1)
   40    continue
      go to 100
   50 continue
c
c        job = nonzero, solve  trans(a) * x = b
c        first solve  trans(u)*y = b
c
         do 60 k = 1, n
            t = sdot(k-1,a(1,k),1,b(1),1)
            b(k) = (b(k) - t)/a(k,k)
   60    continue
c
c        now solve trans(l)*x = y
c
         if (nm1 .lt. 1) go to 90
         do 80 kb = 1, nm1
            k = n - kb
            b(k) = b(k) + sdot(n-k,a(k+1,k),1,b(k+1),1)
            l = ipvt(k)
            if (l .eq. k) go to 70
               t = b(l)
               b(l) = b(k)
               b(k) = t
   70       continue
   80    continue
   90    continue
  100 continue
      return
      end

C$ann[NoSideEffect()]
      subroutine saxpy( n, sa, sx, incx, sy, incy )
*
*     constant times a vector plus a vector.
*     uses unrolled loop for increments equal to one.
*     jack dongarra, linpack, 3/11/78.
*
*     .. scalar arguments ..
      integer           incx, incy, n
      double precision              sa
*     ..
*     .. array arguments ..
      double precision              sx( * ), sy( * )
*     ..
*     .. local scalars ..
      integer           i, ix, iy, m, mp1
*     ..
*     .. intrinsic functions ..
      intrinsic         mod
*     ..
*     .. executable statements ..
*
      if( n.le.0 )
     $   return
      if( sa.eq.0.0d0 )
     $   return
      if( incx.eq.1 .and. incy.eq.1 )
     $   go to 20
*
*        code for unequal increments or equal increments
*          not equal to 1
*
      ix = 1
      iy = 1
      if( incx.lt.0 )
     $   ix = ( -n+1 )*incx + 1
      if( incy.lt.0 )
     $   iy = ( -n+1 )*incy + 1
      do 10 i = 1, n
         sy( iy ) = sy( iy ) + sa*sx( ix )
         ix = ix + incx
         iy = iy + incy
   10 continue
      return
*
*        code for both increments equal to 1
*
*
*     clean-up loop
*
   20 m = mod( n, 4 )
      if( m.eq.0 )
     $   go to 40
      do 30 i = 1, m
         sy( i ) = sy( i ) + sa*sx( i )
   30 continue
      if( n.lt.4 )
     $   return
   40 mp1 = m + 1
      do 50 i = mp1, n, 4
         sy( i ) = sy( i ) + sa*sx( i )
         sy( i+1 ) = sy( i+1 ) + sa*sx( i+1 )
         sy( i+2 ) = sy( i+2 ) + sa*sx( i+2 )
         sy( i+3 ) = sy( i+3 ) + sa*sx( i+3 )
   50 continue
      return
      end

C$ann[NoSideEffect()]
      subroutine sscal( n, sa, sx, incx )
*
*     scales a vector by a constant.
*     uses unrolled loops for increment equal to 1.
*     jack dongarra, linpack, 3/11/78.
*
*     .. scalar arguments ..
      integer           incx, n
      double precision              sa
*     ..
*     .. array arguments ..
      double precision              sx( * )
*     ..
*     .. local scalars ..
      integer           i, ix, m, mp1, nincx
*     ..
*     .. intrinsic functions ..
      intrinsic         mod
*     ..
*     .. executable statements ..
*
      if( n.le.0 )
     $   return
      if( incx.eq.1 )
     $   go to 20
*
*        code for increment not equal to 1
*
      ix = 1
      if( incx.lt.0 )
     $   ix = 1 - ( n-1 )*incx
      nincx = ix + ( n-1 )*incx
      do 10 i = ix, nincx, incx
         sx( i ) = sa*sx( i )
   10 continue
      return
*
*        code for increment equal to 1
*
*
*        clean-up loop
*
   20 m = mod( n, 5 )
      if( m.eq.0 )
     $   go to 40
      do 30 i = 1, m
         sx( i ) = sa*sx( i )
   30 continue
      if( n.lt.5 )
     $   return
   40 mp1 = m + 1
      do 50 i = mp1, n, 5
         sx( i ) = sa*sx( i )
         sx( i+1 ) = sa*sx( i+1 )
         sx( i+2 ) = sa*sx( i+2 )
         sx( i+3 ) = sa*sx( i+3 )
         sx( i+4 ) = sa*sx( i+4 )
   50 continue
      return
      end

C$ann[NoSideEffect()]
      double precision function sdot( n, sx, incx, sy, incy )
*
*     forms the dot product of two vectors.
*     uses unrolled loops for increments equal to one.
*     jack dongarra, linpack, 3/11/78.
*
*     .. scalar arguments ..
      integer                         incx, incy, n
*     ..
*     .. array arguments ..
      double precision                sx( * ), sy( * )
*     ..
*     .. local scalars ..
      integer                         i, ix, iy, m, mp1
      double precision                stemp
*     ..
*     .. intrinsic functions ..
      intrinsic                       mod
*     ..
*     .. executable statements ..
*
      stemp = 0.0d0
      sdot = 0.0d0
      if( n.le.0 )
     $   return
      if( incx.eq.1 .and. incy.eq.1 )
     $   go to 20
*
*        code for unequal increments or equal increments
*          not equal to 1
*
      ix = 1
      iy = 1
      if( incx.lt.0 )
     $   ix = ( -n+1 )*incx + 1
      if( incy.lt.0 )
     $   iy = ( -n+1 )*incy + 1
      do 10 i = 1, n
         stemp = stemp + sx( ix )*sy( iy )
         ix = ix + incx
         iy = iy + incy
   10 continue
      sdot = stemp
      return
*
*        code for both increments equal to 1
*
*
*        clean-up loop
*
   20 m = mod( n, 5 )
      if( m.eq.0 )
     $   go to 40
      do 30 i = 1, m
         stemp = stemp + sx( i )*sy( i )
   30 continue
      if( n.lt.5 )
     $   go to 60
   40 mp1 = m + 1
      do 50 i = mp1, n, 5
         stemp = stemp + sx( i )*sy( i ) + sx( i+1 )*sy( i+1 ) +
     $           sx( i+2 )*sy( i+2 ) + sx( i+3 )*sy( i+3 ) +
     $           sx( i+4 )*sy( i+4 )
   50 continue
   60 sdot = stemp
      return
      end

C$ann[NoSideEffect()]
      integer          function isamax( n, sx, incx )
*
*     finds the index of element having max. absolute value.
*     jack dongarra, linpack, 3/11/78.
*
*     .. scalar arguments ..
      integer                           incx, n
*     ..
*     .. array arguments ..
      double precision                  sx( * )
*     ..
*     .. local scalars ..
      integer                           i, ix
      double precision                  smax
*     ..
*     .. intrinsic functions ..
      intrinsic                         abs
*     ..
*     .. executable statements ..
*
      isamax = 0
      if( n.lt.1 )
     $   return
      isamax = 1
      if( n.eq.1 )
     $   return
      if( incx.eq.1 )
     $   go to 30
*
*        code for increment not equal to 1
*
      ix = 1
      if( incx.lt.0 )
     $   ix = 1 - ( n-1 )*incx
      smax = abs( sx( ix ) )
      ix = ix + incx
      do 20 i = 2, n
         if( abs( sx( ix ) ).le.smax )
     $      go to 10
         isamax = i
         smax = abs( sx( ix ) )
   10    ix = ix + incx
   20 continue
      if( incx.lt.0 )
     $   isamax = n - isamax + 1
      return
*
*        code for increment equal to 1
*
   30 smax = abs( sx( 1 ) )
      do 40 i = 2, n
         if( abs( sx( i ) ).le.smax )
     $      go to 40
         isamax = i
         smax = abs( sx( i ) )
   40 continue
      return
      end


