C************************************************************************
C*
C*     Written by: Rajit Manohar
C*             On: Mon Nov 15 13:34:18 PST 1993
C*       Original: /home/ama-iris/r/dim/rm/efm/2-d/src/efm2d.f
C*
C************************************************************************

      PROGRAM cfd
      
C****************************************************************************
C****************************************************************************
C*
C*       Mesh Template parameter file
C*       Written By: Rajit Manohar 
C*       On: Mon Oct 25 20:12:06 PDT 1993
C*
C****************************************************************************
C****************************************************************************

C
C GRID: the # of processes (X times Y)
C
      parameter (NGRIDX=2, NGRIDY=2)
C
C ROWS/COLS: the amt of data per process
C
      parameter (NROWS=100, NCOLS=200)
C
C WIDTH: The # of boundary cells to be exchanged
C
      parameter (NWIDTH=2)
C
C ITEMS: The # of data items
C
      parameter (NITEMS=4)
C
C  NTOTX = NGRIDX*NCOLS, NTOTY = NGRIDY*NROWS
C
      parameter (NTOTX=400, NTOTY=200)
C
C  NLOCXL = -NWIDTH+1, NLOCXR = NCOLS + NWIDTH
C  NLOCYL = -NWIDTH+1, NLOCYR = NROWS + NWIDTH
C
      parameter (NLOCXL=-1, NLOCXR=202)
      parameter (NLOCYL=-1, NLOCYR=102)



      parameter (IGRIDTYPE = 1, IGRIDFORM = 1)
      parameter (IHOSTTYPE = 2, IHOSTFORM = 2)

      parameter (IMASS=1, IMOMX=2, IMOMY=3, IENER=4)

      parameter (IEXTRA = 2)

C
C      parameter (ITEMPO = NCOLS + 1)
C      parameter (ITEMPI = NCOLS + NWIDTH + NWIDTH)
C      parameter (ITEMP2 = NTOTX + 2, ITEMP3 = NTOTY + 2)
C

      parameter (ITEMPO = 201)
      parameter (ITEMPI = 204)
      parameter (ITEMP2 = 402, ITEMP3 = 202)

      parameter (MINUS1 = -1)
      parameter (MINUS2 = -2)
      

      processors (NGRIDX,NGRIDY)

      inport (real  x(NWIDTH,NITEMS,NROWS)) ewl_in (NGRIDX,NGRIDY)
      inport (real  x(NWIDTH,NITEMS,NCOLS)) nsu_in (NGRIDX,NGRIDY)
      inport (real  x(NWIDTH,NITEMS,NROWS)) ewr_in (NGRIDX,NGRIDY)
      inport (real  x(NWIDTH,NITEMS,NCOLS)) nsd_in (NGRIDX,NGRIDY)
      inport (real  x, real  x(IEXTRA)) globsend_in (NGRIDX, NGRIDY)
      inport (integer m, real  x(m)) globrecv_in (NGRIDX, NGRIDY)

      outport (real  x(NWIDTH,NITEMS,NROWS)) ewl_out (NGRIDX,NGRIDY)
      outport (real  x(NWIDTH,NITEMS,NCOLS)) nsu_out (NGRIDX,NGRIDY)
      outport (real  x(NWIDTH,NITEMS,NROWS)) ewr_out (NGRIDX,NGRIDY)
      outport (real  x(NWIDTH,NITEMS,NCOLS)) nsd_out (NGRIDX,NGRIDY)
      outport (real  x, real  x(IEXTRA)) globsend_out (NGRIDX,NGRIDY)
      outport (integer m, real  x(m)) globrecv_out (NGRIDX,NGRIDY)

      inport (real  x(NITEMS,NROWS,NCOLS)) HtoGin(NGRIDX,NGRIDY),
     $     GtoHin (NGRIDX,NGRIDY)

      outport (real  x(NITEMS,NROWS,NCOLS)) HtoGout(NGRIDX,NGRIDY),
     $     GtoHout (NGRIDX,NGRIDY)

      integer iloc(NGRIDX,NGRIDY)
C##############################################################################
C     iloc = 
C            1 - left border
C            2 - right border
C            4 - top border
C            8 - bottom border
C##############################################################################


      do i = 1, NGRIDX
         do j = 1, NGRIDY
C************************************************************************
            iloc(i,j) = 0
            if (i .eq. 1) iloc(i,j) = iloc(i,j) + 1
            if (j .eq. 1) iloc(i,j) = iloc(i,j) + 4
            if (i .eq. NGRIDX) iloc(i,j) = iloc(i,j) + 2
            if (j .eq. NGRIDY) iloc(i,j) = iloc(i,j) + 8
C************************************************************************
            channel (in=globsend_in(i,j), out=globsend_out(i,j))
            channel (in=globrecv_in(i,j), out=globrecv_out(i,j))
            il = i-1
            if (il .eq. 0) il = NGRIDX
            ir = mod(i, NGRIDX)+1
            jt = j-1
            if (jt .eq. 0) jt = NGRIDY
            jb = mod(j,NGRIDY)+1
            channel (in=ewl_in(i,j),out=ewr_out(il,j))
            channel (in=ewr_in(i,j),out=ewl_out(ir,j))
            channel (in=nsu_in(i,j),out=nsd_out(i,jt))
            channel (in=nsd_in(i,j),out=nsu_out(i,jb))
            channel (in=HtoGin(i,j),out=HtoGout(i,j))
            channel (in=GtoHin(i,j),out=GtoHout(i,j))
         end do
      end do
      
      processes
         processdo i = 1, NGRIDX
            processdo j = 1, NGRIDY
               process call gridproc(ewr_in(i,j),ewl_in(i,j),
     $           nsu_in(i,j), nsd_in(i,j), ewr_out(i,j),ewl_out(i,j),
     $           nsu_out(i,j),nsd_out(i,j), HtoGin(i,j),GtoHout(i,j),
     $           globsend_out(i,j), globrecv_in(i,j), iloc(i,j))
     $           location(i,j)
            endprocessdo
         endprocessdo
         process call mainproc (HtoGout, GtoHin, globsend_in,
     $        globrecv_out) location(1,1)
      endprocesses

      
      end

      process gridproc (ewr_in, ewl_in, nsu_in, nsd_in, ewr_out, ewl_out,
     $     nsu_out, nsd_out, HtoGin, GtoHout, globsend_out, globrecv_in,
     $     iloc)

      
C****************************************************************************
C****************************************************************************
C*
C*       Mesh Template parameter file
C*       Written By: Rajit Manohar 
C*       On: Mon Oct 25 20:12:06 PDT 1993
C*
C****************************************************************************
C****************************************************************************

C
C GRID: the # of processes (X times Y)
C
      parameter (NGRIDX=2, NGRIDY=2)
C
C ROWS/COLS: the amt of data per process
C
      parameter (NROWS=100, NCOLS=200)
C
C WIDTH: The # of boundary cells to be exchanged
C
      parameter (NWIDTH=2)
C
C ITEMS: The # of data items
C
      parameter (NITEMS=4)
C
C  NTOTX = NGRIDX*NCOLS, NTOTY = NGRIDY*NROWS
C
      parameter (NTOTX=400, NTOTY=200)
C
C  NLOCXL = -NWIDTH+1, NLOCXR = NCOLS + NWIDTH
C  NLOCYL = -NWIDTH+1, NLOCYR = NROWS + NWIDTH
C
      parameter (NLOCXL=-1, NLOCXR=202)
      parameter (NLOCYL=-1, NLOCYR=102)



      parameter (IGRIDTYPE = 1, IGRIDFORM = 1)
      parameter (IHOSTTYPE = 2, IHOSTFORM = 2)

      parameter (IMASS=1, IMOMX=2, IMOMY=3, IENER=4)

      parameter (IEXTRA = 2)

C
C      parameter (ITEMPO = NCOLS + 1)
C      parameter (ITEMPI = NCOLS + NWIDTH + NWIDTH)
C      parameter (ITEMP2 = NTOTX + 2, ITEMP3 = NTOTY + 2)
C

      parameter (ITEMPO = 201)
      parameter (ITEMPI = 204)
      parameter (ITEMP2 = 402, ITEMP3 = 202)

      parameter (MINUS1 = -1)
      parameter (MINUS2 = -2)
      

      
      inport (real  x(NWIDTH,NITEMS,NROWS)) ewl_in, cl_ewl_in
      inport (real  x(NWIDTH,NITEMS,NCOLS)) nsu_in, cl_nsu_in
      inport (real  x(NWIDTH,NITEMS,NROWS)) ewr_in, cl_ewr_in
      inport (real  x(NWIDTH,NITEMS,NCOLS)) nsd_in, cl_nsd_in

      outport (real  x(NWIDTH,NITEMS,NROWS)) ewl_out, cl_ewl_out
      outport (real  x(NWIDTH,NITEMS,NCOLS)) nsu_out, cl_nsu_out
      outport (real  x(NWIDTH,NITEMS,NROWS)) ewr_out, cl_ewr_out
      outport (real  x(NWIDTH,NITEMS,NCOLS)) nsd_out, cl_nsd_out

      inport (real  x(NITEMS,NROWS,NCOLS)) HtoGin, cl_HtoGin
      outport (real  x(NITEMS,NROWS,NCOLS)) GtoHout, cl_GtoHout

      outport (real  x, real  x(IEXTRA)) globsend_out, cl_globsend_out
      inport (integer m, real  x(m)) globrecv_in, cl_globrecv_in

      real  slice (NITEMS, NLOCXL:NLOCXR, NLOCYL:NLOCYR)

      real rmasst(MINUS1:NLOCXR,MINUS1:NLOCYR)
      real rmomxt(MINUS1:NLOCXR,MINUS1:NLOCYR)
      real rmomyt(MINUS1:NLOCXR,MINUS1:NLOCYR)
      real enert(MINUS1:NLOCXR,MINUS1:NLOCYR)
      real rho(MINUS1:NLOCXR, MINUS1:1), rhol(MINUS1:NLOCXR, 2)
      real u(MINUS1:NLOCXR, MINUS1:1), ul(MINUS1:NLOCXR, 2)
      real v(MINUS1:NLOCXR, MINUS1:1), vl(MINUS1:NLOCXR, 2)
      real beta(MINUS1:NLOCXR, MINUS1:1), betal (MINUS1:NLOCXR, 2)
      real fl(0:ITEMPO, 2, 0:3)
      real erfsx(0:ITEMPO, 2), sx (0:ITEMPO,2), es2x(0:ITEMPO,2)
      real erfsy(0:ITEMPO, 2), sy (0:ITEMPO, 2), es2y(0:ITEMPO,2)
      real dx(MINUS1:NLOCXR), dy(MINUS1:NLOCYR)
      real g(0:ITEMPO), g1(0:ITEMPO), g2(0:ITEMPO)
      real xmid(MINUS1:NLOCXR), ymid(MINUS1:NLOCYR)
      real x(MINUS2:NLOCXR), y(MINUS2:NLOCYR)

      PROCESS COMMON /GRID/ cl_ewl_in, cl_nsu_in, cl_ewr_in, cl_nsd_in,
     $     cl_ewl_out, cl_nsu_out, cl_ewr_out, cl_nsd_out, cl_HtoGin,
     $     cl_GtoHout, cl_globsend_out, cl_globrecv_in
      PROCESS COMMON /DATA/ slice
      real const(ITEMPI)
      PROCESS COMMON /CONSTDATA/ const
C************************************************************************
C*
C*     Written by: Rajit Manohar
C*             On: Sun Nov 14 22:59:32 PST 1993
C*       Original: /home/ama-iris/r/dim/rm/efm/2-d/src/common
C*
C************************************************************************

	PROCESS COMMON /CONST/ bigr, gamma, rnu


      moveport (from=globsend_out, to=cl_globsend_out)
      moveport (from=globrecv_in, to=cl_globrecv_in)
      moveport (from=ewl_in, to=cl_ewl_in)
      moveport (from=ewr_in, to=cl_ewr_in)
      moveport (from=ewl_out, to=cl_ewl_out)
      moveport (from=ewr_out, to=cl_ewr_out)
      moveport (from=nsu_in, to=cl_nsu_in)
      moveport (from=nsd_in, to=cl_nsd_in)
      moveport (from=nsu_out, to=cl_nsu_out)
      moveport (from=nsd_out, to=cl_nsd_out)
      moveport (from=HtoGin, to=cl_HtoGin)
      moveport (from=GtoHout, to=cl_GtoHout)
      call INITIALIZE_FORMS (IGRIDTYPE)

C** ** put all the useful stuff here...      

      call GET_CONST_DATA
      iout = const(10)
      nsteps = const(9)
      ibc = const(8)
      bigr = const(7)
      gamma = const(1)
      rnu = const(2)
      cflmax = const(3)
      t = const(4)
      dtold = const(5)
      dt = const(6)
      receive (cl_globrecv_in) i, xmid
      receive (cl_globrecv_in) i, dx
      receive (cl_globrecv_in) i, x
      receive (cl_globrecv_in) i, ymid
      receive (cl_globrecv_in) i, dy
      receive (cl_globrecv_in) i, y
      call MOVE_TO_GRID_FORM
      nx = NCOLS
      ny = NROWS
      do istep = 1,nsteps
         do ii = 1, ny
            slice(IMASS,-1, ii) = slice(IMASS, 1, ii)
            slice(IMASS,0, ii) = slice(IMASS,2,ii)
            slice(IMASS,NLOCXR, ii) = slice(IMASS, nx, ii)
            slice(IMASS,NLOCXR-1, ii) = slice(IMASS,nx-1,ii)

            slice(IMOMX,-1, ii) = slice(IMOMX, 1, ii)
            slice(IMOMX,0, ii) = slice(IMOMX,2,ii)
            slice(IMOMX,NLOCXR, ii) = slice(IMOMX, nx, ii)
            slice(IMOMX,NLOCXR-1, ii) = slice(IMOMX,nx-1,ii)

            slice(IMOMY,-1, ii) = slice(IMOMY, 1, ii)
            slice(IMOMY,0, ii) = slice(IMOMY,2,ii)
            slice(IMOMY,NLOCXR, ii) = slice(IMOMY, nx, ii)
            slice(IMOMY,NLOCXR-1, ii) = slice(IMOMY,nx-1,ii)

            slice(IENER,-1, ii) = slice(IENER, 1, ii)
            slice(IENER,0, ii) = slice(IENER,2,ii)
            slice(IENER,NLOCXR, ii) = slice(IENER, nx, ii)
            slice(IENER,NLOCXR-1, ii) = slice(IENER,nx-1,ii)

         end do

         do ii = 1, nx
            slice(IMASS,ii,-1) = slice(IMASS,ii,1)
            slice(IMASS,ii,0) = slice(IMASS,ii,2)
            slice(IMASS,ii,NLOCYR) = slice(IMASS, ii, ny)
            slice(IMASS,ii,NLOCYR-1) = slice(IMASS,ii,ny-1)

            slice(IMOMX,ii,-1) = slice(IMOMX, ii, 1)
            slice(IMOMX,ii, 0) = slice(IMOMX,ii,2)
            slice(IMOMX,ii, NLOCYR) = slice(IMOMX, ii, ny)
            slice(IMOMX,ii,NLOCYR-1) = slice(IMOMX,ii,ny-1)

            slice(IMOMY,ii,-1) = slice(IMOMY, ii, 1)
            slice(IMOMY,ii, 0) = slice(IMOMY,ii,2)
            slice(IMOMY,ii, NLOCYR) = slice(IMOMY, ii, ny)
            slice(IMOMY,ii,NLOCYR-1) = slice(IMOMY,ii,ny-1)

            slice(IENER,ii,-1) = slice(IENER, ii, 1)
            slice(IENER,ii, 0) = slice(IENER,ii,2)
            slice(IENER,ii, NLOCYR) = slice(IENER, ii, ny)
            slice(IENER,ii,NLOCYR-1) = slice(IENER,ii,ny-1)
         end do

         call EXCHANGE_BOUNDARIES2
         call getdt (t,cflmax,dtold,dt,dx, dy, slice, nx, ny)
         if (iloc .ne. 0) call bc (ibc, nx, ny, slice, iloc)

         do j = -1,ny+2
            do i = -1,nx+2
               rmasst(i,j) = slice(IMASS, i,j)
               rmomxt(i,j) = slice(IMOMX,i,j)
               rmomyt(i,j) = slice(IMOMY,i,j)
               enert(i,j) = slice(IENER,i,j)
            end do
         end do
c     
c     do partial time step (x-forward)
c     
         ixy = 1
         ifb = 1
         do i = 1,nx
c     
c     first assemble the primitive variables for rows i-1 to i+1
c     
            do ii = -1,1
               ir = i + ii
               do j = -1,ny+2
                  rho(j,ii) = rmasst(ir,j)/(dx(ir)*dy(j))
                  u(j,ii) = rmomxt(ir,j)/rmasst(ir,j)
                  v(j,ii) = rmomyt(ir,j)/rmasst(ir,j)
                  beta(j,ii) = (2.0e0*enert(ir,j)/rmasst(ir,j)
     $                 - u(j,ii)**2 - v(j,ii)**2)/((rnu+3.0e0)*bigr)
                  beta(j,ii) = 1.0e0/sqrt(2.0e0*bigr*beta(j,ii))
               end do
            end do
c     
c     extrapolate to the cell boundaries
c     
            call slplimx (nx,ny,x,dx,xmid,ifb,i,rho,rhol(-1,2),g,g1,g2)
            call slplimx (nx,ny,x,dx,xmid,ifb,i,u,ul(-1,2),g,g1,g2)
            call slplimx (nx,ny,x,dx,xmid,ifb,i,v,vl(-1,2),g,g1,g2)
            call slplimx (nx,ny,x,dx,xmid,ifb,i,beta,betal(-1,2),g,g1,g2)
c     
c     now assemble the primitive variables for rows i-2 to i
c     
            do ii = -1,1
               ir = i+ii-1
               do j = -1,ny+2
                  rho(j,ii) = rmasst(ir,j)/(dx(ir)*dy(j))
                  u(j,ii) = rmomxt(ir,j)/rmasst(ir,j)
                  v(j,ii) = rmomyt(ir,j)/rmasst(ir,j)
                  beta(j,ii) = (2.0e0*enert(ir,j)/rmasst(ir,j)
     $                 - u(j,ii)**2 - v(j,ii)**2)/((rnu+3.0e0)*bigr)
                  beta(j,ii) = 1.0e0/sqrt(2.0e0*bigr*beta(j,ii))
               end do
            end do
c     
c     extrapolate to the cell boundaries
c     
            call slplimx (nx,ny,x,dx,xmid,ifb,i-1,rho,rhol(-1,1),g,g1,g2)
            call slplimx (nx,ny,x,dx,xmid,ifb,i-1,u,ul(-1,1),g,g1,g2)
            call slplimx (nx,ny,x,dx,xmid,ifb,i-1,v,vl(-1,1),g,g1,g2)
            call slplimx (nx,ny,x,dx,xmid,ifb,i-1,beta,betal(-1,1),g,g1,g2)
c     
c     compute the fluxes
c     
            call flux (nx,ny,ixy,ifb,dx,dy,betal,rhol,ul,vl,fl,
     $           sx,erfsx,es2x,sy,erfsy,es2y)
c     
c     do partial time step x-forward
c     
            do j = 1,ny
               slice(IMASS,i,j) = slice(IMASS,i,j)
     $              + dt*dy(j)*(-fl(j,2,0)+fl(j,1,0))
               slice(IMOMX,i,j) = slice(IMOMX,i,j)
     $              + dt*dy(j)*(-fl(j,2,1)+fl(j,1,1))
               slice(IMOMY,i,j) = slice(IMOMY,i,j)
     $              + dt*dy(j)*(-fl(j,2,2)+fl(j,1,2))
               slice(IENER,i,j) = slice(IENER,i,j)
     $              + dt*dy(j)*(-fl(j,2,3)+fl(j,1,3))
               slice(IENER,i,j) = slice(IENER,i,j) +
     $              0.25e0*dt*dy(j)*(rnu+1.0e0)*(
     $              -fl(j,2,0)/betal(j,2)**2 + fl(j,1,0)/betal(j,1)**2)
            end do
         end do

c     
c     do partial time step x-backward
c     
         ixy = 1
         ifb = -1
         
         do i = 1,nx
c     
c     first assemble the primitive variables for rows i-1 to i+1
c     
            do ii = -1,1
               ir = i + ii
               do j = -1,ny+2
                  rho(j,ii) = rmasst(ir,j)/(dx(ir)*dy(j))
                  u(j,ii) = rmomxt(ir,j)/rmasst(ir,j)
                  v(j,ii) = rmomyt(ir,j)/rmasst(ir,j)
                  beta(j,ii) = (2.0e0*enert(ir,j)/rmasst(ir,j)
     $                 - u(j,ii)**2 - v(j,ii)**2)/((rnu+3.0e0)*bigr)
                  beta(j,ii) = 1.0e0/sqrt(2.0e0*bigr*beta(j,ii))
               end do
            end do
c     
c     extrapolate to the cell boundaries
c     
            call slplimx (nx,ny,x,dx,xmid,ifb,i,rho,rhol(-1,1),g,g1,g2)
            call slplimx (nx,ny,x,dx,xmid,ifb,i,u,ul(-1,1),g,g1,g2)
            call slplimx (nx,ny,x,dx,xmid,ifb,i,v,vl(-1,1),g,g1,g2)
            call slplimx (nx,ny,x,dx,xmid,ifb,i,beta,betal(-1,1),g,g1,g2)
c     
c     now assemble the primitive variables for rows i to i+2
c     
            do ii = -1,1
               ir = i+1+ii
               do j = -1,ny+2
                  rho(j,ii) = rmasst(ir,j)/(dx(ir)*dy(j))
                  u(j,ii) = rmomxt(ir,j)/rmasst(ir,j)
                  v(j,ii) = rmomyt(ir,j)/rmasst(ir,j)
                  beta(j,ii) = (2.0e0*enert(ir,j)/rmasst(ir,j)
     $                 - u(j,ii)**2 - v(j,ii)**2)/((rnu+3.0e0)*bigr)
                  beta(j,ii) = 1.0e0/sqrt(2.0e0*bigr*beta(j,ii))
               end do
            end do
c     
c     extrapolate to the cell boundaries
c     
            call slplimx (nx,ny,x,dx,xmid,ifb,i+1,rho,rhol(-1,2),g,g1,g2)
            call slplimx (nx,ny,x,dx,xmid,ifb,i+1,u,ul(-1,2),g,g1,g2)
            call slplimx (nx,ny,x,dx,xmid,ifb,i+1,v,vl(-1,2),g,g1,g2)
            call slplimx (nx,ny,x,dx,xmid,ifb,i+1,beta,betal(-1,2),g,g1,g2)
c     
c     compute the fluxes
c     
            call flux (nx,ny,ixy,ifb,dx,dy,betal,rhol,ul,vl,fl,
     $           sx,erfsx,es2x,sy,erfsy,es2y)
c     
c     do partial time step x-backward
c     
            do j = 1,ny
               slice(IMASS,i,j) = slice(IMASS,i,j)
     $              + dt*dy(j)*(fl(j,1,0)-fl(j,2,0))
               slice(IMOMX,i,j) = slice(IMOMX,i,j)
     $              + dt*dy(j)*(fl(j,1,1)-fl(j,2,1))
               slice(IMOMY,i,j) = slice(IMOMY,i,j)
     $              + dt*dy(j)*(fl(j,1,2)-fl(j,2,2))
               slice(IENER,i,j) = slice(IENER,i,j)
     $              + dt*dy(j)*(fl(j,1,3)-fl(j,2,3))
               slice(IENER,i,j) = slice(IENER,i,j)
     $              + 0.25e0*dt*dy(j)*(rnu+1.0e0)*(
     $              fl(j,1,0)/betal(j,1)**2 - fl(j,2,0)/betal(j,2)**2)
            end do
         end do
c     
c     do partial time step y-forward
c     
         ixy = -1
         ifb = 1
         do j = 1,ny
c     
c     first assemble the primitive variables for rows j-1 to j+1
c     
            do jj = -1,1
               jr = j + jj
               do i = -1,nx+2
                  rho(i,jj) = rmasst(i,jr)/(dx(i)*dy(jr))
                  u(i,jj) = rmomxt(i,jr)/rmasst(i,jr)
                  v(i,jj) = rmomyt(i,jr)/rmasst(i,jr)
                  beta(i,jj) = (2.0e0*enert(i,jr)/rmasst(i,jr)
     $                 - u(i,jj)**2 - v(i,jj)**2)/((rnu+3.0e0)*bigr)
                  beta(i,jj) = 1.0e0/sqrt(2.0e0*bigr*beta(i,jj))
               end do
            end do
c     
c     extrapolate to the cell boundaries
c     
            call slplimy (nx,ny,y,dy,ymid,ifb,j,rho,rhol(-1,2),g,g1,g2)
            call slplimy (nx,ny,y,dy,ymid,ifb,j,u,ul(-1,2),g,g1,g2)
            call slplimy (nx,ny,y,dy,ymid,ifb,j,v,vl(-1,2),g,g1,g2)
            call slplimy (nx,ny,y,dy,ymid,ifb,j,beta,betal(-1,2),g,g1,g2)
c     
c     now assemble the primitive variables for rows j-2 to j
c     
            do jj = -1,1
               jr = j + jj-1
               do i = -1,nx+2
                  rho(i,jj) = rmasst(i,jr)/(dx(i)*dy(jr))
                  u(i,jj) = rmomxt(i,jr)/rmasst(i,jr)
                  v(i,jj) = rmomyt(i,jr)/rmasst(i,jr)
                  beta(i,jj) = (2.0e0*enert(i,jr)/rmasst(i,jr)
     $                 - u(i,jj)**2 - v(i,jj)**2)/((rnu+3.0e0)*bigr)
                  beta(i,jj) = 1.0e0/sqrt(2.0e0*bigr*beta(i,jj))
               end do
            end do
c     
c     extrapolate to the cell boundaries
c     
            call slplimy (nx,ny,y,dy,ymid,ifb,j-1,rho,rhol(-1,1),g,g1,g2)
            call slplimy (nx,ny,y,dy,ymid,ifb,j-1,u,ul(-1,1),g,g1,g2)
            call slplimy (nx,ny,y,dy,ymid,ifb,j-1,v,vl(-1,1),g,g1,g2)
            call slplimy (nx,ny,y,dy,ymid,ifb,j-1,beta,betal(-1,1),g,g1,g2)
c     
c     compute the fluxes
c     
            call flux (nx,nx,ixy,ifb,dx,dy,betal,rhol,ul,vl,fl,
     $           sx,erfsx,es2x,sy,erfsy,es2y)
c     
c     do partial time step y-forward
c     
            do i = 1,nx
               slice(IMASS,i,j) = slice(IMASS,i,j)
     $              + dt*dx(i)*(-fl(i,2,0)+fl(i,1,0))
               slice(IMOMX,i,j) = slice(IMOMX,i,j)
     $              + dt*dx(i)*(-fl(i,2,1)+fl(i,1,1))
               slice(IMOMY,i,j) = slice(IMOMY,i,j)
     $              + dt*dx(i)*(-fl(i,2,2)+fl(i,1,2))
               slice(IENER,i,j) = slice(IENER,i,j)
     $              + dt*dx(i)*(-fl(i,2,3)+fl(i,1,3))
               slice(IENER,i,j) = slice(IENER,i,j)
     $              + 0.25e0*dt*dx(i)*(rnu+1.0e0)*(
     $              -fl(i,2,0)/betal(i,2)**2 + fl(i,1,0)/betal(i,1)**2)
            end do
         end do
c     
c     do partial time step y-backward
c     
         ixy = -1
         ifb = -1
         do j = 1,ny
c     
c     first assemble the primitive variables for rows j-1 to j+1
c     
            do jj = -1,1
               jr = j + jj
               do i = -1,nx+2
                  rho(i,jj) = rmasst(i,jr)/(dx(i)*dy(jr))
                  u(i,jj) = rmomxt(i,jr)/rmasst(i,jr)
                  v(i,jj) = rmomyt(i,jr)/rmasst(i,jr)
                  beta(i,jj) = (2.0e0*enert(i,jr)/rmasst(i,jr)
     $                 - u(i,jj)**2 - v(i,jj)**2)/((rnu+3.0e0)*bigr)
                  beta(i,jj) = 1.0e0/sqrt(2.0e0*bigr*beta(i,jj))
               end do
            end do
c     
c     extrapolate to the cell boundaries
c     
            call slplimy (nx,ny,y,dy,ymid,ifb,j,rho,rhol(-1,1),g,g1,g2)
            call slplimy (nx,ny,y,dy,ymid,ifb,j,u,ul(-1,1),g,g1,g2)
            call slplimy (nx,ny,y,dy,ymid,ifb,j,v,vl(-1,1),g,g1,g2)
            call slplimy (nx,ny,y,dy,ymid,ifb,j,beta,betal(-1,1),g,g1,g2)
c     
c     now assemble the primitive variables for rows j to j+2
c     
            do jj = -1,1
               jr = j + jj + 1
               do i = -1,nx+2
                  rho(i,jj) = rmasst(i,jr)/(dx(i)*dy(jr))
                  u(i,jj) = rmomxt(i,jr)/rmasst(i,jr)
                  v(i,jj) = rmomyt(i,jr)/rmasst(i,jr)
                  beta(i,jj) = (2.0e0*enert(i,jr)/rmasst(i,jr)
     $                 - u(i,jj)**2 - v(i,jj)**2)/((rnu+3.0e0)*bigr)
                  beta(i,jj) = 1.0e0/sqrt(2.0e0*bigr*beta(i,jj))
               end do
            end do
c     
c     extrapolate to the cell boundaries
c     
            call slplimy (nx,ny,y,dy,ymid,ifb,j+1,rho,rhol(-1,2),g,g1,g2)
            call slplimy (nx,ny,y,dy,ymid,ifb,j+1,u,ul(-1,2),g,g1,g2)
            call slplimy (nx,ny,y,dy,ymid,ifb,j+1,v,vl(-1,2),g,g1,g2)
            call slplimy (nx,ny,y,dy,ymid,ifb,j+1,beta,betal(-1,2),g,g1,g2)
c     
c     compute the fluxes
c     
            call flux (nx,nx,ixy,ifb,dx,dy,betal,rhol,ul,vl,fl,
     $           sx,erfsx,es2x,sy,erfsy,es2y)
c     
c     do partial time step y-backward
c     
            do i = 1,nx
               slice(IMASS,i,j) = slice(IMASS,i,j)
     $              + dt*dx(i)*(fl(i,1,0)-fl(i,2,0))
               slice(IMOMX,i,j) = slice(IMOMX,i,j)
     $              + dt*dx(i)*(fl(i,1,1)-fl(i,2,1))
               slice(IMOMY,i,j) = slice(IMOMY,i,j)
     $              + dt*dx(i)*(fl(i,1,2)-fl(i,2,2))
               slice(IENER,i,j) = slice(IENER,i,j)
     $              + dt*dx(i)*(fl(i,1,3)-fl(i,2,3))
               slice(IENER,i,j) = slice(IENER,i,j)
     $              + 0.25e0*dt*dx(i)*(rnu+1.0e0)*(
     $              fl(i,1,0)/betal(i,1)**2 - fl(i,2,0)/betal(i,2)**2)
            end do
         end do

 2992    continue

         if (mod(istep,iout) .eq. 0) then
            call MOVE_TO_HOST_FORM
            call MOVE_TO_GRID_FORM
         endif
         t = t + dt
      end do

      end


      process mainproc (HtoGout, GtoHin, globsend_in, globrecv_out)

C****************************************************************************
C****************************************************************************
C*
C*       Mesh Template parameter file
C*       Written By: Rajit Manohar 
C*       On: Mon Oct 25 20:12:06 PDT 1993
C*
C****************************************************************************
C****************************************************************************

C
C GRID: the # of processes (X times Y)
C
      parameter (NGRIDX=2, NGRIDY=2)
C
C ROWS/COLS: the amt of data per process
C
      parameter (NROWS=100, NCOLS=200)
C
C WIDTH: The # of boundary cells to be exchanged
C
      parameter (NWIDTH=2)
C
C ITEMS: The # of data items
C
      parameter (NITEMS=4)
C
C  NTOTX = NGRIDX*NCOLS, NTOTY = NGRIDY*NROWS
C
      parameter (NTOTX=400, NTOTY=200)
C
C  NLOCXL = -NWIDTH+1, NLOCXR = NCOLS + NWIDTH
C  NLOCYL = -NWIDTH+1, NLOCYR = NROWS + NWIDTH
C
      parameter (NLOCXL=-1, NLOCXR=202)
      parameter (NLOCYL=-1, NLOCYR=102)



      parameter (IGRIDTYPE = 1, IGRIDFORM = 1)
      parameter (IHOSTTYPE = 2, IHOSTFORM = 2)

      parameter (IMASS=1, IMOMX=2, IMOMY=3, IENER=4)

      parameter (IEXTRA = 2)

C
C      parameter (ITEMPO = NCOLS + 1)
C      parameter (ITEMPI = NCOLS + NWIDTH + NWIDTH)
C      parameter (ITEMP2 = NTOTX + 2, ITEMP3 = NTOTY + 2)
C

      parameter (ITEMPO = 201)
      parameter (ITEMPI = 204)
      parameter (ITEMP2 = 402, ITEMP3 = 202)

      parameter (MINUS1 = -1)
      parameter (MINUS2 = -2)
      


      inport (real  x(NITEMS,NROWS,NCOLS)) GtoHin (NGRIDX,NGRIDY),
     $     cl_GtoHin(NGRIDX,NGRIDY)
      outport (real  x(NITEMS,NROWS,NCOLS)) HtoGout(NGRIDX,NGRIDY),
     $     cl_HtoGout(NGRIDX,NGRIDY)
      inport (real  x, real  x(IEXTRA)) globsend_in (NGRIDX,NGRIDY),
     $     cl_globsend_in (NGRIDX,NGRIDY)
      outport (integer m, real  x(m)) globrecv_out (NGRIDX,NGRIDY),
     $     cl_globrecv_out(NGRIDX,NGRIDY)

      real  data (NITEMS, NTOTX, NTOTY)
      PROCESS COMMON /MAINPROCCOM/ cl_GtoHin, cl_HtoGout, data,
     $     cl_globsend_in, cl_globrecv_out
      real const(ITEMPI)
      PROCESS COMMON /CONSTDATA/ const

C************************************************************************
C*
C*     Written by: Rajit Manohar
C*             On: Sun Nov 14 22:59:32 PST 1993
C*       Original: /home/ama-iris/r/dim/rm/efm/2-d/src/common
C*
C************************************************************************

	PROCESS COMMON /CONST/ bigr, gamma, rnu

C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      character*20 jname
      character*20 dimfile
      character*20 resfile
      character*3 recno
      integer chdir
      logical ires
      real xmid(MINUS1:ITEMP2),ymid(MINUS1:ITEMP3)
      real dx(MINUS1:ITEMP2), dy(MINUS1:ITEMP3)
      real x(MINUS2:ITEMP2), y(MINUS2:ITEMP3)
      real timearray(2), dtime

      PROCESS common /debug0/ jname

C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      do i = 1, NGRIDX
         do j = 1, NGRIDY
            moveport (from=globsend_in(i,j), to=cl_globsend_in(i,j))
            moveport (from=globrecv_out(i,j),to=cl_globrecv_out(i,j))
            moveport (from=GtoHin(i,j), to=cl_GtoHin(i,j))
            moveport (from=HtoGout(i,j),to=cl_HtoGout(i,j))
         end do
      end do
      call INITIALIZE_FORMS (IHOSTTYPE)
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

c
c     read in the jobname
c     
      open (unit=11, file='.job_name')
      read (11, 1000) jname
 1000 format (a)
      
      call getrlen(jname, ilen)
      ierr=chdir(jname(1:ilen))
c      dimfile = jname(1:ilen) // ".dim"
      open (unit=11, file=dimfile)
      read (11, 1001) nx, ny
 1001 format (2i5)
      close (unit=11)
      if (nx .lt. ny) then
         write (6,*) ' nx must be >= ny '
         stop
      endif
      
      if (nx .ne. NTOTX .or. ny .ne. NTOTY) then
         write (6,*) ' Please recompile using the following parameters'
         write (6,*) '        NTOTX=', nx
         write (6,*) '        NTOTY=', ny
         stop
      endif

      call startlog (jname)

      call parin (jname, ires, resfile, irec, dt, cflmax,
     $     nsteps, iout)
c     
c     read initial condition
c     
      call incon (jname,ires,resfile,irec,t,dt,xmin,
     $     xmax,ymin,ymax,ibc,gamma,bigr,cflmax,
     $     x,y, data)

c     
c     compute rnu
c     
      rnu = (5.0e0-3.0e0*gamma)/(gamma - 1.0e0)
c     
c     compute mid-points and deltax deltay
c     
      call init (x,y,dx,dy,xmid,ymid)
c     
c     if not a restart dump the initial condition
c     
      if (.not. ires) then
         irec = 0
         call getrlen (jname,ilen)
         write (recno,2100) irec
 2100    format (i3.3)
c         resfile = jname(1:ilen)//".r"//recno
         call putdat (resfile,dt,t,xmin,xmax,ymin,ymax,
     $        ibc,gamma,bigr,cflmax,x,y,data)
c     
c     report 
c     
         call openlog (jname)
         write (12,1003) resfile,t
 1003    format(/,' wrote restart data to ',a, 'at t = ',e15.7,/)
         call closelog
      end if
c     
c     start time step loop
c     
      const(10) = iout
      const(9) = nsteps
      const(8) = ibc
      const(7) = bigr
      const(1) = gamma
      const(2) = rnu
      const(3) = cflmax
      const(4) = t
      const(5) = dtold
      const(6) = dt
      call GET_CONST_DATA

      do i = 1, NGRIDX
         do j = 1, NGRIDY
            send (cl_globrecv_out(i,j)) NLOCXR+2, xmid((i-1)*NCOLS-1)
            send (cl_globrecv_out(i,j)) NLOCXR+2, dx((i-1)*NCOLS-1)
            send (cl_globrecv_out(i,j)) NLOCXR+3, x((i-1)*NCOLS-2)
         end do
      end do

      do i = 1, NGRIDY
         do j = 1, NGRIDX
            send (cl_globrecv_out(j,i)) NLOCYR+2, ymid((i-1)*NROWS-1)
            send (cl_globrecv_out(j,i)) NLOCYR+2, dy((i-1)*NROWS-1)
            send (cl_globrecv_out(j,i)) NLOCYR+3, y((i-1)*NROWS-2)
         end do
      end do


      call MOVE_TO_GRID_FORM

      do istep = 1,nsteps
         call EXCHANGE_BOUNDARIES2

         call getdt (t,cflmax,dtold,dt,dx,dy,data, ntotx, ntoty)
         if (dt .ne. dtold) then
            call openlog(jname)
            write (12,1005) dtold,dt
 1005       format (/,' time step changed due to cfl criterion',/,
     $           ' old dt: ',e15.7,' new dt', e15.7)
            call closelog
         end if

C****** timestep performed by grid process
C Added by MRN 24 Feb 94  1  does not have dtime


         call openlog(jname)
         write (12,2000) istep,t,dt,ttim
 2000    format (' istep =        ',i5,10x,' time =         ',e15.7,/,
     $        ' dt =           ',e15.7, ' time for step  ',e15.7,/)
         call closelog

         if (mod(istep,iout) .eq. 0) then
            call MOVE_TO_HOST_FORM
            irec = irec + 1
            call getrlen (jname,ilen)
            write (recno,2001) irec
 2001       format (i3.3)
            resfile = jname(1:ilen)//".r"//recno
            call putdat (resfile,dt,t,xmin,xmax,ymin,ymax,
     $           ibc,gamma,bigr,cflmax,x,y,data)
c     
c     report 
c     
            call openlog (jname)
            write (12,2004) resfile,t
 2004       format(/,' wrote restart data to ',a, 'at t = ',e15.7,/)
            call closelog
            call MOVE_TO_GRID_FORM
         endif
         t = t + dt
      end do
      call endlog (jname)
      return
      end 





C###########################################################################
C###########################################################################
C
C                  T E M P L A T E    S U B R O U T I N E S
C
C###########################################################################
C###########################################################################

      subroutine INITIALIZE_FORMS (mytype)

C****************************************************************************
C****************************************************************************
C*
C*       Mesh Template parameter file
C*       Written By: Rajit Manohar 
C*       On: Mon Oct 25 20:12:06 PDT 1993
C*
C****************************************************************************
C****************************************************************************

C
C GRID: the # of processes (X times Y)
C
      parameter (NGRIDX=2, NGRIDY=2)
C
C ROWS/COLS: the amt of data per process
C
      parameter (NROWS=100, NCOLS=200)
C
C WIDTH: The # of boundary cells to be exchanged
C
      parameter (NWIDTH=2)
C
C ITEMS: The # of data items
C
      parameter (NITEMS=4)
C
C  NTOTX = NGRIDX*NCOLS, NTOTY = NGRIDY*NROWS
C
      parameter (NTOTX=400, NTOTY=200)
C
C  NLOCXL = -NWIDTH+1, NLOCXR = NCOLS + NWIDTH
C  NLOCYL = -NWIDTH+1, NLOCYR = NROWS + NWIDTH
C
      parameter (NLOCXL=-1, NLOCXR=202)
      parameter (NLOCYL=-1, NLOCYR=102)



      parameter (IGRIDTYPE = 1, IGRIDFORM = 1)
      parameter (IHOSTTYPE = 2, IHOSTFORM = 2)

      parameter (IMASS=1, IMOMX=2, IMOMY=3, IENER=4)

      parameter (IEXTRA = 2)

C
C      parameter (ITEMPO = NCOLS + 1)
C      parameter (ITEMPI = NCOLS + NWIDTH + NWIDTH)
C      parameter (ITEMP2 = NTOTX + 2, ITEMP3 = NTOTY + 2)
C

      parameter (ITEMPO = 201)
      parameter (ITEMPI = 204)
      parameter (ITEMP2 = 402, ITEMP3 = 202)

      parameter (MINUS1 = -1)
      parameter (MINUS2 = -2)
      


      process COMMON /FORMS/ iform, itype
      
      iform = IHOSTFORM
      itype = mytype

      end

      subroutine MOVE_TO_HOST_FORM

C****************************************************************************
C****************************************************************************
C*
C*       Mesh Template parameter file
C*       Written By: Rajit Manohar 
C*       On: Mon Oct 25 20:12:06 PDT 1993
C*
C****************************************************************************
C****************************************************************************

C
C GRID: the # of processes (X times Y)
C
      parameter (NGRIDX=2, NGRIDY=2)
C
C ROWS/COLS: the amt of data per process
C
      parameter (NROWS=100, NCOLS=200)
C
C WIDTH: The # of boundary cells to be exchanged
C
      parameter (NWIDTH=2)
C
C ITEMS: The # of data items
C
      parameter (NITEMS=4)
C
C  NTOTX = NGRIDX*NCOLS, NTOTY = NGRIDY*NROWS
C
      parameter (NTOTX=400, NTOTY=200)
C
C  NLOCXL = -NWIDTH+1, NLOCXR = NCOLS + NWIDTH
C  NLOCYL = -NWIDTH+1, NLOCYR = NROWS + NWIDTH
C
      parameter (NLOCXL=-1, NLOCXR=202)
      parameter (NLOCYL=-1, NLOCYR=102)



      parameter (IGRIDTYPE = 1, IGRIDFORM = 1)
      parameter (IHOSTTYPE = 2, IHOSTFORM = 2)

      parameter (IMASS=1, IMOMX=2, IMOMY=3, IENER=4)

      parameter (IEXTRA = 2)

C
C      parameter (ITEMPO = NCOLS + 1)
C      parameter (ITEMPI = NCOLS + NWIDTH + NWIDTH)
C      parameter (ITEMP2 = NTOTX + 2, ITEMP3 = NTOTY + 2)
C

      parameter (ITEMPO = 201)
      parameter (ITEMPI = 204)
      parameter (ITEMP2 = 402, ITEMP3 = 202)

      parameter (MINUS1 = -1)
      parameter (MINUS2 = -2)
      


      inport (real  x(NITEMS,NROWS,NCOLS)) GtoHin (NGRIDX,NGRIDY)
      outport (real  x(NITEMS,NROWS,NCOLS)) HtoGout(NGRIDX,NGRIDY)
      inport (real  x(NWIDTH,NITEMS,NROWS)) ewl_in
      inport (real  x(NWIDTH,NITEMS,NCOLS)) nsu_in
      inport (real  x(NWIDTH,NITEMS,NROWS)) ewr_in
      inport (real  x(NWIDTH,NITEMS,NCOLS)) nsd_in

      outport (real  x(NWIDTH,NITEMS,NROWS)) ewl_out
      outport (real  x(NWIDTH,NITEMS,NCOLS)) nsu_out
      outport (real  x(NWIDTH,NITEMS,NROWS)) ewr_out
      outport (real  x(NWIDTH,NITEMS,NCOLS)) nsd_out

      inport (real  x(NITEMS,NROWS,NCOLS)) HtoGin
      outport (real  x(NITEMS,NROWS,NCOLS)) GtoHout
      outport (real  x, real  x(IEXTRA)) globsend_out
      inport (integer m, real  x(m)) globrecv_in
      inport (real  x, real  x(IEXTRA)) globsend_in (NGRIDX,NGRIDY)
      outport (integer m, real  x(m)) globrecv_out (NGRIDX,NGRIDY)

      real  slice (NITEMS, NLOCXL:NLOCXR, NLOCYL:NLOCYR)
      real  comslice (NITEMS, NROWS, NCOLS)
      real  data (NITEMS, NTOTX, NTOTY)
      PROCESS COMMON /GRID/ ewl_in, nsu_in, ewr_in, nsd_in,
     $     ewl_out, nsu_out, ewr_out, nsd_out, HtoGin, GtoHout,
     $     globsend_out, globrecv_in
      PROCESS COMMON /DATA/ slice
      PROCESS COMMON /MAINPROCCOM/ GtoHin, HtoGout, data,
     $     globsend_in, globrecv_out
      PROCESS COMMON /FORMS/ iform, itype

      if (iform .eq. IHOSTFORM) then
         return
      endif
         
      if (itype .eq. IHOSTTYPE) then
         do i = 1, NGRIDX
            do j = 1, NGRIDY
               receive (GtoHin(i,j)) comslice
               do kk = 1, NITEMS
                  do ii = 1, NCOLS
                     do jj = 1, NROWS
                        data (kk,(i-1)*NCOLS+ii, (j-1)*NROWS+jj) =
     $                       comslice (kk, jj, ii)
                     end do
                  end do
               end do
            end do
         end do
      else
         do k = 1, NITEMS
            do j = 1, NROWS
               do i = 1, NCOLS
                  comslice(k,j,i) = slice(k,i,j)
               end do
            end do
         end do
         send (GtoHout) comslice
      endif
      iform = IHOSTFORM
      
      end

      subroutine MOVE_TO_GRID_FORM

C****************************************************************************
C****************************************************************************
C*
C*       Mesh Template parameter file
C*       Written By: Rajit Manohar 
C*       On: Mon Oct 25 20:12:06 PDT 1993
C*
C****************************************************************************
C****************************************************************************

C
C GRID: the # of processes (X times Y)
C
      parameter (NGRIDX=2, NGRIDY=2)
C
C ROWS/COLS: the amt of data per process
C
      parameter (NROWS=100, NCOLS=200)
C
C WIDTH: The # of boundary cells to be exchanged
C
      parameter (NWIDTH=2)
C
C ITEMS: The # of data items
C
      parameter (NITEMS=4)
C
C  NTOTX = NGRIDX*NCOLS, NTOTY = NGRIDY*NROWS
C
      parameter (NTOTX=400, NTOTY=200)
C
C  NLOCXL = -NWIDTH+1, NLOCXR = NCOLS + NWIDTH
C  NLOCYL = -NWIDTH+1, NLOCYR = NROWS + NWIDTH
C
      parameter (NLOCXL=-1, NLOCXR=202)
      parameter (NLOCYL=-1, NLOCYR=102)



      parameter (IGRIDTYPE = 1, IGRIDFORM = 1)
      parameter (IHOSTTYPE = 2, IHOSTFORM = 2)

      parameter (IMASS=1, IMOMX=2, IMOMY=3, IENER=4)

      parameter (IEXTRA = 2)

C
C      parameter (ITEMPO = NCOLS + 1)
C      parameter (ITEMPI = NCOLS + NWIDTH + NWIDTH)
C      parameter (ITEMP2 = NTOTX + 2, ITEMP3 = NTOTY + 2)
C

      parameter (ITEMPO = 201)
      parameter (ITEMPI = 204)
      parameter (ITEMP2 = 402, ITEMP3 = 202)

      parameter (MINUS1 = -1)
      parameter (MINUS2 = -2)
      


      inport (real  x(NITEMS,NROWS,NCOLS)) GtoHin (NGRIDX,NGRIDY)
      outport (real  x(NITEMS,NROWS,NCOLS)) HtoGout(NGRIDX,NGRIDY)
      inport (real  x(NWIDTH,NITEMS,NROWS)) ewl_in
      inport (real  x(NWIDTH,NITEMS,NCOLS)) nsu_in
      inport (real  x(NWIDTH,NITEMS,NROWS)) ewr_in
      inport (real  x(NWIDTH,NITEMS,NCOLS)) nsd_in

      outport (real  x(NWIDTH,NITEMS,NROWS)) ewl_out
      outport (real  x(NWIDTH,NITEMS,NCOLS)) nsu_out
      outport (real  x(NWIDTH,NITEMS,NROWS)) ewr_out
      outport (real  x(NWIDTH,NITEMS,NCOLS)) nsd_out

      inport (real  x(NITEMS,NROWS,NCOLS)) HtoGin
      outport (real  x(NITEMS,NROWS,NCOLS)) GtoHout

      outport (real  x, real  x(IEXTRA)) globsend_out
      inport (integer m, real  x(m)) globrecv_in

      inport (real  x, real  x(IEXTRA)) globsend_in (NGRIDX,NGRIDY)
      outport (integer m, real  x(m)) globrecv_out (NGRIDX,NGRIDY)

      real  slice (NITEMS, NLOCXL:NLOCXR, NLOCYL:NLOCYR)
      real  comslice (NITEMS, NROWS, NCOLS)
      real  data (NITEMS, NTOTX, NTOTY)
      PROCESS COMMON /GRID/ ewl_in, nsu_in, ewr_in, nsd_in,
     $     ewl_out, nsu_out, ewr_out, nsd_out, HtoGin, GtoHout,
     $     globsend_out, globrecv_in
      PROCESS COMMON /DATA/ slice
      PROCESS COMMON /MAINPROCCOM/ GtoHin, HtoGout, data,
     $     globsend_in, globrecv_out
      PROCESS COMMON /FORMS/ iform, itype

      if (iform .eq. IGRIDFORM) then
         return
      endif
         
      if (itype .eq. IHOSTTYPE) then
         do i = 1, NGRIDX
            do j = 1, NGRIDY
               do kk = 1, NITEMS
                  do ii = 1, NCOLS
                     do jj = 1, NROWS
                        comslice (kk, jj, ii) =
     $                       data (kk,(i-1)*NCOLS+ii, (j-1)*NROWS+jj)
                     end do
                  end do
               end do
               send (HtoGout(i,j)) comslice
            end do
         end do
      else
         receive (HtoGin) comslice
         do k = 1, NITEMS
            do j = 1, NROWS
               do i = 1, NCOLS
                  slice(k,i,j) = comslice(k,j,i)
               end do
            end do
         end do
      endif
      iform = IGRIDFORM
      
      end

      subroutine EXCHANGE_BOUNDARIES2

C****************************************************************************
C****************************************************************************
C*
C*       Mesh Template parameter file
C*       Written By: Rajit Manohar 
C*       On: Mon Oct 25 20:12:06 PDT 1993
C*
C****************************************************************************
C****************************************************************************

C
C GRID: the # of processes (X times Y)
C
      parameter (NGRIDX=2, NGRIDY=2)
C
C ROWS/COLS: the amt of data per process
C
      parameter (NROWS=100, NCOLS=200)
C
C WIDTH: The # of boundary cells to be exchanged
C
      parameter (NWIDTH=2)
C
C ITEMS: The # of data items
C
      parameter (NITEMS=4)
C
C  NTOTX = NGRIDX*NCOLS, NTOTY = NGRIDY*NROWS
C
      parameter (NTOTX=400, NTOTY=200)
C
C  NLOCXL = -NWIDTH+1, NLOCXR = NCOLS + NWIDTH
C  NLOCYL = -NWIDTH+1, NLOCYR = NROWS + NWIDTH
C
      parameter (NLOCXL=-1, NLOCXR=202)
      parameter (NLOCYL=-1, NLOCYR=102)



      parameter (IGRIDTYPE = 1, IGRIDFORM = 1)
      parameter (IHOSTTYPE = 2, IHOSTFORM = 2)

      parameter (IMASS=1, IMOMX=2, IMOMY=3, IENER=4)

      parameter (IEXTRA = 2)

C
C      parameter (ITEMPO = NCOLS + 1)
C      parameter (ITEMPI = NCOLS + NWIDTH + NWIDTH)
C      parameter (ITEMP2 = NTOTX + 2, ITEMP3 = NTOTY + 2)
C

      parameter (ITEMPO = 201)
      parameter (ITEMPI = 204)
      parameter (ITEMP2 = 402, ITEMP3 = 202)

      parameter (MINUS1 = -1)
      parameter (MINUS2 = -2)
      

      parameter (IFIRST=NROWS+NWIDTH*2, INEXT=NCOLS+NWIDTH*2)
      inport (real  x(NWIDTH,NITEMS,IFIRST)) ewl_in
      inport (real  x(NWIDTH,NITEMS,INEXT)) nsu_in
      inport (real  x(NWIDTH,NITEMS,IFIRST)) ewr_in
      inport (real  x(NWIDTH,NITEMS,INEXT)) nsd_in

      outport (real  x(NWIDTH,NITEMS,IFIRST)) ewl_out
      outport (real  x(NWIDTH,NITEMS,INEXT)) nsu_out
      outport (real  x(NWIDTH,NITEMS,IFIRST)) ewr_out
      outport (real  x(NWIDTH,NITEMS,INEXT)) nsd_out

      outport (real  x, real  x(IEXTRA)) globsend_out
      inport (integer m, real  x(m)) globrecv_in

      real  slice (NITEMS, NLOCXL:NLOCXR, NLOCYL:NLOCYR)
      PROCESS COMMON /GRID/ ewl_in, nsu_in, ewr_in, nsd_in,
     $     ewl_out, nsu_out, ewr_out, nsd_out, HtoGin, GtoHout,
     $     globsend_out, globrecv_in
      PROCESS COMMON /DATA/ slice
      PROCESS COMMON /FORMS/ iform, itype

      real  borderh (NWIDTH,NITEMS,NLOCXL:NLOCXR)
      real  borderv (NWIDTH,NITEMS,NLOCYL:NLOCYR)

      if (itype .eq. IHOSTTYPE) then
         return
      endif
      if (iform .eq. IHOSTFORM) then
         print *, 'ERROR: Tried to exchange boundaries when in HOST form'
         stop
      endif
      
C   *** Copy top/bot into borderh
      do i = 1, NWIDTH
         do j = 1, NITEMS
            do k = NLOCXL, NLOCXR
               borderh(i,j,k) = slice(j,k,NLOCYL+i-1)
            end do
         end do
      end do
      send (nsu_out) borderh
      do i = 1, NWIDTH
         do j = 1, NITEMS
            do k = NLOCXL, NLOCXR
               borderh(i,j,k) = slice(j,k,NLOCYR-NWIDTH+i)
            end do
         end do
      end do
      send (nsd_out) borderh
      receive (nsu_in) borderh
      do i = 1, NWIDTH
         do j = 1, NITEMS
            do k = NLOCXL, NLOCXR
               slice(j,k,NLOCYL+i-1) = borderh(i,j,k)
            end do
         end do
      end do
      receive (nsd_in) borderh
      do i = 1, NWIDTH
         do j = 1, NITEMS
            do k = NLOCXL, NLOCXR
               slice(j,k,NLOCYR-NWIDTH+i) = borderh(i,j,k)
            end do
         end do
      end do
C
C
C     Copy an NWIDTH x NWIDTH square from the strips exchanged into the 
C     slice array for the next exchange.
C
      do i = 1, NWIDTH
         do j = 1, NWIDTH
            do k = 1, NITEMS
               slice (k, NLOCXL+i-1, NLOCYL+j-1) =
     $              slice(k,i,NLOCYL+j-1)
               slice (k, NLOCXR-NWIDTH+i, NLOCYL+j-1) =
     $              slice(k,NCOLS-NWIDTH+i, NLOCYL+j-1)
               slice (k,NLOCXL+i-1, NLOCYR-NWIDTH+j) =
     $              slice(k,i,NLOCYR-NWIDTH+j)
               slice (k,NLOCXR-NWIDTH+i, NLOCYR-NWIDTH+j) =
     $              slice (k,NCOLS-NWIDTH+i, NLOCYR-NWIDTH+j)
            end do
         end do
      end do

      do i = 1, NWIDTH
         do j = 1, NITEMS
            do k = NLOCYL, NLOCYR
               borderv(i,j,k) = slice(j,NLOCXL+i-1,k)
            end do
         end do
      end do
      send (ewl_out) borderv
      do i = 1, NWIDTH
         do j = 1, NITEMS
            do k = NLOCYL, NLOCYR
               borderv(i,j,k) = slice(j,NLOCXR-NWIDTH+i,k)
            end do
         end do
      end do
      send (ewr_out) borderv
      receive (ewl_in) borderv
      do i = 1, NWIDTH
         do j = 1, NITEMS
            do k = NLOCYL, NLOCYR
               slice(j,NLOCXL+i-1,k) = borderv(i,j,k)
            end do
         end do
      end do
      receive (ewr_in) borderv
      do i = 1, NWIDTH
         do j = 1, NITEMS
            do k = NLOCYL,NLOCYR
               slice(j,NLOCXR-NWIDTH+i,k) = borderv(i,j,k)
            end do
         end do
      end do
      
      end

      
      subroutine EXCHANGE_BOUNDARIES 


C****************************************************************************
C****************************************************************************
C*
C*       Mesh Template parameter file
C*       Written By: Rajit Manohar 
C*       On: Mon Oct 25 20:12:06 PDT 1993
C*
C****************************************************************************
C****************************************************************************

C
C GRID: the # of processes (X times Y)
C
      parameter (NGRIDX=2, NGRIDY=2)
C
C ROWS/COLS: the amt of data per process
C
      parameter (NROWS=100, NCOLS=200)
C
C WIDTH: The # of boundary cells to be exchanged
C
      parameter (NWIDTH=2)
C
C ITEMS: The # of data items
C
      parameter (NITEMS=4)
C
C  NTOTX = NGRIDX*NCOLS, NTOTY = NGRIDY*NROWS
C
      parameter (NTOTX=400, NTOTY=200)
C
C  NLOCXL = -NWIDTH+1, NLOCXR = NCOLS + NWIDTH
C  NLOCYL = -NWIDTH+1, NLOCYR = NROWS + NWIDTH
C
      parameter (NLOCXL=-1, NLOCXR=202)
      parameter (NLOCYL=-1, NLOCYR=102)



      parameter (IGRIDTYPE = 1, IGRIDFORM = 1)
      parameter (IHOSTTYPE = 2, IHOSTFORM = 2)

      parameter (IMASS=1, IMOMX=2, IMOMY=3, IENER=4)

      parameter (IEXTRA = 2)

C
C      parameter (ITEMPO = NCOLS + 1)
C      parameter (ITEMPI = NCOLS + NWIDTH + NWIDTH)
C      parameter (ITEMP2 = NTOTX + 2, ITEMP3 = NTOTY + 2)
C

      parameter (ITEMPO = 201)
      parameter (ITEMPI = 204)
      parameter (ITEMP2 = 402, ITEMP3 = 202)

      parameter (MINUS1 = -1)
      parameter (MINUS2 = -2)
      


      inport (real  x(NWIDTH,NITEMS,NROWS)) ewl_in
      inport (real  x(NWIDTH,NITEMS,NCOLS)) nsu_in
      inport (real  x(NWIDTH,NITEMS,NROWS)) ewr_in
      inport (real  x(NWIDTH,NITEMS,NCOLS)) nsd_in

      outport (real  x(NWIDTH,NITEMS,NROWS)) ewl_out
      outport (real  x(NWIDTH,NITEMS,NCOLS)) nsu_out
      outport (real  x(NWIDTH,NITEMS,NROWS)) ewr_out
      outport (real  x(NWIDTH,NITEMS,NCOLS)) nsd_out

      outport (real  x, real  x(IEXTRA)) globsend_out
      inport (integer m, real  x(m)) globrecv_in

      real  slice (NITEMS, NLOCXL:NLOCXR, NLOCYL:NLOCYR)
      PROCESS COMMON /GRID/ ewl_in, nsu_in, ewr_in, nsd_in,
     $     ewl_out, nsu_out, ewr_out, nsd_out, HtoGin, GtoHout,
     $     globsend_out, globrecv_in
      PROCESS COMMON /DATA/ slice
      PROCESS COMMON /FORMS/ iform, itype

      real  borderh (NWIDTH,NITEMS,NCOLS), borderv(NWIDTH,NITEMS,NROWS)

      if (itype .eq. IHOSTTYPE) then
         return
      endif
      if (iform .eq. IHOSTFORM) then
         print *, 'ERROR: Tried to exchange boundaries when in HOST form'
         stop
      endif
      
C   *** Copy top/bot into borderh
      do i = 1, NWIDTH
         do j = 1, NITEMS
            do k = 1, NCOLS
               borderh(i,j,k) = slice(j,NLOCXL+k-1,NLOCYL+i-1)
            end do
         end do
      end do
      send (nsu_out) borderh
      do i = 1, NWIDTH
         do j = 1, NITEMS
            do k = 1, NCOLS
               borderh(i,j,k) = slice(j,NLOCXL+k-1,NLOCYR-NWIDTH+i)
            end do
         end do
      end do
      send (nsd_out) borderh
      do i = 1, NWIDTH
         do j = 1, NITEMS
            do k = 1, NROWS
               borderv(i,j,k) = slice(j,NLOCXL+i-1,NLOCYL+k-1)
            end do
         end do
      end do
      send (ewl_out) borderv
      do i = 1, NWIDTH
         do j = 1, NITEMS
            do k = 1, NROWS
               borderv(i,j,k) = slice(j,NLOCXR-NWIDTH+i,NLOCYL+k-1)
            end do
         end do
      end do
      send (ewr_out) borderv
      receive (nsu_in) borderh
      do i = 1, NWIDTH
         do j = 1, NITEMS
            do k = 1, NCOLS
               slice(j,NLOCXL+k-1,NLOCYL+i-1) = borderh(i,j,k)
            end do
         end do
      end do
      receive (nsd_in) borderh
      do i = 1, NWIDTH
         do j = 1, NITEMS
            do k = 1, NCOLS
               slice(j,NLOCXL+k-1,NLOCYR-NWIDTH+i) = borderh(i,j,k)
            end do
         end do
      end do
      receive (ewl_in) borderv
      do i = 1, NWIDTH
         do j = 1, NITEMS
            do k = 1, NROWS
               slice(j,NLOCXL+i-1,NLOCYL+k-1) = borderv(i,j,k)
            end do
         end do
      end do
      receive (ewr_in) borderv
      do i = 1, NWIDTH
         do j = 1, NITEMS
            do k = 1, NROWS
               slice(j,NLOCXR-NWIDTH+i,NLOCYL+k-1) = borderv(i,j,k)
            end do
         end do
      end do
      
      end


      subroutine GLOBAL_REDUCTION (SUB, VAL, EXTRAINFO)

C****************************************************************************
C****************************************************************************
C*
C*       Mesh Template parameter file
C*       Written By: Rajit Manohar 
C*       On: Mon Oct 25 20:12:06 PDT 1993
C*
C****************************************************************************
C****************************************************************************

C
C GRID: the # of processes (X times Y)
C
      parameter (NGRIDX=2, NGRIDY=2)
C
C ROWS/COLS: the amt of data per process
C
      parameter (NROWS=100, NCOLS=200)
C
C WIDTH: The # of boundary cells to be exchanged
C
      parameter (NWIDTH=2)
C
C ITEMS: The # of data items
C
      parameter (NITEMS=4)
C
C  NTOTX = NGRIDX*NCOLS, NTOTY = NGRIDY*NROWS
C
      parameter (NTOTX=400, NTOTY=200)
C
C  NLOCXL = -NWIDTH+1, NLOCXR = NCOLS + NWIDTH
C  NLOCYL = -NWIDTH+1, NLOCYR = NROWS + NWIDTH
C
      parameter (NLOCXL=-1, NLOCXR=202)
      parameter (NLOCYL=-1, NLOCYR=102)



      parameter (IGRIDTYPE = 1, IGRIDFORM = 1)
      parameter (IHOSTTYPE = 2, IHOSTFORM = 2)

      parameter (IMASS=1, IMOMX=2, IMOMY=3, IENER=4)

      parameter (IEXTRA = 2)

C
C      parameter (ITEMPO = NCOLS + 1)
C      parameter (ITEMPI = NCOLS + NWIDTH + NWIDTH)
C      parameter (ITEMP2 = NTOTX + 2, ITEMP3 = NTOTY + 2)
C

      parameter (ITEMPO = 201)
      parameter (ITEMPI = 204)
      parameter (ITEMP2 = 402, ITEMP3 = 202)

      parameter (MINUS1 = -1)
      parameter (MINUS2 = -2)
      


      EXTERNAL SUB

      inport (real  x(NITEMS,NROWS,NCOLS)) GtoHin (NGRIDX,NGRIDY)
      outport (real  x(NITEMS,NROWS,NCOLS)) HtoGout(NGRIDX,NGRIDY)
      inport (real  x(NWIDTH,NITEMS,NROWS)) ewl_in
      inport (real  x(NWIDTH,NITEMS,NCOLS)) nsu_in
      inport (real  x(NWIDTH,NITEMS,NROWS)) ewr_in
      inport (real  x(NWIDTH,NITEMS,NCOLS)) nsd_in

      outport (real  x(NWIDTH,NITEMS,NROWS)) ewl_out
      outport (real  x(NWIDTH,NITEMS,NCOLS)) nsu_out
      outport (real  x(NWIDTH,NITEMS,NROWS)) ewr_out
      outport (real  x(NWIDTH,NITEMS,NCOLS)) nsd_out

      inport (real  x(NITEMS,NROWS,NCOLS)) HtoGin
      outport (real  x(NITEMS,NROWS,NCOLS)) GtoHout

      outport (real  x, real  x(IEXTRA)) globsend_out
      inport (integer m, real  x(m)) globrecv_in

      inport (real  x, real  x(IEXTRA)) globsend_in (NGRIDX,NGRIDY)
      outport (integer m, real  x(m)) globrecv_out (NGRIDX,NGRIDY)

      real  tmparray(NGRIDX,NGRIDY)
      real  tmpextra(IEXTRA,NGRIDX,NGRIDY)

      real  data (NITEMS, NTOTX, NTOTY)
      PROCESS COMMON /GRID/ ewl_in, nsu_in, ewr_in, nsd_in,
     $     ewl_out, nsu_out, ewr_out, nsd_out, HtoGin, GtoHout,
     $     globsend_out, globrecv_in
      PROCESS COMMON /MAINPROCCOM/ GtoHin, HtoGout, data,
     $     globsend_in, globrecv_out
      PROCESS COMMON /FORMS/ iform, itype
      real  VAL
      real  EXTRAINFO(IEXTRA)

      if (itype .eq. IHOSTTYPE) then
         do i = 1, NGRIDX
            do j = 1, NGRIDY
               receive (globsend_in(i,j)) tmparray(i,j), tmpextra(1,i,j)
            end do
         end do
         iresi = 1
         iresj = 1
         do i = 1, NGRIDX
            do j = 1, NGRIDY
               if (i .ne. 1 .or. j .ne. 1) then
                  call SUB(tmparray(i,j),tmparray(iresi,iresj),
     $                 tmpextra(1,i,j), tmpextra(1,iresi, iresj), iwhich)
               endif
               if (iwhich .eq. 1) then
                  iresi = i
                  iresj = j
               endif
            end do
         end do
         do i = 1, NGRIDX
            do j = 1, NGRIDY
               send (globrecv_out(i,j)) iextra, tmpextra(1,iresi, iresj)
            end do
         end do
         do i = 1, IEXTRA
            extrainfo(i) = tmpextra(i,iresi, iresj)
         end do
      else
         send (globsend_out) val, extrainfo
         receive (globrecv_in) itmp, extrainfo
      end if
      
      end


      subroutine GET_CONST_DATA

C****************************************************************************
C****************************************************************************
C*
C*       Mesh Template parameter file
C*       Written By: Rajit Manohar 
C*       On: Mon Oct 25 20:12:06 PDT 1993
C*
C****************************************************************************
C****************************************************************************

C
C GRID: the # of processes (X times Y)
C
      parameter (NGRIDX=2, NGRIDY=2)
C
C ROWS/COLS: the amt of data per process
C
      parameter (NROWS=100, NCOLS=200)
C
C WIDTH: The # of boundary cells to be exchanged
C
      parameter (NWIDTH=2)
C
C ITEMS: The # of data items
C
      parameter (NITEMS=4)
C
C  NTOTX = NGRIDX*NCOLS, NTOTY = NGRIDY*NROWS
C
      parameter (NTOTX=400, NTOTY=200)
C
C  NLOCXL = -NWIDTH+1, NLOCXR = NCOLS + NWIDTH
C  NLOCYL = -NWIDTH+1, NLOCYR = NROWS + NWIDTH
C
      parameter (NLOCXL=-1, NLOCXR=202)
      parameter (NLOCYL=-1, NLOCYR=102)



      parameter (IGRIDTYPE = 1, IGRIDFORM = 1)
      parameter (IHOSTTYPE = 2, IHOSTFORM = 2)

      parameter (IMASS=1, IMOMX=2, IMOMY=3, IENER=4)

      parameter (IEXTRA = 2)

C
C      parameter (ITEMPO = NCOLS + 1)
C      parameter (ITEMPI = NCOLS + NWIDTH + NWIDTH)
C      parameter (ITEMP2 = NTOTX + 2, ITEMP3 = NTOTY + 2)
C

      parameter (ITEMPO = 201)
      parameter (ITEMPI = 204)
      parameter (ITEMP2 = 402, ITEMP3 = 202)

      parameter (MINUS1 = -1)
      parameter (MINUS2 = -2)
      


      inport (real  x(NITEMS,NROWS,NCOLS)) GtoHin (NGRIDX,NGRIDY)
      outport (real  x(NITEMS,NROWS,NCOLS)) HtoGout(NGRIDX,NGRIDY)
      inport (real  x(NWIDTH,NITEMS,NROWS)) ewl_in
      inport (real  x(NWIDTH,NITEMS,NCOLS)) nsu_in
      inport (real  x(NWIDTH,NITEMS,NROWS)) ewr_in
      inport (real  x(NWIDTH,NITEMS,NCOLS)) nsd_in

      outport (real  x(NWIDTH,NITEMS,NROWS)) ewl_out
      outport (real  x(NWIDTH,NITEMS,NCOLS)) nsu_out
      outport (real  x(NWIDTH,NITEMS,NROWS)) ewr_out
      outport (real  x(NWIDTH,NITEMS,NCOLS)) nsd_out

      inport (real  x(NITEMS,NROWS,NCOLS)) HtoGin
      outport (real  x(NITEMS,NROWS,NCOLS)) GtoHout

      outport (real  x, real  x(IEXTRA)) globsend_out
      inport (integer m, real  x(m)) globrecv_in

      inport (real  x, real  x(IEXTRA)) globsend_in (NGRIDX,NGRIDY)
      outport (integer m, real  x(m)) globrecv_out (NGRIDX,NGRIDY)

      real  tmparray(NGRIDX,NGRIDY)
      real  tmpextra(IEXTRA,NGRIDX,NGRIDY)

      real  data (NITEMS, NTOTX, NTOTY)
      PROCESS COMMON /GRID/ ewl_in, nsu_in, ewr_in, nsd_in,
     $     ewl_out, nsu_out, ewr_out, nsd_out, HtoGin, GtoHout,
     $     globsend_out, globrecv_in
      PROCESS COMMON /MAINPROCCOM/ GtoHin, HtoGout, data,
     $     globsend_in, globrecv_out
      PROCESS COMMON /FORMS/ iform, itype
      real const(ITEMPI)
      PROCESS COMMON /CONSTDATA/ const

      if (itype .eq. IHOSTTYPE) then
         do i = 1, NGRIDX
            do j = 1, NGRIDY
               send (globrecv_out(i,j)) ITEMPI, const
            end do
         end do
      else
         receive (globrecv_in) ival, const
      endif

      end
