      program main

ccc   
ccc   The matrix is an N by N matrix.
ccc   
      parameter (n = 20)
      parameter (nodes = 3)
      processors (nodes)
      inport (double precision x(n)) in_p(nodes)
      outport (double precision x(n)) out_p(nodes)
      outport (integer , integer , double precision ) next_node(nodes)
      inport (integer , integer , double precision ) previous_node(nodes
     +)
      inport (double precision x(n)) in_return_p(nodes)
      outport (double precision x(n)) out_return_p(nodes)
      integer  num_columns_per_node(nodes)
      double precision  c(n)
      double precision  b(n)
      integer  i
      double precision  result
      double precision  check(n)
      double precision  actual_solution
      double precision  solution_vector(n)
      do  i = 1,nodes

c          channel(IN = p(i), OUT = n(mod(i, NODES) + 1))
         channel(OUT=nn(mod (i,nodes) + 1), IN=p(i))
         channel(OUT=next_node(mod (i,nodes) + 1), IN=previous_node(i))
         channel(OUT=out_p(i), IN=in_p(i))
         channel(OUT=out_p(i), IN=in_p(i))
         channel(OUT=in_p(i), IN=out_p(i))
         channel(OUT=out_return_p(i), IN=in_return_p(i))
      enddo

ccc   
ccc  first we will generate the matrix and send 
ccc  each column to a node 
ccc  The matrix has N columns.  There is also one
ccc  column for the constant vector, B.  This final
ccc  column is sent to the last node, number NODE
ccc   
      do  i = 1,n
         call fill_in_a_column(c)
         check(i) = c(1)
         call determine_location(i,c,num_columns_per_node,out_p)
      enddo

ccc   
ccc  Send the final column, B to the last node.
ccc   
      call fill_in_a_column(b)
      send(PORT=out_p(nodes)) b
      actual_solution = b(1)
      num_columns_per_node(nodes) = num_columns_per_node(nodes) + 1
      processdo 10 i = 1,np
10    continue
      processes
         processdo  i = 1,nodes
            process call gaussian_elimination(i,in_p(i),out_p(i),next_no
     +de(i),previous_node(i),num_columns_per_node(i),out_return_p(i)) lo
     +cation(i)
         endprocessdo
      endprocesses

ccc   
ccc  First get the constant column, B, from the last node.
ccc   
ccc  We can receive on in_p(1) but not other in_p 's which wre
ccc  on other processors.  This is a problem with the forwarding.
ccc  so I've created another channel, out_return_p -- in_return_p
ccc  which is only received by the master node and so no forwarding
ccc  takes place.
ccc   
      do  i = 1,num_columns_per_node(nodes) - 1
         receive(PORT=in_return_p(nodes)) c
         send(PORT=out_return_p(nodes)) c
      enddo
      receive(PORT=in_return_p(nodes)) b
      num_columns_per_node(nodes) = num_columns_per_node(nodes) - 1
      do  i = 1,nodes
         call print_result(in_return_p(i),num_columns_per_node(i),b,solu
     +tion_vector)
      enddo
      result = 0
      do  i = 1,n
         result = result + solution_vector(i) * check(i)
      enddo
      if (abs (actual_solution - result) .lt. 0.00001) then
         print *,'Gauss reduction performed OK on',n,' by',n,' matrix ac
     +ross,',nodes,' nodes.'
      else
         print *,'Gauss reduction finished but error was',abs (actual_so
     +lution - result)
         print *,'Calculated solution:  ',result
         print *,'Actual solution:  ',actual_solution
      endif
      end


ccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccc For now I just fill in each column with random numbers
ccc If the user wanted, he could use this procedure to 
ccc read in the matrix or fill in the column in some 
ccc other way.  
      subroutine fill_in_a_column (c)
      parameter (n = 20)
      parameter (nodes = 3)
      double precision  c(n)
      double precision  r
      integer  column_number
      integer  seed
      save column_number,seed
      data column_number,seed /1,35000/
      do  i = 1,n
         call my_random(seed,r)
         c(i) = 100 * r
      enddo
      column_number = column_number + 1
      return
      end


ccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine determine_location (column_number, c, num_columns_per_n
     +oout_p)
      parameter (n = 20)
      parameter (nodes = 3)
      integer  column_number
      double precision  c(n)
      integer  num_columns_per_node(nodes)
      outport (double precision x(n)) out_p(nodes)
      integer  current_node,num_to_put_on_current_node,num_put_on_curren
     +t_node
      integer  nodes_with_extra_columns
      save current_node,num_to_put_on_current_node,num_put_on_current_no
     +de
      data current_node,num_to_put_on_current_node,num_put_on_current_no
     +de /0,0,0/

ccc We want to balance the load of columns on the nodes.
ccc With this scheme there will be at most a difference
ccc of 1 column between any pair of nodes.
      if (num_put_on_current_node .eq. num_to_put_on_current_node) then
         current_node = current_node + 1
         nodes_with_extra_columns = mod (n,nodes)
         num_columns_per_node(current_node) = 0
         num_put_on_current_node = 0
         num_to_put_on_current_node = int (n / nodes)
         if (current_node .le. nodes_with_extra_columns) then
            num_to_put_on_current_node = num_to_put_on_current_node + 1
         endif
      endif
      send(PORT=out_p(current_node)) c
      num_put_on_current_node = num_put_on_current_node + 1
      num_columns_per_node(current_node) = num_put_on_current_node
      return
      end


cccccccccccccccccccccccccccccccccccccccccccccccccc
ccc This subroutine is the heart of the program.
ccc   
      process gaussian_elimination (id, in_p, out_p, next_node, previous
     +_node, num_columns_this_node, return_p)
      parameter (n = 20)
      parameter (nodes = 3)
      intent(in) id,num_columns_this_node
      integer  id
      inport (double precision x(n)) in_p
      outport (double precision x(n)) out_p
      outport (integer , integer , double precision ) next_node
      inport (integer , integer , double precision ) previous_node
      integer  num_columns_this_node
      outport (double precision x(n)) return_p
      double precision  c(n)
      logical  row_done(n)
      logical  boss
      logical  done
      integer  i
      integer  pivot_row,target_row
      integer  dummy_a,dummy_b
      double precision  dummy_c
      logical  done_picking_pivot
      integer  columns_done
      double precision  factor
      do  i = 1,n
         row_done(i) = .FALSE.
      enddo
      done = .FALSE.
      done_picking_pivot = .FALSE.
      columns_done = 0

ccc   
ccc row_done() is a logical array whose i'th element is set 
ccc true after a row has become the pivot row.
ccc   
      if (id .eq. 1) then

ccc       This is the first boss!
         boss = .TRUE.
      else

ccc       This is not boss.
         boss = .FALSE.
      endif

ccc      print *,'Node',id
      do while (.not.(done))
         if (boss) then
            call do_boss_stuff(id,pivot_row,target_row,factor,num_column
     +s_this_node,in_p,out_p,next_node,previous_node,c,row_done,done_pic
     +king_pivot,columns_done)
         else
            call do_non_boss_stuff(pivot_row,target_row,factor,num_colum
     +ns_this_node,in_p,previous_node,next_node,c,row_done)
         endif

ccc   
ccc           Here we work on our columns
ccc           unless we see that target_row
ccc           is equal to zero which indicates
ccc           that the boss is changing.
ccc           In this latter case we use the 
ccc           target_row to determine the new 
ccc           boss - If target_row is equal to our
ccc           id, we are boss, otherwise if 
ccc           target_row is equal to zero, this 
ccc           matrix has been completely reduced
ccc           and we are done.
ccc   
         if (pivot_row .ne. 0) then
            do  i = 1,num_columns_this_node
               call column_work(c,pivot_row,target_row,factor)
               row_done(pivot_row) = .TRUE.
               send(PORT=out_p) c
               if (i .lt. num_columns_this_node) then
                  receive(PORT=in_p) c
               endif
            enddo
            if (boss) then
               receive(PORT=previous_node) dummy_a,dummy_b,dummy_c
               if (pivot_row .eq. 0) then

ccc   
ccc                   If the boss is being changed, we set ourself
ccc                   to not boss once we've received dequeued that
ccc                   message from the previous_node port
ccc   
                  boss = .FALSE.
               endif
            endif
         else
            if (target_row .eq. id) then
               boss = .TRUE.
            else
               boss = .FALSE.
               if (target_row .eq. 0) then
                  done = .TRUE.
               endif
            endif
         endif
      enddo

ccc   -- end of "do while (.not.done)"
ccc  dequeue stuff off in_p and put it on return_p
      do  i = 1,num_columns_this_node
         receive(PORT=in_p) c
         send(PORT=return_p) c
      enddo
      return
      end


cccccccccccccccccccccccccccccccccccccccccccccccc
ccc   
      subroutine do_boss_stuff (id, pivot_row, target_row, factor, num_c
     +olumns_this_node, in_p, out_p, next_node, previous_node, c, row_do
     +ne, done_picking_pivot, columns_done)
      parameter (n = 20)
      parameter (nodes = 3)
      integer  id
      integer  pivot_row,target_row,num_columns_this_node
      double precision  factor
      inport (double precision x(n)) in_p
      outport (double precision x(n)) out_p
      outport (integer , integer , double precision ) next_node
      inport (integer , integer , double precision ) previous_node
      double precision  c(n)
      logical  row_done(n)
      logical  done_picking_pivot
      logical  done_selecting_pivot_target
      integer  columns_done
      integer  j
      done_selecting_pivot_target = .FALSE.
      receive(PORT=in_p) c
      do while (.not.(done_selecting_pivot_target))
         if (.not.(done_picking_pivot)) then

ccc           We must select a pivot row for this column
            j = 1
            biggest_row = n + 1
            do while (.not.(done_picking_pivot))
               pivot_row = non_zero_row (c,j)
               if (pivot_row .eq. n + 1) then
                  if (biggest_row .eq. n + 1) then

ccc                       if the pivot row can't be found in the 
ccc                       first N elements we must be on the vector
ccc                       B in the last node so we want to terminate.
                     done_picking_pivot = .TRUE.
                     pivot_row = 0
                     target_row = 0
                     factor = 0
                     done_selecting_pivot_target = .TRUE.
                     send(PORT=out_p) c
                     send(PORT=next_node) pivot_row,target_row,factor
                     receive(PORT=previous_node) pivot_row,target_row,fa
     +ctor
                  else
                     pivot_row = biggest_row
                     done_picking_pivot = .TRUE.
                  endif
               else
                  if (row_done(pivot_row)) then
                     j = j + 1
                     if (j .eq. n + 1 .and. biggest_row .eq. n + 1) then
     +

ccc                           if the pivot row can't be found in the 
ccc                           first N elements we must be on the vector
ccc                           B in the last node so we want to terminate.
                        done_picking_pivot = .TRUE.
                        pivot_row = 0
                        target_row = 0
                        factor = 0
                        done_selecting_pivot_target = .TRUE.
                        send(PORT=out_p) c
                        send(PORT=next_node) pivot_row,target_row,factor
     +
                        receive(PORT=previous_node) pivot_row,target_row
     +,factor
                     else
                        if (j .eq. n + 1) then
                           pivot_row = biggest_row
                           done_selecting_pivot_target = .TRUE.
                        endif
                     endif
                  else
                     if (biggest_row .eq. n + 1) then
                        biggest_row = pivot_row
                     else if (abs (c(pivot_row)) .gt. abs (c(biggest_row
     +))) then
                           biggest_row = pivot_row
                     endif
                     j = j + 1
                  endif
               endif
            enddo
         endif

ccc       We must select a new target_row for this column
         if (pivot_row .ne. 0) then
            target_row = non_zero_row (c,1)
            if (target_row .eq. pivot_row) then
               j = pivot_row + 1
               target_row = non_zero_row (c,j)
            endif
            if (target_row .gt. n) then

ccc           This indicates that there is a Non-zero row in 
ccc           the N rows of C, other than the pivot_row.  
ccc           We must either go to the next column if there are 
ccc           any columns left on this node, or go to the next boss.
               columns_done = columns_done + 1
               if (columns_done .lt. num_columns_this_node) then

ccc               We switch columns and find tnew pivot_row and target_row
                  done_picking_pivot = .FALSE.
                  send(PORT=out_p) c
                  receive(PORT=in_p) c
               else

ccc               We want to yield control to the next set of columnns and
ccc               return our current column, C to the in_p message queue.
                  done_selecting_pivot_target = .TRUE.
                  send(PORT=out_p) c

ccc                  print *,'Yielding boss to next node.' 
                  pivot_row = 0
                  target_row = id + 1
                  factor = 0
                  send(PORT=next_node) pivot_row,target_row,factor
                  receive(PORT=previous_node) pivot_row,target_row,facto
     +r
               endif
            else
               factor = (-(c(target_row))) / c(pivot_row)
               send(PORT=next_node) pivot_row,target_row,factor
               done_selecting_pivot_target = .TRUE.
            endif
         endif

ccc      -- end of "if (pivot_row .ne. 0)"
      enddo
      return
      end


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine do_non_boss_stuff (pivot_row, target_row, factor, num_c
     +olumns_this_node, in_p, previous_node, next_node, c, row_done)
      parameter (n = 20)
      parameter (nodes = 3)
      integer  pivot_row,target_row,num_columns_this_node
      double precision  factor
      inport (double precision x(n)) in_p
      inport (integer , integer , double precision ) previous_node
      outport (integer , integer , double precision ) next_node
      double precision  c(n)
      logical  row_done(n)
      receive(PORT=previous_node) pivot_row,target_row,factor
      send(PORT=next_node) pivot_row,target_row,factor
      if (pivot_row .ne. 0) then

ccc   
ccc       If pivot_row .eq. 0 then it would mean this message
ccc       is just saying to switch bosses, not to do row 
ccc       operations
ccc   
         receive(PORT=in_p) c
         row_done(pivot_row) = .TRUE.
      endif
      return
      end


cccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine column_work (c, pivot_row, target_row, factor)
      parameter (n = 20)
      parameter (nodes = 3)
      double precision  c(n)
      integer  pivot_row,target_row
      double precision  factor,r
      integer  i

ccc   
ccc  We want to assign C(target_row) the proper value
ccc  There is a slight problem in assigning C(target_row)
ccc  the value 0 because it is likely that because of a 
ccc  lack of precision, the addition below won't come out
ccc  to zero.  If C(target_row) .eq. factor*C(pivot_row) 
ccc  then we set C(target_row) to zero.  Otherwise we check 
ccc  if -C(target_row) is within 
ccc  10^-5 of factor*C(pivot_row).  If this is the case,
ccc  we assign C(target_row) the value 0.
ccc   
      r = factor * c(pivot_row)
      if ((-(c(target_row))) .eq. r) then
         c(target_row) = 0
      else
         if (abs (((-(c(target_row))) - r) / ((-(c(target_row))) + r)) .
     +lt. 1e-5) then
            c(target_row) = 0
         else
            c(target_row) = c(target_row) + r
         endif
      endif
      do  i = 1,n
      enddo
      return
      end


cccccccccccccccccccccccccccccccccccccccccc
ccc This function returns the row number of
ccc the first non-zero entry in our Column,
ccc by starting to look at row i.
      integer  function non_zero_row (c, i2) 
      parameter (n = 20)
      double precision  c(n)
      integer  i,i2
      logical  done
      i = i2
      done = .FALSE.
      if (i .le. n) then
         do while (.not.(done) .and. i .le. n)
            if (c(i) .ne. 0) then
               done = .TRUE.
            else
               i = i + 1
            endif
         enddo
      endif
      non_zero_row = i
      return
      end


cccccccccccccccccccccccccccccccccccccccccccccccccc
ccc This subroutine gets the column C and finds 
ccc the first non-zero entry.  This i'th entry
ccc indicates that C(i)Xi = B(i)  or 
ccc Xi = B(i)/C(i)
ccc   
      subroutine print_result (in_p, num_columns_this_node, b, solution_
     +vector)
      parameter (n = 20)
      inport (double precision x(n)) in_p
      integer  num_columns_this_node
      double precision  b(n)
      double precision  solution_vector(n)
      double precision  c(n)
      integer  i,j
      integer  next
      save next
      data next /1/
      do  i = 1,num_columns_this_node
         j = 1
         receive(PORT=in_p) c
         do while (c(j) .eq. 0)
            j = j + 1
         enddo
         solution_vector(next) = b(j) / c(j)
         print *,'X',next,' = ',solution_vector(j)
         next = next + 1
      enddo
      return
      end


cccccccccccccccccccccccccccccccccccccccccccccccccc
ccc This subroutine generates random number
ccc between 0 and 1.
      subroutine my_random (seed, randx)
      integer  seed
      double precision  randx
      seed = 2045 * seed + 1
      seed = seed - seed / 1048576 * 1048576
      randx = (seed + 1) / 1048577.0
      return
      end

