
cccccccccccccccccccccccccccccccccccccccccccccccccccc
ccc   Create several channels on which we probe.  
ccc   Two of the channels aren't filled with a value 
ccc   (and thus a probe on those two channels should 
ccc   indicate an empty channel) until all of the 
ccc   other channels were probed and data was taken 
ccc   off the other channels.  Then the two remaining 
ccc   channels are filled with data and they are probed 
ccc   again.  These last two channels should eventually 
ccc   be recognized as having data by the probe statement, 
ccc   and their data is received off the channel.  As 
ccc   values are received off channels, they are added 
ccc   to a sum.  If the proper sum is reached after we 
ccc   received on each channel, then the probe is assumed 
ccc   to have worked.
cccccccccccccccccccccccccccccccccccccccccccccccccccc
      program main
      parameter (nodes = 4)
      processors (nodes)
      inport (integer ) in(nodes),go_in(nodes)
      outport (integer ) out(nodes),go_out(nodes)
      do  i = 1,nodes
         channel(OUT=out(i), IN=in(i))
         channel(OUT=go_out(i), IN=go_in(i))
      enddo
      processes
         call probe_the_channels(in,go_out)
         processdo  i = 1,nodes
            process call send_data(out(i),i,go_in(i)) location(i)
         endprocessdo
      endprocesses
      end


ccccccccccccccccccccccccccccccccccccccccccccc
      process send_data (out, id, go)
      integer  id
      outport (integer ) out
      inport (integer ) go
      integer  dummy
      intent(in) id
      if (id .ne. 3 .and. id .ne. 2) then
         print *,'sending ',id
         send(PORT=out) id
      else
         print *,'waiting to receive',id
         receive(PORT=go) dummy
         print *,'received',dummy
         send(PORT=out) id
      endif
      endchannel(PORT=out)
      return
      end


cccccccccccccccccccccccccccccccccccccccccccccccc
      process probe_the_channels (in, go_out)
      parameter (nodes = 4)
      inport (integer ) in(nodes)
      outport (integer ) go_out(nodes)
      integer  m
      integer  ports_done
      integer  accum
      accum = 0
      i = 1
      ports_done = 0
      do while (ports_done .lt. nodes)
10    continue
         print *,'About to call probe on port',i
         probe(PORT=in(i), EMPTY=20)
         print *,'Done with probe call on port',i
         receive(PORT=in(i)) m
         print *,'Port has',m,' from port',i
         accum = accum + m
         ports_done = ports_done + 1
         if (ports_done .eq. 2) then
            send(PORT=go_out(3)) 1
         endif
         if (ports_done .eq. 3) then
            send(PORT=go_out(2)) 1
         endif
         goto 30
20       print *,'Port',i,' empty.'
         i = i + 1
         if (i .eq. nodes + 1) then
            i = 1
         endif
         goto 10
30    continue
      enddo
      print *,'ports_done: ',ports_done
100   if (accum .eq. int (nodes * (nodes + 1) / 2)) then
         print *,'PROBE OK.'
      else
         print *,'PROBE not OK.'
         print *,'Accum was',accum
         print *,'Accum should have been',int (nodes * (nodes + 1) / 2)
      endif
      return
      end

