
ccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccc   Spawn off an arbitrary number of processes, the 
ccc   number being specified by a parameter.  Half of 
ccc   the processes call the function "a" and half call
ccc   the function "b".  The arguments that are returned 
ccc   by the processes are checked for consistency. 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      program test_processes
      parameter (min_processes = 2)
      parameter (num_iterations = 4)
      parameter (max_processes = min_processes * 2** num_iterations)
      integer  i(max_processes)
      integer  j(max_processes)
      integer  ti(max_processes)
      integer  tj(max_processes)
      real  tr1(max_processes),tr2(max_processes)
      real  r1(max_processes),r2(max_processes)
      logical  success
      integer  m,k
      do  m = 1,max_processes
         ti(m) = m
         tj(m) = m
         tr1(m) = 3.01 + real (m)
         tr2(m) = (-(37.3748)) + real (m)
         i(m) = ti(m)
         j(m) = tj(m)
         r1(m) = tr1(m)
         r2(m) = tr2(m)
      enddo
      num_processes = min_processes
      do  k = 1,num_iterations
         print *,'Trying PROCESSES with',num_processes * 2,' processes.'
     +
         processes
            processdo  m = 1,num_processes
               process call a(i(m),r1(m))
            endprocessdo
            processdo  m = 1,num_processes
               process call b(j(m),r2(m))
            endprocessdo
         endprocesses
         success = .TRUE.
         do  m = 1,num_processes
            ti(m) = ti(m) + 1
            tj(m) = tj(m) * tj(m)
            tr1(m) = tr1(m) + 1.
            tr2(m) = tr2(m) + 1.
            if (ti(m) .ne. i(m) .or. tj(m) .ne. j(m) .or. tr1(m) .ne. r1
     +(m) .or. tr2(m) .ne. r2(m)) then
               success = .FALSE.
               bad_one = m
            endif
         enddo
         if (success) then
            print *,'PROCESSES ran OK with',num_processes * 2,' processe
     +s.'
         else
            print *,'Did not get correct arguments back fromPROCESSES.'
            print *,'i(',bad_one,')',i(bad_one)
            print *,'ti(',bad_one,')',ti(bad_one)
            print *,'j(',bad_one,')',j(bad_one)
            print *,'tj(',bad_one,')',tj(bad_one)
            print *,'r1(',bad_one,')',r1(bad_one)
            print *,'tr1(',bad_one,')',tr1(bad_one)
            print *,'r2(',bad_one,')',r2(bad_one)
            print *,'tr2(',bad_one,')',tr2(bad_one)
            stop
         endif
         num_processes = num_processes * 2
      enddo
      print *,'PROCESS test ran OK.'
      end


ccccccccccccccccccccccccccccccccccccccc
      process a (j, r)
      integer  j
      real  r
      intent(inout) j
      intent(inout) r
      j = j + 1
      r = r + 1.
      return
      end


ccccccccccccccccccccccccccccccccccccccc
      process b (j, r)
      integer  j
      intent(inout) j
      intent(inout) r
      j = j * j
      r = r + 1.
      return
      end

