
cccccccccccccccccccccccccccccccccccccccccccccc
ccc Pass data around a ring.  If you want  ccc
ccc to vary the amount of data that is     ccc
ccc passed, change the NUM_ITERATIONS      ccc
ccc parameter in the pass_em process.      ccc
cccccccccccccccccccccccccccccccccccccccccccccc
      program main
      parameter (nodes = 4)
      parameter (num_iterations = 50)
      processors (nodes)
      inport (integer , real , integer , character ) in(nodes)
      outport (integer , real , integer , character ) out(nodes)
      integer  id(nodes)
      real  b(nodes)
      integer  c(nodes)
      character  d(nodes)
      integer  result(nodes)
      integer  success
      integer  seed
      real  r
      seed = 35000

ccc   
ccc   We need to fill in the data that each node will pass
ccc   
      do  i = 1,nodes
         id(i) = i
         call my_random(seed,r)
         b(i) = sin (r)
         call my_random(seed,r)
         c(i) = int (1000 * r)
         call rand_char(seed,d(i))
      enddo
      do  i = 1,nodes
         channel(OUT=out(mod (i,nodes) + 1), IN=in(i))
         result(i) = 0
      enddo
      processes
         processdo  i = 1,nodes
            process call pass_em(id(i),b(i),c(i),d(i),in(i),out(i),resul
     +t(i)) location(i)
         endprocessdo
      endprocesses
      success = 0
      do  i = 1,nodes
         success = success + result(i)
      enddo
      if (success .eq. 0) then
         print *,'Ring passed all data OK.'
         print *,'It passed',nodes * num_iterations * 13,' bytes of data
     +.'
      else
         print *,'Ring did not pass data properly.'
      endif
      end


ccccccccccccccccccccccccccccccccccccccccccccc
      process pass_em (id, b, c, d, in, out, result)
      parameter (nodes = 4)
      parameter (num_iterations = 50)

ccc   
ccc   Note:  For each iteration, a node passes 2 integers, one real, and one 
ccc   character = 8 bytes + 4 bytes + 1 byte = 13 bytes.  So about
ccc   80 iterations make one kilobyte per node.  Additionally, each node 
ccc   passes the data for each other node so each iteration actually 
ccc   involves NODES * NUM_ITERATIONS * 13 bytes or data.
ccc   
      integer  id
      real  b
      integer  c
      character  d
      real  result
      real  checksum_passed_in
      real  checksum_computed
      inport (integer , real , integer , character ) in
      outport (integer , real , integer , character ) out
      intent(in) id,b,c,d
      intent(out) result
      do  j = 1,num_iterations

ccc   
ccc       Change the values slightly for each iteration to make
ccc       the program more interesting.
ccc   
         b = b + .1
         c = c - 3
         call check_sum_compute(checksum_computed,id,b,c,d)
         send(PORT=out, IOSTAT=temp_stat, ERR=200) id,b,c,d
         do  i = 1,nodes - 1
            receive(PORT=in, IOSTAT=temp_stat, ERR=100, END=50) id,b,c,d
     +
            send(PORT=out, IOSTAT=temp_stat, ERR=200) id,b,c,d
         enddo
         receive(PORT=in, IOSTAT=temp_stat, ERR=100, END=50) id,b,c,d
         call check_sum_compute(checksum_passed_in,id,b,c,d)
         if (checksum_computed .ne. checksum_passed_in) then
            result = result + 1
            print *,'Ring:  bad data from id: ',id
         else
            result = result + 0
         endif
      enddo
      endchannel(PORT=out)
      return
50    print *,'END of channel found when it should not have been.  IOSTA
     +T was',temp_stat
      print *,'Terminating.'
      stop
100   print *,'Error detected in receive.  IOSTAT was',temp_stat
      print *,'Terminating.'
      stop
200   print *,'Error detected in send.  IOSTAT was',temp_stat
      print *,'Terminating.'
      stop
      end


cccccccccccccccccccccccccccccccccccccccccccccccc
ccc Now we went to get a random number 
ccc in the range [65,91] and we
ccc convert this to a character A...Z
ccc   
      subroutine rand_char (the_seed, c)
      integer  the_seed
      character  c
      real  r
      integer  m
      call my_random(the_seed,r)
      m = 65 + int (mod (r * 1000,91 - 65))
      c = char (m)
      return
      end


cccccccccccccccccccccccccccccccccccccccccccccccccc
ccc This subroutine generates random number 
ccc between 0 and 1.
      subroutine my_random (seed, randx)
      integer  seed
      real  randx
      seed = 2045 * seed + 1
      seed = seed - seed / 1048576 * 1048576
      randx = real (seed + 1) / 1048577.0
      return
      end


cccccccccccccccccccccccccccccccccccccccccccccccccc
ccc This subroutine assigns the checksum variable
ccc the real value of each the i'th elements of the
ccc arrays for each node.
      subroutine check_sum_compute (checksum, id, b, c, d)
      real  checksum
      integer  id
      real  b
      integer  c
      character  d
      checksum = real (id) + real (b) + real (c) + real (int (d))
      return
      end

