/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993,1995             */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/

/* This file is used to automatically generate a "#include" header */
/*
mkCextern $SAGEROOT/pC++2dep/utility.c > ! $SAGEROOT/pC++2dep/ext_utility.h
*/

/* utility.c for PC++                            */
/* Created by Jenq-Kuen Lee Dec 16, 1989         */
/* modified 1992 */


#include "macro.h"        /* All the macros for node manipulation */
#include "vpc.h"   
#include "vextern.h"
#include "sage.h"
#include "ext_low.h"
#include "ext_parser_lib.h"
#include "ext_vinit.h"
#include "ext_vhash.h"
#include "y++.tab.h"

extern void err();  /* from verrors.c */

/**************************************************************************/
int name_of_struct(i)
int i;
{

 switch(i) {
 case  STRUCT:
   return(STRUCT_NAME);
 case CLASS:
   return(CLASS_NAME);
  case TECLASS:
   return(TECLASS_NAME);
case COLLECTION:
   return(COLLECTION_NAME);
 }

err("Internal Error: name_of_struct: illegal case");
abort();
return 0;
}


/**************************************************************************/
int node_of_struct(i)
int i;
{

 switch(i) {
 case  STRUCT:
   return(STRUCT_DECL);
 case CLASS:
   return(CLASS_DECL);
 case TECLASS:
   return(TECLASS_DECL);
 case COLLECTION:
   return(COLLECTION_DECL);
 case EXTERN_C_LANG:
   return(EXTERN_C_STAT);
 }

err("Internal Error: node_of_struct: illegal case");
abort();
return 0;
}


/**************************************************************************/
int type_of_struct(i)
int i;
{

 switch(i) {
 case  STRUCT:
   return(T_STRUCT);
 case CLASS:
   return(T_CLASS);
 case TECLASS:
   return(T_TECLASS);
 case COLLECTION:
   return(T_COLLECTION);
 }

err("Internal Error: type_of_struct: illegal case");
abort();
return 0;
}


/*
  This routine set up the new flag for the class_decl bif node
*/
/**************************************************************************/
void change_public_flag(i)
     int i;
{
  switch (i) {
  case  PUBLIC_FIELD:
  case  PROTECTED_FIELD:
  case  PRIVATE_FIELD:
     pred_bfnd->prop_list = (pred_bfnd->variant==COLLECTION_DECL)?
                           (PTR_PLNK)( i| COLLECTION_FIELD) : (PTR_PLNK) i ;
     break;
  case ELEMENT_FIELD:
     pred_bfnd->prop_list = (PTR_PLNK) (i | PUBLIC_FIELD);
   }


}


/**************************************************************************/
int area()
{
 PTR_BFND p;

  for (p =pred_bfnd;((p->variant != FUNC_HEDR)&&(p->variant != GLOBAL)) ;
       p = p->control_parent) ;

  if (p->variant==GLOBAL) return(ALL_FIELDS);
  if (p->entry.Template.symbol->attr & ELEMENT_FIELD)
      return(ELEMENT_ONLY);
  return(ALL_FIELDS);
}


/* Utility routine for substitute_element_type
   copy_type_list: Given a type and return a copy of the type which
                   is structurally equivalent to the old one.

   duplicated node: T_POINTER, T_FUNCTION, T_DESCRIPT, T_POINTER
   same node      : T_CHAR, T_FLOAT ... T_STRUCT, T_DERIVED_COLLECTION
   eliminated/reduce node: T_DERIVED_TYPE
   

   copy_type_list will stop in the type stop_node and it will copy the
                  whole type list if stop_node is NULL
		  (The stop_node is included in the copy process.)

*/

/**************************************************************************/
static PTR_TYPE copy_type_list(passing_type,stop_node)
PTR_TYPE passing_type;
PTR_TYPE stop_node;
{ 
 PTR_TYPE new_type,old_type,next_type,one_type;
  
  new_type = NULL;
  for (next_type= passing_type; next_type;  )
   {  
     
     switch(next_type->variant) {
     case T_ARRAY :
       old_type = next_type;
       one_type = (PTR_TYPE) newNode(T_ARRAY);
       new_type=addToBaseTypeList(one_type,new_type);
       one_type->entry.ar_decl.ranges = next_type->entry.ar_decl.ranges;
       one_type->entry.ar_decl.num_dimensions = next_type->entry.ar_decl.num_dimensions;
       next_type = next_type->entry.Template.base_type ;
       break;
     case T_FUNCTION :
     case T_POINTER  :
     case T_REFERENCE:
     case T_DESCRIPT : 
       old_type = next_type;
       one_type = (PTR_TYPE) newNode(next_type->variant);
       new_type = addToBaseTypeList(one_type,new_type);
       one_type->entry.Template.ranges = next_type->entry.Template.ranges;
       one_type->entry.Template.dummy1 = next_type->entry.Template.dummy1;
       one_type->entry.Template.dummy2 = next_type->entry.Template.dummy2;
       one_type->entry.Template.dummy3 = next_type->entry.Template.dummy3;
       one_type->entry.Template.dummy4 = next_type->entry.Template.dummy4;
       one_type->entry.Template.dummy5 = next_type->entry.Template.dummy5;
       next_type = next_type->entry.Template.base_type ;
       break;
     case T_DERIVED_TYPE :
       old_type = next_type;
       next_type = next_type->entry.derived_type.symbol->type;
       break;
    case T_DERIVED_COLLECTION:
    case T_COLLECTION:
    case T_CLASS:
    case T_TECLASS:
    case T_UNION:
    case T_ENUM:
    default:
       old_type = next_type;
       new_type =addToBaseTypeList(next_type,new_type);
       next_type= NULL;
     }
     if (old_type==stop_node) break;
   }
 return(new_type);
}

/**************************************************************************/
/*                                                                        */
/* The followings are the routines to handle parameterized type-checking  */
/*                                                                        */
/**************************************************************************/
/*
 This routine substitute the elementtype with real/correct type
*/
/**************************************************************************/
PTR_TYPE substitute_element_type(passing_type, element_type)
PTR_TYPE passing_type;
PTR_TYPE element_type;
{ PTR_TYPE type,old_type ;
  PTR_SYMB symb;

   for (old_type=type=passing_type ;type ; )
   {  
       switch(type->variant) {
       case T_ARRAY :
       case T_FUNCTION :
       case T_POINTER  :
       case T_REFERENCE:
       case T_DESCRIPT :
	 old_type = type ;
	 type = type->entry.Template.base_type ;
	 break;
       case T_DERIVED_TYPE :
	 symb = type->entry.derived_type.symbol;
	 if (symb== elementtype_symb) {
	   if (type==passing_type) type = element_type;
	   else  {
	      type = copy_type_list(passing_type,old_type);
	      if (type) type->entry.Template.base_type= element_type;
	      else      type = element_type;
	    }
	   return(type);
	 }
	 else {
	   old_type = type ;
	   if (!(type = symb->type)) return(passing_type);
	 }
	 break;
       case T_DERIVED_COLLECTION:
       default :
            type = (PTR_TYPE) NULL ;
      }
     }

return(passing_type);
}

/**************************************************************************/
char* map_op( value)
int value;
{

  switch (value) {
  case ((int) PLUS_EXPR) : return("+=");
                           
  case ((int) MINUS_EXPR): return("-=");
                           
  case ((int) BIT_AND_EXPR):return("&=");
                           
  case ((int) BIT_IOR_EXPR):return("|=");
                           
  case ((int) MULT_EXPR):  return("*=");
                           
  case ((int) TRUNC_DIV_EXPR): return("/=");
                           
  case ((int) TRUNC_MOD_EXPR): return("%=");
                           
  case ((int) BIT_XOR_EXPR): return("^=");
                           
  case ((int) LSHIFT_EXPR): return("<<=");
                           
  case ((int) RSHIFT_EXPR): return(">>=");
                                
  case LE_EXPR:
           return("<=");
  case GE_EXPR:
          return(">=");
  case EQ_EXPR:
          return("==");
  case NE_EXPR:
          return("!=");
  default : return("=");
 
  }
  
}


/**************************************************************************/
char* map_unop(i)
int i;
{


   switch(i) {
    case ADDRESS_OP: return("&");
    case MINUS_OP:  return("-");
    case UNARY_ADD_OP: return("+");
    case PLUSPLUS_OP:  return("++");
    case MINUSMINUS_OP:return("--");
    case BIT_COMPLEMENT_OP: return("~");
    case NOT_OP: return("!");
    default:
       return("+");
    }

}
