/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993,1995             */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/


/* vlex.c */

#include <stdio.h>
#include <stdlib.h>

#include "vparse.h"
#include "vpc.h"
#include "db.h"
#include "vextern.h"
#include "ext_parser_lib.h"
#include "ext_comments.h"
#include "y++.tab.h"

extern void yyerror();  /* from verrors.c */
extern void warning();  /* from verrors.c */

/************ Parts for bushback buffer ************/
#define PUSHBACK_SIZE 10
#define INCHAR 1
#define INSTRING 0
int PushbackBuffer[PUSHBACK_SIZE];
int PushbackPointer = -1;

extern    int lastdecl_id;
PTR_CMNT   make_comment(),follow_comment();
extern     int cur_counter ;    
extern    char      *input_filename;
extern PTR_HASH Scope_Name;    /* BW */
extern int Scope_Flag;          /* BW */
	
PTR_FNAME find_file_entry();
PTR_HASH   look_up_type(),look_up() ;
static int readescape();
int lineno;			/* current line number in file being read */
FILE *finput;			/* input file.
				   Normally a pipe from the preprocessor.  */
/* comments structure */
#define MAX_COMMENT_SIZE  1024 
char    comment_buf[MAX_COMMENT_SIZE + 2];  /* OFFSET '2' to avoid boundary */
int     comment_cursor = 0 ;
int     global_comment_type ;

/* lexical analyzer */
static int maxtoken;		/* Current length of token buffer */
static char *token_buffer;	/* Pointer to token buffer */
static int previous_value ;     /* last token to be remembered */

/* frw[i] is index in rw of the first word whose length is i. */

#define MAXRESERVED 15

static char frw[17] =
  { 0, 0, 0, 2, 8, 18, 28, 44, 49, 57, 59, 60, 60, 60, 60, 60, 61 };
/*  0  1  2  3  4   5   6   7   8   9  10  11  12  13  14  15  16 */
static char *rw[] =
  { /* Zero length keywords */
    /* one length keywords */
    "if", "do", 
    "int", "for", "asm", "new", "try", "par",
    "case", "char", "auto", "goto", "else", "long", "void", "enum","this",
            "Sync",
    "float", "short", "union", "break", "while", "const","class",
             "catch", "throw", "spawn",
    "double", "static", "extern", "struct", "return", "sizeof", "switch", 
             "signed","global","parfor","friend","public",
             "delete","future","inline", "atomic",
    "typedef", "default","private","TEClass","virtual",
    "unsigned", "continue", "register", "volatile","operator","overload", 
		"template", "restrict",
    "protected", "__private",
    "Collection",
    "MethodOfElement"
  };

static short rtoken[] =
  { /* Zero length keywords */
    /* one length keywords */
    IF, DO, 
    INT, FOR, ASM, NEW, TRY, PAR,
    CASE, CHAR, AUTO, GOTO, ELSE, LONG, VOID, ENUM, THIS, SYNC,
    FLOAT, SHORT, UNION, BREAK, WHILE, CONST, CLASS, CATCH, THROW, SPAWN,
    DOUBLE, STATIC, EXTERN, STRUCT, RETURN, SIZEOF, SWITCH, 
             SIGNED, GLOBL, PERFER, FRIEND, PUBLIC,
             DELETE, FUTURE, INLINE, ATOMIC,
    TYPEDEF, DEFAULT_TOKEN, PRIVATE, TECLASS, VIRTUAL,
    UNSIGNED, CONTINUE, REGISTER, VOLATILE, OPERATOR, OVERLOAD, TEMPLATE,
              RESTRICT,
    PROTECTED, KSRPRIVATE,
    COLLECTION,
    METHODOFELEMENT
 };

/* This table corresponds to rw and rtoken.
   Its element is an index in ridpointers  */

#define NORID RID_UNUSED

static enum rid rid[] =
  { /* Zero length keywords */
    /* one length keywords */
    NORID, NORID, 
    RID_INT, NORID, NORID, NORID, NORID, NORID,
    NORID, RID_CHAR, RID_AUTO, NORID, NORID, RID_LONG, RID_VOID, NORID,NORID, RID_SYNC,
    RID_FLOAT, RID_SHORT, NORID, NORID, NORID, RID_CONST,NORID, NORID, NORID,
              NORID,
    RID_DOUBLE, RID_STATIC, RID_EXTERN, NORID, NORID, NORID, NORID, 
              RID_SIGNED, RID_GLOBL, NORID, RID_FRIEND, NORID,
              NORID, RID_FUTURE, RID_INLINE, RID_ATOMIC,
    RID_TYPEDEF, NORID, RID_PRIVATE, NORID, RID_VIRTUAL,
    RID_UNSIGNED, NORID, RID_REGISTER, RID_VOLATILE,NORID,NORID, NORID,
             RID_RESTRICT,
    RID_PROTECTED, RID_KSRPRIVATE,
    NORID,
    NORID
  };

/* The elements of `ridpointers' are identifier nodes
   for the reserved type names and storage classes.  
tree ridpointers[(int) RID_MAX];
static tree line_identifier;    The identifier node named "line" */

void check_newline();

/* The current lexer trys to pushback two characters at times (when
comments are found.  Rather than understand the lexer, Im just going to
implement a simple pushback feature in front of the getc and ungetc
calls.  This may be sub-optimal.  (PHB) */
/**************************************************************************/
int GETC(FILE *stream)
{
  int c;
  if (PushbackPointer == -1) {
    /* No characters in my pushback buffer, do a REAL getc */
    return getc(stream);
  }
  else {
    /* Use the characters from my pushback buffer */
    c = PushbackBuffer[PushbackPointer];
    --PushbackPointer;
    return c;
  }
}

/* Front end for ungetc() function (PHB) */
/**************************************************************************/
void UNGETC(int c, FILE *stream)
{
  /* Will this character overflow my pushback buffer? */
  ++PushbackPointer;
  if (PushbackPointer == PUSHBACK_SIZE) {
    yyerror("Pushback buffer overflow, lex error");
  }
  else {
    /* There is room to add this character */
    PushbackBuffer[PushbackPointer] = c;
  }
}  

/**************************************************************************/
void init_lex()
{
  /* Start it at 0, because check_newline is called at the very beginning
     and will increment it to 1.  */
  lineno = 0;
  maxtoken = 40;
  lastdecl_id = 0;
  wait_first_include_name= ON;
  token_buffer = (char *) malloc((unsigned)(maxtoken+1));
  check_newline();
/*
  line_identifier = get_identifier("line");
  ridpointers[(int) RID_INT] = get_identifier("int");
  ridpointers[(int) RID_CHAR] = get_identifier("char");
  ridpointers[(int) RID_VOID] = get_identifier("void");
  ridpointers[(int) RID_FLOAT] = get_identifier("float");
  ridpointers[(int) RID_DOUBLE] = get_identifier("double");
  ridpointers[(int) RID_SHORT] = get_identifier("short");
  ridpointers[(int) RID_LONG] = get_identifier("long");
  ridpointers[(int) RID_UNSIGNED] = get_identifier("unsigned");
  ridpointers[(int) RID_SIGNED] = get_identifier("signed");
  ridpointers[(int) RID_CONST] = get_identifier("const");
  ridpointers[(int) RID_VOLATILE] = get_identifier("volatile");
  ridpointers[(int) RID_AUTO] = get_identifier("auto");
  ridpointers[(int) RID_STATIC] = get_identifier("static");
  ridpointers[(int) RID_EXTERN] = get_identifier("extern");
  ridpointers[(int) RID_TYPEDEF] = get_identifier("typedef");
  ridpointers[(int) RID_REGISTER] = get_identifier("register");
  ridpointers[(int) RID_VIRTUAL] = get_identifier("virtual");
  ridpointers[(int) RID_PRIVATE] = get_identifier("private");
                                                              */
}

/**************************************************************************/

/*
static void reinit_parse_for_function ()
{}
*/

/* Put char into comment buffer. When the buffer is full, we make a comment */
/* structure and reset the comment_cursor. */
/**************************************************************************/
static void put_char_buffer(c,sw)
char c ;
int sw;
{
  char *temptr ;
  PTR_CMNT c_ptr1,c_ptr ;

   if (( comment_cursor <= (MAX_COMMENT_SIZE -1)) && (sw == 0))
     {  *(comment_buf + comment_cursor) = c ;
        comment_cursor++;
      }
   else
     {   *(comment_buf +comment_cursor) = c ;
         *(comment_buf + comment_cursor+ 1) =  0  ;
	 temptr = copys(comment_buf);
         c_ptr1 = make_comment(fi,temptr, global_comment_type);
	 if (!new_cur_comment)
	   { 
              new_cur_comment = c_ptr1;
	    }
         else
	   {  c_ptr = follow_comment(new_cur_comment);
              c_ptr->next = c_ptr1 ;
	    }
         c_ptr1->counter = cur_counter ;
         comment_cursor = 0 ;
       }
}


static int
handle_new_comment()
{
  int inside;
  int c;  /* changed from char (phb) */

  put_char_buffer('/',0); put_char_buffer('/',0);
  c = GETC(finput);
  inside = 1;
  while (inside)
    {
      if (c == '\n')
	{
	  inside = 0;
	  check_newline();
	  c = GETC(finput);
	}
      else if (c == EOF) {
        inside = 0;
      }
      else
	{  put_char_buffer(c,0) ; c = GETC(finput);  }
    }
  return c;
  
}



static int
skip_white_space(type)
  int type ;
{
  register int c;
  register int inside;


  c = GETC(finput);
  global_comment_type =type ;
/*  new_cur_comment     = (PTR_CMNT) NULL ; */

  for (;;)
    {
      switch (c)
	{
	case '/':
	  c = GETC(finput);
	  if ((c != '*')&&(c != '/'))
	    {
	      UNGETC(c, finput);
	      return '/';
	    }
          if (c == '/')  { c = handle_new_comment();
			   break;
			 }

          put_char_buffer('/',0); put_char_buffer('*',0);
	  c = GETC(finput);

	  inside = 1;
	  while (inside)
	    {
	      if (c == '*')
		{
		  while (c == '*')
		   {  put_char_buffer(c, 0);
                      c = GETC(finput);
		    }
		  if (c == '/')
		    {
		      inside = 0;
                      put_char_buffer(c,1);
		      c = GETC(finput);
		    }
		}
	      else if (c == '\n')
		{
		  lineno++;
                  put_char_buffer(c,0);
		  c = GETC(finput);
		}
	      else if (c == EOF)
		yyerror("unterminated comment");
	      else
		{  put_char_buffer(c,0) ; c = GETC(finput);  }
	    }

	  break;

	case '\n':
	  check_newline();

	case ' ':
	case '\t':
	case '\f':
	case '\r':
	case '\b':
	  c = GETC(finput);
	  break;

	case '\\':
	  c = GETC(finput);
	  if (c == '\n')
	    lineno++;
	  else
	    yyerror("stray '\\' in program");
	  c = GETC(finput);
	  break;

	default:
	  return (c);
	}
    }
}

/* Take care of the comments in the tail of the source code */
static int
skip_white_space_2()
{
  register int c;
  register int inside;

  c = GETC(finput);
  global_comment_type =HALF ;
  for (;;)
    {
      switch (c)
	{
	case '/':
	  c = GETC(finput);
	  if ((c != '*')&& (c != '/'))
	    {
	      UNGETC(c, finput);
	      return '/';
	    }
	  if (c == '/') { c =handle_new_comment();
			  break;
			}

          put_char_buffer('/',0); put_char_buffer('*',0);
	  c = GETC(finput);

	  inside = 1;
	  while (inside)
	    {
	      if (c == '*')
		{
		  while (c == '*')
		   {  put_char_buffer(c, 0);
                      c = GETC(finput);
		    }
		  if (c == '/')
		    {
		      inside = 0;
                      put_char_buffer(c,1);
		      c = GETC(finput);
		    }
		}
	      else if (c == '\n')
		{
		  lineno++;
                  put_char_buffer(c,0);
		  c = GETC(finput);
		}
	      else if (c == EOF)
		yyerror("unterminated comment");
	      else
		{  put_char_buffer(c,0) ; c = GETC(finput);  }
	    }

	  break;

	case '\n':
	  /* check_newline();  */ 
           return(c);

	case ' ':
	case '\t':
	case '\f':
	case '\r':
	case '\b':
	  c = GETC(finput);
	  break;

	case '\\':
	  c = GETC(finput);
	  if (c == '\n')
	    lineno++;
	  else
	    yyerror("stray '\\' in program");
	  c = GETC(finput);
	  break;

	default:
	  return (c);
	}
    }
}



/* make the token buffer longer, preserving the data in it.
p should point to just beyond the last valid character in the old buffer
and the value points to the corresponding place in the new one.  */

static char *
extend_token_buffer(p)
char *p;
{
  register char *newbuf;
  register char *value;
  int newlength = maxtoken * 2 + 10;
  register char *p2, *p1;

  newbuf = (char *) malloc((unsigned)(newlength+1));

  p2 = newbuf;
  p1 = newbuf + newlength + 1;
  while (p1 != p2) *p2++ = 0;

  value = newbuf;
  p2 = token_buffer;
  while (p2 != p)
   *value++ = *p2++;

  token_buffer = newbuf;

  maxtoken = newlength;

  return (value);
}




#define isalnum(char) ((char >= 'a' && char <= 'z') || (char >= 'A' && char <= 'Z') || (char >= '0' && char <= '9'))
#define isdigit(char) (char >= '0' && char <= '9')
#define ENDFILE -1  /* token that represents end-of-file */
#define isanop(d) ((d == '+') || (d == '-') || (d == '&') || (d == '|') || (d == '<') || (d == '>') || (d == '*') || (d == '/') || (d == '%') || (d == '^') || (d == '!') || (d == '=') || (d == '~'))

/* At the beginning of a line,
   increment the line number
   and handle a #line directive immediately following  */

void
check_newline ()
{
  register int c;
  int l;
  short temp_shorts[8];
  int   temp_count;
  int   temp_base;
  char *p;

  while (1)
    {
      c = GETC(finput);
      lineno++;

      /* Some #pragma lines may not begin at the beginning of a line */
      /* Skip leading whitespace no matter what the next character (PHB) */
      while (c == ' ' || c == '\t')
	  c = GETC(finput);

      /* Check if line begins with "#" */
      if (c != '#')
	{
	  /* If no #, unread the character,
	     except don't bother if it is whitespace.  */
	  if (c == ' ' || c == '\t')
	    return;
	  UNGETC(c, finput);
	  return;
	}

      /* Line begins with "#".  Skip all whitespace characters */
      while (1)
	{
	  c = GETC(finput);
	  if (! (c == ' ' || c == '\t'))
	    break;
	}

      /* If the # is the only nonwhite char on the line,
	 just ignore it.  Check the new newline.  */
      if (c == '\n')
	continue;

      /* Something follows the #; read a token.  */
      /* -----------------reserved---------------*/

      /* check for optional "line" token  */
      if (c == 'l')
        {
          if ((c = GETC(finput)) == 'i')
            if ((c = GETC(finput)) == 'n')
              if ((c = GETC(finput)) == 'e')
                {
                  while (1)
                    {
                      c = GETC(finput);
                      if (! (c == ' ' || c == '\t'))
                        break;
                    }
                }
        }

      /* grab line number */
      if ( (c- '0') > 9 ) 
	{  
	   /* warning ("invalid #line skipped"); */
	   /*skip the rest of this line.  */
           if(TRACEON) {
             printf ("++ ignoring ");
	     while ((c = GETC(finput)) != '\n') printf ("%c", c);
             printf ("\n");
           } else
	     while ((c = GETC(finput)) != '\n');
           /* lineno--;  /*ignore means don't count as a line too NO!*/
	   continue;
	 }
      for ( temp_count =0 ; temp_count < 8 ; temp_count++)
            temp_shorts[temp_count] = 0 ;
      temp_base =10;
      while (isdigit(c))
	{  c = c -'0';
           for (temp_count =0 ; temp_count < 8; temp_count++)
	     {   
                     (temp_shorts[temp_count] *= temp_base) ;
		     if (temp_count)
                       {   temp_shorts[temp_count] += (temp_shorts[temp_count-1] >> 8 );
			   temp_shorts[temp_count -1] &= (1 <<8) -1 ;
			 }
		     else temp_shorts[0] += c ;
             }
          c = GETC(finput);
	 }
         l = (temp_shorts[3]<<24)+(temp_shorts[2]<<16)+(temp_shorts[1]<<8)+temp_shorts[0];
         UNGETC(c,finput);
         while (1)
	   {
	     c = GETC(finput);
	     if (! (c == ' ' || c == '\t'))
	     break;
	   }

	 if (c == '\n') {   
	     		    c = GETC(finput);
                            if (c != '\n') { UNGETC(c,finput); l--; }
                            lineno = l;
                            if(TRACEON)
                              printf ("++ resetting to line %d\n", lineno);
                            continue;
                          }
         else if (c != '"')  { warning("invalid #line without file name");
                            /*skip the rest of this line.  */
                            if(TRACEON) {
                              printf ("++ ignoring #line ");
	                      while ((c = GETC(finput)) != '\n') printf("%c",c);
                              printf ("\n");
                            } else
	                      while ((c = GETC(finput)) != '\n');
                            continue;
                          }

	c = GETC(finput);
	p = token_buffer;

	while (c != '"')
	  {
	    if (c == '\\')
	      {
                /* New Added Three lines */
                if (p == token_buffer + maxtoken)
	          p = extend_token_buffer(p);
  	        *p++ = c;

		c = readescape (INSTRING);
		if (c < 0)
		  goto skipnew_2;
	      }
	    else if (c == '\n')
	      {
		if (pedantic)
		  warning ("ANSI C forbids newline in string constant");
		lineno++;
	      }

	    if (p == token_buffer + maxtoken)
	      p = extend_token_buffer(p);
	    *p++ = c;

	  skipnew_2:
	    c = GETC(finput);
	  }

	*p++ = 0;
        new_cur_fname = input_filename =  copys(token_buffer);
        if (wait_first_include_name == ON)
	  { 
	    wait_first_include_name = OFF;
	    first_line_name         = new_cur_fname;
	    global_bfnd->filename = find_file_entry(new_cur_fname);
	    global_bfnd->g_line   = 0;
	  }
        lineno = l - 1 ;
        if(TRACEON)
          printf ("++ setting to line %d in %s\n", lineno, input_filename);
        /*skip the rest of this line.  */
        while ((c = GETC(finput)) != '\n');
	
    }
} 






static int
readescape (inchar)
int inchar;
{
  register int c = GETC(finput);
  register int count, code;

  switch (c)
    {
    case 'x':
      code = 0;
      count = 0;
      while (1)
	{
	  c = GETC(finput);
	  if (!(c >= 'a' && c <= 'f')
	      && !(c >= 'A' && c <= 'F')
	      && !(c >= '0' && c <= '9'))
	    {
	      UNGETC(c, finput);
	      break;
	    }
	  if (c >= 'a' && c <= 'z')
	    c -= 'a' - 'A';
	  code *= 16;
	  if (c >= 'a' && c <= 'f')
	    code += c - 'a' + 10;
	  if (c >= 'A' && c <= 'F')
	    code += c - 'A' + 10;
	  if (c >= '0' && c <= '9')
	    code += c - '0';
	  count++;
	  if (count == 3)
	    break;
	}
      if (count == 0)
	yyerror ("\\x used with no following hex digits");
      return code;

    case '0':  case '1':  case '2':  case '3':  case '4':
    case '5':  case '6':  case '7':
      code = 0;
      count = 0;
      while ((c <= '7') && (c >= '0') && (count++ < 3))
	{
	  code = (code * 8) + (c - '0');
	  c = GETC(finput);
	}
      UNGETC(c, finput);
      return code;

    case '\\': case '\'': case '"':
      return c;

    case '\n':
      lineno++;
      return -1;

    case 'n':
      return (inchar)?TARGET_NEWLINE:c; 

    case 't':
      return (inchar)?TARGET_TAB:c;
      
    case 'r':
      return (inchar)?TARGET_CR:c;

    case 'f':
      return (inchar)?TARGET_FF:c;

    case 'b':
      return (inchar)?TARGET_BS:c;

    case 'a':
      return (inchar)?TARGET_BELL:c;

    case 'v':
      return (inchar)?TARGET_VT:c;
    }
  return c;
}

 
int
yylex()
{
  register int c;
  register char *p;
  register int value;
  int low /*,high */;
  char *str1 ;
  int c3;
  if (recursive_yylex == OFF) new_cur_comment = (PTR_CMNT) NULL ;

  /* line_pos_1 = lineno +1 ; */
  c = skip_white_space(FULL);
/*  yylloc.first_line = lineno; */

  switch (c)
    {
    case EOF:
      value = ENDFILE; break;

    case 'A':  case 'B':  case 'C':  case 'D':  case 'E':
    case 'F':  case 'G':  case 'H':  case 'I':  case 'J':
    case 'K':  case 'L':  case 'M':  case 'N':  case 'O':
    case 'P':  case 'Q':  case 'R':  case 'S':  case 'T':
    case 'U':  case 'V':  case 'W':  case 'X':  case 'Y':
    case 'Z':
    case 'a':  case 'b':  case 'c':  case 'd':  case 'e':
    case 'f':  case 'g':  case 'h':  case 'i':  case 'j':
    case 'k':  case 'l':  case 'm':  case 'n':  case 'o':
    case 'p':  case 'q':  case 'r':  case 's':  case 't':
    case 'u':  case 'v':  case 'w':  case 'x':  case 'y':
    case 'z':
    case '_':

      p = token_buffer;
      while (isalnum(c) || (c == '_') /* ||  (c == '~') */)
	{
	  if (p >= token_buffer + maxtoken)
	    p = extend_token_buffer(p);
	  *p++ = c;
	  c = GETC(finput);
	}

      *p = 0;
      UNGETC(c, finput);

      value = IDENTIFIER;


      if (p - token_buffer <= MAXRESERVED)
	{
	  register int lim = frw [p - token_buffer + 1];
	  register int i;

	  for (i = frw[p - token_buffer]; i < lim; i++)
	    if (rw[i][0] == token_buffer[0] && !strcmp(rw[i], token_buffer))
	      {
		if (rid[i])
		  yylval.token = (int) rid[i] ;
		value = (int) rtoken[i];
		if (rid[i]==RID_EXTERN) {
		  /* Check if this is a language-type declaration.*/
		  c = skip_white_space_2();
		  if (c != '"')      
                    UNGETC(c, finput); /* put it back into the buffer */
		  else {
		    c = GETC(finput);  /* get next char */
                    if ((c == 'C') || (c == 'c') || (c == 'b')) {
                      c = GETC(finput); 
                      if (c == '"') 
                        value = EXTERN_C_LANG; 
                      else {
			if (c == 'u') { /* Assume extern "builtin" (PHB) */
			  while (c != '"') c = GETC(finput); /* scan to end */
			  value = EXTERN_C_LANG; }
			else {
			  while (c != '"') c = GETC(finput); /* scan to end */
			  value = EXTERN_UNKNOWN_LANG; /* set token */ }
		      }
		    }
		    else {
		      while (c != '"') c = GETC(finput); /* scan to end */
		      value = EXTERN_UNKNOWN_LANG; /* set token */ 
		    }
		  }
		}
		break;
	      }
	}

      if (value == IDENTIFIER)
	{ int t_status ;
/* temp move it out */

          yylval.hash_entry = look_up_type(token_buffer,&t_status);
          /*
          printf("Scope_Flag = %d t_stats = %d lastdecl_id = %d\n", Scope_Flag,t_status, lastdecl_id); 
          if(yylval.hash_entry && yylval.hash_entry->id_attr)
	  printf("and the yylvax.hash_entry = %d\n", yylval.hash_entry->id_attr->variant);
          */
          if ((t_status)&&(lastdecl_id ==0)){   
             if(Scope_Flag == 1) {value = SCOPED_TYPENAME;}
             else if(t_status == OTHER &&
                     (previous_value != CLASS) &&
                     (previous_value != STRUCT) &&
                     (previous_value != UNION)) value = IDENTIFIER;
             else value = TYPENAME;       
             }
          else if(t_status){
	        c = skip_white_space_2();
		if(c == '<') value = TYPENAME;
                UNGETC(c, finput);
		}
          else if(yylval.hash_entry->id_attr && 
             (yylval.hash_entry->id_attr->variant == MEMBER_FUNC)){
	        c = skip_white_space_2();
		if(c == '<') value = TFUNCNAME;
		UNGETC(c, finput);
		}
        }
           Scope_Flag = 0; 

      break;

    case '0':  case '1':  case '2':  case '3':  case '4':
    case '5':  case '6':  case '7':  case '8':  case '9':
    case '.':
      {
	int base = 10;
	int count = 0;
	int largest_digit = 0;
	/* for multi-precision arithmetic,
	   we store only 8 live bits in each short,
          giving us 64 bits of reliable precision */
	short shorts[8];
	int floatflag = 0;  /* Set 1 if we learn this is a floating constant */

	for (count = 0; count < 8; count++)
	  shorts[count] = 0;

	p = token_buffer;
	*p++ = c;

	if (c == '0')
	  {
	    *p++ = (c = GETC(finput));
	    if ((c == 'x') || (c == 'X'))
	      {
		base = 16;
		*p++ = (c = GETC(finput));
	      }
	    else
	      {
		base = 8;
	      }
	  }

	while (c == '.'
	       || (isalnum (c) && (c != 'l') && (c != 'L')
		   && (c != 'u') && (c != 'U')
		   && (!floatflag || ((c != 'f') && (c != 'F')))))
	  {
	    if (c == '.')
	      {
		if (base == 16)
		  yyerror ("floating constant may not be in radix 16");
		floatflag = 1;
		base = 10;
		*p++ = c = GETC(finput);
		/* Accept '.' as the start of a floating-point number
		   only when it is followed by a digit.
		   Otherwise, unread the following non-digit
		   and use the '.' as a structural token.  */
		if (p == token_buffer + 2 && !isdigit (c))
		  {
		    if (c == '.')
		      {
			c = GETC(finput);
			if (c == '.')
			  { if (TRACEON) 
			      fprintf(stderr,
				      "TRC: Ellipsis token (...)\n");
                            value = ELLIPSIS ;
			    goto done ;
                          }
			yyerror ("syntax error");
		      }
		    UNGETC(c, finput);
		    value = '.';
                    goto done;
		  }
	      }
	    else
	      {
		if (isdigit(c))
		  {
		    c = c - '0';
		  }
		else if (base <= 10)
		  {
		    if ((c&~040) == 'E')
		      {
			if (base == 8)
			  yyerror ("floating constant may not be in radix 8");
			base = 10;
			floatflag = 1;
			break;   /* start of exponent */
		      }
		    yyerror ("nondigits in number and not hexadecimal");
		    c = 0;
		  }
		else if (c >= 'a')
		  {
		    c = c - 'a' + 10;
		  }
		else
		  {
		    c = c - 'A' + 10;
		  }
		if (c >= largest_digit)
		  largest_digit = c;
	    
		for (count = 0; count < 8; count++)
		  {
		    (shorts[count] *= base);
		    if (count)
		      {
			shorts[count] += (shorts[count-1] >> 8);
			shorts[count-1] &= (1<<8)-1;
		      }
		    else shorts[0] += c;
		  }
    
		*p++ = (c = GETC(finput));
	      }
	  }

	if (largest_digit >= base)
	  yyerror ("numeric constant contains digits beyond the radix");

	/* Remove terminating char from the token buffer and delimit the string */
	*--p = 0;

	if (floatflag)
	  {
	    enum rid type = DOUBLE_TYPE_CONST ;

	    /* Read explicit exponent if any, and put it in tokenbuf.  */

	    if ((c == 'e') || (c == 'E'))
	      {
		*p++ = c;
		c = GETC(finput);
		if ((c == '+') || (c == '-'))
		  {
		    *p++ = c;
		    c = GETC(finput);
		  }
	        while (isdigit(c))
		  {
		    *p++ = c;
		    c = GETC(finput);
		  }
	      }

	    *p = 0;

	    while (1)
	      {
		if (c == 'f' || c == 'F')
		  type = FLOAT_TYPE_CONST ;
		else if (c == 'l' || c == 'L')
		  type = LONG_DOUBLE_TYPE_CONST ;
		else
		  {
		    if (isalnum (c))
		      {
			yyerror ("garbage at end of number");
			while (isalnum (c))
			  c = GETC(finput);
		      }
		    break;
		  }
		c = GETC(finput);
	      }

	    UNGETC(c, finput);

/*	    ddval = build_real_from_string (token_buffer, 0);  */
            str1= copys(token_buffer);
            switch(type){
             case FLOAT_TYPE_CONST:
               yylval.ll_node = installLowLevelNode(FLOAT_VAL,LLNULL,LLNULL,str1);
               break;
             case LONG_DOUBLE_TYPE_CONST:
               yylval.ll_node = installLowLevelNode(LONG_DOUBLE_VAL,LLNULL,LLNULL,str1);
               break;
             default:
               yylval.ll_node = installLowLevelNode(DOUBLE_VAL,LLNULL,LLNULL,str1);
               break;
           }


	  }
	else
	  {
	    /* enum rid  type; */

	    int spec_unsigned = 0;
	    int spec_long = 0;

	    while (1)
	      {
		if (c == 'u' || c == 'U')
		  {
		    spec_unsigned = 1;
		  }
		else if (c == 'l' || c == 'L')
		  {
		    spec_long = 1;
		  }
		else
		  {
		    if (isalnum (c))
		      {
			yyerror ("garbage at end of number");
			while (isalnum (c))
			  c = GETC(finput);
		      }
		    break;
		  }
		c = GETC(finput);
	      }

	    UNGETC(c, finput);

	    /* This is simplified by the fact that our constant
	       is always positive.  */

	    low= (shorts[3]<<24) + (shorts[2]<<16) + (shorts[1]<<8) + shorts[0] ;
	   /* high = (shorts[7]<<24) + (shorts[6]<<16) + (shorts[5]<<8) + shorts[4] ; */
	    



    /* Reserved Temporarily   UNDONE 5
	    if (!spec_long && !spec_unsigned
		&& int_fits_type_p (yylval.ttype, integer_type_node))
	      type = integer_type_node;

	    else if (!spec_long && base != 10
		&& int_fits_type_p (yylval.ttype, unsigned_type_node))
	      type = unsigned_type_node;

	    else if (!spec_unsigned
		&& int_fits_type_p (yylval.ttype, long_integer_type_node))
	      type = long_integer_type_node;

	    else
	      type = long_unsigned_type_node;    */

	      /* type = LONG_UNSIGNED_TYPE_CONST ; */

/* not sure why the above code is commented out but I really need a way to keep
   those u and l suffixes around so try again BW */
            if(spec_long && spec_unsigned)
              yylval.ll_node = installLowLevelNode(UNSIGNED_LONG_INT_VAL,LLNULL,LLNULL,low);
            else if(spec_long)
              yylval.ll_node = installLowLevelNode(LONG_INT_VAL,LLNULL,LLNULL,low);
            else if(spec_unsigned)
              yylval.ll_node = installLowLevelNode(UNSIGNED_INT_VAL,LLNULL,LLNULL,low);
            else
              yylval.ll_node = installLowLevelNode(INT_VAL,LLNULL,LLNULL,low);


	
	 }

	value = CONSTANT; break;
      }

    case '\'':
      c = GETC(finput);
      {
	register int code = 0;

      tryagain:

	if (c == '\\')
	  {
	    c = readescape (INCHAR);
	    if (c < 0)
	      goto tryagain;
	  }
	else if (c == '\n')
	  {
	    if (pedantic)
	      warning ("ANSI C forbids newline in character constant");
	    lineno++;
	  }

	code = c;
	c3=c;
	c = GETC(finput);
	if (c != '\'')
	  yyerror("malformatted character constant");

	/* If char type is signed, sign-extend the constant.  */
        /* UNDONE 6 */
	if (CHAR_TYPE_CONST == UNSIGNED_CHAR_TYPE_CONST
	    || (code >> (BITS_PER_UNIT - 1)) == 0)
	  {
             low = code;
            /* high = 0 ; */
	   }
         else
	   {  low = code | ((-1) << BITS_PER_UNIT );
             /* high = -1 ; */
	  }
        yylval.ll_node = installLowLevelNode(CHAR_VAL,LLNULL,LLNULL,low);
	yylval.ll_node->entry.cval = c3;
	value = CONSTANT; break;
      }

    case '"':
      {
	c = GETC(finput);
	p = token_buffer;

	while (c != '"')
	  {
	    if (c == '\\')
	      {
                /* New Added Three lines */
                if (p == token_buffer + maxtoken)
	          p = extend_token_buffer(p);
  	        *p++ = c;

		c = readescape (INSTRING);
		if (c < 0)
		  goto skipnewline;
	      }
	    else if (c == '\n')
	      {
		if (pedantic)
		  warning ("ANSI C forbids newline in string constant");
		lineno++;
	      }

	    if (p == token_buffer + maxtoken)
	      p = extend_token_buffer(p);
	    *p++ = c;

	  skipnewline:
	    c = GETC(finput);
	  }

	*p++ = 0;

	str1= copys(token_buffer);
        yylval.ll_node = installLowLevelNode(STRING_VAL,LLNULL,LLNULL,str1);
	value = STRING; break;
      }

    case '+':
    case '-':
    case '&':
    case '|':
    case '<':
    case '>':
    case '*':
    case '/':
    case '%':
    case '^':
    case '!':
    case '=':
    case '~':
      {
	register int c1;
        if ( previous_value == OPERATOR )
           {
             p = token_buffer;
             while (isanop(c) )
              {
                  if (p >= token_buffer + maxtoken)
	          p = extend_token_buffer(p);
	          *p++ = c;
	          c = GETC(finput);
               }
             *p = 0;
             UNGETC(c, finput);
             value =  LOADEDOPR ;
             yylval.hash_entry = look_up(token_buffer);
             break;
            }
      combine:

	switch (c)
	  {
	  case '+':
	    yylval.token = (int) PLUS_EXPR; break;
	  case '-':
	    yylval.token = (int) MINUS_EXPR; break;
	  case '&':
	    yylval.token = (int) BIT_AND_EXPR; break;
	  case '|':
	    yylval.token = (int) BIT_IOR_EXPR; break;
	  case '*':
	    yylval.token = (int) MULT_EXPR; break;
	  case '/':
	    yylval.token = (int) TRUNC_DIV_EXPR; break;
	  case '%':
	    yylval.token = (int) TRUNC_MOD_EXPR; break;
	  case '^':
	    yylval.token = (int) BIT_XOR_EXPR; break;
	  case LSHIFT:
	    yylval.token = (int) LSHIFT_EXPR; break;
	  case RSHIFT:
	    yylval.token = (int) RSHIFT_EXPR; break;
	  case '<':
	    yylval.token = (int) LT_EXPR; break;
	  case '>':
	    yylval.token = (int) GT_EXPR; break;
	  }	

	c1 = GETC(finput);

	if (c1 == '=')
	  {
	    switch (c)
	      {
	      case '<':
		value = ARITHCOMPARE; yylval.token = (int) LE_EXPR; goto done;
	      case '>':
		value = ARITHCOMPARE; yylval.token = (int) GE_EXPR; goto done;
	      case '!':
		value = EQCOMPARE; yylval.token = (int) NE_EXPR; goto done;
	      case '=':
		value = EQCOMPARE; yylval.token = (int) EQ_EXPR; goto done;
	      }	
	    value = ASSIGN; goto done;
	  }
	else if (c == c1)
	  switch (c)
	    {
	    case '+':
	      value = PLUSPLUS; goto done;
	    case '-':
	      value = MINUSMINUS; goto done;
	    case '&':
	      value = ANDAND; goto done;
	    case '|':
	      value = OROR; goto done;
	    case '<':
	      c = LSHIFT;
	      goto combine;
	    case '>':
	      c = RSHIFT;
	      goto combine;
	    }
	else if ((c == '-') && (c1 == '>'))
	  { value = POINTSAT; goto done; }
	UNGETC(c1, finput);


        value = c;
	goto done;
      }
    case ':':
      {
	char c1;
        c1 = GETC(finput);
        if (c1 == c){
		 value = DOUBLEMARK;
		 Scope_Flag = 1;
		}
	else  {
	  UNGETC(c1,finput);
          value =c;
	}	
	goto done;
	
      }
    case '(':
    case '[':
      {	register int c1;
        if ( previous_value == OPERATOR )
           {

/* This code makes no sense to me, (but if it ain't broke....)  (PHB) */
             p = token_buffer;
	     if (p >= token_buffer + maxtoken)
	       p = extend_token_buffer(p);
	     *p++ = c;

	     c1 = skip_white_space_2();  /* added by (PHB) */
	     /* c1 = GETC(finput);  */  /* removed by (PHB) */

             if (((c=='(')&&(c1==')'))||
                 ((c=='[')&&(c1==']')))
	       {
		 *p++ = c1;
                 *p=0;
		 value =  LOADEDOPR ;
		 yylval.hash_entry = look_up(token_buffer);
	       }
	     else  {
	       UNGETC(c1,finput);
	       value = c;
	     }
	   }
	else  value =c;
        break;
      }
    default:
      value = c;
    }

done:

  if (recursive_yylex == OFF) {
    int value2;
    previous_value = value ;
    line_pos_1 = lineno ;
    c = skip_white_space_2();
    if (c == '\n') check_newline();
    else           UNGETC(c, finput);
    if (value != '}') 
      { c = skip_white_space(NEXT_FULL);
	if (c == '\n') lineno++ ;
	else           UNGETC(c, finput);
      }
    if(value == TFUNCNAME) value2 = IDENTIFIER;
    else value2 = value;
    set_up_momentum(value2,yylval.token);
    line_pos_fname = new_cur_fname;
    automata_driver(value2);
    put_comment_queue();
    cur_counter++;
    old_line = yylineno  ;
    yylineno = line_pos_1;
  }

  if (TRACEON) 
    fprintf(stderr,
       "TRC: token=%d, char=%c, lineno=%d\n",value,value,old_line);
  return (value);
}


