/* --------------------------------------------------
 *
 *  Darryl Brown
 *  
 *  October, 1994
 *
 *  astrlib.h
 *  
 *  This file is the inlcude file for the implementation of 
 *  several useful string functions.
 *
 * --------------------------------------------------
 */


/*
 * --------------------------------------------------
 *  TYPES
 * --------------------------------------------------
 */

#ifndef ASTRLIB_HDR
#define ASTRLIB_HDR

#ifdef __cplusplus 
extern "C" {
#endif

typedef struct {
  char *buf;
  char *curPtr;
  char *delimStr;
} strtokStruct;

/*
 *  char *strsave(char *str)- accepts a string, and mallocs space 
 *       for it, or returns an error if malloc fails...;
 *
 *  int strsame(char *str1, char *str2) - returns true (1) is strings
 *       are the same, false (0) if not.
 *
 *  char strappend(char *str1, char *str2) - returns concatenation
 *       of str2 and str2, allocating memory for the result.  
 *       It does not free any space used by str1 and str2.
 *
 *  strtokStruct *initstrtok(char *buf) -
 *       initializes a structure for parsing functions that
 *       work like strtok, except that there is a unique
 *       buffer associated with each call to initastrtok.
 *       In this way, you can use the functions on more
 *       than one string at a time.
 *
 *  char *astrtok(strtokStruct *st, char *delim) - works
 *       exactly like strtok (except you supply the 
 *       string tok struct 'st'.
 *  
 *  void freestrtok(strtokStruct *st) - frees all space 
 *       associated with a string tok struct.
 *
 *  
 */

/*
 *
 *  int isAllDigits(char *str1) - returns true (1) if string
 *       is made of all digits.
 *
 */
int isAllDigits(char *str1);
char * strsave(char * str);
int strsame(char *str1, char *str2);
char *strappend(char *str1, char *str2);
strtokStruct *initstrtok(char *buf);
char *sstrtok(strtokStruct *st, char *delim);
char *astrtok(strtokStruct *st, char *delim);
void freestrtok(strtokStruct *st);
char * trimLeadingSpaces(char *st);
int wordSame(char *str1, char *str2);
  /* tests to see if first non-blank characters
   * in each string are the same.
   */


#ifdef __cplusplus 
}
#endif

#endif

