/* --------------------------------------------------
 *
 *  Darryl Brown
 *  
 *  March, 1995
 *
 *  breezyInc.h
 *  
 *  This file is included in kernel.h.  It has breezy relevant
 *  declarations.  Also, if not compiling for breakpointing, it
 *  takes out all references to breezy applications (using macros).
 *
 * --------------------------------------------------
 */


#ifndef BRZ_INC_HDR
#define BRZ_INC_HDR
#ifdef BRKPNT_ON

#include "clServ.h"
#include "cargo.h"
#include "typeApi.h"
#include "astrlib.h"
#include "collInst.h"
#include "distApi.h"

#ifdef __cplusplus 
extern "C" {
#endif
/*
 *  ------------------------------------------------------------
 *  Macros
 *  ------------------------------------------------------------
 */


extern int brk_ConnectionNum;
extern int brk_BREAKPOINT_TOGGLE_VAR;
#define brk_TOGGLE_BREAKPOINT(a) (brk_BREAKPOINT_TOGGLE_VAR = a)

#ifdef __cplusplus 
}
#endif

/* include the distributed API stuff,
 * and the collection instance handling code.
 */
#include "collInst.C"


/* else BRKPNT_ON is not switched on, not compiling for breakpoint mode
 */
#else


/*----------------------------------------------------------
 * if breakpoint compiler switch is not on...;
 * get rid of function calls;
 */
#define brk_TOGGLE_BREAKPOINT(a)
#define brk_QUE_COLLECTION_INSTANCE(a,b,c) 
#define brk_ADD_COLLECTION_ENTRY(a,b,c) 
#define brk_DELETE_COLLECTION_ENTRY(a) 
#define brk_BREAKPOINT_EXECUTIVE()

#endif
#endif

