/* --------------------------------------------------
 *
 *  Darryl Brown
 *  
 *  October, 1994
 *
 *  clServ.h
 *  
 *  This file is the include file for the implementation of 
 *  the client server layer above the
 *  API for data & TYPE transfer (typeApi.c).
 *
 * --------------------------------------------------
 */




#ifndef CLTAPI_HDR
#define CLTAPI_HDR

/*
 *  ------------------------------------------------------------
 *  Macros
 *  ------------------------------------------------------------
 */

/*
 *  ------------------------------------------------------------
 *  Types
 *  ------------------------------------------------------------
 */


/* ------------------------- */

/* enumeration of client / server
 * communication roles. 
 *  
 * Note that this distinquishes between 
 * who is the server and who is the client
 * in the communication connection.
 * 
 */

typedef enum {
  cn_client, cn_server
} connRoleEnum; 

/* ------------------------- */

/* Enumeration of client server
 * data roles.
 *
 * Note that is can be (and IS,
 * in the breezy case) the 
 * opposite of the connectionRole. 
 * This states who is storing the
 * the data, if you are the client
 * requesting data, or if you are
 * serving it.
 * 
 */

typedef enum {
  dr_client, dr_server
} dataRoleEnum;

#endif
