extern "C" {
#include "thread_iface.h"
}

typedef void (*voidFuncPtr)(void *);

/* Created by the compiler (dep2C++) */
extern int pcxx_inpar;

/* Used to do my own tally of whether I am parallel */
int  pcaw_inseq   = 1;

/* The compiler will add this: */
void WorkerSwitch(int pcaw_cf, char *pcaw_cc);

struct params {
  int s;
  void * c;
};


/***********************************************************************/
void WorkerSwitch0(void *p)
{
  WorkerSwitch( ((struct params *) p) -> s, 
	       (char *) ((struct params *) p) -> c);
}

/***********************************************************************/
void MShack_DoWork(int selector, void *coll) 
{ 
  struct params *p;
  p = (struct params *) tulip_SharedMalloc(sizeof(struct params));
  p -> s = selector;
  p -> c = (void *) coll;

  thread_Fork( (voidFuncPtr) WorkerSwitch0, (void *) p);
  tulip_SharedFree(p);
}

/***********************************************************************/
int MShack_InParallelSection()
{
  if (pcaw_inseq)
    return 0;
  else
    return 1;
}

/***********************************************************************/
void pcaw_Barrier()
{
  if (!pcaw_inseq)
    thread_Barrier();
}


/***********************************************************************/
int MShack_IamtheOwner(int elem)
{
 if ( elem % thread_NumThreads() == thread_MyID() )
   return 1;
 else
   return 0;
 }

/***********************************************************************/
void pcaw_EnterPar(Kernel *coll, int selector)
{
  if(coll){
    ResetLocal(coll);
  }
  pcxx_inpar++;
  pcaw_inseq--;
  MShack_DoWork( selector, (void *) coll);
}

void pcaw_ExitPar()
{
  pcaw_inseq++;
  pcxx_inpar--;
  ResetCollectionTraversalLevel();
}





