/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993,1995             */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/

/* Include file for pC++ parallel IO routines and stddef these
definitions are meant to simulate stdio.h, stargs.h, stddef.h, errno.h
by simulate, we mean each of the standard types, functions and defines
are given an acutual type.  defines become variables or typedefs.  all
the stdio functions are translated into pcxx_ functions so that the
may call our parallel versions.  IMPORTANT POINT: doing it this way
allows standard system defines to pass into output C++ code in their
standard symbolic form.  However, the definitions are deleted prior to
generation of the C++ code, so that the target systems include files
may be placed in runtime.h and the outputfile temp.C is independent of
system.  */

int pcxx_cut_start_stdio;  // the statement below will be used for parsing
                           // the remainder of the program and then they are
                           // removed from this point until pcxx_cut_end

#ifdef __SOLARIS2__
  typedef long wchar_t;
#endif
 
#include <stdio.h>

int pcxx_cut_end_stdio; // all variable from pcxx_cut_start to here will not appear
                  // in the final output.

// removed because Sage now does a special thing there
// define printf pcxx_printf

#ifdef open
#  undef open
#endif
#define open pcxx_open 

#ifdef lseek
#  undef lseek
#endif
#define lseek pcxx_lseek

#ifdef tell
#  undef tell
#endif
#define tell pcxx_tell

#ifdef pipe
#  undef pipe
#endif
#define pipe pcxx_pipe

#ifdef read
#  undef read
#endif
#define read pcxx_read

#ifdef write
#  undef write
#endif
#define write pcxx_write

#ifdef fclose
#  undef fclose
#endif
#define fclose pcxx_fclose

#ifdef fflush
#  undef fflush
#endif
#define fflush pcxx_fflush

#ifdef ferror
#  undef ferror
#endif
#define ferror pcxx_ferror

#ifdef feof
#  undef feof
#endif
#define feof pcxx_feof

#ifdef clearerr
#  undef clearerr
#endif
#define clearerr pcxx_clearerr

#ifdef fileno
#  undef fileno
#endif
#define fileno pcxx_fileno

#ifdef fopen
#  undef fopen
#endif
#define fopen pcxx_fopen

#ifdef freopen
#  undef freopen
#endif
#define freopen pcxx_freopen

#ifdef fdopen
#  undef fdopen
#endif
#define fdopen pcxx_fdopen

#ifdef fread
#  undef fread
#endif
#define fread pcxx_fread

#ifdef fwrite
#  undef fwrite
#endif
#define fwrite pcxx_fwrite

#ifdef fseek
#  undef fseek
#endif
#define fseek pcxx_fseek

#ifdef ftell
#  undef ftell
#endif
#define ftell pcxx_ftell

#ifdef rewind
#  undef rewind
#endif
#define rewind pcxx_rewind

#ifdef getc
#  undef getc
#endif
#define getc pcxx_getc

#ifdef getchar
#  undef getchar
#endif
#define getchar pcxx_getchar

#ifdef fgetc
#  undef fgetc
#endif
#define fgetc pcxx_fgetc

#ifdef getw
#  undef getw
#endif
#define getw pcxx_getw

#ifdef gets
#  undef gets
#endif
#define gets pcxx_gets

#ifdef fgets
#  undef fgets
#endif
#define fgets pcxx_fgets

#ifdef popen
#  undef popen
#endif
#define popen pcxx_popen

#ifdef pclose
#  undef pclose
#endif
#define pclose pcxx_pclose

#ifdef e
#  undef e
#endif
// define fprintf pcxx_fprintf

#ifdef putc
#  undef putc
#endif
#define putc pcxx_putc

#ifdef putchar
#  undef putchar
#endif
#define putchar pcxx_putchar

#ifdef fputc
#  undef fputc
#endif
#define fputc pcxx_fputc

#ifdef putw
#  undef putw
#endif
#define putw pcxx_putw

#ifdef puts
#  undef puts
#endif
#define puts pcxx_puts

#ifdef fputs
#  undef fputs
#endif
#define fputs pcxx_fputs

#ifdef setbuf
#  undef setbuf
#endif
#define setbuf pcxx_setbuf

#if 0
#ifdef setbuffer
#  undef setbuffer
#endif
#define setbuffer pcxx_setbuffer

#ifdef setlinebuf
#  undef setlinebuf
#endif
#define setlinebuf pcxx_setlinebuf
#endif

#ifndef sequent
#ifdef setvbuf
#  undef setvbuf
#endif
#define setvbuf pcxx_setvbuf

#ifdef tmpfile
#  undef tmpfile
#endif
#define tmpfile pcxx_tmpfile
#endif

#ifdef tmpnam
#  undef tmpnam
#endif
#define tmpnam pcxx_tmpnam

#ifdef ungetc
#  undef ungetc
#endif
#define ungetc pcxx_ungetc
