/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993,1995             */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/

/* Pete Beckman */

/* This file should be included ONCE for every pC++ program It defined
some basic pC++ things, and must be included AFTER the basic RTS is
included and defined */

#define PCXX_FAIL -1
#define PCXX_SUCCESS 0

/*********************************************************************/
/* Kernel-level RTS to LOW-LEVEL RTS mappings */
/*********************************************************************/
#define PCXX_WARNING TULIP_WARNING
#define PCXX_FATAL TULIP_FATAL

#define pcxx_NodeNumber() tulip_MyContext()
#define pcxx_TotalNodes() tulip_NumContexts()
#define pcxx_Poll() tulip_Poll()
#define pcxx_Abort() tulip_Abort()
#define pcxx_Message(a,b) tulip_Message(a,b)
#define pcxx_ParallelMain(a,b) tulip_ParallelMain(a,b)
#define pcxx_RemoteAction(a,b,c,d) tulip_RemoteAction(a,b,c,d)
#define pcxx_RemoteActionHandler(a,b,c) tulip_RemoteActionHandler(a,b,c)

/*********************************************************************/
#define pcxx_UserTimerClear(a) tulip_UserTimerClear(a)
#define pcxx_UserTimerStart(a) tulip_UserTimerStart(a) 
#define pcxx_UserTimerStop(a) tulip_UserTimerStop(a)
#define pcxx_UserTimerElapsed(a) tulip_UserTimerElapsed(a)

#define pcxx_WallTimerClear(a) tulip_WallTimerClear(a)
#define pcxx_WallTimerStart(a) tulip_WallTimerStart(a) 
#define pcxx_WallTimerStop(a) tulip_WallTimerStop(a)
#define pcxx_WallTimerElapsed(a) tulip_WallTimerElapsed(a)

#define pcxx_WallClock() tulip_WallClock()
#define pcxx_UserClock() tulip_UserClock()

/*********************************************************************/
#define pcxx_NativeReduceDoubleAdd(a,b) tulip_NativeReduceDoubleAdd(a,b)
#define pcxx_NativeReduceFloatAdd(a,b) tulip_NativeReduceFloatAdd(a,b)
#define pcxx_NativeReduceIntAdd(a,b) tulip_NativeReduceIntAdd(a,b)
#define pcxx_NativeReduceDoubleMax(a,b) tulip_NativeReduceDoubleMax(a,b)
#define pcxx_NativeReduceFloatMax(a,b) tulip_NativeReduceFloatMax(a,b)
#define pcxx_NativeReduceIntMax(a,b) tulip_NativeReduceIntMax(a,b)
#define pcxx_NativeReduceDoubleMin(a,b) tulip_NativeReduceDoubleMin(a,b)
#define pcxx_NativeReduceFloatMin(a,b) tulip_NativeReduceFloatMin(a,b)
#define pcxx_NativeReduceIntMin(a,b) tulip_NativeReduceIntMin(a,b)
#define pcxx_NativeBroadcastBytes(a,b,c) tulip_NativeBroadcastBytes(a,b,c)

#define pcxx_AlienReduceDoubleAdd(a,b) tulip_AlienReduceDoubleAdd(a,b)
#define pcxx_AlienReduceFloatAdd(a,b) tulip_AlienReduceFloatAdd(a,b)
#define pcxx_AlienReduceIntAdd(a,b) tulip_AlienReduceIntAdd(a,b)
#define pcxx_AlienReduceDoubleMax(a,b) tulip_AlienReduceDoubleMax(a,b)
#define pcxx_AlienReduceFloatMax(a,b) tulip_AlienReduceFloatMax(a,b)
#define pcxx_AlienReduceIntMax(a,b) tulip_AlienReduceIntMax(a,b)
#define pcxx_AlienReduceDoubleMin(a,b) tulip_AlienReduceDoubleMin(a,b)
#define pcxx_AlienReduceFloatMin(a,b) tulip_AlienReduceFloatMin(a,b)
#define pcxx_AlienReduceIntMin(a,b) tulip_AlienReduceIntMin(a,b)
#define pcxx_AlienBroadcastBytes(a,b,c) tulip_AlienBroadcastBytes(a,b,c)

#define pcxx_ReduceDoubleAdd(a,b) tulip_ReduceDoubleAdd(a,b)
#define pcxx_ReduceFloatAdd(a,b) tulip_ReduceFloatAdd(a,b)
#define pcxx_ReduceIntAdd(a,b) tulip_ReduceIntAdd(a,b)
#define pcxx_ReduceDoubleMax(a,b) tulip_ReduceDoubleMax(a,b)
#define pcxx_ReduceFloatMax(a,b) tulip_ReduceFloatMax(a,b)
#define pcxx_ReduceIntMax(a,b) tulip_ReduceIntMax(a,b)
#define pcxx_ReduceDoubleMin(a,b) tulip_ReduceDoubleMin(a,b)
#define pcxx_ReduceFloatMin(a,b) tulip_ReduceFloatMin(a,b)
#define pcxx_ReduceIntMin(a,b) tulip_ReduceIntMin(a,b)
#define pcxx_BroadcastBytes(a,b,c) tulip_BroadcastBytes(a,b,c)

/* PC++, defines */
#define MAXPARAL 10
#define BLOCK 1
#define CYCLIC 2
#define WHOLE 3
#define QBLOCK 4

#if defined(__ksr__) || defined(_SEQUENT_) || defined(sequent) || defined(butterfly) || defined(sgi)
#  if !defined(UNIPROC) && !defined(__PVM__) && !defined(__MPI__)
#    define _SMRTS_        /* Shared Memory RunTime System */
#  endif
#endif

