/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993,1995             */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/

#ifndef __wchar_t
typedef int __wchar_t;
#endif

#ifdef CM5
# include <cm/cmmd.h>
#endif

#include "pcxx_events_def.h"

/* C library functions used by the Kernel; */
/* Used in kernel.h and kernel-*.h         */

#if defined(_AWE_)
extern  "C" void free(void *ptr);
#endif

/* Functions provided by the various      */
/* Runtime Systems to the Kernel;         */
/* Used in kernel.h and kernel-*.h        */

#if defined(__ksr__) || defined(_SEQUENT_) || defined(sequent) || defined(butterfly) || defined(sgi)
#  if !defined(UNIPROC) && !defined(__PVM__) && !defined(__MPI__)
#    define _SMRTS_        /* Shared Memory RunTime System */
#  endif
#endif

/* For Awesime, these are C++ functions,  */
/* for others these are C functions       */

#if !defined(_AWE_)
  extern "C" {
#endif

/* Following are used in both kernel.h    */
/* and kernel-*.h                         */

  extern  int GetNumberOfCollection();
  extern  void IncNumberOfCollection();
  extern  void SetNextCollectionTraversalLevel(char *addr);
  extern  char *GetCollectionTraversalLevel();
  extern  void DecCollectionTraversalLevel();
  extern  void ResetCollectionTraversalLevel();
  extern  int pcxx_ScanBcast(char *, ...);
#if defined(_AWE_) 
  extern  int _pcxx_Barrier();
  extern  int QGridToProc(unsigned i, unsigned j, int M);
  extern  void pcxx_Message(char *st, int flag);
//  extern  void AskForRemoteExecute(int CollectionNumber,int element_index,
//				   int function_number,char *arg_buffer,
//				   int size,long tag_location);
#else
  extern  int QGridToProc(...);
#endif

/* Following are used only in kernel-*.h and the GENERAL part of kernel.h */

#if defined(_AWE_) 
  extern void AweAllocElemSpace (int thread_id, int size);
  extern void *AweGetElemSpacePtr (int thread_id);
  extern void AweDealloc(void *ptr);
#endif

#ifdef _SMRTS_
  extern void SMRTSAllocElemSpace (int proc, int size);
  extern void *SMRTSGetElemSpacePtr (int proc);
  extern void SMRTSDealloc (void *ptr);
  extern int SMRTSNewProc(int);
#endif

# if defined(_SEQUENT_) || defined(sequent)
  extern char * shmalloc(unsigned);
  extern shfree(void *);
  /* define these functions so that other C programs can call them */
# endif

# if defined(sgi) && defined(_SMRTS_)
  extern void SMRTSWaitToEnd();
  extern int SharedHandle;
  extern int * usmalloc(int size, int handle);
  extern usfree(void *, int handle);
# endif

# ifdef butterfly
  extern void free(char *);
  /* define these functions so that other C programs can call them */
# endif

# ifdef __ksr__
  extern void *malloc(unsigned long);
  extern void free(void *);
  extern  int SpecialSyncbarrier();
  /* define these functions so that other C programs can call them */
# endif

#if !defined(_AWE_)
}
#endif

extern "C" {
  int pcxx_open(char *path, int flags, int mode);
  int pcxx_close(int fd);   
  long pcxx_lseek(int fd, long offset, int whence);   
  long int pcxx_tell(int fd);
  int pcxx_pipe(int fd[2]);
  int pcxx_read(int fd, char *buf, int nbytes);
  int pcxx_write(int fd, char *buf, int nbytes);
  int pcxx_fclose(FILE *stream);
  int pcxx_fflush(FILE *stream);
  int pcxx_ferror(FILE *stream);
  int pcxx_feof(FILE *stream);
  void pcxx_clearerr(FILE *stream);
  int pcxx_fileno(FILE *stream);
  FILE *pcxx_fopen(char *filename, char *type);
  FILE *pcxx_freopen(char *filename, char *type, FILE *stream);
  FILE *pcxx_fdopen(int fd, char *type);
  int pcxx_fread(char *ptr, int size, int nitems, FILE* stream);
  int pcxx_fwrite(char *ptr, int size, int nitems, FILE* stream);
  int pcxx_fseek(FILE *stream, long offset, int ptrname); 
  long int pcxx_ftell(FILE *stream);
  void pcxx_rewind(FILE *stream);
  int pcxx_getc(FILE *stream);
  int pcxx_getchar();
  int pcxx_fgetc(FILE *stream);
  int pcxx_getw(FILE *stream);
  char *pcxx_gets(char *s);
  char *pcxx_fgets(char *s, int n, FILE *stream);
  FILE *pcxx_popen(char *command, char *type);
  int pcxx_pclose(FILE* stream);
  int pcxx_printf(char * format, ...);
  int pcxx_fprintf(FILE * stream, char * format, ...);
  int pcxx_putc(char c, FILE *stream);
  int pcxx_putchar(char c);
  int pcxx_fputc(char c, FILE *stream);
  int pcxx_putw(int w, FILE *stream);
  int pcxx_puts(char *s);
  int pcxx_fputs(char *s, FILE *stream);
  void pcxx_setbuf(FILE *stream, char *buf);
  void pcxx_setbuffer(FILE *stream, char *buf, int size);
  int pcxx_setlinebuf(FILE *stream);
  int pcxx_setvbuf(FILE *stream, char *buf, int type,int size);
  FILE *pcxx_tmpfile();
  char *pcxx_tmpnam (char *s);
  char *pcxx_tempnam (char *dir, char * pfx);
  int pcxx_ungetc(int c, FILE *stream);
/*  int pcxx_system(char *s);*/
}
# include "pcxx_timers.h"
