/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993,1995             */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/


# include <stdio.h>

# if defined(_SEQUENT_) || defined(sequent)
    extern char * shmalloc(unsigned);
    extern shfree(void *);
#   define tulip_SharedMalloc(size) shmalloc(size)
#   define tulip_SharedFree(ptr) shfree(ptr)
#   if defined(sequent)
      typedef int size_t;
      shared int *shd_int;
#   else
#     pragma sequent_shared
      int *shd_int;
#     pragma sequent_shared_end
#   endif
# endif

# if defined(sgi)
    extern void SMRTSWaitToEnd();
    extern int SharedHandle;
    extern int * usmalloc(int size, int handle);
    extern usfree(void *, int handle);
#   define tulip_SharedMalloc(size) usmalloc(size,SharedHandle)
#   define tulip_SharedFree(ptr) usfree(ptr,SharedHandle)
    int *shd_int;
# else
#   define  SMRTSWaitToEnd()
# endif

# ifdef butterfly
    extern void free(char *);
#   define tulip_SharedMalloc(size) malloc(size)
#   define tulip_SharedFree(ptr) free((char *) ptr)
    shared int *shd_int;
# endif

# ifdef __ksr__
    extern void *malloc(unsigned long);
    extern void free(void *);
#   define tulip_SharedMalloc(size) malloc(size)
#   define tulip_SharedFree(ptr) free(ptr)
    int *shd_int;
# else
#   define __private
# endif

typedef struct
{
  int numproc;
}
pcxx_PARAM_t;

pcxx_PARAM_t pcxx_param;

void Message (st, flag)
char *st;
int flag;
{
  printf ("Message: %s\n", st);
}

void pcxx_InitClocks () {}

extern int  MyTotalNodes;
__private extern int  MyNodeNumber;

int pcxx_TotalNodes() { return(MyTotalNodes); }

int pcxx_NodeNumber() { return(MyNodeNumber); }

Processor_Main ()
{
  int *x;

  if ( pcxx_NodeNumber() == 0 ) {
    *shd_int = 42;
  }
  pcxx_Barrier();
  printf ("[1] hello from %2d of %d\n", pcxx_NodeNumber(), pcxx_TotalNodes());
  pcxx_Barrier();
  printf ("[2] hello from %2d of %d (magic = %d)\n", pcxx_NodeNumber(),
          pcxx_TotalNodes(), *shd_int);
  pcxx_Barrier();
  if ( pcxx_NodeNumber() == 0 ) {
    tulip_SharedFree (shd_int);
  }
}

New_Main (id)
void *id;
{
  SMRTSNewProc((int) id);
  Processor_Main();
  SMRTSWaitToEnd();
}

main (argc, argv)
int argc;
char **argv;
{
  pcxx_param.numproc = 4;
  SMRTSSetup ();
  shd_int = (int *) tulip_SharedMalloc (sizeof(int));
  SMRTSFork (argc, argv);
}
