/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993,1995             */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/


#define WARNING 0
#define FATAL 1

/* This should NOT be defined here, but makes us backwards compatible */
/* until I get all the target stuff eliminated with the new tulip stuff */
#define TULIP_FATAL 1
#define TULIP_WARNING 0

#ifdef _MASTER_SLAVE_
#  define MAXPARAL 1
#else 
#  define MAXPARAL 10
#endif

#define BLOCK 1
#define CYCLIC 2
#define WHOLE 3
#define QBLOCK 4

/* Define _SMRTS_ */
#include "pcxx_machines.h"

struct INFO_HEAD {
  int    LocalTraversalCount;
  char   *CurrentCollectionTraversal;
  int    type;
  int    number_dimension;
  int    element_size;
  int    nb_element;
  int    dim1size, dim2size, dim3size;
  int    **Table; /* temporary */
  int    *Where; /* temporary */
};

typedef struct INFO_HEAD *PTR_INFO;

typedef struct
{
  int numproc;

#ifdef TRACING_ON
  int eventclass;
  char *tracefile;
#endif

#ifdef _MASTER_SLAVE_
  int numcpus;
  int shmemsize;
  int stacksize;
#endif

#ifdef BRKPNT_ON
  int SocketNum;
  int ControlSocketNum;
  char *HostAddr;
#endif
}
pcxx_PARAM_t;

