//  ----------------------------------
//  Darryl Brown
//  University of Oregon pC++/Sage++
//
//  TIbasics.h
//
//  
//  ----------------------------------


#ifdef TYPE_DESCR_BASICS_INC 

// already included, do nothing

#else 

#define TYPE_DESCR_BASICS_INC

// derived from brk_basePtr...;
class brk_myStr : public brk_basePtr {
 public:
  char *ing;
  brk_myStr(char *st);
  virtual void printToBuf(char *);
  virtual void printToBuf(int, char *);
  virtual void print();
  virtual void print(int);
  virtual void print(int, FILE *);
  virtual void print(FILE *fptr);
};

  
// a class for representing a particluar composite data structure
// such as a struct, class, or collection.;
class brk_aComposite : public brk_linkedList {
 public:
  char *elementType;
  char *name;
  int thisType;
  int hasPointer;
  brk_linkedList * superClasses;
  void (*accessFunc)(void * objPtr, int elemNum, char *fname);
  brk_aComposite(char * aName);
  brk_aComposite();
  brk_aComposite(char * aName, int t);
  virtual void push(brk_basePtr *h);
  virtual void printToBuf(int, char *);
  virtual void print();
  virtual void print(int tabs);
  virtual void print(int tabs, FILE *fptr);
  virtual int compare(brk_basePtr *);
  virtual int compare(brk_ptrNode *);
};

//  List which keeps track of composite data structures
//    such as structs, classes, unions and collections.
class brk_compositeList : public brk_linkedList {
 public:
  char *elementType;
  virtual void printToBuf(int, char *);
  virtual void print();
  virtual void print(int tabs);
  virtual void print(int tabs, FILE *fptr);
  brk_compositeList();
  brk_compositeList(char *);
  brk_aComposite * findMember(brk_aComposite *n);
};


// a class for specifying a type ;
class brk_basicAType : public brk_basePtr {
 public:
  int thisType;
  // if a composite, this contains the composite name,;
  // if other types, this could contain modifiers.
  char *description;
  int mt;
  // this value can be used for array dimensions,  ;
  // or other descriptive items.  ;
  int accessory;
  
  // accessable functions;
  virtual void printToBuf(int, char *);
  virtual void print();
  virtual void print(int tabs);
  virtual void print(int tabs, FILE *fptr);
  brk_basicAType();
  brk_basicAType(char *desc, int ty);
};

// a class for specifying a type ;
class brk_basicPType : public brk_basicAType  {
 public:
  // the type of the elements stored int the pointer;
  brk_basicAType *baseType;
  // an array of sizes for each dimension;
  int *sizes;
  int totalSize;
  // the number of dimensions if it is an array..;
  int dimensions;
  brk_basicPType(brk_basicAType *baseType, int ty);
  brk_basicPType();
  brk_basicPType(char *desc, int ty);
  virtual void printToBuf(int, char *);
  virtual void print();
  virtual void print(int tabs);
  virtual void print(int tabs, FILE *fptr);
  char  *(*accessFunc)(void  *objPtr, int elemNum);
};

// a class for representing a field withing a composite data;
// structure.;
class brk_aField : public brk_basePtr {
 public:
  brk_basicAType *fieldType;
  char *name;
  brk_aField(brk_basicAType *f, char *n);
  brk_aField();
  virtual void printToBuf(int, char *);
  virtual void print();
  virtual void print(int tabs);
  virtual void print(int tabs, FILE *fptr);
};



//  ----------------------------------
// declare lists for keeping track of differrent types of 
// composite data structures.

extern brk_compositeList *brk_classLIST;
extern brk_compositeList *brk_collectionLIST;
extern brk_compositeList *brk_collectionElemLIST;
extern brk_compositeList *brk_elementTypeLIST;
extern brk_compositeList *brk_structLIST;
extern brk_compositeList *brk_unionLIST;


// extern declarations.
extern char * brk_stringSave(char * str);
extern int brk_strsame(char * str, char * str1);
extern void brk_addCollectionWithElem(char *collName, char *elemName);
extern void brk_addElementType(char *elemName);
extern brk_aComposite *brk_lookupComposite(brk_basicAType *cType);
extern char * brk_TItypeToStr (int ty);
extern int brk_TIstrToType(char *s);
extern char * brk_typeToFormat(brk_basicAType *ty);
extern brk_aComposite *brk_findInCompositeList(char *compName, char *elemName, 
				       brk_compositeList *cList);
extern int brk_evalExp(char *expStr);
extern int brk_nonComposite(char *str);
extern void brk_basicInit();
extern void brk_printTIFFile();
extern void brk_readIn();
#endif
