/* --------------------------------------------------
 *
 *  Darryl Brown
 *  
 *  March, 1995
 *
 *  collInst.h
 *  
 *  This file implements the classes that keepn
 *  track of collection instances during runtime of a 
 *  pC++ program.
 *
 * --------------------------------------------------
 */

/* see if this file has already been included; */
#ifndef COLL_INST_HDR
#define COLL_INST_HDR


/*
 *  ----------------------------------------------
 *  CLASSES 
 *  ----------------------------------------------
 */   

// to maintain collectoin instances
class DA_collInstance {

 public:
  virtual void printToBuf( char *buf);
  char *varName;
  char *collName;
  char *elemName;
  int numDims;
  int numElems;
  int sizeElem;
  int collectionId;
  DA_collInstance *next;
  void *collectionPtr;
  int elemIndex(int idx1, int idx2);
  int dim1size;
  int dim2size;
};

/* name list */
class DA_collQueue {
 public:
  DA_collQueue(void);
  virtual void printToBuf(char *buf);
  DA_collInstance *first;
  DA_collInstance *last;
  void push(DA_collInstance *collInst);
  DA_collInstance *pop(void);
  DA_collInstance *getIth(int i);
  int length;
};

/* This points to the queue which names of collection variables are 
 *  placed just before they are created. 
 */
extern DA_collQueue *DA_collDeclQueue;

/* This points to the tables (list) of collection instances and a record 
 * of information about them. 
 */
extern DA_collQueue *DA_collInstanceTable;

#endif
