/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993,1995             */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/


/* Common support routined for EVERY SINGLE KernelCom.c */

#if defined(__ksr__) && ! defined(UNIPROC) && ! defined(_MASTER_SLAVE_)
extern __private int pcxx_inpar;
#else
extern int pcxx_inpar;
#endif

FILE pcxx_dummy;
void pcxx_BroadcastBytes(int, int, void *);
int pcxx_NodeNumber();

/*************************************************************/
/* this is the pC++ stdio lib. */
/*************************************************************/
#include <stdio.h>
#include <stdlib.h>
/* include <varargs.h> */

#if (defined(NeXT) || defined(MIPSEL) || \
     defined(sequent) || defined(_SEQUENT_))
#  include <sys/types.h>
#else
#  include <unistd.h> 
#endif

static char gettype(char **argp){
   char *args;
   char c;
   int found = 0;
    args = *argp;
    while(!found){
	while((*args != '%') && (*args != '\0')) args++;
	if(*args == '%') args++;
	while((*args <= '9') && (*args >= '0')) args++;
        while((*args == 'l') || (*args == 'h')) args++;
	switch(*args){
		case 'd':
		case 'c':
		case 's':
		case 'f':
		case 'e':
		case 'u':
		case 'o':
		case 'x':
		case 'i':
		case 'n':
		case 'g':
		case '[':
 		case '\0':
			c = *args;
			found = 1;
			break;
		default: break;
		}
	}
    *argp = args;
    return c;
}

#define BIT_SHORT     256
#define BIT_LONG      512


int pcxx_ScanBcast(char * args,  ...){
 va_list ap;
 int i, no_of_args;
 int long_short_flag;
 int type_flag, return_val;
 char c;
 int len;
 long int *z1;
 short int *z2;
 float *z4;
 int *z3;
 long double *z5;
 double *z6;
 char * z7;

 va_start(ap, args);
 no_of_args = va_arg(ap, int);
 /* printf("number of args = %d\n", no_of_args); */
 for(i = 0; i < no_of_args; i++){
        /* printf("doing arg%d\n", i); */
	c = gettype(&args);
        /* printf("type = %c\n", c); */
	long_short_flag = va_arg(ap, int);
        type_flag = va_arg(ap, int);
	switch(type_flag){
          /* int values  */
          case 1: if(BIT_LONG & long_short_flag){
		     len = (int) sizeof (long int);
		     z1 = va_arg(ap, long int *);
		     pcxx_BroadcastBytes(pcxx_NodeNumber(), len, (void *) z1);
		     }
                 else if(BIT_SHORT & long_short_flag){
		     len = (int) sizeof(short int);
		     z2 = va_arg(ap, short int *);
		     pcxx_BroadcastBytes(pcxx_NodeNumber(), len, (void *) z2);
		     }
                 else{
		     len = (int) sizeof(int);
		     z3 = va_arg(ap, int *);
		     pcxx_BroadcastBytes(pcxx_NodeNumber(), len, (void *) z3);
	             }
	         break;
	  /* float vals */
          case 2: len = (int) sizeof(float);
	          z4 = va_arg(ap, float *);
	          pcxx_BroadcastBytes(pcxx_NodeNumber(), len, (void *) z4);
	          break;
	  /* double vals */
          case 3: if (BIT_LONG & long_short_flag){
		         len = (int) sizeof (long double);
		         z5 = va_arg(ap, long double *);
		         pcxx_BroadcastBytes(pcxx_NodeNumber(), len, (void *) z5);
			 }
                     else{
		         len = (int) sizeof(double);
		         z6 = va_arg(ap, double *);
		         pcxx_BroadcastBytes(pcxx_NodeNumber(), len, (void *) z6);
			 }
	          break;
	  /* chars and strings */
          case 4: z7 = va_arg(ap, char *);
	         if((c == 's') || (c == '[')){
		     if(pcxx_NodeNumber() == 0){
			len = strlen(z7) +1;
			pcxx_BroadcastBytes(0, (int) sizeof( int), (void *) &len);
			pcxx_BroadcastBytes(0, len, (void *) z7);
			}
	             else{
			pcxx_BroadcastBytes(1, (int) sizeof( int), (void *) &len);
			pcxx_BroadcastBytes(1, len, (void *) z7);
		      }
		    }
	         else{
		    len = (int) sizeof(char);
		    pcxx_BroadcastBytes(pcxx_NodeNumber(), len, (void *) z7);
		    }
	         break;
	  default: printf("error in scanf types\n"); break;
	 }
     }
     return_val = va_arg(ap, int);
     va_end(ap);
     return return_val;
}

int pcxx_open(char *path, int flags, int mode){
  int ret_val;
  if(pcxx_inpar){
	return open(path,flags,mode);
	}
  else   if(pcxx_NodeNumber() == 0){
	ret_val = open(path,flags,mode);
        pcxx_BroadcastBytes(0, (int) sizeof(int), &ret_val);
	}
  else pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val);
  return ret_val;
}  

int pcxx_close(int fd){   
  int ret_val;
  if(pcxx_inpar){
	return close(fd);
	}
  else   if(pcxx_NodeNumber() == 0){
	ret_val = close(fd);
        pcxx_BroadcastBytes(0, (int) sizeof(int), &ret_val);
	}
  else pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val);
  return ret_val;
}  

off_t pcxx_lseek(int fd, off_t offset, int whence) {
  off_t ret_val;
  if(pcxx_inpar){
	return lseek(fd, offset, whence);
	}
  else  if(pcxx_NodeNumber() == 0){
	ret_val = lseek(fd, offset, whence);
        pcxx_BroadcastBytes(0, (int) sizeof(off_t), &ret_val);
	}
  else pcxx_BroadcastBytes(1, (int) sizeof(off_t), &ret_val);
  return ret_val;
}

long pcxx_tell(int fd){
  long ret_val;
  if(pcxx_inpar){
	return tell(fd);
	}
  else if(pcxx_NodeNumber() == 0){
	ret_val = tell(fd);
        pcxx_BroadcastBytes(0, (int) sizeof(long), &ret_val);
	}
  else pcxx_BroadcastBytes(1, (int) sizeof(long), &ret_val);
  return ret_val;
}  

int pcxx_pipe(int fd[2]){
  int ret_val;
  if(pcxx_inpar){
	return pipe(fd);
	}
  else  if(pcxx_NodeNumber() == 0){
	ret_val = pipe(fd);
        pcxx_BroadcastBytes(0, (int) sizeof(int), &ret_val);
	}
  else pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val);
  return ret_val;
}  
   

int pcxx_read(int fd, char *buf, int nbytes){
  int ret_val;
  if(pcxx_inpar){
	return read(fd, buf, nbytes);
	}
  else  if(pcxx_NodeNumber() == 0){
	ret_val = read(fd, buf, nbytes);
        pcxx_BroadcastBytes(0, (int) sizeof(int), &ret_val);
	pcxx_BroadcastBytes(0, ret_val, buf);
	}
  else{
	pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val);
	pcxx_BroadcastBytes(1, ret_val, buf);
	}
  return ret_val;
}  

/*
int pcxx_readv(int fd, struct iovec *iov, int iovcnt){
   if(pcxx_NodeNumber() == 0) printf("readv not yet finished for pcxx_++\n");
   return -1;
}
*/     
int pcxx_write(int fd, char *buf, int nbytes){
  int ret_val;
  if(pcxx_inpar){
	return write(fd, buf, nbytes);
	}
  else if(pcxx_NodeNumber() == 0){
	ret_val = write(fd, buf, nbytes);
	pcxx_BroadcastBytes(0, (int) sizeof(int), &ret_val);
	}
  else{
	pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val);
	}
  return ret_val;
}

/*
int pcxx_writev(int fd, struct iovec *iov, int iovcnt){
   if(pcxx_NodeNumber() == 0) printf("writev not yet finished for pcxx_++\n");
   return -1;
}
*/


int pcxx_fclose(FILE *stream){
  if(pcxx_inpar){
	return fclose(stream);
	}
  else  if(pcxx_NodeNumber() == 0) return fclose(stream);
  else return 0;
} 
int pcxx_fflush(FILE *stream){
  if(pcxx_inpar){
	return fflush(stream);
	}
  else  if(pcxx_NodeNumber() == 0) return fflush(stream);
  else return 0;
} 

int pcxx_ferror(FILE *stream){
  int ret_val;
  if(pcxx_inpar){
	return ferror(stream);
	}
  else   if(pcxx_NodeNumber() == 0){
	ret_val = ferror(stream);
        pcxx_BroadcastBytes(0, (int) sizeof(int), &ret_val);
	}
  else pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val);
  return ret_val;
}  

int pcxx_feof(FILE *stream){
  int ret_val;
  if(pcxx_inpar){
	return feof(stream);
	}
  else   if(pcxx_NodeNumber() == 0){
	ret_val = feof(stream);
        pcxx_BroadcastBytes(0, (int) sizeof(int), &ret_val);
	}
  else pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val);
  return ret_val;
}

void pcxx_clearerr(FILE *stream){
  /* int ret_val; */
  if(pcxx_inpar){
	clearerr(stream);
	}
  else   if(pcxx_NodeNumber() == 0){
	clearerr(stream);
        /* pcxx_BroadcastBytes(0, (int) sizeof(int), &ret_val); */
	}
 /* else pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val); */
 /* return ret_val; */
}  
  
int pcxx_fileno(FILE *stream){
  int ret_val;
  if(pcxx_inpar){
	return fileno(stream);
	}
  else    if(pcxx_NodeNumber() == 0){
	ret_val = fileno(stream);
        pcxx_BroadcastBytes(0, (int) sizeof(int), &ret_val);
	}
  else pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val);
  return ret_val;
}  

/* note: f functions are allowed only in the sequential section.
// you can do printf from a processor environment thread but not
// an fprintf.  the reason for this is that we need a standardized
// parallel io form if we are to do real parallel io. 
*/
FILE *pcxx_fopen(char *filename, char *type){
  if(pcxx_inpar){
	return fopen(filename, type);
	}
  else   if(pcxx_NodeNumber() == 0)
	return fopen(filename, type);
  else return &pcxx_dummy;
}

FILE *pcxx_freopen(char *filename, char *type, FILE *stream){
  if(pcxx_inpar){
	return freopen(filename, type, stream);
	}
  else    if(pcxx_NodeNumber() == 0)
      return freopen(filename, type, stream);
  else return &pcxx_dummy;
}

FILE *pcxx_fdopen(int fd, char *type){
  if(pcxx_inpar){
	return (FILE *)fdopen(fd, type);
	}
  else  if(pcxx_NodeNumber() == 0)
      return (FILE *)fdopen(fd, type);
  else return &pcxx_dummy;
}

     
int pcxx_fread(char *ptr, int size, int nitems, FILE* stream){
  int ret_val;
  if(pcxx_inpar){
             return fread(ptr, size, nitems, stream);
	}
  else  if(pcxx_NodeNumber() == 0){
	ret_val = fread(ptr, size, nitems, stream);
        pcxx_BroadcastBytes(0, (int) sizeof(int), &ret_val);
	pcxx_BroadcastBytes(0, ret_val*size, ptr);
	}
  else{
	pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val);
	pcxx_BroadcastBytes(1, ret_val*size, ptr);
	}
  return ret_val;
}  
	   
int pcxx_fwrite(char *ptr, int size, int nitems, FILE* stream){
  int ret_val;
  if(pcxx_inpar){
             return fwrite(ptr, size, nitems, stream);
	}
  else   if(pcxx_NodeNumber() == 0){
	ret_val = fwrite(ptr, size, nitems, stream);
	pcxx_BroadcastBytes(0, (int) sizeof(int), &ret_val);
	}
  else{
	pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val);
	}
  return ret_val;
}

int pcxx_fseek(FILE *stream, long offset, int ptrname){ 
  int ret_val;
  if(pcxx_inpar){
             return fseek(stream, offset, ptrname);
	}
  else   if(pcxx_NodeNumber() == 0){ 
	ret_val = fseek(stream, offset, ptrname);
	pcxx_BroadcastBytes(0, (int) sizeof(int), &ret_val);
	}
  else{
	pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val);
	}
  return ret_val;
}

long pcxx_ftell(FILE *stream){
  int ret_val;
  if(pcxx_inpar){
             return ftell(stream);
	}
  else    if(pcxx_NodeNumber() == 0){ 
	ret_val = ftell(stream);
	pcxx_BroadcastBytes(0, (int) sizeof(int), &ret_val);
	}
  else{
	pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val);
	}
  return ret_val;
}

void pcxx_rewind(FILE *stream){
  /*int ret_val;*/
  if(pcxx_inpar){
             rewind(stream);
	}
  else   if(pcxx_NodeNumber() == 0){ 
	rewind(stream);
	/* pcxx_BroadcastBytes(0, (int) sizeof(int), &ret_val); */
	}
  else{
	/* pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val); */
	}
}

int pcxx_getc(FILE *stream){
  int ret_val;
  if(pcxx_inpar){
             return getc(stream);
	}
  else    if(pcxx_NodeNumber() == 0){ 
	ret_val = getc(stream);
	pcxx_BroadcastBytes(0, (int) sizeof(int), &ret_val);
	}
  else{
	pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val);
	}
  return ret_val;
}

int pcxx_getchar(){
  int ret_val;
  if(pcxx_inpar){
             return getchar();
	}
  else   if(pcxx_NodeNumber() == 0){ 
	ret_val = getchar();
	pcxx_BroadcastBytes(0, (int) sizeof(int), &ret_val);
	}
  else{
	pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val);
	}
  return ret_val;
}

int pcxx_fgetc(FILE *stream){
  int ret_val;
  if(pcxx_inpar){
             return fgetc(stream);
	}
  else   if(pcxx_NodeNumber() == 0){ 
	ret_val = fgetc(stream);
	pcxx_BroadcastBytes(0, (int) sizeof(int), &ret_val);
	}
  else{
	pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val);
	}
  return ret_val;
}

int pcxx_getw(FILE *stream){
  int ret_val;
  if(pcxx_inpar){
             return getw(stream);
	}
  else   if(pcxx_NodeNumber() == 0){ 
	ret_val = getw(stream);
	pcxx_BroadcastBytes(0, (int) sizeof(int), &ret_val);
	}
  else{
	pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val);
	}
  return ret_val;
}

char *pcxx_gets(char *s){
  int len;
  char *c;
  if(pcxx_inpar){
             return gets(s);
	}
  else  if(pcxx_NodeNumber() == 0){
	c = gets(s);
	len = strlen(s);
        pcxx_BroadcastBytes(0, (int) sizeof(int), &len);
	pcxx_BroadcastBytes(0, len, s);
	}
  else{
	pcxx_BroadcastBytes(1, (int) sizeof(int), &len);
	pcxx_BroadcastBytes(1, len, s);
	}
  return s;
}  

char *pcxx_fgets(char *s, int n, FILE *stream){
  int len;
  char *c;
  if(pcxx_inpar){
             return fgets(s, n, stream);
	}
  else  if(pcxx_NodeNumber() == 0){
	c = fgets(s, n, stream);
	len = strlen(s);
        pcxx_BroadcastBytes(0, (int) sizeof(int), &len);
	pcxx_BroadcastBytes(0, len, s);
	}
  else{
	pcxx_BroadcastBytes(1, (int) sizeof(int), &len);
	pcxx_BroadcastBytes(1, len, s);
	}
  return s;
}  
     
FILE *pcxx_popen(char *command, char *type){
  if(pcxx_inpar){
             return (FILE *)popen(command, type);
	}
  else   if(pcxx_NodeNumber() == 0) return (FILE *) popen(command, type);
   else return &pcxx_dummy;
}

int pcxx_pclose(FILE* stream){
  int ret_val;
  if(pcxx_inpar){
             return pclose(stream);
	}
  else    if(pcxx_NodeNumber() == 0){ 
	ret_val = pclose(stream);
	pcxx_BroadcastBytes(0, (int) sizeof(int), &ret_val);
	}
  else{
	pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val);
	}
  return ret_val;
}   


int pcxx_printf(char * format, ...){
  int ret_val;
  va_list args;
  va_start(args, format);
  
  if(pcxx_inpar){
	return vprintf(format, args);
	}
  else if(pcxx_NodeNumber() == 0){
	ret_val = vprintf(format, args);
	pcxx_BroadcastBytes(0, (int) sizeof(int) , &ret_val);
	}
  else{
	pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val);
	}
  va_end(args);
  return ret_val;
}

/* fprintf called by a pC++ program is converted to pcxx_printf... Different
   special code is generated depending on whether the call is in a parallel
   or a sequential section. 
int pcxx_fprintf(FILE * stream, char * format, ...){
  int ret_val;
  va_list args;
  va_start(args, format);
  
  if(pcxx_inpar){
	return vfprintf(stream, format, args);
	}
  else  if(pcxx_NodeNumber() == 0){
	ret_val = vfprintf(stream, format, args);
	pcxx_BroadcastBytes(0, (int) sizeof(int), &ret_val);
	}
  else{
	pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val);
	}
  va_end(args);
  return ret_val;
}
*/

int pcxx_putc(char c, FILE *stream){
  int ret_val;
  if(pcxx_inpar){
	return  putc(c, stream);
	}
  else    if(pcxx_NodeNumber() == 0){ 
	ret_val = putc(c, stream);
	pcxx_BroadcastBytes(0, (int) sizeof(int), &ret_val);
	}
  else{
	pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val);
	}
  return ret_val;
}

int pcxx_putchar(char c){
  int ret_val;
  if(pcxx_inpar){
	return   putchar(c);
	}
  else   if(pcxx_NodeNumber() == 0){ 
	ret_val = putchar(c);
	pcxx_BroadcastBytes(0, (int) sizeof(int), &ret_val);
	}
  else{
	pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val);
	}
  return ret_val;
}

int pcxx_fputc(char c, FILE *stream){
  int ret_val;
  if(pcxx_inpar){
	return   fputc(c, stream);
	}
  else   if(pcxx_NodeNumber() == 0){ 
	ret_val = fputc(c, stream);
	pcxx_BroadcastBytes(0, (int) sizeof(int), &ret_val);
	}
  else{
	pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val);
	}
  return ret_val;
}

int pcxx_putw(int w, FILE *stream){
  int ret_val;
  if(pcxx_inpar){
	return   putw(w,stream);
	}
  else   if(pcxx_NodeNumber() == 0){ 
	ret_val = putw(w,stream);
	pcxx_BroadcastBytes(0, (int) sizeof(int), &ret_val);
	}
  else{
	pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val);
	}
  return ret_val;
}

int pcxx_puts(char *s){
  int ret_val;
  if(pcxx_inpar){
	return   puts(s);
	}
  else   if(pcxx_NodeNumber() == 0){ 
	ret_val = puts(s);
	pcxx_BroadcastBytes(0, (int) sizeof(int), &ret_val);
	}
  else{
	pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val);
	}
  return ret_val;
}

int pcxx_fputs(char *s, FILE *stream){
  int ret_val;
  if(pcxx_inpar){
	return  fputs(s,stream);
	}
  else   if(pcxx_NodeNumber() == 0){ 
	ret_val = fputs(s,stream);
	pcxx_BroadcastBytes(0, (int) sizeof(int), &ret_val);
	}
  else{
	pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val);
	}
  return ret_val;
}
     

void pcxx_setbuf(FILE *stream, char *buf){
  if(pcxx_inpar){
	setbuf(stream, buf);
	}
  else  if(pcxx_NodeNumber() == 0)
   setbuf(stream, buf);
}

#if 0
void pcxx_setbuffer(FILE *stream, char *buf, int size){
  if(pcxx_inpar){
	setbuffer(stream, buf, size);
	}
  else    if(pcxx_NodeNumber() == 0)
	setbuffer(stream, buf, size);
}

int pcxx_setlinebuf(FILE *stream){
  int ret_val;
  if(pcxx_inpar){
	setlinebuf(stream);
        return 0;
	}
  else   if(pcxx_NodeNumber() == 0){ 
	setlinebuf(stream);
	/* pcxx_BroadcastBytes(0, (int) sizeof(int), &ret_val); */
	}
  else{
	/* pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val); */
	}
  return 0;
}
#endif

#ifndef sequent
int pcxx_setvbuf(FILE *stream, char *buf, int type,int size){
  int ret_val;
  if(pcxx_inpar){
	return  setvbuf(stream, buf, type, size);
	}
  else    if(pcxx_NodeNumber() == 0){ 
	ret_val = setvbuf(stream, buf, type, size);
	pcxx_BroadcastBytes(0, (int) sizeof(int), &ret_val);
	}
  else{
	pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val);
	}
  return ret_val;
}

FILE *pcxx_tmpfile(){
  if(pcxx_inpar){
	return  tmpfile();
	}
  else   if(pcxx_NodeNumber() == 0) return tmpfile();
   else return &pcxx_dummy;
}
#endif

#if 0
static char pcxx_tempbuffer[L_tmpnam+32];
char *pcxx_tmpnam (char *s){
  int len;
  char *c;
  if(pcxx_inpar){
	return  tmpnam (s);
	}
  else  if(pcxx_NodeNumber() == 0){
	if(s) c = tmpnam (s);
	else c = tmpnam(pcxx_tempbuffer);
	len = strlen(c);
        pcxx_BroadcastBytes(0, (int) sizeof(int), &len);
	pcxx_BroadcastBytes(0, len, c);
	}
  else{
	pcxx_BroadcastBytes(1, (int) sizeof(int), &len);
	pcxx_BroadcastBytes(1, len, &(pcxx_tempbuffer[0]));
	c = &(pcxx_tempbuffer[0]);
	}
  return c;
}  
#endif

int pcxx_ungetc(int c, FILE *stream){
  int ret_val;
  if(pcxx_inpar){
	return  ungetc(c, stream);
	}
  else    if(pcxx_NodeNumber() == 0){ 
	ret_val = ungetc(c, stream);
	pcxx_BroadcastBytes(0, (int) sizeof(int), &ret_val);
	}
  else{
	pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val);
	}
  return ret_val;
}

pcxx_system(char *s){
  int ret_val;
  if(pcxx_inpar){
	return  system(s);
	}
  else    if(pcxx_NodeNumber() == 0){ 
	ret_val = system(s);
	pcxx_BroadcastBytes(0, (int) sizeof(int), &ret_val);
	}
  else{
	pcxx_BroadcastBytes(1, (int) sizeof(int), &ret_val);
	}
  return ret_val;
}

/*************************************************************/
/* Simple bit shuffle for quadtree numbering to 2d grid (PHB) */
/*************************************************************/
unsigned long BitShuffle(p,q)
  unsigned long p,q;
{
unsigned long x,y,z;
int i,bit1,bit2;

/* Mask off high 16 bits, they are out of range... */
x = (1<<16)-1 & p;
y = (1<<16)-1 & q;

if ((x != p) || (y != q))
     Message("Error, BitShuffle() parm too big, must be <= 16 bits\n",FATAL);

/* Shuffle-d-bits */
z = 0;
for (i=15; i>=0; i--)
  {
  bit1 = (x >> i) & 1;
  bit2 = (y >> i) & 1;
  z = (z << 2) | (bit1 << 1) | (bit2 << 0);
  }

return z;
}  
  

/*************************************************************/
/* Simple bit shuffle for quadtree numbering to 2d grid (PHB) */
/*************************************************************/
void BitUnshuffle(p,q,x)
  unsigned long *p, *q, x;
  {
int i,bit1,bit2;

*p = 0;
*q = 0;
for (i=31; i>=1; i=i-2)
  { 
  bit1 = (x >> i)     & 1;
  bit2 = (x >> (i-1)) & 1;
  *p = (*p << 1) | bit1;
  *q = (*q << 1) | bit2;
}
}


/*************************************************************/
/* Maps (i,j) elements in grid to linear number (x) by blocks (PHB) */
/*************************************************************/
int QGridToProc( i, j, M)
  unsigned i,j;
  int M;
{
unsigned long jprime, block;
int procnum;

jprime = j % (unsigned long) M;
block = j / (unsigned long) M;

procnum = (int) ((unsigned long) M * (unsigned long) M * block + 
                     BitShuffle(i,jprime));
return procnum;
}


