/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993,1995             */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/

#ifndef __wchar_t
typedef int __wchar_t;
#endif

#ifdef CM5
# include <cm/cmmd.h>
#endif

#include "pcxx_events_def.h"

/* C library functions used by the Kernel; */
/* Used in kernel.h and kernel-*.h         */

/* Functions provided by the various      */
/* Runtime Systems to the Kernel;         */
/* Used in kernel.h and kernel-*.h        */

/* Define _SMRTS_ */
#include "pcxx_machines.h"

extern "C" {

/* Following are used in both kernel.h    */
/* and kernel-*.h                         */

  extern  int IamtheManager(int i);
  extern  void SetTableOfCollection(int num, char * addr);
  extern  int GetNumberOfCollection();
  extern  void IncNumberOfCollection();
  extern  void SetNextCollectionTraversalLevel(char *addr);
  extern  char *GetCollectionTraversalLevel();
  extern  void DecCollectionTraversalLevel();
  extern  void ResetCollectionTraversalLevel();

  extern  int pcxx_TotalNodes();
  extern  int pcxx_NodeNumber();
  extern  void pcxx_MainBegin(...);
  extern  void pcxx_MainEnd();
  extern  void pcxx_Poll(); 

  extern  void pcxx_BroadcastBytes(int source,int size,void *buffer);
  extern  void pcxx_NativeBroadcastBytes(int source,int size,void *buffer);
  extern  void pcxx_AlienBroadcastBytes(int source,int size,void *buffer);
  extern  void pcxx_ReduceDoubleAdd(void *,int);
  extern  void pcxx_AlienReduceDoubleAdd(void *,int);
  extern  void pcxx_NativeReduceDoubleAdd(void *,int);

  extern  int pcxx_ScanBcast(char *, ...);
  extern  void pcxx_Abort();

  extern  int pcxx_Barrier();
  extern  int QGridToProc(...);
  extern  int WhereIsData(...);
  extern  int AskForDataBlock(...);
  extern  void Message(...);
  extern  void AskForRemoteExecute(int CollectionNumber,int element_index,
				   int function_number,char *arg_buffer,
				   int size,long tag_location);

/* Following are used only in kernel-*.h and the GENERAL part of kernel.h */

#ifdef _SMRTS_
  extern void SMRTSDealloc (void *ptr);
  extern int SMRTSNewProc(int);

# define pcxx_Poll() 

# if defined(_SEQUENT_) || defined(sequent)
    extern char * shmalloc(unsigned);
    extern shfree(void *);
#   define tulip_SharedMalloc(size) shmalloc(size)
#   define tulip_SharedFree(ptr) shfree(ptr)
#   if defined(sequent)
      typedef int size_t;
#   endif
# endif

# if defined(sgi) && !defined(_MASTER_SLAVE_)
    extern void SMRTSWaitToEnd();
    extern int SharedHandle;
    /* tulip_SharedMalloc and tulip_SharedFree are defined in sgilib.c where they belong */
    extern char* tulip_SharedMalloc(int);
    extern void  tulip_SharedFree(void *p);
# endif

# if defined(sgi) && defined(_MASTER_SLAVE_)
    extern void *malloc(size_t size);
    extern void free(void *);
# endif

# ifdef butterfly
    extern void free(char *);
#   define tulip_SharedMalloc(size) malloc(size)
#   define tulip_SharedFree(ptr) free((char *) ptr)
# endif

# ifdef __ksr__
    extern void *malloc(unsigned long);
    extern void free(void *);
    extern  int SpecialSyncbarrier();
#   define tulip_SharedMalloc(size) malloc(size)
#   define tulip_SharedFree(ptr) free(ptr)
# endif

/*# ifndef tulip_SharedMalloc
    error: you should define it
# endif*/

#endif

}

extern "C" {
  /* int pcxx_ScanBcast(char * args,  ...); */
  int pcxx_open(char *path, int flags, int mode);
  int pcxx_close(int fd);   
  long pcxx_lseek(int fd, long offset, int whence);   
  long int pcxx_tell(int fd);
  int pcxx_pipe(int fd[2]);
  int pcxx_read(int fd, char *buf, int nbytes);
  int pcxx_write(int fd, char *buf, int nbytes);
  int pcxx_fclose(FILE *stream);
  int pcxx_fflush(FILE *stream);
  int pcxx_ferror(FILE *stream);
  int pcxx_feof(FILE *stream);
  void pcxx_clearerr(FILE *stream);
  int pcxx_fileno(FILE *stream);
  FILE *pcxx_fopen(char *filename, char *type);
  FILE *pcxx_freopen(char *filename, char *type, FILE *stream);
  FILE *pcxx_fdopen(int fd, char *type);
  int pcxx_fread(char *ptr, int size, int nitems, FILE* stream);
  int pcxx_fwrite(char *ptr, int size, int nitems, FILE* stream);
  int pcxx_fseek(FILE *stream, long offset, int ptrname); 
  long int pcxx_ftell(FILE *stream);
  void pcxx_rewind(FILE *stream);
  int pcxx_getc(FILE *stream);
  int pcxx_getchar();
  int pcxx_fgetc(FILE *stream);
  int pcxx_getw(FILE *stream);
  char *pcxx_gets(char *s);
  char *pcxx_fgets(char *s, int n, FILE *stream);
  FILE *pcxx_popen(char *command, char *type);
  int pcxx_pclose(FILE* stream);
  int pcxx_printf(char * format, ...);
  int pcxx_fprintf(FILE * stream, char * format, ...);
  int pcxx_putc(char c, FILE *stream);
  int pcxx_putchar(char c);
  int pcxx_fputc(char c, FILE *stream);
  int pcxx_putw(int w, FILE *stream);
  int pcxx_puts(char *s);
  int pcxx_fputs(char *s, FILE *stream);
  void pcxx_setbuf(FILE *stream, char *buf);
  void pcxx_setbuffer(FILE *stream, char *buf, int size);
  int pcxx_setlinebuf(FILE *stream);
  int pcxx_setvbuf(FILE *stream, char *buf, int type,int size);
  FILE *pcxx_tmpfile();
  char *pcxx_tmpnam (char *s);
  char *pcxx_tempnam (char *dir, char * pfx);
  int pcxx_ungetc(int c, FILE *stream);
/*  int pcxx_system(char *s);*/
}
# include "pcxx_timers.h"

#ifdef _MASTER_SLAVE_
    extern void pcaw_EnterPar(class Kernel *, int);
    extern void pcaw_SubsetEnterPar(class Kernel *, int);
    extern void pcaw_ExitPar();
    extern "C" int IamtheMainThread();
#endif

