/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993,1995             */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/


#include <stdio.h>			/* standard I/O */
#include <parallel/microtask.h>		/* microtasking */
#include <parallel/parallel.h>		/* parallel utilities */
#include <usclkc.h>

# pragma sequent_shared
  sbarrier_t Barr;
# pragma sequent_shared_end

void btest()
{
  int i; unsigned long t1, t2, c, sum;

  usclk_init ();
  t1 = GETUSCLK();
  t2 = GETUSCLK();
  c = t1 - t2;

  for (i=0; i<100000; i++) {
    s_wait_barrier(&Barr);
    t1 = GETUSCLK();
    s_wait_barrier(&Barr);
    t2 = GETUSCLK();
    sum += t2 - t1 - c;
  }
  printf ("%lu\n", sum / 100000);
}

main(argc, argv)
int argc; char **argv;
{
  m_set_procs(atoi(argv[1]));
  s_init_barrier(&Barr, atoi(argv[1]));
  m_fork(btest);
  m_kill_procs();
  exit(0);
}
