/*
 *	(C) Copyright 1990
 *
 *	   The Regents of the University of California
 *			All Rights Reserved.
 *
 *	This work was produced under the sponsorship of
 *	the U.S. Department of Energy.   The Government
 *	retains certains rights therein.
 *
 *
 *	                             Notice
 *	This computer code material was prepared as an  account  of  work
 *	sponsored  by  the  United States Government.  Neither the United
 *	States nor the United States Department of  Energy,  nor  any  of
 *	their employees, nor any of their contractors, subcontractors, or
 *	their employees, makes any warranty, express or implied,  or  as-
 *	sumes  any  legal  liability  or responsibility for the accuracy,
 *	completeness or usefulness of any information, apparatus, product
 *	or  process  disclosed,  or represents that its use would not in-
 *	fringe privately-owned rights.
 *
 */

/*
 * the hard limit for the number of processors allowable in the "switchgen"
 * version of the barrier statement.
 */
#define _SWITCHGEN_MAXNPROCS	32

/*
 * The hard limit for team descriptor numbers for barrier.
 */
#define _PXP_HARD_MAXTDESC 1024

/*
 * The max number of processors we can handle
 */
#define _MAXNPROCS	128

/*
 * The pcp teamstate block
 */
extern int MyTotalNodes;
extern int MyNodeNumber;
extern int _TSIZE;
extern int _TDESC;
extern int _TINDEX;
extern int _CMPTDESC;


/* call waitspin with the number of 10usec loops you want to do */

#define instrs_per_ten_usec	45
#define waitspin(spintime) { register unsigned long usecs = (spintime) * \
						   instrs_per_ten_usec;\
			     while (usecs > 0) usecs--; }

/*
 * The definition for lock - the verb.
 */
#define unlocked 0
#define locked (!unlocked)
#define lock(ptr) simple_lock(ptr)
#define unlock(ptr)	*(ptr) = unlocked


/*
 * external declarations for compact team descriptor routines.
 */
extern void _pxp_td_initv();
#ifdef __STDC__
extern int _pxp_td_set(int, int);
extern void _pxp_td_initl(int);
extern void _pxp_td_get(int, int, int, char *);
extern void _pxp_td_ret(int, int, int, char *);
#else
extern int _pxp_td_set();
extern void _pxp_td_initl();
extern void _pxp_td_get();
extern void _pxp_td_ret();
#endif
