/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993,1995             */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/

#ifdef SNEEZY
/* For now. */
void snz_register_context( void );
void snz_shutdown_context( void );
void snz_ready_event( void );
#include <stdio.h>
#endif

/* Startup stuff for SPMD-executing computers */
int main(int argc, char **argv) { 

  /* Startup */
  /* pass by reference required because some startups remove arguments */
  /* MPI_Init for example, requires *argc, ***argv */

  My_MainBegin(&argc, &argv);

  /* Call the external "user" code */
#ifdef SNEEZY
  printf( "NOW REGISTERING\n" ); fflush( stdout );
  snz_register_context();
  printf( "NOW GETTING READY\n" ); fflush( stdout );
  snz_ready_event();
  printf( "GOTTEN READY\n" ); fflush( stdout );
#endif
  tulip_ParallelMain(argc, argv);
#ifdef SNEEZY
  snz_shutdown_context();
#endif

  /* Shut-down stuff */
  My_MainEnd();

  return 0;
}
