/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993,1995             */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/

/*********************************************************************/
/*                Parallel run-time library                          */
/*                                                                   */
/*                Uniprocessor "Stubs"                               */
/*                                                                   */
/* Contributions to this module have been made by:                   */
/*                                                                   */
/*     Pete Beckman *** Francois Bodin *** Dennis Gannon             */
/*                Bernd Mohr *** Shelby Yang                         */
/*********************************************************************/

/*****************************/
/* System Includes           */
/*****************************/
#include <stdarg.h>
#include <stdio.h>

/*****************************/
/* Our Include Files         */
/*****************************/
#include "pcxx_machines.h"

/*****************************/
/* Module Global Variables   */
/*****************************/
static int MyNodeNumber, MyTotalNodes;
int tulip_MsgBlockSize = PCXX_SUGGESTED_MSG_SIZE;

/*********************************************************************/
/*********************************************************************/
/*********************************************************************/
/* GENERAL FUNCTIONS */
/*********************************************************************/
/*********************************************************************/
/*********************************************************************/

/*******************************************************************/
int tulip_NumContexts()
{ return MyTotalNodes; }

/*******************************************************************/
int tulip_MyContext() 
{ return MyNodeNumber; }

/*********************************************************************/
int tulip_Get(char *dst, tulip_GlobalPointer_t src, int len, 
	      tulip_ACK_t *ackhandle)
{
  memcpy(dst, tulip_ToLocalPointer(&src), len);
  tulip_SetACK(ackhandle);
  return 0;
}

/*********************************************************************/
int tulip_Put(tulip_GlobalPointer_t dst, char *src, int len, 
	      tulip_ACK_t *ackhandle)
{
  memcpy(tulip_ToLocalPointer(&dst), src, len);
  tulip_SetACK(ackhandle);
  return 0;
}  

/*********************************************************************/
int tulip_RemoteAction(int remote_node, char *buffer, int len, 
		       tulip_ACK_t *ackhandle)
{

  /* RemoteAction to same uniproc node never happens?....???? */
  tulip_SetACK(ackhandle);
  return 0;

}

/*******************************************************************/
void tulip_BroadcastBytes(int flag, int length, void * buffer) {}

void tulip_ReduceIntAdd(void* buffer,int elem_count) {}

void tulip_ReduceFloatAdd(void* buffer,int elem_count) {}

void tulip_ReduceDoubleAdd(void* buffer,int elem_count) {}

void tulip_ReduceDoubleMax(void* buffer,int elem_count) {}

void tulip_ReduceFloatMax(void* buffer,int elem_count) {}

void tulip_ReduceIntMax(void* buffer,int elem_count) {}

void tulip_ReduceDoubleMin(void* buffer,int elem_count) {}

void tulip_ReduceFloatMin(void* buffer,int elem_count) {}

void tulip_ReduceIntMin(void* buffer,int elem_count) {}
