/* Repeating the FLOP test for 4 cases */

/* defined: TESTCASE1(); TESTCASE2(); TESTCASE3(); */

/**********************************************************************/
/**********************************************************************/
  /* LOOP THROUGH VARIOUS VECTOR LENGTHS */
  for (k=1; k<=FLOPLOOP; k=k*10) {

/**********************************************************************/
  /* INITIALIZE ARRAYS */
  for (i=0; i<FLOPLOOP+100; i++) {
    A[i]=1.1 +((double) i)/1000000;
    B[i]=1.2 +((double) i)/1000000;
    C[i]=1.0 +((double) i)/1000000;
    D[i]=1.01+((double) i)/1000000;
  }
  
  x=1.1; y=1.2; u=1.3; s=1.4; u=1.5; sum=0.0;
/**********************************************************************/
  /* EMPTY LOOP TIMERS */
  ALL_START(TW[0],TU[0]);
  for (j=1; j<=FLOPLOOP/k*mplyer; j++)
    for (i=1; i<=k; i++) {
    s = s + 4.0;
    x = x + 1.0;
    y = y + 2.0;
    u = u + 3.0;
  }
  ALL_END(TW[0],TU[0]);
    
  ALL_START(ew,eu);
  for (j=1; j<=FLOPLOOP/k*mplyer; j++)
    for (i=1; i<=k; i++) {
    y = y + 2.0;
    u = u + 3.0;
  }
  ALL_END(ew,eu);

  ew = eu - (TW[0] - ew);   /* Time for empty loops */
  eu = eu - (TU[0] - eu);   /* Time for empty loops */

  if (s+x+y+u > 1000.0) force++;    /* Force -O to keep computation */

  x=1.1; y=1.2; u=1.3; s=1.4; u=1.5; /* re-initialize variables */
/**********************************************************************/
  ALL_START(TW[0],TU[0]);
  for (j=1; j<=FLOPLOOP/k*mplyer; j++)
    for (i=1; i<=k; i++)
TESTCASE1();
  ALL_END(TW[0],TU[0]);
  sum = sum + A[1];

  ALL_START(TW[1],TU[1]);
  for (j=1; j<=FLOPLOOP/k*mplyer; j++)
    for (i=1; i<=k; i++)
TESTCASE2();
  ALL_END(TW[1],TU[1]);
  sum = sum + A[1];

  ALL_START(TW[2],TU[2]);
  for (j=1; j<=FLOPLOOP/k*mplyer; j++)
    for (i=1; i<=k; i++)
TESTCASE3();
  ALL_END(TW[2],TU[2]);
  sum = sum + A[1];

  printf("%6.e%6.e%8.3f%7.3f%7.3f%7.3f%8.3f%7.3f%7.3f%7.3f\n",
    (double) (FLOPLOOP/k*mplyer),(double) k,ew,
    ((double) FLOPLOOP*mplyer)/(TW[0]-0)/1000000*FLOPNUM,
    ((double) FLOPLOOP*mplyer)/(TW[1]-0)/1000000*FLOPNUM,
    ((double) FLOPLOOP*mplyer)/(TW[2]-0)/1000000*FLOPNUM,eu,
    ((double) FLOPLOOP*mplyer)/(TU[0]-0)/1000000*FLOPNUM,
    ((double) FLOPLOOP*mplyer)/(TU[1]-0)/1000000*FLOPNUM,
    ((double) FLOPLOOP*mplyer)/(TU[2]-0)/1000000*FLOPNUM,
    ew);
  
  if ( (A[1]+A[k]+sum) > 1000.0 ) force++;
}

