/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993,1995             */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/

/* Thread interface for pC++ in one context (shared memory( */
/* Pete Beckman */

#ifndef THREADS_IFACE_H
#define THREADS_IFACE_H

#include "thread_iface_sys.h"

/* Remove parameters, and set field in thread_param struct */
void thread_InitParam(int *argc, char **argv);

/* Initialize threads, modifies argc/argv, returns control to caller */
void thread_Init(int *argc, char **argv);

/* Shut down and wrap up the thread package */
void thread_Term();

/* Fork some work onto a "rope" of threads, passing a single void* arg */
void thread_Fork( void (*function)(void *), void *arg );

/* Am I somehow "distinguished" from the other threads? */
void thread_IamDistinguished();

/* Collective Operation: barrier sync */
void thread_Barrier();

/* Returns the thread ID for the calling thread */
int thread_MyID();

/* Returns the current number of threads in this "group", however
 * "group" is defined.  May be dynamic, and does not require a count of
 * all threads everywhere */
int thread_NumThreads();

#endif

