/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993,1995             */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/

/* "Thread" interface for SGI */
/* Pete Beckman */

#include <stdio.h>
#include <ulocks.h>
#include <task.h>

#include "thread_iface.h"

/* struct for the command line parameters or environment variables */
extern thread_PARAM_t thread_param;

/* Initialize threads, uses argc/argv, and modifying them */
void thread_Init(int *argc, char **argv)
{
  /* Extract the "-thread_" parameters */
  thread_InitParam(argc,argv);
  m_set_procs(thread_param.numthreads);
}

/* Shut down and wrap up the thread package */
void thread_Term()
{
  printf("Shutting down the thread package...\n");
}

/* For some work onto a thread, passing a single void* argument */
void thread_Fork( void (*function)(void *), void *arg )
{
  m_fork( (void (*)()) function,arg);
}

/* Am I somehow "distinguished" from the other threads? */
void thread_IamDistinguished()
{
  printf("Who called me, I am not used yet...\n");
}

void thread_Barrier()
{
  m_sync();
}

int thread_MyID() 
{
  return m_get_myid();
}

int thread_NumThreads()
{
  return m_get_numprocs();
}

