/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993,1995             */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/

/*********************************************************************/
/*                Parallel run-time library                          */
/*                                                                   */
/*                Uniprocessor Version                               */
/*                                                                   */
/* Contributions to this module have been made by:                   */
/*                                                                   */
/*     Pete Beckman *** Francois Bodin *** Dennis Gannon             */
/*                Bernd Mohr *** Shelby Yang                         */
/*********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <fcntl.h>

#include "compatible.h"
#ifdef SYS5
#include <string.h>
#else
#include <strings.h>
#endif
 
#include "tulip.h"
#include "profiler_defs.h"

#include "uniproc.h"

extern pcxx_PARAM_t pcxx_param;

/*********************************************************************/
void * tulip_SharedMalloc(int size) {
  return (void *) malloc(size);
}

/*********************************************************************/
void tulip_SharedFree(void *p) {
  free(p);
}

/*********************************************************************/
void tulip_Abort() { 
  exit(1); 
}

/*********************************************************************/
static void My_MainBegin(int *argc, char ***argv)
{
  pcxx_InitParam(argc, *argv);
  tulip_InitClocks();

  MyNodeNumber = 0;
  MyTotalNodes = 1;

  pcxx_EvInit (pcxx_param.tracefile);
  PCXX_EVENT (PCXX_EC_BASIC, PCXX_MAIN_ENTER, 0);
}

/*********************************************************************/
static void My_MainEnd()
{
  PCXX_EVENT (PCXX_EC_BASIC, PCXX_MAIN_EXIT, 0);
  pcxx_EvClose();
}

/*******************************************************************/
void tulip_Poll()
{
  return;
}

/*******************************************************************/
void tulip_Barrier()
{
  PROFILE_ENTER(PROFILE_Barrier);

  PROFILE_EXIT(PROFILE_Barrier);
}

#include "SPMD.h"

