/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993,1995             */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/

#include "compatible.h"
#ifdef SYS5
#include <string.h>
#else
#include <strings.h>
#endif

/*
 * This is a simple test program for testing some features in the data base
 * The way to use it is:
 *
 *	dbtest <dep_filename>
 *
 * as in the following example
 *
 *	dbtest test.dep
 */

#include <stdio.h>
#include "db.h"

/*
 * external references
 */
int	debug = 0;

static char *proj_name = "test";

void foo(PTR_BLOB1 b)
{
	PTR_BLOB1 bl;

	for(bl = b; bl; bl=bl->next)
		if(bl->tag == IsObj)
			printf("In file \"%s\" lines %d, %d\n\t%s\n",
			       ((PTR_INFO)bl->ref)->filename,
			       ((PTR_INFO)bl->ref)->g_line,
			       ((PTR_INFO)bl->ref)->l_line,
			       ((PTR_INFO)bl->ref)->source);
		else
			foo((PTR_BLOB1) bl->ref);
}


main(int argc, char *argv[], char *envp[])
{
	PTR_PROJ fi;
	PTR_BLOB1 bl;
	char buf[200];

        if (argc < 2)
        {
           printf("Usage:%s <depfile>\n", argv[0]);
           exit(1);
        }
	argv++;
	if ((fi = OpenProj(proj_name, --argc, argv)) != NULL) {
		printf("\n*** Testing GetProjInfo ***\n");
		for(bl = GetProjInfo(proj_name, ProjNames); bl; bl=bl->next)
			if(bl->tag == IsObj)
				printf("In file \"%s\" lines %d, %d\n\t%s",
				       ((PTR_INFO)bl->ref)->filename,
				       ((PTR_INFO)bl->ref)->g_line,
				       ((PTR_INFO)bl->ref)->l_line,
				       ((PTR_INFO)bl->ref)->source);

		for(bl = GetProjInfo(proj_name, ProjSrc); bl; bl=bl->next)
			if(bl->tag == IsObj)
				printf("\"%s\"\n",((PTR_INFO)bl->ref)->filename);
		printf("\nWhich .dep to be replaced? ");
		(void) fgets(buf, 200, stdin);
		buf[strlen(buf)-1] = '\0';
		AddToProj(buf);
		for(bl = GetProjInfo(proj_name, ProjSrc); bl; bl=bl->next)
			if(bl->tag == IsObj)
				printf("\"%s\"\n",((PTR_INFO)bl->ref)->filename);

/*
		printf("%d\n",SymbType("test.f", 1, "testprog"));
		printf("%d\n",SymbType("test.f", 2, "x"));
		printf("%d\n",SymbType("test.f", 3, "i"));
		printf("%d\n",SymbType("test.f", 4, "stuff"));
		printf("%d\n",SymbType("test.f", 4, "y"));
		printf("%d\n",SymbType("test.f", 4, "t"));
		printf("%d\n",SymbType("test.f", 33, "fo1"));

		printf("%d\n",EndOfLoop("test.f",5));
		printf("%d\n",EndOfLoop("test.f",6));		       
*/
		while (1) {
			char b1[200], b2[200];

			printf("\n*** Testing GetTypeDef ***\nType name? ");
			(void) fgets(b1, 200, stdin);
			if (b1[0] == '\n')
				break;
			b1[strlen(b1)-1] = '\0';

			printf("Procedure name? ");
			(void) fgets(b2, 200, stdin);
			b2[strlen(b2)-1] = '\0';
			bl = GetTypeDef(b1, b2[0]? b2: NULL);
			for(; bl ; bl = bl->next)
				printf("In procedure \"%s\" lines %d, %d\n%s\n",
				       ((PTR_INFO)bl->ref)->filename,
				       ((PTR_INFO)bl->ref)->g_line,
				       ((PTR_INFO)bl->ref)->l_line,
				       ((PTR_INFO)bl->ref)->source);
		}

		while (1) {
		printf("\n*** Testing GetProcInfo - ProcDef ***\nProcedure name? ");
		(void) fgets(buf, 200, stdin);
		if (buf[0] == '\n') break;
		buf[strlen(buf)-1] = '\0';
		for(bl = GetProcInfo(buf, ProcDef); bl; bl=bl->next)
			if(bl->tag == IsObj)
				printf("In file \"%s\" lines %d, %d\n%s",
				       ((PTR_INFO)bl->ref)->filename,
				       ((PTR_INFO)bl->ref)->g_line,
				       ((PTR_INFO)bl->ref)->l_line,
				       ((PTR_INFO)bl->ref)->source);

		printf("\n*** Testing GetProcInfo - CallSiteE ***\n");
		foo(GetProcInfo(buf, CallSiteE));

		printf("\nTesting GetProcInfo - CallSite\n");
		for(bl = GetProcInfo(buf, CallSite); bl; bl=bl->next)
			if(bl->tag == IsObj)
				printf("In file \"%s\" lines %d, %d\n\t%s",
				       ((PTR_INFO)bl->ref)->filename,
				       ((PTR_INFO)bl->ref)->g_line,
				       ((PTR_INFO)bl->ref)->l_line,
				       ((PTR_INFO)bl->ref)->source);

		printf("\nTesting GetProcInfo - Mod\n");
		for(bl = GetProcInfo(buf, Mod); bl; bl=bl->next)
			if(bl->tag == IsObj)
				printf("In file \"%s\" lines %d, %d\n\t%s",
				       ((PTR_INFO)bl->ref)->filename,
				       ((PTR_INFO)bl->ref)->g_line,
				       ((PTR_INFO)bl->ref)->l_line,
				       ((PTR_INFO)bl->ref)->source);

		printf("\nTesting GetProcInfo - Use\n");
		for(bl = GetProcInfo(buf, Use); bl; bl=bl->next)
			if(bl->tag == IsObj)
				printf("In file \"%s\" lines %d, %d\n\t%s",
				       ((PTR_INFO)bl->ref)->filename,
				       ((PTR_INFO)bl->ref)->g_line,
				       ((PTR_INFO)bl->ref)->l_line,
				       ((PTR_INFO)bl->ref)->source);
		}
	}
}
