/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993,1995             */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/

/*------------------------------------------------------*
 *							*
 *	This is a program that can dump BIF graph	*
 *	into human readable from:			*
 *							*
 *	Usage:						*
 *		dumpdep <dep_filename>			*
 *							*
 *------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>

#include "compatible.h"
#ifdef SYS5
#include <string.h>
#else
#include <strings.h>
#endif

#include "db.h"
#include "dep_struct.h"

int	debug;

static void usage()
{
	fprintf(stderr,"Usage: dumpdep [-d nnn] dep_file\n");
	exit(1);
}


int main(int argc, char *argv[], char *envp[])
{
	FILE	 *fd;
	PTR_FILE  f;

	argv++; argc--;
	if (!argc)
		usage();
	if (**argv == '-')
		if ((*argv)[1] == 'd') {
			argv++;
			debug = atoi(*argv++);
			printf("debug = %d\n",debug);
		} else
			usage();
	if((fd=fopen(*argv, "r")) == NULL) {
		fprintf(stderr,"Cannot open file \"%s\"\n", *argv);
		exit(1);
	}
	if ((f = (PTR_FILE) calloc(1, sizeof(struct file_obj))) == NULL) {
		fprintf(stderr, "main -- No more space\n");
		exit(1);
	}
	f->fid = fd;

	if (read_nodes(f) >= 0) {
		f->global_bfnd->control_parent = NULL;
		dump_nodes(f, "");
	}
	return 0;
}
