; s l e e p . s c h
;
;   Copyright (C) 1995 The University of Oregon
;   Copyright (C) 1995 Lars Thomas Hansen <lth@cs.uoregon.edu>
;
;   Permission to use, copy, and/or distribute this software and its
;   documentation for any purpose and with or without fee is hereby granted,
;   provided that both the above copyright notice and this permission notice
;   appear in all copies and derived works.  
;
;   This software is provided ``as is'' without express or implied warranty.
;
; lth@cs.uoregon.edu / June 27, 1995
; $Id$
; 
; Sleep code for STk tasking library.
;
; Suspend the current thread for a given amount of time. It takes a numeric
; argument and an optional unit, defaulting to milliseconds.
;
; BUGS
; - Requires Tk (for 'after'). Should fix this.

(require "callback.sch")
(require "synch.sch")

(define (sleep n . rest)
  (let ((unit (if (not (null? rest))
		  (cond ((memq (car rest) '(seconds s))
			 1000)
			((memq (car rest) '(milliseconds ms))
			 1)
			((memq (car rest) '(minutes min))
			 60000)
			(else
			 (error "sleep: Unknown unit: " (car rest))))
		  1))
	(s    (make-semaphore 0)))
    (after (* n unit) (tk-oneshot-callback (lambda () (semaphore-up s))))
    (semaphore-down s)
    #t))

(provide "sleep.sch")

; eof
